#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 2e9;

int n;
vector<int> g[100000], c, l, r, add, ans, s, p;
set<tuple<int, int, int>> st;

void dfs1(int v, int p)
{
	int suml = 0, sumr = 0;
	for (auto& i : g[v])
	{
		if (i == p)
		{
			continue;
		}

		dfs1(i, v);
	}

	bool leaf = true;
	for (auto& i : g[v])
	{
		if (i == p)
		{
			continue;
		}

		suml += l[i];
		sumr += r[i];
		leaf = false;
	}
	if (leaf)
	{
		return;
	}

	l[v] = max(l[v], suml);
	r[v] = min(r[v], sumr);
}

void upd(int v, int rt, int added)
{
	if (v == rt)
	{
		return;
	}

	st.erase({ c[v], add[v], v });
	add[v] -= added;
	if (add[v])
	{
		st.insert({ c[v], add[v], v });
	}
	upd(p[v], rt, added);
}

void recalc(int v, int rt)
{
	st.erase({ c[v], add[v], v });
	add[v] = min(add[v], add[rt]);
	if (add[v])
	{
		st.insert({ c[v], add[v], v });
	}
	for (auto& i : g[v])
	{
		if (i == p[v])
		{
			continue;
		}

		recalc(i, rt);
	}
}

void dfs2(int v)
{
	set<tuple<int, int, int>> all;
	for (auto& i : g[v])
	{
		if (i == p[v])
		{
			continue;
		}

		dfs2(i);
		for (auto& j : st)
		{
			all.insert(j);
		}
		st = {};
	}
	st = all;

	int sum = 0;
	for (auto& i : g[v])
	{
		if (i == p[v])
		{
			continue;
		}

		sum += l[i];
	}

	int need = l[v] - sum;
	if (need > 0)
	{
		st.insert({ c[v], INF, v });
	}
	while (need > 0)
	{
		auto [cst, can_add, ver] = *st.begin();
		int added = min(need, can_add);
		ans[ver] += added;
		if (ver == v)
		{
			need = 0;
			st.erase({ c[v], INF, v });
			break;
		}
		upd(ver, v, added);
		need -= added;
	}

	add[v] = r[v] - l[v];
	if (add[v])
	{
		st.insert({ c[v], add[v], v });
	}
	recalc(v, v);
}

void solve()
{
	cin >> n;
	c.resize(n);
	l.resize(n);
	r.resize(n);
	add.resize(n);
	ans.resize(n);
	s.resize(n);
	p.resize(n);
	p[0] = -1;
	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;
		x--;
		g[i].push_back(x);
		g[x].push_back(i);
		p[i] = x;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}

	dfs1(0, -1);
	for (int i = 0; i < n; i++)
	{
		if (l[i] > r[i])
		{
			cout << -1 << "\n";
			return;
		}
	}

	dfs2(0);
	int costttt = 0;
	for (int i = 0; i < n; i++)
	{
		costttt += ans[i] * c[i];
	}
	cout << costttt << "\n";
	for (int i = 0; i < n; i++)
	{
		cout << ans[i] << " ";
	}
	cout << "\n";
}

void reset()
{
	for (int i = 0; i < n; i++)
	{
		g[i] = {};
	}
	c = l = r = add = ans = s = p = {};
	st = {};
	n = 0;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tests;
	cin >> tests;
	while (tests--)
	{
		solve();
		reset();
	}

	return 0;
}

/*













*/
