#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e10, MOD = 1e9 + 7, LOG = 13;

struct req
{
	int r1, c1, r2, c2;
};

int n, q;
vector<int> v, p;
vector<int> g[4504511];
vector<req> r;

int ver(int a, int b)
{
	return (a + 1) * a / 2 + b;
}

long long get_lca(long long a, long long b)
{
	vector<long long> pa, pb;
	while (a != -1)
	{
		pa.push_back(a);
		a = p[a];
	}
	while (b != -1)
	{
		pb.push_back(b);
		b = p[b];
	}

	reverse(pa.begin(), pa.end());
	reverse(pb.begin(), pb.end());

	long long idx = 0;
	while (idx != pa.size() && idx != pb.size() && pa[idx] == pb[idx])
	{
		idx++;
	}

	return pa[idx - 1];
}

bool subtask2()
{
	if (n > 3000)
	{
		return false;
	}

	vector<int> path(n + 1);
	vector<pair<int, int>> idx(ver(n, n) + 1);
	p.resize(ver(n, n) + 1);
	for (int i = 0; i < n + 1; i++)
	{
		for (int j = 0; j < i + 1; j++)
		{
			idx[ver(i, j)] = { i, j };
		}
	}
	for (int i = 0; i < n + 1; i++)
	{
		path[i] = i;
	}
	for (int i = 0; i < n; i++)
	{
		g[ver(i, path[i])].push_back(ver(i + 1, path[i + 1]));
		p[ver(i + 1, path[i + 1])] = ver(i, path[i]);
		g[ver(i + 1, path[i + 1])].push_back(ver(i, path[i]));
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = v[i]; j < n + 1; j++)
		{
			path[j]--;
		}

		for (int k = v[i] - 1; k < n; k++)
		{
			g[ver(k, path[k])].push_back(ver(k + 1, path[k + 1]));
			p[ver(k + 1, path[k + 1])] = ver(k, path[k]);
			g[ver(k + 1, path[k + 1])].push_back(ver(k, path[k]));
		}
	}

	p[0] = -1;
	for (int i = 0; i < q; i++)
	{
		long long r1 = r[i].r1, c1 = r[i].c1, r2 = r[i].r2, c2 = r[i].c2;
		int v1 = ver(r1, c1), v2 = ver(r2, c2);
		int vlca = get_lca(v1, v2);

		cout << idx[vlca].first << " " << idx[vlca].second << "\n";
	}
}

void solve()
{
	cin >> n;
	v.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	cin >> q;
	r.resize(q);
	for (int i = 0; i < q; i++)
	{
		cin >> r[i].r1 >> r[i].c1 >> r[i].r2 >> r[i].c2;
	}

	if (subtask2())
	{
		return;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*













*/
