#pragma GCC optimize("03,unroll-loops")
// #pragma GCC optimize("0fast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;


using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i <<' ';}; cout << endl;
#define tm _tm
#define tree _tr


struct node {
    int sum, l, r;
    node() {
        l = r = -1;
        sum = 0;
    }
};


const int T = 9e6, N = 3e5 + 2;
node t[T];
int root[N];
int sz = 1;


void build (int x, int lx, int rx) {
    if (rx - lx == 1) {
        return;
    }
    int m = (lx + rx) >> 1;
    build(2 * x + 1, lx, m);
    build(2 * x + 2, m, rx);
    t[x].l = 2 * x + 1;
    t[x].r = 2 * x + 2;
}


int update (int i, int x, int lx, int rx) {
    node A;
    if (rx - lx == 1) {
        A.sum = 1;
        t[sz] = A;
        return sz++;
    }
    int m = (lx + rx) >> 1;
    if (i < m) {
        A.l = update(i, t[x].l, lx, m);
        A.r = t[x].r;
        if (A.l != -1) {
            A.sum += t[A.l].sum;
        }
        if (A.r != -1) {
            A.sum += t[A.r].sum;
        }
        // A.sum = t[A.l].sum + t[A.r].sum;
        t[sz] = A;
        return sz++;
    }
    else {
        A.r = update(i, t[x].r, m, rx);
        A.l = t[x].l;
        if (A.l != -1) {
            A.sum += t[A.l].sum;
        }
        if (A.r != -1) {
            A.sum += t[A.r].sum;
        }
        t[sz] = A;
        return sz++;
    }
}


int get (int l, int r, int x, int lx, int rx) {
    if (lx >= r || l >= rx) {
        return 0;
    }
    if (lx >= l && rx <= r) {
        return t[x].sum;
    }
    int m = (lx + rx) >> 1;
    return get(l, r, t[x].l, lx, m) + get(l, r, t[x].r, m, rx);
}


int n;
vector <int> a;


int get1 (int x, int y) {
    if (!x) {
        return 0;
    }
    int op = x - y;
    if (!op) {
        return 0;
    }
    int l = op, r = n + 1;
    while (r - l > 1) {
        int m = (l + r) >> 1;
        int g = get(0, x, root[m], 0, n);
        if (g == op) {
            return m;
        }
        if (g > op) {
            r = m;
        }
        else {
            l = m;
        }
    }
    return l;
}


const int k = 19;
int tree[k][N];
int po[k];


int get_st (int i, int j) {
    int res = 1e9;
    while (i + 1 < j) {
        for (int l = 0; l < k; ++l) {
            if (i + po[l] >= j) {
                res = min(res, tree[l - 1][i]);
                i += po[l - 1];
                break;
            }
        }
    }
    if (i - 1 >= 0) {
        res = min(res, a[i - 1]);
    }
    return res;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    root[0] = 0;
    po[0] = 1;
    for (int i = 1; i < k; ++i) {
        po[i] = po[i - 1] * 2;
    }
    cin >> n;
    while (sz < n) {
        sz *= 2;
    }
    sz = 2 * sz - 1;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    tree[0][0] = 1e9;
    for (int i = 0; i < n; ++i) {
        tree[0][i + 1] = a[i];
    }
    for (int i = 1; i < k; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (j + po[i] <= n) {
                tree[i][j] = min(tree[i - 1][j], tree[i - 1][j + po[i - 1]]);
            }
        }
    }
    // cout << get_st(0 , 1) << endl;
    build(0, 0, n);
    for (int i = 0; i < n; ++i) {
        root[i + 1] = update(a[i], root[i], 0, n);
    }
    // cout << t[root[1]].sum << endl;
    int q;
    cin >> q;
    int done = 0;
    gp_hash_table <ll, int> mp;
    ll C = 1e6 + 3;
    while (q--) {
        ++done;
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        int g1, g2;
        if (!mp[C * x1 + y1]) {
            g1 = get1(x1, y1);
            mp[C * x1 + y1] = g1;
        }
        else {
            g1 = mp[C * x1 + y1];
        }
        if (!mp[C * x2 + y2]) {
            g2 = get1(x2, y2);
            mp[C * x2 + y2] = g2;
        }
        else {
            g2 = mp[C * x2 + y2];
        }
        if (g1 == g2) {
            if (x1 < x2) {
                cout << x1 << ' ' << y1 << endl;
            }
            else {
                cout << x2 << ' ' << y2 << endl;
            }
        }
        else {
            // cout << g1 << ' ' << g2 << endl;
            if (g1 > g2) {
                swap(g1, g2);
            }
            int mi = get_st(g1 + 1, g2 + 1), ans2;
            mi = min(mi, x1);
            mi = min(mi, x2);
            if (mi == 0) {
                ans2 = 0;
            }
            else {
                ans2 = get(0, mi, root[g1], 0, n);
            }
            cout << mi << ' ' << mi - ans2 << endl;
        }
        if (done >= 3e5) {
            return 0;
        }
    }
}