#include <iostream>
#include <vector>
#include <cassert>
#include <map>
#include <algorithm>
using namespace std;
using ll = long long;

const ll MAXN = 1e5 + 123;
vector<ll> edg[MAXN];
ll rt[MAXN];
ll cost[MAXN];
pair<ll, ll> seg[MAXN];
ll b[MAXN];

pair<ll, ll> llersect(pair<ll, ll> s1, pair<ll, ll> s2) {
    return {max(s1.first, s2.first), min(s1.second, s2.second)};
}

bool cmpsz(map<pair<ll, ll>, ll>* mp0, map<pair<ll, ll>, ll>* mp1) {
    return mp0->size() < mp1->size();
}

void add(map<pair<ll, ll>, ll>* mp, map<pair<ll, ll>, ll>* amp) {
    for (auto [x, cnt] : *amp) {
        (*mp)[x] += cnt;
    }
    delete amp;
}

pair<map<pair<ll, ll>, ll>*, pair<ll, ll>> dfs(ll v) {
    vector<map<pair<ll, ll>, ll>*> mps;
    map<pair<ll, ll>, ll>* mpvinit = new map<pair<ll, ll>, ll>();
    (*mpvinit)[pair<ll, ll>(cost[v], v)] = seg[v].second;
    ll allcnt = seg[v].second;
    ll lv = 0;
    ll startv = 0;
    mps.push_back(mpvinit);
    for (auto u : edg[v]) {
        auto [mpu, delt] = dfs(u);
        if (!mpu)
            return {nullptr, {0, 0}};
        mps.push_back(mpu);
        allcnt += seg[u].second;
        lv += delt.first;
        startv += delt.second;
    }
    map<pair<ll, ll>, ll>* ans = *max_element(mps.begin(), mps.end(), cmpsz);
    for (auto mp : mps) {
        if (mp != ans)
            add(ans, mp);
    }
    while (lv < seg[v].first) {
        if (ans->empty())
            return {nullptr, {0, 0}};
        auto& el = *ans->begin();
        if (el.second <= seg[v].first - lv) {
            startv += el.second * el.first.first;
            b[el.first.second] += el.second;
            lv += el.second;
            ans->erase(ans->begin());
        } else {
            startv += (seg[v].first - lv) * el.first.first;
            b[el.first.second] += (seg[v].first - lv);
            el.second -= (seg[v].first - lv);
            lv = seg[v].first;
        }
    }
    ll sumcnt = 0;
    for (auto [el, cnt] : *ans)
        sumcnt += cnt;
    if (sumcnt + lv != allcnt) {
        assert(0);
    }
    while (allcnt > seg[v].second) {
        if (ans->empty())
            return {nullptr, {0, 0}};
        auto& el = *ans->rbegin();
        if (el.second <= allcnt - seg[v].second) {
            allcnt -= el.second;
            ans->erase(prev(ans->end()));
        } else {
            el.second -= allcnt - seg[v].second;
            allcnt = seg[v].second;
        }
    }
    if (ans->empty())
        return {nullptr, {0, 0}};
    // cout << v << ": " << "(" << lv << ' ' << startv << ") ";
    return {ans, {lv, startv}};
}

void solve() {
    ll n;
    cin >> n;
    edg[0].clear();
    b[0] = 0;
    for (ll i = 1; i < n; ++i) {
        cin >> rt[i];
        --rt[i];
        edg[rt[i]].push_back(i);
        edg[i].clear();
        b[i] = 0;
    }
    for (ll i = 0; i < n; ++i)
        cin >> cost[i];
    for (ll i = 0; i < n; ++i)
        cin >> seg[i].first >> seg[i].second;
    auto [ans, remilia] = dfs(0);
    if (!ans) {
        cout << -1 << '\n';
    } else {
        cout << remilia.second << '\n';
        for (ll i = 0; i < n; ++i)
            cout << b[i] << ' ';
        cout << '\n';
    }
}

signed main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
