#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
using ll = long long;

const int MAXN = 1e5 + 123;
vector<int> edg[MAXN];
int rt[MAXN];
int cost[MAXN];
pair<int, int> seg[MAXN];
ll b[MAXN];
ll subcnt[MAXN];

pair<int, int> intersect(pair<int, int> s1, pair<int, int> s2) {
    return {max(s1.first, s2.first), min(s1.second, s2.second)};
}

bool cmpsz(map<pair<ll, ll>, ll>* mp0, map<pair<ll, ll>, ll>* mp1) {
    return mp0->size() < mp1->size();
}

ll find_dfs(int v) {
    if (subcnt[v] == seg[v].second)
        return -1;
    int ans = v;
    for (auto u : edg[v]) {
        int ansu = find_dfs(u);
        if (ansu != -1 && cost[ansu] < cost[ans]) {
            ans = ansu;
        }
    }
    return ans;
}

bool dfs(int v) {
    for (auto u : edg[v]) {
        if (!dfs(u))
            return false;
    }
    while (subcnt[v] < seg[v].first) {
        int u = find_dfs(v);
        // cout << "(" << v << ' ' << u << ") ";
        if (u == -1)
            return false;
        ++b[u];
        while (u > -1) {
            ++subcnt[u];
            u = rt[u];
        }
    }
    return subcnt[v] <= seg[v].second;
}

void solve() {
    int n;
    cin >> n;
    edg[0].clear();
    b[0] = 0;
    rt[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> rt[i];
        --rt[i];
        edg[rt[i]].push_back(i);
        edg[i].clear();
        b[i] = 0;
    }
    for (int i = 0; i < n; ++i)
        cin >> cost[i];
    for (int i = 0; i < n; ++i)
        cin >> seg[i].first >> seg[i].second;
    if (!dfs(0)) {
        cout << -1 << '\n';
    } else {
        ll sm = 0;
        for (int i = 0; i < n; ++i)
            sm += b[i] * cost[i];
        cout << sm << '\n';
        for (int i = 0; i < n; ++i)
            cout << b[i] << ' ';
        cout << '\n';
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
