#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define assert(...) (static_cast<bool>(__VA_ARGS__) ? (void)0 : abort());
#endif

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vc = vector<char>;
using vvc = vector<vc>;
using vb = vector<bool>;
using vvb = vector<vb>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  ll t = 1;
//  cin >> t;
  while (t--)
    solve();
}

// ------------

vector<vector<pair<bool, bool>>> gr;
vector<vector<pair<bool, bool>>> grev;
vb cmd;

#ifdef DEBUG
bool debug = true;
#else
bool debug = false;
#endif

void solve() {
  ll n;
  cin >> n;
  vi a(n);
  cin >> a;

  // ...

  if (n <= 3000 and !debug) {

    gr.resize(n + 1, vector<pair<bool, bool>>(n + 1));
    grev.resize(n + 1, vector<pair<bool, bool>>(n + 1));
    cmd.resize(n, true);
    for (int start = 0; start <= n; ++start) {
      ll r = 0, c = 0;
      for (int i = 0; i < n; ++i) {
        if (cmd[i]) {
          gr[r][c].second = true;
          grev[r + 1][c + 1].first = true;
          ++c;
        } else {
          gr[r][c].first = true;
          grev[r + 1][c].second = true;
        }
        ++r;
      }

      if (start < n) {
        cmd[a[start] - 1] = false;
      }
    }

    ll q;
    cin >> q;
    for (int qq = 0; qq < q; ++qq) {
      ll r1, c1, r2, c2;
      cin >> r1 >> c1 >> r2 >> c2;

      vi re1({c1});
      while (r1 > r2) {
        vi re1new;
        for (auto c : re1) {
          if (grev[r1][c].first) re1new.push_back(c - 1);
          if (grev[r1][c].second) re1new.push_back(c);
        }
        re1 = move(re1new);
        --r1;
      }
      vi re2({c2});
      while (r2 > r1) {
        vi re2new;
        for (auto c : re2) {
          if (grev[r2][c].first) re2new.push_back(c - 1);
          if (grev[r2][c].second) re2new.push_back(c);
        }
        re2 = move(re2new);
        --r2;
      }

      while (true) {
        ll s = -1;
        for (auto cc1 : re1) {
          for (auto cc2 : re2) {
            if (cc1 == cc2) {
              s = cc1;
              break;
            }
          }
          if (s != -1) break;
        }
        if (s != -1) {
          cout << r1 << ' ' << s << endl;
          break;
        }
        assert(r1 > 0);
        vi re1new;
        for (auto c : re1) {
          if (grev[r1][c].first) re1new.push_back(c - 1);
          if (grev[r1][c].second) re1new.push_back(c);
        }
        re1 = move(re1new);
        --r1;
        vi re2new;
        for (auto c : re2) {
          if (grev[r2][c].first) re2new.push_back(c - 1);
          if (grev[r2][c].second) re2new.push_back(c);
        }
        re2 = move(re2new);
        --r2;
      }
    }
  } else {
    ll q;
    cin >> q;
    for (int qq = 0; qq < q; ++qq) {
      ll r1, c1, r2, c2;
      cin >> r1 >> c1 >> r2 >> c2;
      cout << min(r1 - c1, r2 - c2) << ' ' << 0 << endl;
    }
  }
}