#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <assert.h>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 3010;

int p[N][N];
int a[N];
int n;

void dfs(int r, int c)
{
	if (r == n) return;
	if (a[r] == 1)
	{
		assert(p[r + 1][c + 1] == -1 || p[r + 1][c + 1] == c);
		p[r + 1][c + 1] = c;
		dfs(r + 1, c + 1);
	}
	else
	{
		assert(p[r + 1][c] == -1 || p[r + 1][c] == c);
		p[r + 1][c] = c;
		dfs(r + 1, c);
	}
}

void solve()
{
	cin >> n;

	for (int i = 0; i <= n; i++)
	{
		for (int j = 0; j <= n; j++)
		{
			p[i][j] = -1;
		}
	}

	for (int i = 0; i < n; i++)
	{
		a[i] = 1;
	}

	dfs(0, 0);	
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		a[k - 1] = 0;
		dfs(0, 0);	
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++)
	{
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;

		while (r1 > r2)
		{
			c1 = p[r1--][c1];
		}

		while (r1 < r2)
		{
			c2 = p[r2--][c2];
		}

		while (c1 != c2)
		{
			c1 = p[r1--][c1];
			c2 = p[r2--][c2];
		}

		cout << r1 << " " << c1 << '\n';
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}
