/*
 * author: WeetHet
 */
#include <bits/stdc++.h>

using namespace std;

#define int ll
#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template<typename T, typename U>
bool ckmin(T &a, const U &b) {
    return a > b && (a = b, true);
}

template<typename T, typename U>
bool ckmax(T &a, const U &b) {
    return a < b && (a = b, true);
}

struct Solution {
    vector<vi> g;
    vi w, c, l, r, par, answ;
    vector<vector<pii>> now;
    vi heavy;

    void init(int n) {
        g.resize(n);
        w.resize(n), c.resize(n), par.resize(n);
        l.resize(n), r.resize(n), answ.resize(n);
        now.resize(n);
        heavy.resize(n);
    }

    int min_path(int v, int u) {
        return v == u ? r[v] - w[v] : min(r[v] - w[v], min_path(par[v], u));
    }

    void add_path(int v, int u, int value) {
        w[v] += value;
        if (v != u) add_path(par[v], u, value);
    }

    ll ans = 0;

    void calc(int v) {
        if (ans == -1) return;

        now[v].push_back({c[v], v});
        for (auto u: g[v]) {
            calc(u);

            w[v] += w[u];
            vector<pii> nxt;
            merge(all(now[v]), all(now[u]), back_inserter(nxt));
            now[v] = nxt;
        }

        if (w[v] > r[v]) {
            ans = -1;
            return;
        }

        int pos = 0;
        while (w[v] < l[v]) {
            if (pos == now[v].size() || ans == -1) {
                ans = -1;
                return;
            }
            int u = now[v][pos].second, add = min(l[v] - w[v], min_path(u, v));
            answ[u] += add;
            ans += 1LL * c[u] * add;
            add_path(u, v, add);
            pos++;
        }
    }

    void solve() {
        int n;
        cin >> n;
        init(n);

        ans = 0;
        rep(i, 0, n) {
            now[i].clear();
            g[i].clear();
            w[i] = 0;
            answ[i] = 0;
        }

        rep(i, 1, n) {
            cin >> par[i], --par[i];
            g[par[i]].push_back(i);
        }
        rep(i, 0, n) cin >> c[i];
        rep(i, 0, n) cin >> l[i] >> r[i];

        calc(0);
        cout << ans << '\n';

        if (ans != -1) {
            rep(i, 0, n) cout << answ[i] << ' ';
            cout << '\n';
        }
    }
};


signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    int T;
    cin >> T;
    while (T--) Solution().solve();
}