/*
 * author: WeetHet
 */
#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

template<typename T, typename U>
bool ckmin(T &a, const U &b) {
    return a > b && (a = b, true);
}

template<typename T, typename U>
bool ckmax(T &a, const U &b) {
    return a < b && (a = b, true);
}

constexpr int N = 5e5;
int n, rot[N], p[N], fup[20][N], h[N];
vi g[N];

void build() {
    int x = 0, y = 0;
    rep(i, 0, n) {
        int nx = 0, ny = 0;
        if (rot[i]) {
            nx = x + 1, ny = y;
        } else {
            nx = x + 1, ny = y + 1;
        }

        if (g[n * x + y].empty() || g[n * x + y].back() != (n * nx + ny))
            g[n * x + y].push_back(n * nx + ny), p[n * nx + ny] = n * x + y;
        tie(x, y) = {nx, ny};
    }
}

void dfs(int v) {
    fup[0][v] = p[v];
    rep(i, 1, 20) fup[i][v] = fup[i - 1][fup[i - 1][v]];
    for (auto u: g[v]) {
        if (u == p[v]) continue;
        h[u] = h[v] + 1;
        dfs(u);
    }
}

int la(int v, int k) {
    k = min(k, h[v]);
    for (int i = 19; i >= 0; --i) {
        if ((1<<i) <= k) v = fup[i][v], k -= (1<<i);
    }
    return v;
}

int lca(int v, int u) {
    if (h[v] < h[u]) swap(v, u);
    v = la(v, h[v] - h[u]);

    for (int i = 19; i >= 0; --i) {
        if (fup[i][v] != fup[i][u]) v = fup[i][v], u = fup[i][u];
    }
    return (v == u? v: p[v]);
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cin.exceptions(ios::failbit);

    cin >> n;

    build();
    rep(i, 0, n) {
        int a;
        cin >> a;

        rot[a - 1] ^= 1;
        build();
    }
    dfs(0);

    int q;
    cin >> q;
    while (q--) {
        int x, y, a, b;
        cin >> x >> y >> a >> b;
        int ans = lca(x * n + y, a * n + b);
        cout << ans / n << ' ' << ans % n << '\n';
    }
}