#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define int long long
#define set multiset

const int MAXN = 1e5;

int n;
int l_mx[MAXN], mx_can[MAXN], lb[MAXN], rb[MAXN], l_sum[MAXN], cost[MAXN], ans_cnt[MAXN], overall[MAXN];
vector<int> g[MAXN];

struct cmp {
    bool operator()(int a, int b) const {
        return cost[a] < cost[b];
    }
};

void merge(set<int, cmp> &big, set<int, cmp> &small) {
    for (auto i : small) {
        big.insert(i);
    }
}

void dfs1(int v, int p) {
    l_mx[v] = lb[v];
    int l_mx_sum = 0;
    for (auto u : g[v]) {
        dfs1(u, v);
        l_mx_sum += l_mx[u];
    }
    l_mx[v] = max(l_mx[v], l_mx_sum);
    l_sum[v] = l_mx_sum;
    mx_can[v] = rb[v] - l_mx[v];
}

void dfs3(int v, int p) {
    if (p != -1) {
        mx_can[v] = min(mx_can[v], mx_can[p]);
    }
    for (auto u : g[v]) {
        dfs3(u, v);
    }
}

set<int, cmp> dfs2(int v) {
    set<int, cmp> cur;
    for (auto u : g[v]) {
        auto add = dfs2(u);
        if (cur.size() < add.size()) swap(cur, add);
        merge(cur, add);
    }
    if (l_mx[v] == l_sum[v]) {
        cur.insert(v);
        return cur;
    }
    int more = l_mx[v] - l_sum[v];
    int del = 0;
    for (auto u : cur) {
        if (u > cost[v]) break;
        if (mx_can[u] > more) {
            ans_cnt[u] += more;
            mx_can[u] -= more;
            more = 0;
        } else {
            ans_cnt[u] += mx_can[u];
            more -= mx_can[u];
            mx_can[u] = 0;
            ++del;
        }
        if (more == 0) {
            break;
        }
    }
    for (int i = 0; i < del; ++i) {
        cur.erase(cur.begin());
    }
    ans_cnt[v] += more;
    if (mx_can[v] != 0) {
        cur.insert(v);
    }
    return cur;
}

void dfs_check(int v) {
    overall[v] = ans_cnt[v];
    for (auto u : g[v]) {
        dfs_check(u);
        overall[v] += overall[u];
    }
}

void clear() {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        ans_cnt[i] = 0;
    }
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG_BENTSA
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else

#endif
    int t;
    cin >> t;
    while (t--) {
        cin >> n;
        clear();
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            --p;
            g[p].push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            cin >> cost[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> lb[i] >> rb[i];
        }
        dfs1(0, -1);
        dfs3(0, -1);
        bool fl = true;
        for (int i = 0; i < n; ++i) {
            if (mx_can[i] < 0) {
                fl = false;
                break;
            }
        }
        if (!fl) {
            cout << -1 << "\n";
            continue;
        }
        dfs2(0);
        dfs_check(0);
        long long ans_sum = 0;
        for (int i = 0; i < n; ++i) {
            ans_sum += (long long)ans_cnt[i] * cost[i];
            if (!(lb[i] <= overall[i] && overall[i] <= rb[i])) return 1303;
        }
        cout << ans_sum << "\n";
        for (int i = 0; i < n; ++i) {
            cout << ans_cnt[i] << " ";
        }
        cout << "\n";
    }
}
