#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;

#define int ll
#define len(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

template<typename T, typename comparator = less<T>>
using ordered_set = tree<T,
                         null_type,
                         comparator,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;


template<typename T>
istream & operator>> (istream & is, vector<T> & v) {
    for (T & e : v)
        is >> e;
    return is;
}


int n;
bool err;
vector<vector<int>> g;
vector<int> c, subtree_l, subtree_r, b;


struct item {
    int amount, i;

    item (int amount, int i): amount(amount), i(i) {}

    void buy (int t) {
        b[i] += t;
        amount -= t;
    }
};

struct prices {
    int total_size = 0;
    map<int, pair<int, vector<item>>> p;

    int buy_t_cheapest (int t, int max_price) {
        vector<int> schedule_delete;
        int bought = 0;
        for (auto & [price, it] : p) {
            auto & [items_cnt, items] = it;
            if (price >= max_price) {
                total_size -= items_cnt;
                schedule_delete.push_back(price);
                continue;
            }
            if (bought + items_cnt < t) {
                // Buy everything of this price
                schedule_delete.push_back(price);
                total_size -= items_cnt;
                for (auto & item : items) {
                    item.buy(item.amount);
                }
                bought += items_cnt;
            } else {
                // Buy t - bought
                auto & item = items.back();
                while (bought < t) {
                    if (bought + item.amount <= t) {
                        // Buy item stock entirely
                        bought += item.amount;
                        items_cnt -= item.amount;
                        total_size -= item.amount;
                        item.buy(item.amount);
                        items.pop_back();
                        item = items.back();
                    } else {
                        // Buy part of item stock
                        int remaining = t - bought;
                        items_cnt -= remaining;
                        total_size -= remaining;
                        item.buy(remaining);
                        bought = t;
                    }
                }
            }
        }
        for (int price : schedule_delete)
            p.erase(price);
        return bought;
    }

    void shrink_to_t (int t) {
        vector<int> schedule_delete;
        int current_size = 0;
        for (auto & [price, it] : p) {
            auto & [items_cnt, items] = it;
            if (current_size >= t) {
                schedule_delete.push_back(price);
                total_size -= items_cnt;
                continue;
            }
            if (current_size + items_cnt <= t) {
                // Keep everything
                current_size += items_cnt;
            } else {
                // Keep t - current_size items
                int remaining_space = t - current_size;
                total_size -= items_cnt - remaining_space;
                auto & item = items.back();
                while (items_cnt > remaining_space) {
                    if (items_cnt - item.amount >= remaining_space) {
                        // Remove item
                        items_cnt -= item.amount;
                        items.pop_back();
                        item = items.back();
                    } else {
                        int extra = items_cnt - remaining_space;
                        item.amount -= extra;
                        items_cnt = remaining_space;
                    }
                }
            }
        }
        for (int price : schedule_delete)
            p.erase(price);
    }

    void add_to_t (int t, int item_price, int i) {
        if (total_size >= t)
            return;
        p[item_price].second.emplace_back(t - total_size, i);
        p[item_price].first += t - total_size;
        total_size = t;
    }

    void extend_with (prices * o, int max_price) {
        for (auto & [price, it] : o->p) {
            if (price >= max_price)
                break;
            auto & [items_cnt, items] = it;
            p[price].first += items_cnt;
            total_size += items_cnt;
            for (auto & item : items)
                p[price].second.push_back(item);
        }
    }
};

pair<int, prices *> buy_necessary(int v) {
    prices * p = nullptr;
    int bought = 0;
    for (int u : g[v]) {
        auto [child_bought, child_prices] = buy_necessary(u);
        bought += child_bought;
        if (p != nullptr) {
            p->extend_with(child_prices, c[v]);
            delete child_prices;
        } else {
            p = child_prices;
        }
    }
    if (p == nullptr)
        p = new prices;
    if (bought > subtree_r[v]) {
        err = true;
    }
    bought += p->buy_t_cheapest(subtree_l[v] - bought, c[v]);
    if (bought < subtree_l[v]) {
        b[v] += subtree_l[v] - bought;
        bought = subtree_l[v];
    }
    int diff = subtree_r[v] - subtree_l[v];
    if (diff == 0) {
        return {bought, new prices};
    }
    p->shrink_to_t(diff);
    p->add_to_t(diff, c[v], v);
    return {bought, p};
}


void clear() {
    g.clear();
    g.shrink_to_fit();
    c.clear();
    c.shrink_to_fit();
    b.clear();
    b.shrink_to_fit();
    subtree_l.clear();
    subtree_l.shrink_to_fit();
    subtree_r.clear();
    subtree_r.shrink_to_fit();
}

void solve() {
    cin >> n;
    err = false;
    g.resize(n);
    c.resize(n);
    subtree_l.resize(n);
    subtree_r.resize(n);
    b.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    cin >> c;
    for (int i = 0; i < n; ++i) {
        cin >> subtree_l[i] >> subtree_r[i];
    }

    buy_necessary(0);
    if (err) {
        cout << "-1\n";
        return;
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += b[i] * c[i];
    }
    cout << ans << "\n";
    for (int bi : b)
        cout << bi << " ";
    cout << "\n";
    clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}
