#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;

#define int ll
#define len(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

template<typename T, typename comparator = less<T>>
using ordered_set = tree<T,
                         null_type,
                         comparator,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;


template<typename T>
istream & operator>> (istream & is, vector<T> & v) {
    for (T & e : v)
        is >> e;
    return is;
}


int n;
vector<vector<int>> g;
vector<int> c, subtree_l, subtree_r, node_l, b;


void calc_node_l_r(int v) {
    int sum_child_tree_l = 0, sum_child_tree_r = 0;
    for (int u : g[v]) {
        calc_node_l_r(u);
        sum_child_tree_l += subtree_l[u];
        sum_child_tree_r += subtree_r[u];
    }
    subtree_l[v] = max(subtree_l[v], sum_child_tree_l);
    node_l[v] = max(0ll, subtree_l[v] - sum_child_tree_r);
}


int buy_node_l(int v) {
    int bought = 0;
    for (int u : g[v]) {
        bought += buy_node_l(u);
    }
    bought += node_l[v];
    b[v] += node_l[v];
    subtree_l[v] -= bought;
    subtree_r[v] -= bought;
    return bought;
}


map<int, vector<pair<int, int>>> dfs(int v) {
    map<int, vector<pair<int, int>>> prices;
    for (int u : g[v]) {
        for (const auto & [price, nodes] : dfs(u)) {
            if (price >= c[v])
                break;
            for (const auto & node : nodes) {
                prices[price].push_back(node);
            }
        }
    }
    // Buy necessary
    int current_bought = 0;
    vector<int> schedule_delete;
    for (auto & [key, values] : prices) {
        if (current_bought >= subtree_l[v])
            continue;
        while (!values.empty() && current_bought < subtree_l[v]) {
            auto & value = values.back();
            if (current_bought + value.first <= subtree_l[v]) {
                current_bought += value.first;
                b[value.second] += value.first;
                values.pop_back();
            } else {
                int necessary_left = subtree_l[v] - current_bought;
                current_bought += necessary_left;
                b[value.second] += necessary_left;
                value.first -= necessary_left;
            }
        }
        if (values.empty())
            schedule_delete.push_back(key);
    }
    if (current_bought < subtree_l[v]) {
        b[v] += subtree_l[v] - current_bought;
    }
    for (int to_del : schedule_delete)
        prices.erase(to_del);
    schedule_delete.clear();

    // Remove extra
    int cur_left = 0, max_left = subtree_r[v] - subtree_l[v];
    for (auto & [key, values] : prices) {
        if (cur_left >= max_left) {
            schedule_delete.push_back(key);
            continue;
        }
        int sum_amount = 0;
        for (auto & value : values) {
            sum_amount += value.first;
        }
        if (cur_left + sum_amount > max_left) {
            auto last_to_keep = values.begin();
            while (cur_left < max_left) {
                if (cur_left + last_to_keep->first < max_left) {
                    cur_left += last_to_keep->first;
                    ++last_to_keep;
                } else {
                    int diff = max_left - cur_left;
                    last_to_keep->first -= diff;
                    cur_left = max_left;
                }
            }
            while (last_to_keep != values.end())
                values.pop_back();
        }
    }
    for (int to_del : schedule_delete)
        prices.erase(to_del);
    if (cur_left < max_left) {
        prices[c[v]].emplace_back(max_left - cur_left, v);
    }
    return prices;
}


void clear() {
    g.clear();
    g.shrink_to_fit();
    c.clear();
    c.shrink_to_fit();
    b.clear();
    b.shrink_to_fit();
    subtree_l.clear();
    subtree_l.shrink_to_fit();
    subtree_r.clear();
    subtree_r.shrink_to_fit();
    node_l.clear();
    node_l.shrink_to_fit();
}

void solve() {
    cin >> n;
    g.resize(n);
    c.resize(n);
    subtree_l.resize(n);
    subtree_r.resize(n);
    node_l.resize(n);
    b.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    cin >> c;
    for (int i = 0; i < n; ++i) {
        cin >> subtree_l[i] >> subtree_r[i];
    }
    calc_node_l_r(0);
    for (int i = 0; i < n; ++i) {
        if(subtree_l[i] > subtree_r[i]) {
            cout << "-1\n";
            return;
        }
    }
    buy_node_l(0);
    dfs(0);
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += b[i] * c[i];
    }
    cout << ans << "\n";
    for (int bi : b)
        cout << bi << " ";
    cout << "\n";
    clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}
