#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;

ostream& operator<<(ostream& out, const vector<int>& v) {
    for (int i : v) {
        out << i << ' ';
    }
    return out;
}

void dfs(int v, vvi& ch, const vi& c, const vi& l, const vi& r, vi& minc, vi& b) {
    minc[v] = v;
    int suml = 0;
    for (int i : ch[v]) {
        suml += l[i];
        dfs(i, ch, c, l, r, minc, b);
        if (c[minc[v]] > c[minc[i]]) {
            minc[v] = minc[i];
        }
    }
    if (suml < l[v]) {
        b[minc[v]] += l[v] - suml;
    }
}

void solve() {
    int n;
    cin >> n;
    vi p(n, -1), c(n), l(n), r(n), b(n, 0), minc(n);
    vvi ch(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        ch[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(0, ch, c, l, r, minc, b);

    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += b[i] * 1LL * c[i];
    }
    cout << ans << '\n';
    cout << b << '\n';
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }
    return 0;
}
