#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
using namespace std;

#define endl '\n'
#define int long long

struct Node
{
	vector<int> to;
	int l, r, x;

	int cost;

	map<pair<int, int>, int> m;

	int parent = -1;
	int pl = 0;
};

vector<Node> graph;

int ans = 0;
bool isans = true;

map<pair<int, int>, int> dfs(int v)
{
	map<pair<int, int>, int> here;

	for (int i = 0; i < graph[v].to.size(); i++)
	{
		int u = graph[v].to[i];

		map<pair<int, int>, int> m = dfs(u);
		graph[v].x += graph[u].x;

		if (here.size() < m.size())
		{
			swap(here, m);
		}

		for (auto it = m.begin(); it != m.end(); it++)
		{
			here[it->first] = it->second;
		}
	}

	if (graph[v].x > graph[v].r)
	{
		isans = false;
	}

	if (graph[v].x < graph[v].r)
	{
		here[{graph[v].cost, v}] = graph[v].r - graph[v].x;
	}

	int need = max((int)0, graph[v].l - graph[v].x);

	while (need != 0 && here.size() > 0)
	{
		pair<int, int> p = (*here.begin()).first;
		int u = p.second;
		int pr = p.first;
		int left = here[p];

		int er;

		if (left < need)
		{
			er = left;
			need -= left;
		}
		else
		{
			er = need;
			need = 0;
		}

		ans += er * pr;
		graph[v].x += er;

		int cur = u;
		graph[u].pl += er;
		while (cur != graph[v].parent)
		{
			pair<int, int> pa = { graph[cur].cost, cur };

			here[pa] -= er;
			if (here[pa] == 0)
			{
				here.erase(pa);
			}

			cur = graph[cur].parent;
		}
	}

	if (graph[v].x < graph[v].l)
	{
		isans = false;
	}

	for (auto it = here.begin(); it != here.end(); it++)
	{
		it->second = min(it->second, graph[v].r - graph[v].x);
	}

	return here;
}

void task()
{
	graph.clear();
	ans = 0;
	isans = true;

	int n;
	cin >> n;

	graph.resize(n);

	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;

		graph[x - 1].to.push_back(i);
		graph[i].parent = x - 1;
	}

	for (int i = 0; i < n; i++)
	{
		cin >> graph[i].cost;
	}

	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;

		graph[i].l = l;
		graph[i].r = r;
	}

	dfs(0);

	if (isans)
	{
		cout << ans << endl;

		for (int i = 0; i < n; i++)
		{
			cout << graph[i].pl << ' ';
		}
		cout << endl;
	}
	else
	{
		cout << -1 << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--)
	{
		task();
	}

	return 0;
}
