#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <queue>
#include <set>
#include <unordered_set>
using namespace std;

#define endl '\n'
#define int long long

#pragma GCC optimize("Ofast")

struct Node
{
	vector<int> to;
	int l, r, x;

	int cost;

	map<pair<int, int>, int> m;

	int parent = -1;
	int pl = 0;

	int tin = -1;
	int tout = -1;
    pair<int, int> minsub;
};

vector<Node> graph;

long long ans = 0;
bool isans = true;

void dfs2(int v)
{
	graph[v].minsub = { graph[v].cost, v };

	for (int i = 0; i < graph[v].to.size(); i++)
	{
		int u = graph[v].to[i];
		dfs2(u);
		graph[v].x += graph[u].x;

		graph[v].minsub = min(graph[v].minsub, graph[u].minsub);
	}

	if (graph[v].x < graph[v].l)
	{
		int add = graph[v].l - graph[v].x;

		graph[v].x += add;

		graph[graph[v].minsub.second].pl += add;
		ans += add * graph[v].minsub.first;
	}
}

void task2()
{
	graph.clear();
	ans = 0;
	isans = true;

	int n;
	cin >> n;

	graph.resize(n);

	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;

		graph[x - 1].to.push_back(i);
		graph[i].parent = x - 1;
	}

	for (int i = 0; i < n; i++)
	{
		cin >> graph[i].cost;
	}

	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;

		graph[i].l = l;
		graph[i].r = r;
	}

	dfs2(0);

	if (isans)
	{
		cout << ans << endl;

		for (int i = 0; i < n; i++)
		{
			cout << graph[i].pl << ' ';
		}
		cout << endl;
	}
	else
	{
		cout << -1 << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--)
	{
		task2();
	}

	return 0;
}

/*
1
5
1 1 3 3
5 1 3 4 3
10 1000000000
1 1000000000
4 1000000000
2 1000000000
1 1000000000
*/