#include <bits/stdc++.h>

using namespace std;

struct node {
    int val = 0;
    node* l = nullptr;
    node* r = nullptr;
    node() {}
    node(int val): val(val) {}
    node(node* l, node* r): l(l), r(r) {val = l -> val + r -> val;}
};

int n;

node* build(int L = 0, int R = n) {
    if (L + 1 == R) {
        return new node(0);
    }
    int m = (L + R) / 2;
    return new node(build(L, m), build(m, R));
}

node* inc(node* tree, int qi, int L = 0, int R = n) {
    if (qi < L || R <= qi) return tree;
    if (L + 1 == R) {
        return new node(tree -> val + 1);
    }
    int m = (L + R) / 2;
    return new node(inc(tree -> l, qi, L, m), inc(tree -> r, qi, m, R));
}

int getsum(node* tree, int qL, int qR, int L = 0, int R = n) {
    if (qR <= L || R <= qL) return 0;
    if (qL <= L && R <= qR) return tree -> val;
    int m = (L + R) / 2;
    return getsum(tree -> l, qL, qR, L, m) + getsum(tree -> r, qL, qR, m, R);
}

vector<node*> p;

bool wasonpath(int x, int y, int t) {
    return getsum(p[t], 0, x) >= x - y;
}

int firsttime(int x, int y) {
    int L = -1, R = n;
    while (L + 1 < R) {
        int m = (L + R) / 2;
        if (wasonpath(x, y, m)) {
            R = m;
        } else {
            L = m;
        }
    }
    return R;
}

bool tobeonpath(int x, int y, int t) {
    return getsum(p[t], 0, x) <= x - y;
}

int lasttime(int x, int y) {
    int L = 0, R = n + 1;
    while (L + 1 < R) {
        int m = (L + R) / 2;
        if (tobeonpath(x, y, m)) {
            L = m;
        } else {
            R = m;
        }
    }
    return L;
}

signed main() {
    cin >> n;
    vector<int> a (n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] -= 1;
    }
    p = vector<node*> (n + 1);
    p[0] = build(0, n);
    for (int i = 0; i < n; ++i) {
        p[i + 1] = inc(p[i], a[i], 0, n);
    }
    int q; cin >> q;
    while (q--) {
        int x1, y1; cin >> x1 >> y1;
        int x2, y2; cin >> x2 >> y2;
        int l1 = firsttime(x1, y1);
        int r1 = lasttime(x1, y1);
        int l2 = firsttime(x2, y2);
        int r2 = lasttime(x2, y2);
        if (max(l1, l2) <= min(r1, r2)) {
            if (x1 < x2) {
                cout << x1 << ' ' << y1 << '\n';
            } else {
                cout << x2 << ' ' << y2 << '\n';
            }
            continue;
        }
        int l = min(r1, r2);
        int r = max(l1, l2);
        int h = 1e9 + 1329;
        for (int i = l; i < r; ++i) {
            h = min(h, a[i]);
        }
        cout << h << ' ' << h - getsum(p[l1], 0, h) << '\n';
    }
}