#include "bits/stdc++.h"
#define ll long long
#define ld long double

using namespace std;

vector<set<ll>> gr;
vector<ll> lca;
vector<ll> lca_opt;
ll n;
const ll nDeg = 16777216;
vector<ll> tree(nDeg * 2);

void build(ll v, ll lv, ll rv){
    if (lv == rv)
        return;
    ll vmid = (lv + rv) / 2;
    build(v * 2, lv, vmid);
    build(v * 2 + 1, vmid + 1, rv);
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

ll getMin(ll v, ll lv, ll rv, ll lq, ll rq){
    if(lv > rq or rv < lq)
        return LLONG_MAX;
    if(lv >= lq and rv <= rq){
        return tree[v];
    }
    ll vmid = (lv + rv) / 2;
    return min(getMin(v * 2, lv, vmid, lq, rq),
               getMin(v * 2 + 1, vmid + 1, rv, lq, rq));
}

ll ctv(ll r, ll c){
    return (r) * (r + 1) / 2 + c;
}

void write_path(vector<bool> &p){
    ll r = 0;
    ll c = 0;
    for (int i = 0; i < n; ++i) {
        if(!p[i]){
            gr[ctv(r, c)].emplace(ctv(r + 1, c + 1));
            r++;
            c++;
        }else{
            gr[ctv(r, c)].emplace(ctv(r + 1, c));
            r++;
        }
    }
}

vector<bool> was;

void cr_lca(ll v){
    if(was[v])
        return;
    was[v] = true;
    lca.emplace_back(v);
    for(auto h : gr[v]){
        cr_lca(h);
        lca.emplace_back(v);
    }
}

int main() {
    cin >> n;
    ll k;
    vector<ll> a(n);
    bool t_g = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if(a[i] != i + 1)
            t_g = false;
        if(a[i] == n)
            k = i;
    }
    ll q;
    cin >> q;
    if(n > 3000) {
        if (t_g) {
            while (q--) {
                ll r1, c1, r2, c2;
                cin >> r1 >> c1 >> r2 >> c2;
                ll l1 = n - r1 + c1;
                ll l2 = n - r2 + c2;
                if (l1 != l2) {
                    cout << n - max(l1, l2) << " 0" << endl;
                } else {
                    cout << min(r1, r2) << " " << min(c1, c2) << endl;
                }
            }
        } else {
            while (q--) {
                ll r1, c1, r2, c2;
                cin >> r1 >> c1 >> r2 >> c2;
                ll l1 = n - r1 + c1;
                ll l2 = n - r2 + c2;
                bool ink1 = l1 <= n - k;
                bool ink2 = l2 <= n - k;
                if (ink1 and ink2) {
                    ll l1k = c1;
                    ll l2k = c2;
                    if (l1k != l2k) {
                        cout << k + min(l1k, l2k) << " " << min(l1k, l2k) << endl;
                    } else {
                        cout << min(r1, r2) << " " << c1 << endl;
                    }
                } else if (!ink1 and !ink2) {
                    if (l1 != l2) {
                        cout << n - max(l1, l2) << " 0" << endl;
                    } else {
                        cout << min(r1, r2) << " " << min(c1, c2) << endl;
                    }
                } else if (ink1) {
                    c1 = 0;
                    r1 = k;
                    l1 = n - r1 + c1;
                    if (l1 != l2) {
                        cout << n - max(l1, l2) << " 0" << endl;
                    } else {
                        cout << min(r1, r2) << " " << min(c1, c2) << endl;
                    }
                } else {
                    c2 = 0;
                    r2 = k;
                    l2 = n - r2 + c2;
                    if (l1 != l2) {
                        cout << n - max(l1, l2) << " 0" << endl;
                    } else {
                        cout << min(r1, r2) << " " << min(c1, c2) << endl;
                    }
                }
            }
        }
    }else{
        ll sz = (n + 1) * (n + 2) / 2;
        was.assign(sz, false);
        gr.assign(sz, set<ll>());
        lca_opt.assign(sz, LLONG_MAX);
        vector<bool> an(n, false);
        write_path(an);
        for (int i = 0; i < n; ++i) {
            an[a[i] - 1] = true;
            write_path(an);
        }
        cr_lca(0);
        for (ll i = 0; i < lca.size(); ++i) {
            lca_opt[lca[i]] = min(lca_opt[lca[i]], i);
        }
        for (int i = 0; i < lca.size(); ++i) {
            tree[nDeg + i] = lca[i];
        }
        build(1, 0, nDeg - 1);
        while(q--){
            ll r1, c1, r2, c2;
            cin >> r1 >> c1 >> r2 >> c2;
            ll f1 = lca_opt[ctv(r1, c1)];
            ll f2 = lca_opt[ctv(r2, c2)];
            ll g = getMin(1, 0, nDeg - 1, min(f1, f2), max(f1, f2));
            ll line = 0;
            while ((line + 1) * (line + 2) / 2 < g)
                line++;
            cout << line << " " << g - (line + 1) * (line) / 2 << endl;

        }
    }
    return 0;
}
