#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast,unroll-loops")

#define endl '\n'
#define F first
#define S second

typedef long long ll;
typedef long double ld;

using namespace std;

const int R = 1 << 18;
vector <int> p[R * 2 + 10];

void build() {
    for (int i = R - 1; i > 0; i--) {
        int l = 0, r = 0;
        while (l < p[2 * i].size() && r < p[2 * i + 1].size()) {
            if (p[2 * i][l] < p[2 * i + 1][r]) {
                p[i].push_back(p[2 * i][l]);
                l++;
            }
            else {
                p[i].push_back(p[2 * i + 1][r]);
                r++;
            }
        }
        while (l < p[2 * i].size()) {
            p[i].push_back(p[2 * i][l]);
            l++;
        }
        while (r < p[2 * i + 1].size()) {
            p[i].push_back(p[2 * i + 1][r]);
            r++;
        }
    }
}

int query(int ql, int qr, int k, int node = 1, int nl = 0, int nr = R - 1) {
    if (qr < nl || nr < ql)
        return 0;
    if (ql <= nl && nr <= qr)
        return lower_bound(p[node].begin(), p[node].end(), k) - p[node].begin();
    int nm = (nl + nr) / 2;
    return query(ql, qr, k, node * 2, nl, nm) + query(ql, qr, k, node * 2 + 1, nm + 1, nr);
}

int query1(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
    if (qr < nl || nr < ql)
        return 0;
    if (ql <= nl && nr <= qr) {
        if (p[node].size() == 0)
            return 0;
        return p[node][0];
    }
    int nm = (nl + nr) / 2;
    return min(query1(ql, qr, node * 2, nl, nm), query1(ql, qr,  node * 2 + 1, nm + 1, nr));
}

void run() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        int c;
        cin >> c;
        p[R + i] = {c};
    }
    build();

    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int l = -1, r = n + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (query(0, m, a) < b)
                l = m;
            else
                r = m;
        }
        int ans1 = r;
        l = -1, r = n + 1;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            if (query(0, m, c) < d)
                l = m;
            else
                r = m;
        }
        int ans2 = r;
        int ans = query1(ans1, ans2);
        int t = query(ans1, ans2, ans - 1);
        cout << ans - 1 << ' ' << t << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt;
    cin >> tt;
    while (tt--)
        run();
}
