// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <math.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

#define X first
#define Y second
#define All(t) (t).begin(), (t).end()

vector<vector<ll>> gr;
vector<ll> c, l, r, ans, dp, cnt;
vector<vector<pii>> add; //vertex, cnt

bool ok = true;

bool cmp(pii& a, pii& b) {
	return c[a.X] > c[b.X];
}

void dfs(ll v) {
	dp[v] = 0;
	cnt[v] = 0;
	for (auto u : gr[v]) {
		dfs(u);
		dp[v] += dp[u];
		cnt[v] += cnt[u];
		for (auto var : add[u])
			add[v].push_back(var);
	}
	if(r[v] > cnt[v])
		add[v].push_back({ v, r[v] - cnt[v] });
	sort(All(add[v]), cmp);
	ll need = l[v] - cnt[v];
	while (!add[v].empty() && need > 0) {
		pii var = add[v].back();
		if (var.Y <= need) {
			need -= var.Y;
			ans[var.X] += var.Y;
			cnt[v] += var.Y;
			dp[v] += var.Y * c[var.X];
			add[v].pop_back();
		}
		else {
			add[v].back().Y -= need;
			ans[var.X] += need;
			cnt[v] += need;
			dp[v] += need * c[var.X];
			need = 0;
		}
	}
	if (need > 0 || cnt[v] < l[v] || cnt[v] > r[v])
		ok = false;
	vector<pii> cur = add[v];
	add[v].clear();
	ll overall = 0;
	while (!cur.empty() && overall < r[v]) {
		pii var = cur.back();
		cur.pop_back();
		ll put = min(r[v] - overall, var.Y);
		add[v].emplace_back(var.X, put);
	}
}

void solve() { //todo init
	ll n, p;
	cin >> n;
	gr.resize(n);
	c.resize(n);
	l.resize(n);
	r.resize(n);
	dp.resize(n);
	cnt.resize(n);
	add.resize(n);
	ans.assign(n, 0);
	for (ll i = 1; i < n; i++) {
		cin >> p;
		p--;
		gr[p].push_back(i);
	}
	for (ll i = 0; i < n; i++)
		cin >> c[i];
	for (ll i = 0; i < n; i++)
		cin >> l[i] >> r[i];
	dfs(0);
	if (!ok) {
		cout << "-1\n";
		return;
	}
	cout << dp[0] << '\n';
	for (auto f : ans)
		cout << f << ' ';
	cout << '\n';
}

void init() {
	ok = true;
	gr.clear();
	c.clear();
	l.clear();
	r.clear();
	dp.clear();
	cnt.clear();
	add.clear();
	ans.clear();
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		init();
		solve();
	}
}