// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <math.h>
#include <set>

using namespace std;

#pragma GCC optimize("Ofast,no-stack-protector,tune=native")
#pragma GCC optimize("O2")
#pragma GCC optimize("avx,avx2,sse,see2,sse3,sse3,ssse3")
#pragma GCC optimize("unroint-loops,fast-math,section-anchors")


typedef long long ll;
typedef pair<int, int> pii;

#define X first
#define Y second
#define Aint(t) (t).begin(), (t).end()

vector<vector<int>> gr;
vector<int> c, l, r, ans, cnt;
vector<ll> dp;
struct comparer {
	bool operator()(const pii& a, const pii& b) const {
		return c[a.X] < c[b.X];
	}
};
vector<multiset<pii, comparer>> add; //vertex, cnt

bool ok = true;

void dfs(int v) {
	dp[v] = 0;
	cnt[v] = 0;
	multiset<pii, comparer> cur;
	for (auto u : gr[v]) {
		dfs(u);
		dp[v] += dp[u];
		cnt[v] += cnt[u];
		if (add[u].size() > cur.size())
			swap(add[u], cur);
		for (pii var : add[u])
			cur.insert(var);
	}
	if (r[v] > cnt[v])
		cur.insert({ v, r[v] - cnt[v] });
	int need = l[v] - cnt[v];
	while (!cur.empty() && need > 0) {
		pii var = *cur.begin();
		cur.erase(cur.begin());
		if (var.Y <= need) {
			need -= var.Y;
			ans[var.X] += var.Y;
			cnt[v] += var.Y;
			dp[v] += 1ll * var.Y * c[var.X];
		}
		else {
			cur.insert({ var.X, var.Y - need });
			ans[var.X] += need;
			cnt[v] += need;
			dp[v] += 1ll * need * c[var.X];
			need = 0;
		}
	}
	if (need > 0 || cnt[v] < l[v] || cnt[v] > r[v])
		ok = false;
	int overaint = 0;
	for (pii var : cur) {
		if (overaint + cnt[v] >= r[v]) break;
		int put = min(r[v] - overaint - cnt[v], var.Y);
		overaint += put;
		add[v].insert({ var.X, put });
	}
}

void solve() {
	int n, p;
	cin >> n;
	gr.resize(n);
	c.resize(n);
	l.resize(n);
	r.resize(n);
	dp.resize(n);
	cnt.resize(n);
	add.resize(n);
	ans.assign(n, 0);
	for (int i = 1; i < n; i++) {
		cin >> p;
		p--;
		gr[p].push_back(i);
	}
	for (int i = 0; i < n; i++)
		cin >> c[i];
	for (int i = 0; i < n; i++)
		cin >> l[i] >> r[i];
	dfs(0);
	if (!ok) {
		cout << "-1\n";
		return;
	}
	cout << dp[0] << '\n';
	for (auto f : ans)
		cout << f << ' ';
	cout << '\n';
}

void init() {
	ok = true;
	gr.clear();
	c.clear();
	l.clear();
	r.clear();
	dp.clear();
	cnt.clear();
	add.clear();
	ans.clear();
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		init();
		solve();
	}
}