#include <iostream>
#include <cassert>
#include <vector>

using namespace std;
using graph_t = vector<vector<int>>;

const int NO_VERTEX = -1;

int main() {
    int n; cin >> n;
    vector<int> parents((n + 1) * (n + 1), NO_VERTEX);
    auto get_index = [&](int r, int c) {
        return r * (n + 1) + c;
    };
    vector<int> as(n);
    for (int i = 0; i < n; i++) {
        cin >> as[i];
        as[i]--;
    }
    vector<bool> right(n, true);
    for (int i = 0; i <= n; i++) {
        int r = 0, c = 0;
        for (int j = 0; j < n; j++) {
            int r_new = r + 1;
            int c_new = c;
            if (right[j]) {
                c_new++;
            }
            int v = get_index(r, c), u = get_index(r_new, c_new);
            assert(parents[u] == -1 || parents[u] == v);
            parents[u] = v;
            r = r_new;
            c = c_new;
        }
        if (i != n) {
            right[as[i]] = false;
        }
    }
    vector<int> depths((n + 1) * (n + 1));
    for (int v = 0; v < (n + 1) * (n + 1); v++) {
        depths[v] = (parents[v] == -1 ? 0 : depths[parents[v]] + 1);
        if (parents[v] == -1) {
            parents[v] = 0;
        }
    }
    auto LCA = [&](int v, int u) {
        while (depths[v] > depths[u]) {
            v = parents[v];
        }
        while (depths[u] > depths[v]) {
            u = parents[u];
        }
        while (v != u) {
            v = parents[v];
            u = parents[u];
        }
        return v;
    };
    int q; cin >> q;
    while (q--) {
        int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
        int v = get_index(r1, c1), u = get_index(r2, c2);
        int w = LCA(v, u);
        int r = w / (n + 1), c = w % (n + 1);
        cout << r << ' ' << c << endl;
    }
}
