#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

vector<vector<int>>g;
vector<short int>ind;

void dfs(pair<int, int>cell, int l, int r, int i = 0) {
	if (i == ind.size())
		return;
	int v = cell.second + (cell.first + 1) * cell.first / 2;
	int change = ind[i];
	pair<int, int>cell_l = cell, cell_r = cell;
	cell_l.first++;
	cell_r.first++, cell_r.second++;
	if (r <= change) {
		g[v].push_back(cell_r.first * (cell_r.first + 1) / 2 + cell_r.second);
		dfs(cell_r, l, r, i + 1);
		return;
	}
	if (change <= l) {
		g[v].push_back(cell_l.first * (cell_l.first + 1) / 2 + cell_l.second);
		dfs(cell_l, l, r, i + 1);
		return;
	}
	g[v].push_back(cell_r.first * (cell_r.first + 1) / 2 + cell_r.second);
	g[v].push_back(cell_l.first * (cell_l.first + 1) / 2 + cell_l.second);
	dfs(cell_r, l, change, i + 1);
	dfs(cell_l, change, r, i + 1);
}

vector<vector<int>>up;
vector<int>tin, tout;
int tme = 0;

void build(int v = 0, int p = 0) {
	up[0][v] = p;
	for (int i = 1; i < 20; i++) {
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	tin[v] = tme++;
	for (auto u : g[v]) {
		build(u, v);
	}
	tout[v] = tme++;
}

bool is_pr(int v, int p) {
	return tin[p] <= tin[v] && tout[v] <= tout[p];
}

void solve() {
	int n; cin >> n;
	ind.resize(n);
	for (int i = 0; i < n; i++) {
		int x; cin >> x; x--;
		ind[x] = i + 1;
	}
	int cnt = (n + 1) * (n + 2) / 2;
	g.resize(cnt);
	dfs({ 0, 0 }, 0, n + 1);
	ind.clear();
	ind.shrink_to_fit();
	for (auto& i : g)
		i.shrink_to_fit();
	tin.resize(cnt);
	tout.resize(cnt);
	up.resize(20, vector<int>(cnt));
	build();
	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int v1 = c1 + r1 * (r1 + 1) / 2, v2 = c2 + r2 * (r2 + 1) / 2;
		if (is_pr(v1, v2)) {
			cout << r2 << ' ' << c2 << '\n';
		}
		else if (is_pr(v2, v1)) {
			cout << r1 << ' ' << c1 << '\n';
		}
		else {
			for (int i = 19; i >= 0; i--)
				if (!is_pr(v1, up[i][v2]))
					v2 = up[i][v2];
			v2 = up[0][v2];
			int l = 0, r = n;
			while (l + 1 != r) {
				int m = (l + r) / 2;
				if (v2 >= m * (m + 1) / 2)
					l = m;
				else
					r = m;
			}
			cout << l << ' ' << v2 - l * (l + 1) / 2 << '\n';
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}