#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;

vector<vector<int>>code;
vector<pair<int, int>>decode;
vector<vector<int>>g;
vector<int>ind;

void dfs(pair<int, int>cell, int l, int r, int i = 0) {
	if (i == ind.size())
		return;
	int v = code[cell.first][cell.second];
	int change = ind[i];
	pair<int, int>cell_l = cell, cell_r = cell;
	cell_l.first++;
	cell_r.first++, cell_r.second++;
	if (r <= change) {
		g[v].push_back(code[cell_r.first][cell_r.second]);
		dfs(cell_r, l, r, i + 1);
		return;
	}
	if (change <= l) {
		g[v].push_back(code[cell_l.first][cell_l.second]);
		dfs(cell_l, l, r, i + 1);
		return;
	}
	g[v].push_back(code[cell_r.first][cell_r.second]);
	g[v].push_back(code[cell_l.first][cell_l.second]);
	dfs(cell_r, l, change, i + 1);
	dfs(cell_l, change, r, i + 1);
}

vector<vector<int>>up;
vector<int>tin, tout;
int tme = 0;

void build(int v = 0, int p = 0) {
	up[0][v] = p;
	for (int i = 1; i < 20; i++) {
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	tin[v] = tme++;
	for (auto u : g[v]) {
		build(u, v);
	}
	tout[v] = tme++;
}

bool is_pr(int v, int p) {
	return tin[p] <= tin[v] && tout[v] <= tout[p];
}

void solve() {
	int n; cin >> n;
	ind.resize(n);
	code.resize(n + 1);
	for (int i = 0; i < n; i++) {
		int x; cin >> x; x--;
		ind[x] = i + 1;
	}
	int cnt = 0;
	for (int level = 0; level <= n; level++) {
		for (int i = 0; i <= level; i++) {
			decode.push_back({ level, i });
			code[level].push_back(cnt++);
		}
	}
	g.resize(cnt);
	dfs({ 0, 0 }, 0, n + 1);
	tin.resize(cnt);
	tout.resize(cnt);
	up.resize(20, vector<int>(cnt));
	build();
	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int v1 = code[r1][c1], v2 = code[r2][c2];
		if (is_pr(v1, v2)) {
			cout << r2 << ' ' << c2 << '\n';
		}
		else if (is_pr(v2, v1)) {
			cout << r1 << ' ' << c1 << '\n';
		}
		else {
			for (int i = 19; i >= 0; i--)
				if (!is_pr(v1, up[i][v2]))
					v2 = up[i][v2];
			v2 = up[0][v2];
			pair<int, int>res = decode[v2];
			cout << res.first << ' ' << res.second << '\n';
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}