//#pragma GCC optimize("Ofast")
//#pragma unroll-loops
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <deque>
#include <set>

using namespace std;

#define int long long
#define VI vector<int>
#define sz size
#define pb push_back
#define pp pop_back
#define foriab(i, a, b) for(int i=(a);i<(b);++i)
#define fori(i, n) foriab(i, 0, n)
#define foris(i, s) fori(i, s.sz())
#define x first
#define y second
#define VVI vector<VI>
#define VVVI vector<VVI>
#define INF 10000000000000LL
#define PII pair<int, int>
#define PAR PII
#define VP vector<PAR>
#define SP set<PAR>
#define SI set<int>
#define MII map<int, int>
#define endl '\n'
#define endlf endl<<flush
#define DI deque<int>
#define DP deque<PAR>
#define pf push_front
#define ppf pop_front
#define ins insert
#define era erase

template<class A, class B> istream& operator>>(istream& a, pair<A, B>& v){
	return a>>v.x>>v.y;
}
template<class A, class B> ostream& operator<<(ostream& a, const pair<A, B>& v){
	return a<<v.x<<' '<<v.y<<endl;
}
template<class A> istream& operator>>(istream& a, vector<A>& v){
	for(auto& x:v){
		a>>x;
	}
	return a;
}
template<class A> ostream& operator<<(ostream& a, const vector<A>& v){
	for(const auto& x:v){
		a<<x<<' ';
	}
	return a<<endl;
}
int mabs(int x){
	return x<0?-x:x;
}
template<class A, class B> bool rmax(A& a, const B& b){
	A tmp=b;
	if(a<tmp){
		a=move(tmp);
		return 1;
	}
	return 0;
}
template<class A, class B> bool rmin(A& a, const B& b){
	A tmp=b;
	if(a>tmp){
		a=move(tmp);
		return 1;
	}
	return 0;
}
int n;
VI a;
#define Node_idx int
struct Node{
	Node_idx l;
	Node_idx r;
	int val;
	int s;
	int e;
};
vector<Node> nodes;
Node_idx newNode(int f, int t){
	nodes.pb(Node());
	Node_idx i=nodes.sz()-1;
	nodes[i].s=f;
	nodes[i].e=t;
	nodes[i].val=0;
	if(nodes[i].e-nodes[i].s==1){
		nodes[i].l=nodes[i].r=-1;
	}else{
		int m=f+t>>1;
		nodes[i].l=newNode(f, m);
		nodes[i].r=newNode(m, t);
	}
	return i;
}
int get(Node_idx i, int f, int t){
	if(t<=nodes[i].s){
		return 0;
	}
	if(nodes[i].e<=f){
		return 0;
	}
	if(f<=nodes[i].s&&nodes[i].e<=t){
		return nodes[i].val;
	}
	return get(nodes[i].l, f, t)+get(nodes[i].r, f, t);
}
Node_idx inc(Node_idx i, int x){
	if(x>=nodes[i].e){
		return i;
	}
	if(x<nodes[i].s){
		return i;
	}
	if(nodes[i].e-nodes[i].s==1){
		Node_idx nn=newNode(nodes[i].s, nodes[i].e);
		nodes[nn].val=1;
		return nn;
	}else{
		nodes.pb(Node());
		Node_idx ii=nodes.sz()-1;
		nodes[ii].l=inc(nodes[i].l, x);
		nodes[ii].r=inc(nodes[i].r, x);
		nodes[ii].s=nodes[i].s;
		nodes[ii].e=nodes[i].e;
		nodes[ii].val=nodes[nodes[ii].l].val+nodes[nodes[ii].r].val;
		return ii;
	}
}
vector<Node_idx> roots;
int sum(int t, int s, int e){
	return get(roots[t], s, e);
}
struct DOL{
	DOL* l;
	DOL* r;
	int val=INF;
	int s, e;
	DOL(int f, int t){
		s=f;
		e=t;
		if(e-s==1){
			val=a[f];
			l=r=nullptr;
		}else{
			int m=f+t>>1;
			l=new DOL(f, m);
			r=new DOL(m, t);
			val=min(l->val, r->val);
		}
	}
	int get(int f, int t){
		if(t<=s){
			return INF;
		}
		if(e<=f){
			return INF;
		}
		if(f<=s&&e<=t){
			return val;
		}
		return min(l->get(f, t), r->get(f, t));
	}
};
int time_first(int c0, int c1){
	VI all(n);
	if(c1==0){
		return 0;
	}
	int l=0;
	int r=n;
	while(r-l>1){
		int m=l+r>>1;
		if(sum(m, 0, c0+c1)>=c1){
			r=m;
		}else{
			l=m;
		}
	}
	return r;
}
int time_last(int c0, int c1){
	if(c0==0){
		return n;
	}
	--c0;
	++c1;
	return time_first(c0, c1)-1;
}
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin>>n;
	a.resize(n);
	cin>>a;
	fori(i, n){
		--a[i];
	}
	roots.resize(n+1);
	roots[0]=newNode(0, n);
	fori(i, n){
		roots[i+1]=inc(roots[i], a[i]);
	}
	DOL* mina=new DOL(0, n);
	int q;
	cin>>q;
	while(q--){
		int aa, b, c, d;
		cin>>aa>>b>>c>>d;
		int ca0=min(aa, b);
		int ca1=aa-min(aa, b);
		int cb0=min(c, d);
		int cb1=c-min(c, d);
		int tl=time_last(ca0, ca1);
		int tf=time_first(cb0, cb1);
		if(tl>tf){
			swap(ca0, cb0);
			swap(ca1, cb1);
			tl=time_last(ca0, ca1);
			tf=time_first(cb0, cb1);
		}
		int mi=min(ca0+ca1, cb0+cb1);
		//rmin(mi, mina->get(tl, tf));
		int idx=mi;
		int c0=0;
		int c1=sum(tf, 0, idx);
		c0=idx-c1;
		c1+=c0;
		cout<<c1<<' '<<c0<<endl;
	}
	return 0;
}
