#include <iostream>
#include <vector>
#include <algorithm>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <ctime>
#include <cmath>
#include <chrono>
#include <random>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
const int INF = 1e18;

struct seg_tree {
    int sz;
    vector<pair<int, int>> t;

    void upd(int v) {
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    seg_tree(const vector<pair<int, int>> &a) {
        int n = (int) a.size();
        sz = 1;
        while (sz < n) {
            sz <<= 1;
        }
        t.assign(2 * sz, {INF, -1});
        for (int i = 0; i < n; ++i) {
            t[i + sz] = {a[i].first, i};
        }
        for (int i = sz - 1; i > 0; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        if (l > r) {
            swap(l, r);
        }
        l += sz;
        r += sz;
        pair<int, int> res = {INF, -1};
        while (l < r) {
            if (l & 1) {
                res = min(res, t[l]);
                l++;
            }
            if (!(r & 1)) {
                res = min(res, t[r]);
                --r;
            }
            l >>= 1;
            r >>= 1;
        }
        if (l == r) {
            res = min(res, t[l]);
        }
        return res.second;
    }
};

vector<pair<int, int>> s;
vector<vector<pair<bool, bool>>> duo;

void dfs(int r, int c) {
    s.emplace_back(r, c);
    if (duo[r][c].first) {
        dfs(r + 1, c);
        s.emplace_back(r, c);
    }
    if (duo[r][c].second) {
        dfs(r + 1, c + 1);
        s.emplace_back(r, c);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
    int n; cin >> n;
    vector<int> a(n);
    duo.resize(n + 1, vector<pair<bool, bool>> (n + 1, {false, false}));
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    vector<bool> right(n, true);
    for (int i = 0; i < n; ++i) {
        int r = 0, c = 0;
        for (int j = 0; j < a[i]; ++j) {
            if (right[j]) {
                c++;
                duo[r][c].second = true;
            } else {
                duo[r][c].first = true;
            }
            r++;
        }
        right[a[i]] = false;
        duo[r][c].first = true;
        duo[r][c].second = true;
        for (int j = a[i]; j < n; ++j) {
            if (right[j]) {
                c++;
                duo[r][c].second = true;
            } else {
                duo[r][c].first = true;
            }
            r++;
        }
    }
    dfs(0, 0);
    seg_tree lca(s);
    vector<vector<int>> first(n + 1, vector<int> (n + 1, -1)), last(n + 1, vector<int> (n + 1, -1));
    for (int i = 0; i < s.size(); ++i) {
        auto [r, c] = s[i];
        if (first[r][c] == -1) {
            first[r][c] = i;
        }
        last[r][c] = i;
    }
    int q; cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int ind = lca.get(last[r1][c1], first[r2][c2]);
        auto [r, c] = s[ind];
        cout << r << ' ' << c << endl;
    }
    return 0;
}
