#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <utility>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <list>
#include <cassert>
#include <sstream>
#include <numeric>
#include <random>
#include <chrono>

#define all(_a) _a.begin(), _a.end()

using namespace std;

const int MAX_N = 100'000;

int p[MAX_N];
int cost[MAX_N];
int l[MAX_N];
int r[MAX_N];

vector<int> graph[MAX_N];

int dp_cnt[MAX_N];
long long old_dp[MAX_N];

struct Value {
	int v;
	int c;
	int cnt;

	Value() {}
	Value(int v, int c, int cnt) : v(v), c(c), cnt(cnt) {}
};

multiset<Value> st[MAX_N];

bool operator < (const Value& a, const Value& b) {
	return a.c < b.c;
}

bool is_ok = true;

int answer[MAX_N];

void merge(multiset<Value>& st1, multiset<Value>& st2) {
	if (st1.size() < st2.size()) {
		swap(st1, st2);
	}
	st1.insert(all(st2));
}

long long sz[MAX_N];

void check_error(int v) {
	long long sum = 0;
	for (auto [v, c, cnt] : st[v]) {
		sum += cnt;
	}
	assert(sum == sz[v]);
}

void dfs(int v) {
	check_error(v);

	st[v].emplace(v, cost[v], r[v]);
	sz[v] = r[v];

	check_error(v);

	for (int u : graph[v]) {
		dfs(u);
		if (!is_ok) {
			return;
		}
		merge(st[v], st[u]);
		sz[v] += sz[u];
		dp_cnt[v] += dp_cnt[u];
		old_dp[v] += old_dp[u];
	}

	check_error(v);

	if (dp_cnt[v] > r[v]) {
		is_ok = false;
		return;
	}
	{
		int limit = r[v] - dp_cnt[v];
		while (sz[v] > limit) {
			auto [u, c, cnt] = *st[v].rbegin();
			st[v].erase(--st[v].end());
			int k = min((long long)cnt, sz[v] - limit);
			cnt -= k;
			sz[v] -= k;

			if (cnt) {
				st[v].emplace(u, c, cnt);
			}
		}
	}

	check_error(v);


	int limit = l[v] - dp_cnt[v];
	while ((limit > 0) && (!st[v].empty())) {
		auto [u, c, cnt] = *st[v].begin();
		st[v].erase(st[v].begin());
		sz[v] -= cnt;
		int k = min(limit, cnt);
		dp_cnt[v] += k;
		old_dp[v] += 1ll * k * c;
		answer[u] += k;

		limit -= k;
		cnt -= k;
		if (cnt) {
			st[v].emplace(u, c, cnt);
			sz[v] += cnt;
		}
	}

	check_error(v);

	if (limit > 0) {
		is_ok = false;
		return;
	}
}

void solve() {
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> cost[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}

	for (int i = 0; i < n; ++i) {
		graph[i].clear();
	}
	for (int v = 1; v < n; ++v) {
		graph[p[v]].push_back(v);
	}

	fill_n(dp_cnt, n, 0);
	fill_n(old_dp, n, 0);
	fill_n(answer, n, 0);
	fill_n(sz, n, 0);
	for (int i = 0; i < n; ++i) {
		st[i].clear();
	}

	is_ok = true;
	dfs(0);
	if (!is_ok) {
		cout << -1 << '\n';
	} else {
		cout << old_dp[0] << '\n';
		for (int i = 0; i < n; ++i) {
			cout << answer[i] << ' ';
		}
		cout << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}

	return 0;
}