#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <utility>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <list>
#include <cassert>
#include <sstream>
#include <numeric>
#include <random>
#include <chrono>

#define all(_a) _a.begin(), _a.end()

using namespace std;

struct Point {
	int x;
	int y;

	Point() {}
	Point(int x, int y) : x(x), y(y) {}
};

bool operator < (const Point& A, const Point& B) {
	return A.x < B.x;
}

istream& operator >> (istream& in, Point& P) {
	in >> P.x >> P.y;
	return in;
}

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<Point> points(n);
	for (Point& P : points) {
		cin >> P;
	}
	{
		auto lambda = [](const Point& A, const Point& B) {
			if (A.x != B.x) {
				return A.x > B.x;
			}
			return A.y > B.y;
		};
		sort(all(points), lambda);
	}
	vector<Point> st;
	for (auto [x, y] : points) {
		while ((!st.empty()) && (st.back().y >= y)) {
			st.pop_back();
		}
		st.emplace_back(x, y);
	}
	reverse(all(st));
	long long ans = 0;
	int old_y = h;
	for (auto [x, y] : st) {
		ans += 1ll * (old_y - y) * (w - x);
		old_y = y;
	}
	cout << ans << '\n';
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int k;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
	}

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}

	return 0;
}