#include "iostream"
#include "vector"
#include "algorithm"
#include "set"

using namespace std;

vector<vector<int>> g;
vector<long long> ans, l, r, c;

struct elem {
    long long num, cost;
    set<pair<int, pair<int, int>>> vars;
};

elem dfs(int v) {
    set<pair<int, pair<int, int>>> vars;
    long long num = 0, cost = 0;
    for (auto u: g[v]) {
        auto res = dfs(u);
        for (auto el: res.vars) {
            vars.insert(el);
        }
        num += res.num;
        cost += res.cost;
        //dp[u].vars.clear();
    }
    if (num > r[v]) {
        cout << -1 << endl;
        exit(0);
    }
    vars.insert({c[v], {r[v] - num, v}});
    if (num < l[v]) {
        while (not vars.empty()) {
            auto f = *vars.begin();
            long long newnum;
            if (num + f.second.first < l[v]) {
                newnum = f.second.first;
            } else {
                newnum = l[v] - num;
            }
            num += newnum;
            cost += newnum * f.first;
            ans[f.second.second] += newnum;
            vars.erase(vars.begin());
            if (num == l[v]) {
                vars.insert({f.first, {f.second.first - newnum, f.second.second}});
                break;
            }
        }
        if (num < l[v]) {
            cout << -1 << endl;
            exit(0);
        }
    }
    set<pair<int, pair<int, int>>> vars1;
    for (auto el: vars) {
        if (el.second.first > r[v] - num) {
            if (num < r[v]) {
                vars1.insert({el.first, {r[v] - num, el.second.second}});
            }
        } else {
            vars1.insert(el);
        }
    }
    return {num, cost, vars1};
}

signed main() {
    int t; cin >> t;
    while (t--) {
        g.clear(); ans.clear(); l.clear(); r.clear(); c.clear();
        int n; cin >> n;
        g.resize(n);
        for (int i = 1; i < n; ++i) {
            int p; cin >> p;
            p--;
            g[p].push_back(i);
        }
        ans.resize(n, 0);
        l.resize(n); r.resize(n); c.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        auto res = dfs(0);
        cout << res.cost << endl;
        for (auto el: ans) {
            cout << el << " ";
        }
        cout << endl;
    }
}