#include "iostream"
#include "vector"
#include "algorithm"
#include "set"

using namespace std;

vector<vector<int>> g;
vector<long long> ans, l, r, c, sumsub;
vector<int> par;

const long long INF = 1e9 + 1;
pair<long long, int> best;
long long numbest = INF;

void calc_numbest(int v, long long mn = INF) {
    mn = min(mn, r[v] - sumsub[v]);
    if (mn > 0 and (c[v] < best.first or c[v] == best.first and mn < numbest)) {
        best ={c[v], v};
        numbest = mn;
    } else {
        return;
    }
    for (auto u: g[v]) {
        calc_numbest(u, mn);
    }
}

bool psbl;

pair<long long, long long> dfs(int v) {
    if (not psbl) return {-1, -1};
    long long num = 0, cost = 0;
    for (auto u: g[v]) {
        auto res = dfs(u);
        num += res.first;
        cost += res.second;
        //dp[u].vars.clear();
    }
    if (num > r[v]) {
        psbl = false;
        return {-1, -1};
    }
    if (num < l[v]) {
        while (num < l[v]) {
            best = {INF, -1};
            numbest = INF;
            calc_numbest(v);
            if (best.second == -1) break;
            numbest = min(numbest, l[v] - num);
            num += numbest;
            cost += numbest * best.first;
            ans[best.second] += numbest;
            int now = best.second;
            while (now != -1) {
                sumsub[now] += numbest;
                now = par[now];
            }
        }
        if (num < l[v]) {
            psbl = false;
            return {-1, -1};
        }
    }
    return {num, cost};
}

signed main() {
    int t; cin >> t;
    while (t--) {
        g.clear(); ans.clear(); l.clear(); r.clear(); c.clear(); sumsub.clear(); par.clear();
        psbl = true;
        int n; cin >> n;
        g.resize(n);
        par.resize(n, -1);
        for (int i = 1; i < n; ++i) {
            int p; cin >> p;
            p--;
            g[p].push_back(i);
            par[i] = p;
        }
        ans.resize(n, 0);
        l.resize(n); r.resize(n); c.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        sumsub.resize(n, 0);
        auto res = dfs(0);
        if (not psbl) {
            cout << -1 << '\n';
            continue;
        }
        cout << res.second << endl;
        for (auto el: ans) {
            cout << el << " ";
        }
        cout << '\n';
    }
}