#include "iostream"
#include "vector"
#include "algorithm"
#include "set"

using namespace std;

#define debug(x) cerr << #x << " " << x << endl;

int get_num(int r, int c) {
    return r * (r + 1) / 2 + c;
}

const int MAXN = (3001 * 3002) / 2;

vector<int> g[MAXN];
int deep[MAXN];

void dfs(int v, int d = 0) {
    deep[v] = d;
    for (auto u: g[v]) {
        if (deep[u] == -1) {
            dfs(u, d + 1);
        }
    }
}

signed main() {
    int n1; cin >> n1;
    int a[n1];
    for (int i = 0; i < n1; ++i) {
        cin >> a[i];
        a[i]--;
    }
    int go[n1];
    for (int i = 0; i < n1; ++i) {
        go[i] = 1;
    }
    n1++;
    int n = n1 * (n1 + 1) / 2;
    vector<int> par(n, -1);
    for (int i = 0; i < n1; ++i) {
        int r = 0, c = 0;
        for (auto el: go) {
            if (el == 1) {
                par[get_num(r + 1, c + 1)] = get_num(r, c);
                c++;
            } else {
                par[get_num(r + 1, c)] = get_num(r, c);
            }
            r++;
        }
        if (i < n1 - 1) go[a[i]] = -1;
    }
    for (int i = 0; i < n; ++i) {
        deep[i] = -1;
    }
    for (int i = 1; i < n; ++i) {
        g[par[i]].push_back(i);
    }
    dfs(0);
    pair<int, int> rev[n];
    for (int i = 0; i < n1; ++i) {
        for (int j = 0; j <= i; ++j) {
            rev[get_num(i, j)] = {i, j};
        }
    }
    int q; cin >> q;
    while (q--) {
        int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
        int v = get_num(r1, c1), u = get_num(r2, c2);
        if (deep[v] > deep[u]) swap(v, u);
        while (deep[u] > deep[v]) {
            u = par[u];
        }
        //debug(u << " " << v);
        while (v != u) {
            v = par[v];
            u = par[u];
        }
        cout << rev[v].first << " " << rev[v].second << endl;
    }
}