#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9, SIZE = 9e6 + 1, LOG = 25;

vector<set<int>> g;
vector<int> a;
int n;

void make_way() {
    int z = 0;
    for (int r = 0; r < n + 1; ++r) {
        int u = r * n + z;
        int v = (r + 1) * n + z;
        if (a[r]) z++, v++;
        g[u].insert(v);
    }
}

vector<int> tin(SIZE), tout(SIZE);
int up[SIZE][LOG];
int t = 0;

bool is_anc(int x, int y) {
    return (tin[x] <= tin[y] && tout[y] <= tout[x]);
}

void dfs(int u) {
   // cout << u << endl;
    tin[u] = t++;
    for (int l = 1; l < LOG; ++l) {
        up[u][l] = up[up[u][l - 1]][l - 1];
    }
    for (int v : g[u]) {
        up[v][0] = u;
        dfs(v);
    }
    tout[u] = t;
}

int lca(int x, int y) {
   // cout << x << " " << y << endl;
    if (is_anc(x, y)) return x;
    if (is_anc(y, x)) return y;
    for (int l = LOG - 1; l > -1; --l) {
        if (!is_anc(up[x][l], y)) x = up[x][l];
    }
    x = up[x][0];
    return x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int q;
    cin >> n;
    a.resize(n, 1);
    g.resize(SIZE);
    make_way();
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a[x - 1] = 0;
        make_way();
    }
    dfs(0);
    cin >> q;
    while (q--) {
        int a1, b1, a2, b2;
        cin >> a1 >> b1 >> a2 >> b2;
        int ans = lca(a1 * n + b1, a2 * n + b2);
        if (ans / n == n + 1) cout << n << " " << n << endl;
        else cout << ans / n << " " << ans % n << endl;
    }
}
