#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long

int timer = 0;
const int maxn = 3e5;
const int inf = 2e9;
int tin[maxn];
int tout[maxn];
vector<int> ord;
int can[maxn];
int l[maxn];
int r[maxn];
int best[maxn];
int c[maxn];

struct fenwick {
    int f[maxn];

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += f[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }

    void upd(int i, int val) {
        while (i < maxn) {
            f[i] += val;
            i = (i | (i + 1));
        }
    }
};

fenwick d;

void dfs(int v, vector<vector<int>> &g, vector<int> &h, int cc) {
    cc = min(cc, r[v]);
    best[v] = v;
    can[v] = cc;
    tin[v] = timer++;
    ord.push_back(v);
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u, g, h, cc);
        if (c[best[u]] < c[best[v]]) {
            best[v] = best[u];
        }
    }
    ord.push_back(v);
    tout[v] = timer++;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    vector<int> par(n, -1);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
        par[i] = p;
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    vector<int> h(n, 0);
    vector<int> answ(n, 0);
    dfs(0, g, h, inf);
    set<pair<int, int>> nonZero;
    for (int i = 0; i < n; ++i) {
        nonZero.insert({ -h[i], i });
    }
    while (1) {
        int v = -1;
        while (!nonZero.empty()) {
            auto [h, u] = *nonZero.begin();
            if (l[u] + d.get(tout[u]) - d.get(tin[u] - 1) == 0) {
                nonZero.erase(nonZero.begin());
            } else {
                v = u;
                break;
            }
        }
        if (v == -1) break;
        int optv = -1;
        optv = best[v];
        if (optv == -1) {
            cout << -1 << '\n';
            return;
        }
        int work = min(l[v], can[optv]);
        answ[optv] += work;
        int u = optv;
        d.upd(tin[u], -work);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += answ[i] * c[i];
    }
    cout << ans << '\n';
    for (int i : answ) {
        cout << i << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
/*
 * 1
3
1 1
3 1 2
5 7
 1 2
2 4
 */