#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
const int maxn = 3e5;
set<pair<int, int>> flex[maxn];
int answ[maxn];
int cost[maxn];
int l[maxn];
int r[maxn];
const int inf = 2e9;
int sz[maxn];
int tin[maxn];
int tout[maxn];
int timer = 0;
int par[maxn];
struct fenwick {
    int f[maxn];

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += f[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }

    void upd(int i, int val) {
        while (i < maxn) {
            f[i] += val;
            i = (i | (i + 1));
        }
    }
};

bool ok;
fenwick d;

void dfs1(int v, vector<vector<int>> &g) {
    tin[v] = timer++;
    for (int u : g[v]) {
        dfs1(u, g);
    }
    tout[v] = timer++;
}

int getL(int v) {
    return l[v] + d.get(tout[v]) - d.get(tin[v] - 1);
}

int getR(int v) {
    return r[v] + d.get(tout[v]) - d.get(tin[v] - 1);
}

void dfs(int v, vector<vector<int>> &g) {
    flex[v].insert({ cost[v], v });
    for (int u : g[v]) {
        dfs(u, g);
        if (flex[u].size() > flex[v].size()) {
            flex[u].swap(flex[v]);
        }
    }
    for (int u : g[v]) {
        for (auto x : flex[u]) {
            flex[v].insert(x);
        }
        flex[u].clear();
    }
    while (getL(v) > 0 && !flex[v].empty()) {
        auto [c, u] = *flex[v].begin();
        int mnl = inf;
        int mnr = inf;
        int cc = u;
        while (cc != -1) {
            mnl = min(mnl, getL(cc));
            mnr = min(mnr, getR(cc));
            cc = par[cc];
        }
        if (mnr > 0) {
            int x = min(mnr, getL(v));
            answ[u] += x;
            d.upd(tin[u], -x);
        } else {
            flex[v].erase(flex[v].begin());
        }
    }
    if (getL(v) > 0) {
        ok = false;
    }
}

void solve() {
    int n;
    cin >> n;
    fill(par, par + n, -1);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
        par[i] = p;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    ok = 1;
    fill(answ, answ + maxn, 0);
    dfs1(0, g);
    dfs(0, g);
    if (ok) {
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans += cost[i] * answ[i];
        }
        cout << ans << '\n';
        for (int i = 0; i < n; ++i) {
            cout << answ[i] << ' ';
        }
        cout << '\n';
    } else {
        cout << -1 << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
