#include <bits/stdc++.h>
  
using namespace std;
  
const int maxn = 5e5 + 5, R = 1 << 19;

  
vector<int> t[R * 2];
   
int pp[maxn];
   
void build() {
    for (int i = R - 1; i > 0; --i) {
        merge(t[i * 2].begin(), t[i * 2].end(), t[i * 2 + 1].begin(), t[i * 2 + 1].end(), back_inserter(t[i]));
    }
    // for (int i = R * 2 - 1; i > 0; --i) {
    //     for (auto v : t[i]) {
    //         cout << v << ' ';
    //     }
    //     cout << '\n';
    // }
}
   
int get(int l, int r, int x) {
    l += R;
    r += R;
    // cout << "?" << l << ' ' << r << ' ' << x << ' ';
    int ans = 0;
    while (l < r) {
        if (l & 1) {
            ans += lower_bound(t[l].begin(), t[l].end(), x) - t[l].begin();
            l++;
        }
        if (r & 1) {
            r--;
            ans += lower_bound(t[r].begin(), t[r].end(), x) - t[r].begin();
        }
        l >>= 1;
        r >>= 1;
    }
    // cout << ans << '\n';
    return ans;
}

int n;

struct fenwik {
    int n;
    vector<int> f;

    fenwik(int _n) {
        n = _n + 1;
        f.assign(n, 0);
    }

    fenwik() {
        n = 0;
        f.clear();
    }

    void add(int pos, int val) {
        for (int i = pos; i < n; i += i & -i) {
            f[i] += val;
        }
    }

    int get(int pos) {
        int ans = 0;
        for (int i = pos; i > 0; i -= i & -i) {
            ans += f[i];
        }
        return ans;
    }
};
  
pair<int, int> get_kek(pair<int, int> a) {
    pair<int, int> ans = {-1, -1};
    int l1 = 0, r1 = n + 1;
    while (l1 < r1 - 1) {
        int m1 = (l1 + r1) / 2;
        if (get(0, m1, a.first) <= a.first - a.second) {
            l1 = m1;
        } else {
            r1 = m1;
        }
    }
    ans.second = l1;
    int l2 = -1, r2 = n;
    while (l2 < r2 - 1) {
        int m2 = (l2 + r2) / 2;
        if (get(0, m2, a.first) < a.first - a.second) {
            l2 = m2;
        } else {
            r2 = m2;
        }
    }
    ans.first = r2;
    return ans;
}

pair<int, int> a[maxn][2], p[maxn][2];

int l[maxn][2], r[maxn][2];

vector<pair<int, int>> qs[maxn];
 
int mn[R * 2];
 
void build_mn() {
    for (int i = R - 1; i > 0; --i) {
        mn[i] = min(mn[i * 2], mn[i * 2 + 1]);
    }
}
 
int get_mn(int l, int r) {
    l += R;
    r += R;
    int ans = n + 10;
    while (l < r) {
        if (l & 1) {
            ans = min(ans, mn[l++]);
        }
        if (r & 1) {
            ans = min(ans, mn[--r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return ans;
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> pp[i];
        pp[i]--;
        t[i + R] = {pp[i]};
        mn[i + R] = pp[i];
    }
    build();
    build_mn();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> a[i][0].first >> a[i][0].second >> a[i][1].first >> a[i][1].second;
        l[i][0] = l[i][1] = 0;
        r[i][0] = r[i][1] = n + 1;
    }
    while (true) {
        bool ch = false;
        for (int i = 0; i <= n; ++i) {
            qs[i].clear();
        }
        for (int i = 0; i < q; ++i) {
            if (l[i][0] < r[i][0] - 1) {
                ch = true;
                qs[(l[i][0] + r[i][0]) / 2].emplace_back(i, 0);
            }
            if (l[i][1] < r[i][1] - 1) {
                ch = true;
                qs[(l[i][1] + r[i][1]) / 2].emplace_back(i, 1);
            }
        }
        if (!ch) {
            break;
        }
        fenwik f(n + 1);
        for (int i = 0; i <= n; ++i) {
            for (auto [j, k] : qs[i]) {
                if (f.get(a[j][k].first) <= a[j][k].first - a[j][k].second) {
                    l[j][k] = i;
                } else {
                    r[j][k] = i;
                }
            }
            if (i == n) {
                break;
            }
            f.add(pp[i] + 1, 1);
        }
    }
    for (int i = 0; i < q; ++i) {
        p[i][0].second = l[i][0];
        p[i][1].second = l[i][1];
        l[i][0] = l[i][1] = -1;
        r[i][0] = r[i][1] = n;
    }
    while (true) {
        bool ch = false;
        for (int i = 0; i <= n; ++i) {
            qs[i].clear();
        }
        for (int i = 0; i < q; ++i) {
            if (l[i][0] < r[i][0] - 1) {
                ch = true;
                qs[(l[i][0] + r[i][0]) / 2].emplace_back(i, 0);
            }
            if (l[i][1] < r[i][1] - 1) {
                ch = true;
                qs[(l[i][1] + r[i][1]) / 2].emplace_back(i, 1);
            }
        }
        if (!ch) {
            break;
        }
        fenwik f(n + 1);
        for (int i = 0; i <= n; ++i) {
            for (auto [j, k] : qs[i]) {
                if (f.get(a[j][k].first) < a[j][k].first - a[j][k].second) {
                    l[j][k] = i;
                } else {
                    r[j][k] = i;
                }
            }
            if (i == n) {
                break;
            }
            f.add(pp[i] + 1, 1);
        }
    }
    for (int i = 0; i < q; ++i) {
        p[i][0].first = r[i][0];
        p[i][1].first = r[i][1];
        if ((p[i][0].first <= p[i][1].first && p[i][1].second <= p[i][0].second) || (p[i][1].first <= p[i][0].first && p[i][0].second <= p[i][1].second)) {
            cout << min(a[i][0], a[i][1]).first << ' ' << min(a[i][0], a[i][1]).second << '\n';
        } else {
            int ans = get_mn(min(p[i][0].second, p[i][1].second), max(p[i][0].first, p[i][1].first));
            cout << ans << ' ' << ans - get(0, max(p[i][0].first, p[i][1].first), ans) << '\n';
        }
    }
    return 0;
}
