#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;

vector <vector <int>> gr;
vector <ll> p, c, l, r;

vector <ll> spent;
vector <ll> bought, bought_here;
vector <set <pair <ll, int>>> prices;
vector <ll> left_to_buy;

set <pair <ll, int>> merge(set <pair <ll, int>> &a, set <pair <ll, int>> &b) {
    if (a.size() < b.size()) {
        swap(a, b);
    }
    for (auto el: b) {
        a.insert(el);
    }
    b.clear();
    return a;
}

void substract_on_path(int v, int top, ll x) {
    if (v == top) {
        return;
    }
    left_to_buy[v] -= x;
    substract_on_path(p[v], top, x);
}

ll min_on_path(int v, int top) {
    if (v == top) {
        return INF;
    }
    return min(left_to_buy[v], min_on_path(p[v], top));
}

int dfs(int v, int pr) {
    for (auto to: gr[v]) {
        if (to != pr) {
            if (dfs(to, v) == 1) {
                return 1;
            }
            spent[v] += spent[to];
            bought[v] += bought[to];
            prices[v] = merge(prices[v], prices[to]);
        }
    }
    if (bought[v] > r[v]) {
        return 1;
    }
    prices[v].insert({c[v], v});
    while (bought[v] < l[v]) {
        auto [curr_c, idx] = *(prices[v].begin());
        ll curr = min_on_path(idx, v);
        if (l[v] - bought[v] < curr) {
            bought_here[idx] += (l[v] - bought[v]);
            spent[v] += curr_c * (l[v] - bought[v]);
            substract_on_path(idx, v, l[v] - bought[v]);
            bought[v] = l[v];
        } else {
            bought_here[idx] += curr;
            spent[v] += curr_c * curr;
            substract_on_path(idx, v, curr);
            prices[v].erase(prices[v].begin());
            bought[v] += curr;
        }
    }
    left_to_buy[v] = r[v] - bought[v];
    return 0;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        p.assign(n, -1);
        gr.resize(n);
        for (int i = 1; i < n; ++i) {
            cin >> p[i];
            p[i]--;
            gr[p[i]].push_back(i);
        }
        c.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        l.resize(n);
        r.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        spent.assign(n, 0);
        bought.assign(n, 0);
        bought_here.assign(n, 0);
        prices.resize(n);
        left_to_buy.resize(n);
        if (dfs(0, -1) != 1) {
            cout << spent[0] << '\n';
            for (auto el: bought_here) {
                cout << el << ' ';
            }
            cout << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
    return 0;
}