#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <deque>
#include <queue>
#include <cmath>
#include <ctime>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")

using namespace std;

#define sz(x) ((int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct MST {
    int n;
    vector<vector<int>> tree;
    vector<int> a;

    int qL, qR;
    int ans, val;

    MST(int _n) {
        n = _n;
        tree.assign(4 * n, {});
    }

    void update_vertex(int v, int l, int r) {
        int m = l + (r - l) / 2, vL = 2 * v, vR = vL + 1;
        merge(all(tree[vL]), all(tree[vR]), back_inserter(tree[v]));
    }

    void build(vector<int> &_a) {
        a = _a;
        build_tree(1, 0, n);
    }

    void build_tree(int v, int l, int r) {
        if (l + 1 == r) {
            tree[v].emplace_back(a[l]);
            return;
        }
        int m = l + (r - l) / 2, vL = 2 * v, vR = vL + 1;
        build_tree(vL, l, m);
        build_tree(vR,m, r);
        update_vertex(v, l, r);
    }

    int get(int _qL, int _qR, int _val) {
        qL = _qL;
        qR = _qR + 1;
        val = _val;
        ans = 0;
        get_tree(1, 0, n);
        return ans;
    }

    void get_tree(int v, int l, int r) {
        if (qL <= l && r <= qR) {
            ans += lower_bound(all(tree[v]), val) - tree[v].begin();
            return;
        }
        int m = l + (r - l) / 2, vL = 2 * v, vR = vL + 1;
        if (qL < m) get_tree(vL, l, m);
        if (m < qR) get_tree(vR, m, r);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    MST t(n);
    t.build(a);
    int ans = 0;
    for (int i = 0; i < n; ++i) {
//        for (int j = n - 1; j > i; --j) {
        for (int j = i + 1; j < n; ++j) {
            int x = a[i], y = a[j];
            int now = max(abs(x - y), j - i);
            int c = t.get(0, i, x);
            now = max(now, j - i + (i + 1 - c - 1));
            c = t.get(i + 1, n - 1, y) + 1;
            now = max(now, c);
            c = t.get(j, n - 1, y);
            now = max(now, j - i + c);
            ans += now;
//            cerr << i + 1 << ": " << a[i] << ", " << j + 1 << ": " << a[j] << "      " << now << endl;
        }
    }
    cout << ans << en;
}

void stupid() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    map<pii, int> mp;
    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r <= n; ++r) {
            vector<int> b = a;
            vector<int> pos(n + 1);
            sort(b.begin() + l, b.begin() + r);
            for (int i = 0; i < n; ++i) {
                pos[b[i]] = i;
            }
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    pii p = {a[i], a[j]};
                    mp[p] = max(mp[p], abs(pos[a[i]] - pos[a[j]]));
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            pii p = {a[i], a[j]};
            ans += mp[p];
            cerr << i + 1 << ": " << a[i] << ", " << j + 1 << ": " << a[j] << "      " << mp[p] << endl;
        }
    }
    cout << ans << en;
}

int main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("a.txt", "r", stdin);
    T = 3;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    while (T--) {
        solve();
//        stupid();
    }
    return 0;
}
