#include <iostream>
#include <map>
#include <string>
#include <cmath>
#include <deque>
#include <queue>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld PI = acos(-1);
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;

vector<ll> l, r;
vector<vector<ll>> g;
vector<ll> p;
vector<ll> c;
vector<ll> sm;
vector<ll> b;
bool ok = 1;

ll get(ll v, ll to) {
	ll res = r[v]  - sm[v];
	while (v != to) {
		v = p[v];
		res = min(res, r[v] - sm[v]);
	}
	return res;
}

void upd(ll v, ll to, ll x) {
	b[v] += x;
	sm[v] += x;
	while (v != to) {
		v = p[v];
		sm[v] += x;
	}
}

set<pair<ll, ll>> dfs(ll v) {
	set<pair<ll, ll>> s;
	if (l[v] < r[v]) s.insert({ c[v], v });
	for (ll i : g[v]) {
		set<pair<ll, ll>> s1 = dfs(i);
		for (auto j : s1) s.insert(j);
		sm[v] += sm[i];
	}
	while (sm[v] < l[v] && s.size() > 0) {
		ll x = s.begin()->second;
		ll y = get(x, v);
		if (y > l[v] - sm[v]) y = l[v] - sm[v];
		else s.erase(s.begin());
		upd(x, v, y);
	}
	if (sm[v] > r[v] || sm[v] < l[v]) ok = 0;
	return s;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		l.assign(n + 1, 0);
		r.assign(n + 1, 0);
		g.assign(n + 1, vector<ll>(0));
		c.assign(n + 1, 0);
		sm.assign(n + 1, 0);
		b.assign(n + 1, 0);
		p.assign(n + 1, 0);
		ok = 1;
		for (ll i = 2; i <= n; i++) {
			cin >> p[i];
			g[p[i]].push_back(i);
		}
		for (ll i = 1; i <= n; i++) cin >> c[i];
		for (ll i = 1; i <= n; i++) cin >> l[i] >> r[i];
		dfs(1);
		if (ok) {
			ll ans = 0;
			vector<ll> ans1(n + 1);
			for (ll i = 1; i <= n; i++) {
				ll x = b[i];
				ans1[i] = x;
				ans += x * c[i];
			}
			cout << ans << "\n";
			for (ll i = 1; i <= n; i++) cout << ans1[i] << " ";
			cout << "\n";
		}
		else {
			cout << "-1\n";
		}
	}
	return 0;
}