#include <iostream>
#include <map>
#include <string>
#include <cmath>
#include <deque>
#include <queue>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld PI = acos(-1);
const ld EPS = 1e-9;
const ll MOD = 1000000000 + 7;

struct Point {
	ll x, y;
	Point() :x(0), y(0) {};
	Point(ll _x, ll _y) : x(_x), y(_y) {};
	Point operator+(const Point& other) const {
		return Point(x + other.x, y + other.y);
	}
	Point operator-() {
		return Point(-x, -y);
	}
	bool operator==(const Point& other) const {
		bool b = (other.x == x && other.y == y);
		return b;
	}
	void print() const {
		cout << x << " " << y;
	}
	void input() {
		cin >> x >> y;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll k, t;
	cin >> k;
	for (ll i = 0; i < k; i++) cin >> t;
	cin >> t;
	while (t--) {
		ll n, w, h;
		cin >> n >> w >> h;
		vector<Point> a(n);
		for (ll i = 0; i < n; i++) {
			a[i].input();
			a[i] = Point(w - a[i].x, h - a[i].y);
		}
		sort(a.begin(), a.end(), [](const Point& a,  const Point& b) {
			if (a.x != b.x) return a.x < b.x;
			return a.y < b.y;
			});
		vector<Point> st = { {0, INF} };
		for (ll i = 0; i < n; i++) {
			while (a[i].y >= st.back().y) st.pop_back();
			st.push_back(a[i]);
		}
		ll ans = 0;
		for (ll i = 1; i < st.size(); i++) {
			ans += (st[i].x - st[i - 1].x) * st[i].y;
		}
		cout << ans << "\n";
	}
	return 0;
}