#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;
//#define int long long

const int N = 1e7 + 5;

int p[N];
char g[N][2];

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (auto &x : a) {
    cin >> x;
    --x;
  }
  bool equal = 1;
  for (int i = 0; i < n; i++) {
    equal &= a[i] == i;
  }
  int q;
  cin >> q;

  auto add_edge = [&] (int v, int type) {
    g[v][type] = 1;
    if (type == 0) {
//      cout << v << ' ' << v + n + 1 << '\n';
      p[v + n + 1] = v;
    } else {

      p[v + 1] = v;
    }
  };

  vector<array<int, 4>> queries(q);
  for (auto &[a, b, c, d] : queries) {
    cin >> a >> b >> c >> d;
    a -= b;
    c -= d;
  }

  if (equal) {
    for (auto &[x1, y1, x2, y2] : queries) {
      int x, y;
      if (x1 != x2) {
        x = min(x1, x2);
        y = 0;
      } else {
        x = x1;
        y = min(y1, y2);
      }
      x += y;
      cout << x << ' ' << y << '\n';
    }
    return;
  }

  vector<char> vniz(n);
  for (int i = 0; i < n; i++) {
    add_edge(i, 1);
  }
  for (int i = 0; i < n; i++) {
    int cur = 0;
    vniz[a[i]] = 1;
    for (int j = 0; j < n; j++) {
      if (vniz[j]) {
        add_edge(cur, 0);
        cur += n + 1;
      } else {
        add_edge(cur, 1);
        cur++;
      }
    }
  }

  int V = (n + 1) * (n + 1);

  int timer = 0;
  vector<int> tin(V), tout(V);
  function<void(int)> dfs = [&] (int v) {
    tin[v] = timer++;
    if (g[v][0]) {
      dfs(v + n + 1);
    }
    if (g[v][1]) {
      dfs(v + 1);
    }
    tout[v] = timer;
  };

  dfs(0);

//  0 1
//  1 2
//  2 3
//  0 1
//  1 5
//  5 6
//  0 1
//  1 5
//  5 9
//  0 4
//  4 8
//  8 12

  auto ancestor = [&] (int u, int v) -> bool {
    return tin[u] <= tin[v] && tout[u] > tin[v];
  };

  auto lca = [&] (int v, int u) {
    if (ancestor(u, v)) return u;
    if (ancestor(v, u)) return v;
    while (!ancestor(v, u)) v = p[v];
    return v;
  };

  for (int i = 0; i < q; i++) {
    auto [x1, y1, x2, y2] = queries[i];
    int v = x1 * (n + 1) + y1;
    int u = x2 * (n + 1) + y2;
    int l = lca(u, v);
    int x = l / (n + 1);
    int y = l % (n + 1);
    x += y;
    cout << x << ' ' << y << '\n';
  }
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  solve();
  return 0;
}
