#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;
//#define int long long

const int N = 1e7 + 5;
const int LG = 24;

int up[LG][N];
set<int> g[N];
char used[N];

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (auto &x : a) {
    cin >> x;
    --x;
  }
  bool equal = 1;
  for (int i = 0; i < n; i++) {
    equal &= a[i] == i;
  }
  int q;
  cin >> q;

  auto add_edge = [&] (int v, int u) {
    g[v].insert(u);
  };

  vector<array<int, 4>> queries(q);
  for (auto &[a, b, c, d] : queries) {
    cin >> a >> b >> c >> d;
    a -= b;
    c -= d;
//    cout << "coords:" << a << ' ' << b << ' ' << c << ' ' << d << '\n';
  }

  if (equal) {
    for (auto &[x1, y1, x2, y2] : queries) {
      int x, y;
      if (x1 != x2) {
        x = min(x1, x2);
        y = 0;
      } else {
        x = x1;
        y = min(y1, y2);
      }
      x += y;
      cout << x << ' ' << y << '\n';
    }
    return;
  }

  vector<char> vniz(n);
  for (int i = 0; i < n; i++) {
    add_edge(i, i + 1);
  }
  for (int i = 0; i < n; i++) {
    int cur = 0;
    vniz[a[i]] = 1;
    for (int j = 0; j < n; j++) {
      if (vniz[j]) {
        add_edge(cur, cur + n + 1);
        cur += n + 1;
      } else {
        add_edge(cur, cur + 1);
        cur++;
      }
    }
  }

  int V = (n + 1) * (n + 1);

  int timer = 0;
  vector<int> tin(V), tout(V), used(V);
  function<void(int)> dfs = [&] (int v) {
    used[v] = 1;
    tin[v] = timer++;
    used[v] = 1;
    for (int l = 1; l < LG; l++) {
      up[l][v] = up[l - 1][up[l - 1][v]];
    }
    for (auto &u : g[v]) {
      up[0][u] = v;
      dfs(u);
    }
    tout[v] = timer;
  };

  dfs(0);

  auto ancestor = [&] (int u, int v) -> bool {
    return tin[u] <= tin[v] && tout[u] > tin[v];
  };

  auto lca = [&] (int v, int u) {
    if (ancestor(u, v)) return u;
    if (ancestor(v, u)) return v;
    for (int l = LG - 1; l >= 0; l--) {
      if (!ancestor(up[l][v], u)) {
        v = up[l][v];
      }
    }
    return up[0][v];
  };

  for (int i = 0; i < q; i++) {
    auto [x1, y1, x2, y2] = queries[i];
    int v = x1 * (n + 1) + y1;
    int u = x2 * (n + 1) + y2;
    int l = lca(u, v);
    int x = l / (n + 1);
    int y = l % (n + 1);
    x += y;
    cout << x << ' ' << y << '\n';
  }
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  solve();
  return 0;
}
