#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>

using namespace std;

#define int long long

vector<int> now;
vector<vector<int>> gr;

void dfs(int v, int d) {
    if (d == now.size()) {
        return;
    }
    if (now[d] == 0) {
        if (count(gr[v].begin(), gr[v].end(), v + d + 2) == 0) {
            gr[v].push_back(v + d + 2);
        }
        dfs(v + d + 2, d + 1);
    } else {
        if (count(gr[v].begin(), gr[v].end(), v + d + 1) == 0) {
            gr[v].push_back(v + d + 1);
        }
        dfs(v + d + 1, d + 1);
    }
}

bool dfs_find(int v, int fin) {
    if (v == fin) {
        return true;
    }
    bool fl = false;
    for (auto u: gr[v]) {
        fl |= dfs_find(u, fin);
    }
    return fl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    gr.resize((n + 2) * (n + 1) / 2);
    now.resize(n);
    dfs(0, 0);
    for (int i = 0; i < n; ++i) {
        now[a[i] - 1] = 1;
        dfs(0, 0);
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v = r1 * (r1 + 1) / 2;
        v += c1;
        int u = r2 * (r2 + 1) / 2;
        u += c2;
        int r3 = n;
        int c3 = n;
        for (int i = gr.size() - 1; i > -1; --i) {
            if (dfs_find(i, u) && dfs_find(i, v)) {
                cout << r3 << " " << c3 << "\n";
                break;
            }
            --c3;
            if (c3 == -1){
                r3--;
                c3 = r3;
            }
        }
    }
}
