//
// Created by roi on 26.03.2022.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

using namespace std;
using ll = long long;
const int LOG = 15;

struct ha{
    long long x;
    ha(pair<int, int> a = {0, 0}){
        x = a.first * 10000 + a.second;
    }
};

bool operator!=(ha a, ha b){
    return a.x != b.x;
}

bool operator<(ha a, ha b){
    return a.x < b.x;
}

map<ha, vector<ha>> mp;
map<ha, ha> p;

void add(vector<bool> v, int n){
    pair<int, int> now = {0, 0};
    for (int i = 0; i < n; ++i) {
        pair<int, int> nnow = now;
        if (v[i]){
            nnow.first++;
        } else{
            nnow.first++;
            nnow.second++;
        }
        mp[ha(now)].push_back(ha(nnow));
        p[ha(nnow)] = ha(now);
        now = nnow;
    }
}

map<ha, int> tin;
map<ha, int> tout;
map<ha, int> h;
map<ha, bool> used;
int timer = 0;

void dfs(ha v, int he){
    used[v] = true;
    tin[v] = timer;
    timer++;
    h[v] = he;
    for (auto u: mp[v]) {
        if (!used[u]) {
            dfs(u, he + 1);
        }
    }
    tout[v] = timer;
}

bool is_parent(ha u, ha v){
    // is u a parent of v
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

map<ha, vector<ha>> bin_up;

void prepare(int n){
    vector<pair<int, int>> all_v;
    all_v.reserve((n + 1) * n);
    for (int j = 0; j < n + 1; ++j) {
        for (int i = j; i < n + 1; ++i) {
            all_v.push_back({i, j});
            bin_up[all_v.back()].resize(LOG);
        }
    }
    int m = all_v.size();
    for (int i = 0; i < m; ++i) {
        bin_up[ha(all_v[i])][0] = p[ha(all_v[i])];
    }
    for (int log = 1; log < LOG; ++log) {
        for (int i = 0; i < m; ++i) {
            bin_up[ha(all_v[i])][log] = bin_up[bin_up[ha(all_v[i])][log - 1]][log - 1];
        }
    }
}

ha up_h(ha v, int x){
    for (int log = LOG - 1; log >= 0; --log){
        if ((1 << log) <= x){
            x -= (1 << log);
            v = bin_up[v][log];
        }
    }
    return v;
}

ha lca(ha a, ha b){
    if (is_parent(a, b)){
        return a;
    }
    if (is_parent(b, a)){
        return b;
    }
    if (h[a] > h[b]){
        swap(a, b);
    }
    b = up_h(b, h[b] - h[a]);
    for (int log = LOG - 1; log >= 0; --log){
        ha x = bin_up[a][log];
        ha y = bin_up[b][log];
        if (x != y){
            a = x;
            b = y;
        }
    }
    return p[a];
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    ifstream cin("C.in");
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    vector<bool> v(n, false);
    add(v, n);
    for (int i = 0; i < n; ++i) {
        v[a[i]] = true;
        add(v, n);
    }
    dfs(ha({0, 0}), 0);
    prepare(n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        pair<int, int> a;
        pair<int, int> b;
        cin >> a.first >> a.second;
        cin >> b.first >> b.second;
        auto c = lca(ha(a), ha(b));
        cout << c.x / 10000 << ' ' << c.x % 10000 << '\n';
    }
}