#include <bits/stdc++.h>
#include <cmath>

using namespace std;

typedef long long ll;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

mt19937 rnd(time(0));

map<pair<ll, ll>, set<pair<ll, ll>>> g;
vector<ll> now;

void go(ll now_r, ll now_c) {
    if (now_r > now.size()) return;

    g[{now_r, now_c}].insert({now_r + 1, now_c + now[now_r]});

    go(now_r + 1, now_c + now[now_r]);
}

map<pair<ll, ll>, pair<ll, ll>> prv;

void dfs(ll now_r, ll now_c, ll prev_r, ll prev_c) {
    prv[{now_r, now_c}] = {prev_r, prev_c};

    for (auto i : g[{now_r, now_c}]) {
        dfs(i.first, i.second, now_r, now_c);
    }
}

void solve() {
    ll n;
    cin >> n;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];

    now.resize(n, 1);

    go(0, 0);

    for (ll i = 0; i < n; ++i) {
        now[a[i] - 1] = 0;
        go(0, 0);
    }

    dfs(0, 0, -1, -1);

    ll q;
    cin >> q;

    while (q--) {
        ll fir_r, fir_c, sec_r, sec_c;
        cin >> fir_r >> fir_c >> sec_r >> sec_c;

        while (fir_r > sec_r) {
            auto k = prv[{fir_r, fir_c}];
            fir_r = k.first;
            fir_c = k.second;
        }

        while (fir_r < sec_r) {
            auto k = prv[{sec_r, sec_c}];
            sec_r = k.first;
            sec_c = k.second;
        }

        while (fir_c != sec_c) {
            auto k = prv[{fir_r, fir_c}];
            fir_r = k.first;
            fir_c = k.second;

            k = prv[{sec_r, sec_c}];
            sec_r = k.first;
            sec_c = k.second;
        }

        cout << fir_r << ' ' << fir_c << '\n';
    }
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}

/*
10
1 2 3 4 4 5 4 8 1
715028053 417838085 71832107 869116961 872335120 79833896 943607627 948373498 253462209 536117063
544 1000
976 1000
189 1000
564 1000
294 1000
632 1000
576 1000
906 1000
598 1000
99 1000
 */









