#include <bits/stdc++.h>
#include <cmath>

using namespace std;

typedef long long ll;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

mt19937 rnd(time(0));

const int MAXN = 3001 * 3001 + 5;
const int N = 3001;

pair<int, int> g[MAXN];
vector<int> now;

void go(int now_r, int now_c) {
    if (now_r > now.size()) return;

    if (now[now_r]) {
        g[N * now_r + now_c].second = 1;
    }
    else {
        g[N * now_r + now_c].first = 1;
    }

    go(now_r + 1, now_c + now[now_r]);
}

int prv[MAXN];

void dfs(int now_r, int now_c, int prev_r, int prev_c) {
    prv[now_r * N + now_c] = prev_r * N + prev_c;

    if (g[N * now_r + now_c].first) dfs(now_r + 1, now_c, now_r, now_c);
    if (g[N * now_r + now_c].second) dfs(now_r + 1, now_c + 1, now_r, now_c);
}

const ll K = 12;

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    now.resize(n, 1);

    go(0, 0);

    for (int i = 0; i < n; ++i) {
        now[a[i] - 1] = 0;
        go(0, 0);
    }

    dfs(0, 0, 0, 0);

    vector<vector<vector<int>>> ST(K, vector<vector<int>> (N, vector<int> (N)));

    for (ll i = 0; i <= n; ++i) {
        for (ll j = 0; j <= i; ++j) {
            ST[0][i][j] = prv[i * N + j];
        }
    }

    for (ll rt = 1; rt < K; ++rt) {
        for (ll i = 0; i <= n; ++i) {
            for (ll j = 0; j <= i; ++j) {
                // cout << ST[rt - 1][{i, j}].first << ' ' << ST[rt - 1][{i, j}].second << endl;
                ST[rt][i][j] = ST[rt - 1][ST[rt - 1][i][j] / N][ST[rt - 1][i][j] % N];
                // ST[rt][{i, j}] = ST[rt - 1][ST[rt - 1][{i, j}]];
            }
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int fir_r, fir_c, sec_r, sec_c;
        cin >> fir_r >> fir_c >> sec_r >> sec_c;

        if (fir_r < sec_r) {
            swap(fir_r, sec_r);
            swap(fir_c, sec_c);
        }

        ll diff = fir_r - sec_r;
        for (ll rt = 11; rt >= 0; --rt) {
            if (diff >= (1LL << rt)) {
                diff -= (1LL << rt);

                auto k = ST[rt][fir_r][fir_c];

                fir_r = k / N;
                fir_c = k % N;
            }
        }

        if (fir_c == sec_c) {
            cout << fir_r << ' ' << fir_c << '\n';
            continue;
        }

        for (ll rt = 11; rt >= 0; --rt) {
            auto k = ST[rt][fir_r][fir_c];
            auto h = ST[rt][sec_r][sec_c];

            if (k != h) {
                fir_r = k / N;
                fir_c = k % N;

                sec_r = h / N;
                sec_c = h % N;
            }
        }

        auto k = prv[fir_r * N + fir_c];

        cout << k / N << ' ' << k % N << '\n';
    }
}

signed main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}

/*
10
1 2 3 4 4 5 4 8 1
715028053 417838085 71832107 869116961 872335120 79833896 943607627 948373498 253462209 536117063
544 1000
976 1000
189 1000
564 1000
294 1000
632 1000
576 1000
906 1000
598 1000
99 1000
 */









