#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;


#define F first
#define S second

map<pair<int, int>, set<pair<int, int>>> g;
unordered_map<int, unordered_map<int, unordered_map<int, pair<int, int>>>> up;
map<pair<int, int>, int> tin, tout;

int t = 1;
int L = 1;

void dfs(pair<int, int> v, pair<int, int> p){

    up[v.F][v.S][0] = p;
    tin[v] = t++;
    for (int i = 1; i <= L; i++) {
        auto prv = up[v.F][v.S][i - 1];
        up[v.F][v.S][i] = up[prv.F][prv.S][i - 1];
    }

    for (auto u : g[v]){
        dfs(u, v);
    }
    tout[v] = t++;
}

bool upper(pair<int, int> v, pair<int, int> u){
    return tin[v] < tin[u] && tout[u] < tout[v];
}

pair<int, int> get(pair<int, int> v, pair<int, int> u){

    if (upper(v, u)) return v;
    else if (upper(u, v)) return u;
    if (u == v) return v;
    for (int i = L; i >= 0; i--){
        if (!upper(up[v.F][v.S][i], u)) v = up[v.F][v.S][i];
    }
    for (int i = L; i >= 0; i--){
        if (!upper(up[u.F][u.S][i], v)) u = up[u.F][u.S][i];
    }
    return up[v.F][v.S][0];
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    while ((1 << L) <= n) L++;
    L++;
    //g.resize(n + 1, vector<set<pair<int, int>>>(n + 1));
    //up.resize(n + 1, vector<vector<pair<int, int>>>(n + 1, vector<pair<int, int>>(L + 1)));
    //tin.resize(n + 1, vector<int>(n + 1));
    //tout.resize(n + 1, vector<int>(n + 1));
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    vector<bool> to(n, true);
    for (int i = 0; i <= n; i++){
        pair<int, int> cur = {0, 0};
        for (int j = 0; j < n; j++){
            pair<int, int> u = {cur.F + 1, cur.S + to[j]};
            g[cur].insert(u);
            cur = u;
        }
        if (i != n)
            to[a[i] - 1] = false;
    }

    dfs({0, 0}, {0, 0});
    int q;
    cin >> q;
    while (q--){
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto ans = get({r1, c1}, {r2, c2});
        cout << ans.F << ' ' << ans.S << '\n';
    }
}

