#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;


#define F first
#define S second

map<pair<int, int>, vector<pair<int, int>>> g;
vector<map<pair<int, int>, pair<int, int>>> up;
map<pair<int, int>, int> tin, tout;
map<pair<pair<int, int>, pair<int, int>>, bool> used;

int t = 1;
int L = 1;

void dfs(pair<int, int> v, pair<int, int> p){

    up[0][v] = p;
    tin[v] = t++;
    for (int i = 1; i <= L; i++) {
        auto prv = up[i - 1][v];
        up[i][v] = up[i - 1][prv];
    }

    for (auto u : g[v]){
        dfs(u, v);
    }
    tout[v] = t++;
}

bool upper(pair<int, int> v, pair<int, int> u){
    return tin[v] < tin[u] && tout[u] < tout[v];
}

pair<int, int> get(pair<int, int> v, pair<int, int> u){

    if (upper(v, u)) return v;
    else if (upper(u, v)) return u;
    if (u == v) return v;
    for (int i = L; i >= 0; i--){
        if (!upper(up[i][v], u)) v = up[i][v];
    }
    for (int i = L; i >= 0; i--){
        if (!upper(up[i][u], v)) u = up[i][u];
    }
    return up[0][v];
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    while ((1 << L) <= n) L++;
    L++;
    //g.resize(n + 1, vector<set<pair<int, int>>>(n + 1));
    //up.resize(n + 1, vector<vector<pair<int, int>>>(n + 1, vector<pair<int, int>>(L + 1)));
    //tin.resize(n + 1, vector<int>(n + 1));
    //tout.resize(n + 1, vector<int>(n + 1));
    up.resize(L + 1);
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    vector<bool> to(n, true);
    for (int i = 0; i <= n; i++){
        pair<int, int> cur = {0, 0};
        for (int j = 0; j < n; j++){
            pair<int, int> u = {cur.F + 1, cur.S + to[j]};
            if (!used[{cur, u}])
                g[cur].emplace_back(u);
            used[{cur, u}] = true;
            cur = u;
        }
        if (i != n)
            to[a[i] - 1] = false;
    }

    dfs({0, 0}, {0, 0});
    int q;
    cin >> q;
    while (q--){
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto ans = get({r1, c1}, {r2, c2});
        cout << ans.F << ' ' << ans.S << '\n';
    }
}

