#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>

#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ll Mod = 1234567891;
const ld eps = 1e-12;

std::vector<ll> count, cost;
std::vector<ll> real;
std::vector<pll> list;
std::vector<std::vector<ll>> gr;
std::vector<pll> min;
ll ans;

void dfs(ll i) {
	if (gr[i].size() == 0) {
		count[i] = list[i].first;
		ans += cost[i] * list[i].first;
		real[i] = list[i].first;
		min[i] = { cost[i], i };
		return;
	}
	min[i] = { cost[i], i };
	for (auto j : gr[i]) {
		dfs(j);
		count[i] += count[j];
		min[i] = std::min(min[i], min[j]);
	}
	if (count[i] < list[i].first) {
		ans += (list[i].first - count[i]) * min[i].first;
		real[min[i].second] += list[i].first - count[i];
		count[i] = list[i].first;
	}
	if (count[i] > list[i].second) {
		ans = Min;
		return;
	}
}

void solve() {
	ll n;
	std::cin >> n;
	ans = 0;
	real.assign(n, 0);
	gr.assign(n, {});
	min.assign(n, { Max, -1 });
	for (int i = 1; i < n; ++i) {
		ll p;
		std::cin >> p;
		gr[p - 1].push_back(i);
	}
	cost.resize(n, 0);
	count.assign(n, 0);
	list.resize(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> cost[i];
	}
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i].first >> list[i].second;
	}
	dfs(0);
	if (ans >= 0) {
		std::cout << ans << '\n';
		for (int i = 0; i < n; ++i) {
			std::cout << real[i] << ' ';
		}
		std::cout << '\n';
	}
	else {
		std::cout << -1 << '\n';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(100);
	ll t = 1;
	std::cin >> t;
	while (t--) {
		solve();
	}
}
