#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>

#define all(a) (a).begin(), (a).end()

using ll = int;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ll Mod = 1234567891;
const ld eps = 1e-12;

struct Bin {
	std::vector<std::vector<ll>> to;
	std::vector<ll> dist;

	void dfs(std::vector<std::vector<ll>>& gr, ll i, ll p, ll d) {
		dist[i] = d;
		for (auto j : gr[i]) {
			if (j != p) {
				to[0][j] = i;
				dfs(gr, j, i, d + 1);
			}
		}
	}

	Bin(std::vector<std::vector<ll>>& gr) {
		to.resize(12, std::vector<ll>(gr.size()));
		dist.resize(gr.size());
		dfs(gr, 0, -1, 0);
		for (int i = 1; i < 12; ++i) {
			for (int j = 0; j < gr.size(); ++j) {
				to[i][j] = to[i - 1][to[i - 1][j]];
			}
		}
	}

	ll lca(ll a, ll b) {
		if (dist[a] < dist[b]) {
			std::swap(a, b);
		}
		ll dif = dist[a] - dist[b];
		if (dif) {
			for (int i = 11; i >= 0; --i) {
				if ((1ll << i) <= dif) {
					dif -= (1ll << i);
					a = to[i][a];
				}
			}
		}
		if (a == b) return a;
		for (int i = 11; i >= 0; --i) {
			if (to[i][a] != to[i][b]) {
				a = to[i][a];
				b = to[i][b];
			}
		}
		return to[0][a];
	}
};

void solve() {
	ll n;
	std::cin >> n;
	std::vector<ll> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i];
	}
	std::vector<std::vector<ll>> num(n + 1);
	std::vector<pll> numr;
	std::vector<ll> now(n, 1);
	ll cnt = 0;
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= i; ++j) {
			numr.push_back({ i, j });
			num[i].push_back(cnt++);
		}
	}
	std::vector<std::vector<ll>> gr(cnt);
	for (int i = 0; i < n + 1; ++i) {
		ll r = 0, c = 0;
		for (int j = 0; j < n; ++j) {
			if (now[j]) {
				if (gr[num[r][c]].empty() || gr[num[r][c]].back() != num[r + 1][c + 1]) {
					gr[num[r][c]].push_back(num[r + 1][c + 1]);
				}
				r = r + 1;
				c = c + 1;
			}
			else {
				if (gr[num[r][c]].empty() || gr[num[r][c]].back() != num[r + 1][c]) {
					gr[num[r][c]].push_back(num[r + 1][c]);
				}
				r = r + 1;
			}
		}
		if (i != n) {
			now[list[i] - 1] = 0;
		}
	}
	Bin up(gr);
	for (int i = 0; i < gr.size(); ++i) {
		gr[i].clear();
		gr[i].shrink_to_fit();
	}
	ll q;
	std::cin >> q;
	for (int i = 0; i < q; ++i) {
		ll r1, c1, r2, c2;
		std::cin >> r1 >> c1 >> r2 >> c2;
		ll now = up.lca(num[r1][c1], num[r2][c2]);
		std::cout << numr[now].first << ' ' << numr[now].second << '\n';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(100);
	ll t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}
