#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

#define endl '\n'
#define int long long
#define float long double

using namespace std;

template<class T> int ckmin(T &a, const T &b) {
  if (b < a) {
    a = b;
    return 1;
  }
  return 0;
}

template<class T> int ckmax(T &a, const T &b) {
  if (b > a) {
    a = b;
    return 1;
  }
  return 0;
}

struct Tree {
  int n;
  vector<int> t;
  Tree();
  Tree(const vector<int> &a);
  void update(int i, int x);
  int query(int l, int r);
};

Tree::Tree() {}

Tree::Tree(const vector<int> &a) {
  n = (int) a.size();
  t.assign(n << 1, 0);
  for (int i = 0; i < n; ++i) {
    t[n + i] = a[i];
  }
  for (int i = n - 1; i >= 1; --i) {
    t[i] = t[i << 1] + t[i << 1 | 1];
  }
}

void Tree::update(int i, int x) {
  t[i += n] = x;
  for (i >>= 1; i >= 1; i >>= 1) {
    t[i] = t[i << 1] + t[i << 1 | 1];
  }
}

int Tree::query(int l, int r) {
  int ans = 0;
  for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
    if (l & 1) {
      ans += t[l++];
    }
    if (r & 1) {
      ans += t[--r];
    }
  }
  return ans;
}

int n;
vector<int> p;
vector<vector<int>> g;
vector<int> a;
vector<int> l;
vector<int> r;
vector<int> b;
vector<int> c;
vector<set<pair<int, int>>> q;
int ans = 0;

int get_b(int u, int v) {
  int ans = b[v];
  while (u != v) {
    ckmin(ans, b[u]);
    u = p[u];
  }
  return ans;
}

void update_b(int u, int v, int x) {
  b[v] -= x;
  while (u != v) {
    b[u] -= x;
    u = p[u];
  }
}

int dfs(int u) {
  int big = -1;
  vector<int> ch;
  b[u] = 0;
  for (const int &v : g[u]) {
    ch.push_back(dfs(v));
    if (ch.back() == -1) {
      return -1;
    }
    b[u] += r[v] - b[v];
    if (big == -1 || (int) q[big].size() < (int) q[ch.back()].size()) {
      big = ch.back();
    }
  }
  if (b[u] > r[u]) {
    return -1;
  }
  b[u] = r[u] - b[u];
  if (big == -1) {
    big = u;
  }
  for (const int &i : ch) {
    if (i == big) {
      continue;
    }
    for (const pair<int, int> &e : q[i]) {
      q[big].insert(e);
    }
    q[i].clear();
  }
  q[big].insert(make_pair(a[u], u));
  while (r[u] - b[u] < l[u]) {
    while (!q[big].empty() && get_b(q[big].begin()->second, u) == 0) {
      q[big].erase(q[big].begin());
    }
    if (q[big].empty()) {
      return -1;
    }
    int v = q[big].begin()->second;
    int cnt = min(get_b(v, u), l[u] - (r[u] - b[u]));
    update_b(v, u, cnt);
    c[v] += cnt;
    ans += a[v] * cnt;
  }
  return big;
}

void solve() {
  cin >> n;
  p.resize(n);
  p[0] = -1;
  g.assign(n, vector<int>());
  for (int i = 1; i < n; ++i) {
    cin >> p[i];
    --p[i];
    g[p[i]].push_back(i);
  }
  a.resize(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  l.resize(n);
  r.resize(n);
  for (int i = 0; i < n; ++i) {
    cin >> l[i] >> r[i];
  }
  b.resize(n);
  c.assign(n, 0);
  q.assign(n, set<pair<int, int>>());
  ans = 0;
  if (dfs(0) == -1) {
    cout << -1 << endl;
  } else {
    cout << ans << endl;
    for (int i = 0; i < n; ++i) {
      cout << c[i] << " ";
    }
    cout << endl;
  }
}

int32_t main() {
#ifndef LOCAL
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
#endif
  int t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
