#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define endl '\n'
#define int long long
#define float long double

using namespace std;

template<class T> int ckmin(T &a, const T &b) {
  if (b < a) {
    a = b;
    return 1;
  }
  return 0;
}

template<class T> int ckmax(T &a, const T &b) {
  if (b > a) {
    a = b;
    return 1;
  }
  return 0;
}

int k;
vector<int> d;

void solve() {
  int n, w, h;
  cin >> n >> w >> h;
  vector<pair<int, int>> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i].first >> a[i].second;
  }
  sort(a.begin(), a.end());
  vector<int> del(n, 0);
  set<pair<int, int>, greater<pair<int, int>>> q;
  for (int i = n - 1; i >= 0; --i) {
    while (!q.empty() && q.begin()->first >= a[i].second) {
      del[q.begin()->second] = 1;
      q.erase(q.begin());
    }
    q.insert(make_pair(a[i].second, i));
  }
  vector<pair<int, int>> new_a;
  for (int i = 0; i < n; ++i) {
    if (!del[i]) {
      new_a.push_back(a[i]);
    }
  }
  a = new_a;
  n = (int) a.size();
  for (int i = 0; i + 1 < n; ++i) {
    assert(a[i].first < a[i + 1].first);
    assert(a[i].second > a[i + 1].second);
  }
  int ans = (w - a[0].first) * (h - a[0].second);
  for (int i = 0; i + 1 < n; ++i) {
    ans += (w - a[i + 1].first) * (a[i].second - a[i + 1].second);
  }
  cout << ans << endl;
}

int32_t main() {
#ifndef LOCAL
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
#endif
  cin >> k;
  d.resize(k);
  for (int i = 0; i < k; ++i) {
    cin >> d[i];
  }
  assert(k == 1 && d[0] == 1);
  int t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
