#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)


mt19937 rnd(123123);


int n;
vector<int> p;


int insert(vector<int>& a, int x) {
	int i = a.size();
	a.push_back(x);
	while (i > 0 && a[i - 1] > a[i]) {
		swap(a[i], a[i - 1]);
		--i;
	}
	return i;
}


void relax(vector<vector<int>> &dp, int i, int j, int x) {
	if (i > j) {
		swap(i, j);
	}
	dp[i][j] = max(dp[i][j], x);
}


ll solve() {
	vector<vector<int>> dp(n, vector<int>(n, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			dp[i][j] = j - i;
		}
	}
	vector<int> a;
	for (int i = n - 1; i >= 0; --i) {
		int dst = insert(a, p[i]);
		for (int j = 0; j < i; ++j) {
			relax(dp, p[j], p[i], (i - j) + dst);
		}
	}
	a.clear();
	for (int i = 0; i < n; ++i) {
		int dst = i - insert(a, p[i]);
		for (int j = i + 1; j < n; ++j) {
			relax(dp, p[j], p[i], (j - i) + dst);
		}
	}
	ll res = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			res += dp[i][j];
		}
	}
	return res;
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	p.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		--p[i];
	}
	cout << solve() << "\n";
	return 0;
}