#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)
#define len(a) (int)(a.size())


mt19937 rnd(123123);


const ll inf = 1e17;


struct SGT {
	int n;
	vector<pair<ll, int>> t;


	void build(int _n) {
		n = 1;
		while (n < _n) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < n; ++i) {
			t[i + n] = make_pair(inf, i);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	void build(vector<ll> &a) {
		n = 1;
		while (n < a.size()) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < len(a); ++i) {
			t[i + n] = make_pair(a[i], i);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	void set(int i, ll x) {
		t[i + n] = make_pair(x, i);
		i += n;
		for (i /= 2; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	pair<ll, int> get(int l, int r) {
		l += n;
		r += n;
		pair<ll, int> res = make_pair(inf, n * 10);
		while (l < r) {
			if (l & 1) {
				res = min(res, t[l]);
				++l;
			}
			if (r & 1) {
				--r;
				res = min(res, t[r]);
			}
			l /= 2;
			r /= 2;
		}
		return res;
	}
};


int n;
vector<vector<int>> g;
vector<int> p;
vector<ll> c;
vector<ll> l, r;
vector<ll> b;
vector<int> tin, tout;
vector<ll> a;
SGT sgt;
vector<int> e;


void build() {
	a = r;
	sgt.build(n);
	for (int i = 0; i < n; ++i) {
		sgt.set(tin[i], c[i]);
	}
}


ll get_mn(int v) {
	ll res = inf;
	while (v != -1) {
		res = min(res, a[v]);
		v = p[v];
	}
	return res;
}


void add(int v, ll x) {
	while (v != -1) {
		a[v] += x;
		v = p[v];
	}
}


void dfs2(int v) {
	tin[v] = e.size();
	e.push_back(v);
	for (auto to : g[v]) {
		dfs2(to);
	}
	tout[v] = e.size();
}


int dfs3(int v) {
	int cnt = 0;
	for (auto to : g[v]) {
		int x = dfs3(to);
		if (x == -1) {
			return -1;
		}
		cnt += x;
	}
	if (cnt > r[v]) {
		return -1;
	}
	while (cnt < l[v]) {
		auto f = sgt.get(tin[v], tout[v]);
		if (f.first > inf / 2) {
			return -1;
		}
		int u = e[f.second];
		int mxc = get_mn(u);
		int dc = min(mxc, l[v] - cnt);
		add(u, -dc);
		cnt += dc;
		b[u] += dc;
		if (dc == mxc) {
			sgt.set(tin[u], inf);
		}
	}
	return cnt;
}


ll solve() {
	b.assign(n, 0);
	ll res = 0;
	tin.resize(n);
	tout.resize(n);
	e.clear();
	e.reserve(n);
	dfs2(0);
	build();
	int x = dfs3(0);
	if (x == -1) {
		return -1;
	}
	for (int i = 0; i < n; ++i) {
		res += c[i] * b[i];
	}
	return res;
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		g.assign(n, vector<int>());
		p.resize(n);
		p[0] = -1;
		for (int i = 1; i < n; ++i) {
			cin >> p[i];
			--p[i];
			g[p[i]].push_back(i);
		}
		c.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		l.resize(n);
		r.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> l[i] >> r[i];
		}
		ll res = solve();
		cout << res << "\n";
		if (res != -1) {
			for (int i = 0; i < n; ++i) {
				cout << b[i] << " ";
			}
			cout << "\n";
		}
	}
	return 0;
}