
#pragma GCC optimize("Ofast")


#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <string>
#include <set>
#include <map>


using namespace std;


#define int long long
#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define nlpt nullptr
#define prcs cout << fixed << setprecision(20)
#define len(a) (int)(a.size())


mt19937 rnd(123123);


const ll inf = 1e17;


struct SGT2 {
	int n;
	vector<int> t;
	vector<int> d;


	void upd(int v) {
		t[v] = min(t[v + v], t[v + v + 1]);
	}


	void apply(int v, ll x) {
		t[v] += x;
		d[v] += x;
	}


	void push(int v) {
		apply(v + v, d[v]);
		apply(v + v + 1, d[v]);
		d[v] = 0;
	}


	void build(int _n) {
		n = 1;
		while (n < _n) {
			n *= 2;
		}
		t.assign(n + n, 0);
		d.assign(n + n, 0);
	}


	void add(int v, int tl, int tr, int l, int r, int x) {
		if (tr < l || r < tl) {
			return;
		}
		if (l <= tl && tr <= r) {
			apply(v, x);
			return;
		}
		int tm = (tl + tr) / 2;
		push(v);
		add(v + v, tl, tm, l, r, x);
		add(v + v + 1, tm + 1, tr, l, r, x);
		upd(v);
	}


	void add(int l, int r, int x) {
		assert(l <= r);
		add(1, 0, n - 1, l, r, x);
	}


	ll get(int v, int tl, int tr, int l, int r) {
		if (tr < l || r < tl) {
			return inf;
		}
		if (l <= tl && tr <= r) {
			return t[v];
		}
		int tm = (tl + tr) / 2;
		push(v);
		return min(get(v + v, tl, tm, l, r), get(v + v + 1, tm + 1, tr, l, r));
	}


	ll get(int l, int r) {
		assert(l <= r);
		return get(1, 0, n - 1, l, r);
	}
};


struct SGT {
	int n;
	vector<pair<ll, int>> t;


	void build(int _n) {
		n = 1;
		while (n < _n) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < n; ++i) {
			t[i + n] = make_pair(inf, i);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	void build(vector<ll> &a) {
		n = 1;
		while (n < a.size()) {
			n *= 2;
		}
		t.resize(n + n);
		for (int i = 0; i < len(a); ++i) {
			t[i + n] = make_pair(a[i], i);
		}
		for (int i = n - 1; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	void set(int i, ll x) {
		t[i + n] = make_pair(x, i);
		i += n;
		for (i /= 2; i > 0; --i) {
			t[i] = min(t[i + i], t[i + i + 1]);
		}
	}


	pair<ll, int> get(int l, int r) {
		l += n;
		r += n;
		pair<ll, int> res = make_pair(inf, n * 10);
		while (l < r) {
			if (l & 1) {
				res = min(res, t[l]);
				++l;
			}
			if (r & 1) {
				--r;
				res = min(res, t[r]);
			}
			l /= 2;
			r /= 2;
		}
		return res;
	}
};


int n;
vector<vector<int>> g;
vector<int> p;
vector<ll> c;
vector<ll> l, r;
vector<ll> b;
vector<int> tin, tout;
vector<int> s;
vector<int> up;
vector<ll> a;
SGT sgt;
SGT2 sgt2;
vector<int> e;


void build() {
	// a = r;
	sgt.build(n);
	for (int i = 0; i < n; ++i) {
		sgt.set(tin[i], c[i]);
	}
	sgt2.build(n);
	for (int i = 0; i < n; ++i) {
		sgt2.add(tin[i], tin[i], r[i]);
	}
}


ll get_mn(int v) {
	ll res = inf;
	int cnt = 0;
	while (v != -1) {
		res = min(res, sgt2.get(tin[up[v]], tin[v]));
		v = p[up[v]];
		cnt += 1;
	}
	return res;
	/*
	ll res = inf;
	while (v != -1) {
		res = min(res, a[v]);
		v = p[v];
	}
	return res;
	*/
}


void add(int v, ll x) {
	int cnt = 0;
	while (v != -1) {
		sgt2.add(tin[up[v]], tin[v], x);
		v = p[up[v]];
		cnt += 1;
	}
	assert(cnt < 20);
	/*
	while (v != -1) {
		a[v] += x;
		v = p[v];
	}
	*/
}


void dfs0(int v) {
	s[v] = 1;
	int mxsi = -1;
	int mxs = -1;
	for (int i = 0; i < len(g[v]); ++i) {
		int to = g[v][i];
		dfs0(to);
		s[v] += s[to];
		if (s[to] > mxs) {
			mxs = s[to];
			mxsi = i;
		}
	}
	if (mxsi != -1) {
		swap(g[v][0], g[v][mxsi]);
	}
}


void dfs2(int v, int mup) {
	up[v] = mup;
	tin[v] = e.size();
	e.push_back(v);
	for (int i = 0; i < len(g[v]); ++i) {
		int to = g[v][i];
		int toup = to;
		if (i == 0) {
			toup = mup;
		}
		dfs2(to, toup);
	}
	tout[v] = e.size();
}


int dfs3(int v) {
	int cnt = 0;
	for (auto to : g[v]) {
		int x = dfs3(to);
		if (x == -1) {
			return -1;
		}
		cnt += x;
	}
	if (cnt > r[v]) {
		return -1;
	}
	while (cnt < l[v]) {
		auto f = sgt.get(tin[v], tout[v]);
		if (f.first > inf / 2) {
			return -1;
		}
		int u = e[f.second];
		int mxc = get_mn(u);
		int dc = min(mxc, l[v] - cnt);
		add(u, -dc);
		cnt += dc;
		b[u] += dc;
		if (dc == mxc) {
			sgt.set(tin[u], inf);
		}
	}
	return cnt;
}


ll solve() {
	b.assign(n, 0);
	ll res = 0;
	s.resize(n);
	dfs0(0);
	tin.resize(n);
	tout.resize(n);
	e.clear();
	e.reserve(n);
	up.resize(n);
	dfs2(0, 0);
	build();
	int x = dfs3(0);
	if (x == -1) {
		return -1;
	}
	for (int i = 0; i < n; ++i) {
		res += c[i] * b[i];
	}
	return res;
}





int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		g.assign(n, vector<int>());
		p.resize(n);
		p[0] = -1;
		for (int i = 1; i < n; ++i) {
			cin >> p[i];
			--p[i];
			g[p[i]].push_back(i);
		}
		c.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		l.resize(n);
		r.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> l[i] >> r[i];
		}
		ll res = solve();
		cout << res << "\n";
		if (res != -1) {
			for (int i = 0; i < n; ++i) {
				cout << b[i] << " ";
			}
			cout << "\n";
		}
	}
	return 0;
}