#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const ll INF = 1e18;
const int MAXR = 1001;

pair <ll, ll> find_minimal(vector <vector <int>> &graph, vector <ll> &l, vector <ll> &r, vector <ll> &cost, int u, ll capacity) {
    capacity = min(capacity, r[u] - l[u]);

    if (capacity == 0) {
        return make_pair(INF, -1);
    }

    pair <ll, ll> result{cost[u], u};
    for (int v: graph[u])
        result = min(result, find_minimal(graph, l, r, cost, v, capacity));

    return result;
}

void substract(vector <vector <int>> &graph, vector <ll> &l, vector <int> &p, int v, int until) {
    while (v != until) {
        l[v]++;
        v = p[v];
    }
}

bool dfs(vector <vector <int>> &graph, vector <ll> &answer, vector <ll> &l, vector <ll> &r, vector <ll> &cost, vector <int> &p, int u) {
    ll lsum = 0;

    for (int v: graph[u]) {
        if (dfs(graph, answer, l, r, cost, p, v))
            return true;

        answer[u] += answer[v];
        lsum += l[v];
    }

    while (lsum < l[u]) {
        auto [x, v] = find_minimal(graph, l, r, cost, u, INF);
        if (v == -1) {
            return true;
        }

        answer[u] += x;
        substract(graph, l, p, v, u);
        lsum++;
    }

    l[u] = max(l[u], lsum);;
    return false;
}

void solve() {
    int n;
    cin >> n;

    vector <int> p(n);
    vector <vector <int>> graph(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i]; p[i]--;
        graph[p[i]].emplace_back(i);
    }

    vector <ll> cost(n);
    for (ll &x: cost) cin >> x;

    vector <ll> l(n), r(n);
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];

    vector <ll> answer(n);
    if (dfs(graph, answer, l, r, cost, p, 0)) {
        cout << "-1\n";
        return;
    }


    for (int i = 0; i < n; i++) {
        if (l[i] > r[i]) {
            cout << "-1\n";
            return;
        }
    }

    cout << answer[0] << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    int t;
    cin >> t;

    while (t--)
    solve();
}
