#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

vector<set<size_t>> edges;
vector<size_t> parents, tin, tout;
void dfs(size_t u) {
    static size_t time = 0;

    tin[u] = time++;

    for (auto& v : edges[u]) {
        parents[v] = u;
        dfs(v);
    }

    tout[u] = time++;
}

vector<size_t> turns;
size_t n, i, j, a, q, r1, c1, r2, c2, id1, id2;
int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    cin >> n;
    if (n > 3000) return 1;

    turns.resize(n, 1);
    edges.resize((n + 1) * (n + 1));
    for (i = 0; i < n; i++) {
        edges[i * (n + 2)].insert((i + 1) * (n + 2));
    }

    for (i = 0; i < n; i++) {
        cin >> a; turns[a - 1] = 0;

        r1 = c1 = 0;
        for (j = 0; j < n; j++) {
            r2 = r1 + 1; c2 = c1 + turns[j];
            edges[r1 * (n + 1) + c1].insert(r2 * (n + 1) + c2);
            r1 = r2; c1 = c2;
        }
    }

    #ifdef LOCAL_JUDGE
    cout << "Edges:\n";
    for (size_t u = 0; u < edges.size(); u++) {
        for (auto& v : edges[u]) {
            cout << u / (n + 1) << " " << u % (n + 1) << " -> "
                 << v / (n + 1) << " " << v % (n + 1) << endl;
        }
    }
    #endif

    parents.resize((n + 1) * (n + 1));
    tin.resize((n + 1) * (n + 1));
    tout.resize((n + 1) * (n + 1));
    dfs(0);

    cin >> q; while (q--) {
        cin >> r1 >> c1 >> r2 >> c2;
        id1 = r1 * (n + 1) + c1;
        id2 = r2 * (n + 1) + c2;

        while (true) {
            if (tin[id1] <= tin[id2] && tout[id2] <= tout[id1]) {
                cout << id1 / (n + 1) << " " << id1 % (n + 1) << "\n";
                break;
            }
            if (tin[id2] <= tin[id1] && tout[id1] <= tout[id2]) {
                cout << id2 / (n + 1) << " " << id2 % (n + 1) << "\n";
                break;
            }
            id1 = parents[id1];
        }
    }

    return 0;
}
