#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#define int long long

using namespace std;

//map<pair<int, int>, set<pair<int, int>>> g;
//map<pair<int, int>, map<int, pair<int, int>>> up;


vector<set<int>> g;
map<pair<int, int>, int> id;
unordered_map<int, pair<int, int>> cell;
vector<vector<int>> up;
vector<int> tin, tout;
int timer = 0;

const int lg = 30;

void dfs(int v, int p = 0){
    up[v][0] = p;
    tin[v] = timer ++;
    //cout << v << " " << 0 << " " << up[v][0] << "\n";
    for (int i = 1; i < lg; i ++){
        up[v][i] = up[up[v][i - 1]][i - 1];
        //cout << v << " " << i << " " << up[v][i] << "\n";
    }
    for (auto u : g[v]){
        if (u == p) continue;
        dfs(u, v);
    }
    tout[v] = timer ++;
}

int num(pair<int, int> p){
    return id[p];
}

int check(int u, int v){
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca(int u, int v){
    if (check(u, v)){
        return u;
    }
    if (check(v, u)){
        return v;
    }

    //cout << u << " " << v << "\n";
    for (int i = lg - 1; i >= 0; i --){
        if (!check(up[u][i], v)){
            //cout << u << "\n";
            u = up[u][i];
        }
    }

    //cout << "ANS " << up[u][0] << "\n";
    return up[u][0];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    int cnt = 0;
    for (int x = 0; x <= n; x ++){
        for (int y = 0; y <= x; y ++){
            id[{x, y}] = cnt;
            cell[cnt] = {x, y};
            cnt ++;
        }
    }

    g.resize(cnt);
    tin.resize(cnt);
    tout.resize(cnt);
    up.resize(cnt, vector<int>(lg, 0));

    vector<int> c(n);
    vector<int> t(n, 1);
    vector<pair<int, int>> pos(n + 1);

    int x = 0, y = 0;
    pos[0] = {x, y};

    for (int i = 0; i < n; i ++){
        pos[i + 1] = {pos[i].first + 1, pos[i].second + t[i]};
        g[num(pos[i])].insert(num(pos[i + 1]));
    }

    for (int i = 0; i < n; i ++) {
        cin >> c[i];
        c[i]--;

        t[c[i]] = 0;
        for (int j = c[i]; j < n; j++) {
            auto p = pos[j];
            pos[j + 1] = {p.first + 1, p.second + t[j]};
            g[num(pos[j])].insert(num(pos[j + 1]));
        }

    }

    /*for (int i = 0; i < cnt; i ++){
        cout << i << "\n";
        cout << "TO" << "\n";
        for (auto &u : g[i]){
            cout << u << " ";
        }
        cout << "\n";
        cout << "\n";
    }

    cout << "Ok" << "\n";*/

    dfs(0);

    int q;

    cin >> q;

    int x1, y1, x2, y2;
    for (int i = 0; i < q; i ++){
        cin >> x1 >> y1 >> x2 >> y2;
        int u = num({x1, y1}), v = num({x2, y2});
        int M = lca(u, v);
        //cout << M << "\n";
        cout << cell[M].first << " " << cell[M].second << "\n";
    }

    return 0;
}
