#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <cassert>
#define int long long

using namespace std;

bool comp(pair <int, int> a, pair <int, int> b) {
	if (a.first == b.first)
		return a.second < b.second;
	return a.first < b.first;
}

void solve() {
	long long n, w, h;
	cin >> n >> w >> h;
	vector <pair <int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(a.begin(), a.end(), comp);
	long long may = h;
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		if (may > a[i].second) {
			ans += (long long)(w - a[i].first) * (may - a[i].second);
			may = a[i].second;
		}
	}
	cout << ans << "\n";
}

long long f(vector <pair <int, int>> a, long long w, long long h) {
	if (a.empty())
		return 0;
	int id = -1;
	int n = (int)a.size();
	for (int i = 0; i < n; i++)
		if (id == -1 || a[i].second < a[id].second)
			id = i;
	for (int i = 0; i < n; i++)
		if (i != id && a[i].second == a[id].second)
			return w * (h - a[id].second);

	long long ans = (w - a[id].first) * (h - a[id].second);
	int hg = h;
	for (int i = 0; i < n; i++)
		if (a[i].first >= a[id].first && i != id)
			hg = min(hg, a[i].second);
	ans += (h - hg) * a[id].first;
	vector <pair <int, int>> temp;
	for (int i = 0; i < n; i++)
		if (a[i].first < a[id].first && a[i].second < hg)
			temp.push_back(a[i]);
	ans += f(temp, a[id].first, hg);

	long long ans2 = a[id].first * (h - a[id].second);
	hg = h;
	for (int i = 0; i < n; i++)
		if (a[i].first <= a[id].first && i != id)
			hg = min(hg, a[i].second);
	ans2 += (w - a[id].first) * (h - hg);
	temp.clear();
	for (int i = 0; i < n; i++)
		if (a[i].first > a[id].first && a[i].second < hg)
			temp.push_back({ a[i].first - a[id].first, a[i].second });
	ans2 += f(temp, w - a[id].first, hg);
	return max(ans, ans2);
}

void solve1() {
	long long n, w, h;
	cin >> n >> w >> h;
	vector <pair <int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(a.begin(), a.end(), comp);
	cout << f(a, w, h) << "\n";
}

long long ff(vector <pair <int, int>> a, long long w, long long h) {
	if (a.empty())
		return 0;
	int n = (int)a.size();
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		long long temp = (w - a[i].first) * (h - a[i].second);
		int xr = a[i].first, yr = a[i].second;
		bool ok = false;
		for (int j = 0; j < n; j++) {
			if (j != i && a[j].first >= a[i].first && a[j].second >= a[i].second) {
				xr = max(xr, a[j].first); yr = max(yr, a[j].second);
				ok = true;
			}
		}
		if (ok) {
			temp -= a[i].first * a[i].second;
			temp += a[i].first * yr;
			temp += a[i].second * xr;
		}
		vector <pair <int, int>> t1, t2;
		for (int j = 0; j < n; j++) {
			if (a[j].first <= a[i].first && a[j].second >= yr)
				t1.push_back({ a[j].first, a[j].second - yr });
			if (a[j].second <= a[i].second && a[j].first >= xr)
				t2.push_back({ a[j].first - xr, a[j].second });
		}
		temp += ff(t1, a[i].first, h - yr);
		temp += ff(t2, w - xr, a[i].second);
		ans = max(ans, temp);
	}
	for (int i = n - 1; i >= 0; i--) {
		long long temp = a[i].first * a[i].second;
		int xr = a[i].first, yr = a[i].second;
		bool ok = false;
		for (int j = 0; j < n; j++) {
			if (j != i && a[j].first <= a[i].first && a[j].second <= a[i].second) {
				xr = min(xr, a[j].first);
				yr = min(yr, a[j].second);
				ok = true;
			}
		}
		if (ok) {
			temp += (w - xr) * (h - a[i].second);
			temp += (w - a[i].first) * (h - yr);
			temp -= (w - a[i].first) * (h - a[i].second);
		}
		vector <pair <int, int>> t1, t2;
		for (int j = 0; j < n; j++) {
			if (a[j].first >= a[i].first && a[j].second <= yr)
				t2.push_back({ a[j].first - a[i].first, a[j].second });
			if (a[j].second >= a[i].second && a[j].first <= xr)
				t1.push_back({ a[j].first, a[j].second - a[i].second });
		}
		temp += ff(t1, xr, h - a[i].second);
		temp += ff(t2, w - a[i].first, yr);
		ans = max(ans, temp);
	}
	return ans;
}

void solve2() {
	long long n, w, h;
	cin >> n >> w >> h;
	vector <pair <int, int>> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	sort(a.begin(), a.end(), comp);
	cout << ff(a, w, h) << "\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	int k;
	cin >> k;
	vector <int> kek(k);
	for (int i = 0; i < k; i++)
		cin >> kek[i];
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		if (k == 1)
			solve();
		else if (kek[1] == 2)
			solve1();
		else
			solve2();
	}
}