#include <bits/stdc++.h>

using namespace std;

#define vc vector
#define pii pair <int, int>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define sz(a) (int)a.size()
#define pb push_back

const int maxn = 1000, inf = 1e9 + 7, lg = 24;

int p[maxn], n;
set <int> g[maxn * maxn];

int encode (int x, int y) {
    return x * (n + 1) + y;
}

pii decode (int u) {
    return {u / (n + 1), u % (n + 1)};
}

void dfs (int x, int y, int h = 0) {
    if (h > n) return;
    int u = encode(x, y), v = encode(x + 1, y);
    if (!p[h]) ++v;
    g[u].insert(v);
    dfs(decode(v).first, decode(v).second, h + 1);
}

int up[maxn * maxn][lg];
int tin[maxn * maxn], tout[maxn * maxn], timer = 0;

void build (int u) {
    tin[u] = timer++;
    for (int i = 1; i < lg; ++i) {
        up[u][i] = up[up[u][i - 1]][i - 1];
    }
    for (int v: g[u]) {
        up[v][0] = u;
        build(v);
    }
    tout[u] = timer++;
}

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

void output (int u) {
    pii tmp = decode(u);
    cout << tmp.first << ' ' << tmp.second << '\n';
}

void solve () {
    cin >> n;
    vc <int> a(n);
    dfs(0, 0);
    forn (i, n) {
        cin >> a[i];
        p[a[i] - 1] = 1;
        dfs(0, 0);
    }
    build(0);
    int q;
    cin >> q;
    while (q--) {
        int x, y;
        cin >> x >> y;
        int u = encode(x, y);
        cin >> x >> y;
        int v = encode(x, y);
        if (is_ancestor(u, v)) {
            output(u);
            continue;
        }
        if (is_ancestor(v, u)) {
            output(v);
            continue;
        }
        for (int i = lg - 1; i >= 0; --i) {
            if (!is_ancestor(up[u][i], v)) {
                u = up[u][i];
            }
        }
        for (int i = lg - 1; i >= 0 ;--i) {
            if (!is_ancestor(up[v][i], u)) {
                v = up[v][i];
            }
        }
        output(up[u][0]);
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while(t--)solve();
}
