#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
const long long INF = 1000000000;

bool ifCan = true;
long long n, q, k;
long long time = 0;
vector<long long> a;
vector<vector<long long>> v;
vector<long long> PRED;
set<pair<long long, long long>> st;
vector<pair<long long, long long>> Time;
bool bl[5000];

long long toTree(long long r, long long c)
{
	return r * (r + 1) / 2 + c;
}

pair<long long, long long> toNum(long long tr)
{
	long long r = 0;
	long long c = 0;
	while (toTree(r, c) <= tr)
		r++;
	--r;
	c = tr - toTree(r, c);
	return make_pair(r, c);
}

void DFS(long long ver, long long pr)
{
	Time[ver].first = time++;
	for (auto j : v[ver])
	{
		if (j != pr)
			DFS(j, ver);
	}
	Time[ver].second = time++;
}

bool isP(long long i1, long long i2)
{
	return Time[i1].first <= Time[i2].first && Time[i2].second <= Time[i1].second;
}

long long getP(long long i1, long long i2)
{
	if (isP(i1, i2)) return i1;
	if (isP(i2, i1)) return i2;

	while (!isP(i1, i2))
	{
		i1 = PRED[i1];
	}

	return i1;
}

void UPD()
{
	long long R = 0;
	long long C = 0;
	for (long long i = 1; i <= n; ++i)
	{
		long long Rn = R + 1;
		long long Cn = C;
		if (!bl[i])
			Cn++;
		pair<long long, long long> vvv = make_pair(toTree(R, C), toTree(Rn, Cn));
		if (st.find(vvv) == st.end())
		{
			st.insert(vvv);
			v[vvv.first].push_back(vvv.second);
			//v[vvv.second].push_back(vvv.first);
			PRED[vvv.second] = vvv.first;
		}
		R = Rn;
		C = Cn;
	}
}

signed main()
{
	cin >> n;
	a.resize(n);
	v.resize(n * n + 3);
	Time.resize(n * n + 3);
	PRED.resize(n * n + 3);

	UPD();
	for (long long i = 0; i < n; ++i)
	{

		cin >> a[i];
		bl[a[i]] = true;
		UPD();
	}
	DFS(0, 0);
	cin >> q;
	for (long long i = 0; i < q; ++i)
	{
		long long c1, r1, c2, r2;
		cin >> c1 >> r1 >> c2 >> r2;
		pair<long long, long long> p = toNum(getP(toTree(c1, r1), toTree(c2, r2)));
		cout << p.first << " " << p.second << endl;
	}
}
