#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <queue>

#define ll long long
#define ld long double
#define int ll

using namespace std;

const int N = (1 << 20);

vector<int>a[N];
int par[N];
int bin_up[N][30];
int h[N];

void dfs(int v) {
	for (auto to : a[v]) {
		h[to] = h[v] + 1;
		dfs(to);
	}
}

int lca(int a, int b) {
	if (h[a] < h[b]) swap(a, b);
	for (int i = 29; i >= 0; --i) {
		if (h[bin_up[a][i]] >= h[b]) a = bin_up[a][i];
	}
	if (a == b) return a;
	for (int i = 29; i >= 0; --i) {
		if (bin_up[a][i] != bin_up[b][i]) {
			a = bin_up[a][i];
			b = bin_up[b][i];
		}
	}
	return par[a];
}

pair<int, int> Ans(int z) {
	int l = 0;
	int r = 301;
	while (r - l > 1) {
		int md = (l + r) / 2;
		if (md * (md + 1) / 2 <= z) l = md;
		else r = md;
	}
	return { l, z - (l * (l + 1) / 2) };
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector<bool>t(n);
	int ind = 0;
	for (int j = 0; j < n; ++j) {
		int xx = j * (n + 1) + ind;
		if (!t[j]) {
			++ind;
		}
		int yy = (j + 1) * (n + 1) + ind;
		a[xx].push_back(yy);
		par[yy] = xx;
	}
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		t[x - 1] = 1;
		int ind = 0;
		for (int j = 0; j < n; ++j) {
			int xx = j * (n + 1) + ind;
			if (!t[j]) {
				++ind;
			}
			int yy = (j + 1) * (n + 1) + ind;
			a[xx].push_back(yy);
			par[yy] = xx;
		}
	}
	for (int i = 0; i < (n + 1) * (n + 1); ++i) {
		h[i] = i / (n + 1);
		bin_up[i][0] = par[i];
		for (int j = 1; j < 30; ++j) {
			bin_up[i][j] = bin_up[bin_up[i][j - 1]][j - 1];
		}
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int l1, r1;
		cin >> l1 >> r1;
		int x1 = l1 * (n + 1) + r1;
		cin >> l1 >> r1;
		int y1 = l1 * (n + 1) + r1;
		int z1 = lca(x1, y1);
		cout << z1 / (n + 1) << ' ' << z1 % (n + 1) << '\n';
	}
}
