#include <iostream>
#include <vector>
#include <set>
#include <tuple>

using namespace std;

multiset<tuple<int, int, int> > st;

long long dfs(int v, vector<vector<int> > &graph, vector<int> &c, vector<int> &l, vector<int> &r, vector<int> &b)
{
	long long sum = 0;
	for(int i = 0; i < graph[v].size(); i++){
		long long a = dfs(graph[v][i], graph, c, l, r, b);
		if(a == -1)
			return -1;
		sum += a;
	}
	if(sum > r[v]){
		return -1;
	}
	st.insert({c[v], r[v], v});
	while(sum < l[v] && !st.empty()){
		auto [f, s, t]= *st.begin();
		st.erase(st.begin());
		if(s > l[v] - sum){
			st.insert({f, s - (l[v] - sum), t});
			b[t] += l[v] - sum;
			sum += l[v] - sum;
		}
		else{
			b[t] += s;
			sum += s;
		}
	}
	return sum;
}

void solve()
{
	int n;
	cin >> n;
	vector<vector<int> > v(n);
	for(int i = 1; i < n; i++){
		int a;
		cin >> a;
		v[a - 1].push_back(i);
	}
	vector<int> c(n);
	for(int i = 0; i < n; i++)
		cin >> c[i];
	vector<int> l(n), r(n);
	for(int i = 0; i < n; i++)
		cin >> l[i] >> r[i];
	vector<int> b(n, 0);
	long long sum = dfs(0, v, c, l, r, b);
	if(sum == -1)
		cout << -1;
	else{
		long long ans = 0;
		for(int i = 0; i < n; i++){
			ans += b[i] * c[i];
		}
		cout << ans << endl;
		for(int i = 0; i < n; i++)
			cout << b[i] << " ";
		//cout << endl;
	}
	st.clear();

}

int main()
{
    int t;
    cin >> t;
    while(t-- > 0)
		solve();
    return 0;
}
