#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

struct MergeSortTree {
};

void solve() {
	int n;
	cin >> n;

	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first;
		a[i].second = i;
	}

	vector<vector<int>> d(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int cnt1 = 0, cnt2 = 0;
			for (int k = i - 1; k >= 0; --k) cnt1 += (a[k] > a[i]);
			for (int k = j + 1; k < n; ++k) cnt2 += (a[k] < a[j]);
			d[i][j] = max(cnt1, cnt2) + j - i;
		}
	}

	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int x = min(a[i].second, a[j].second);
			int y = max(a[i].second, a[j].second);
			d[x][y] = max(d[x][y], j - i);
		}
	}

	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += d[i][j];
		}
	}

	cout << ans;
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}