#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

struct MergeSortTree {
	int size;
	vector<vector<int>> t;

	MergeSortTree(vector<pair<int, int>>& a) {
		size = sz(a);
		t.resize(4 * size);
		build(0, 0, size, a);
	}

	void build(int x, int lx, int rx, const vector<pair<int, int>>& a) {
		if (rx - lx == 1) {
			if (lx < size) {
				t[x] = { a[lx].first };
			}
		} else {
			int mx = (lx + rx) / 2;
			build(2 * x + 1, lx, mx, a);
			build(2 * x + 2, mx, rx, a);
			t[x].resize(sz(t[2 * x + 1]) + sz(t[2 * x + 2]));
			merge(t[2 * x + 1].begin(), t[2 * x + 1].end(), t[2 * x + 2].begin(), t[2 * x + 2].end(), t[x].begin());
		}
	}

	int get(int l, int r, int v, int x, int lx, int rx, bool kek) {
		if (lx >= r || rx <= l) return 0;
		if (lx >= l && rx <= r) {
			if (kek) return lower_bound(t[x].begin(), t[x].end(), v) - t[x].begin();
			else return r - l - (lower_bound(t[x].begin(), t[x].end(), v) - t[x].begin());
		} 
		int mx = (lx + rx) / 2;
		return get(l, r, v, 2 * x + 1, lx, mx, kek) + get(l, r, v, 2 * x + 2, mx, rx, kek);
	}
	int get(int l, int r, int v, bool kek) {
		return get(l, r, v, 0, 0, size, kek);
	}
};

void solve() {
	int n;
	cin >> n;

	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first;
		a[i].second = i;
	}

	MergeSortTree bebra(a);

	vector<vector<int>> d(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int cnt1 = bebra.get(0, i, a[i].first, true), cnt2 = bebra.get(j + 1, n, a[j].first, false);
			for (int k = i - 1; k >= 0; --k) cnt1 += (a[k] > a[i]);
			for (int k = j + 1; k < n; ++k) cnt2 += (a[k] < a[j]);
			d[i][j] = max(cnt1, cnt2) + j - i;
		}
	}

	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int x = min(a[i].second, a[j].second);
			int y = max(a[i].second, a[j].second);
			d[x][y] = max(d[x][y], j - i);
		}
	}

	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += d[i][j];
		}
	}

	cout << ans;
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}