//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

vector<vector<int>> g;
vector<int> p, c, le, ri, cur, cnt;

int dfs(int u) {
	int mn = u;
	for (int v : g[u]) {
		int kek = dfs(v);
		if (c[kek] < c[mn]) mn = kek;
	}
	for (int v : g[u]) {
		cur[v] += cur[v];
	}
	if (cur[u] < le[u]) {
		cnt[mn] += le[u] - cur[u];
		cur[u] = le[u];
	}
	return mn;
}

void solve() {
	int n;
	cin >> n;

	g.assign(n, {});
	p.assign(n, 0);
	c.assign(n, 0);

	for (int i = 1; i < n; ++i) {
		int j;
		cin >> j;
		--j;
		p[i] = j;
		g[j].push_back(i);
	}

	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}

	cnt.assign(n, 0);
	cur.assign(n, 0);
	le.assign(n, 0);
	ri.assign(n, 0);

	for (int i = 0; i < n; ++i) {
		cin >> le[i] >> ri[i];
	}

	dfs(0);

	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ans += ll(c[i]) * cnt[i];
	}

	cout << ans << '\n';
	for (int i = 0; i < n; ++i) {
		cout << cnt[i] << ' ';
	}
	cout << '\n';
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}