#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cassert>
#include <climits>

using namespace std;

#ifndef DESPAIR_101
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class A>
void print(A x) {
	cerr << x;
}
template<class A, class B>
void print(pair<A, B> x) {
	cerr << "(" << x.first << ' ' << x.second << ")";
}
template<class A>
void print(vector<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A>
void print(unordered_set<A> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}
template<class A, class B>
void print(unordered_map<A, B> x) {
	for (A el : x) {
		print(el);
		cerr << ' ';
	}
	cerr << '\n';
}

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << ":\n "; print(x); cerr << "\n";

int n;
const int N = 4000;

pair<int, int> p[N][N];
bool l[N];

void dfs(int x, int y, int d) {
	if (d == n) return;
	if (l[d]) {
		p[x + 1][y] = { x, y };
		dfs(x + 1, y, d + 1);
	} else {
		p[x + 1][y + 1] = { x, y };
		dfs(x + 1, y + 1, d + 1);
	}
}

void solve() {
	cin >> n;

	dfs(0, 0, 0);

	for (int i = 0; i < n; ++i) {
		int ind;
		cin >> ind;
		l[ind - 1] = true;
		dfs(0, 0, 0);
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; ++i) {
		pair<int, int> a;
		cin >> a.first >> a.second;
		pair<int, int> b;
		cin >> b.first >> b.second;

		while (a.first > b.first) a = p[a.first][a.second];
		while (b.first > a.first) b = p[b.first][b.second];
		while (a != b) {
			a = p[a.first][a.second], b = p[b.first][b.second];
		}

		cout << a.first << ' ' << a.second << '\n';
	}
}

signed main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int te = 1;
	//cin >> te;

	for (int t = 1; t <= te; ++t) {
		cerr << "_____Test #" << t << "_____\n";
		solve();
	}
}