#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()
#define pb push_back
#define INF (int) 1e18 / 2

using namespace std;

const int N = 5005;

vector<int> g[N];
int l[N], r[N], c[N];
int cnt[N];
int has[N];
multiset<pair<int, int>> dp[N];

bool ok = false;

int ans = 0;

void dfs(int v) {
    for (int u : g[v]) {
        dfs(u);
        if (dp[u].size() < dp[v].size())
            swap(dp[v], dp[u]);
        for (auto p : dp[u])
            dp[v].insert(p);
        dp[u].clear();
        cnt[v] += cnt[u];
    }
    if (cnt[v] > r[v])
        ok = false;
    dp[v].insert({c[v], v});
    for (auto[i, j] : dp[v]) {
        if (has[j] < r[j] && l[v] > cnt[v]) {
            int d = min(l[v] - cnt[v], r[j] - has[j]);
            ans += d * i;
            has[j] += d;
            cnt[v] += d;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    fill(g, g + n + 1, vector<int>());
    fill(cnt, cnt + n + 1, 0);
    fill(dp, dp + n + 1, multiset<pair<int, int>>());
    fill(has, has + n + 1, 0);
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].pb(i);
    }
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    ok = true;
    dfs(1);
    if (!ok) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
    for (int i = 1; i <= n; i++)
        cout << has[i] << " ";
    cout << '\n';
}

int32_t main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
}
