#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#include<bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e18;
const int N = 100005;
bool banned[N];
pair<int, int> lr[N];
int c[N], cnt[N], a[N], pr[N], sz[N];
vector<int> g[N];

void preDfs(int v, int p) {
    sz[v] = 1;
    for (int i : g[v]) {
        if (i == p) continue;
        preDfs(i, v);
        sz[v] += sz[i];
    }
}

void bansub(int v, int p) {
    if (banned[v]) return;
    banned[v] = 1;
    for (int i : g[v]) {
        if (i == p) continue;
        if (banned[i]) continue;
        bansub(i, v);
    }
}

pair<int, int> dfs2(int v, int p) {
    int big = -1, mx = 0;
    for (int i : g[v]) {
        if (i == p) continue;
        if (sz[i] > mx) {
            mx = sz[i];
            big = i;
        }
    }
    if (big == -1) {
        a[v] += lr[v].first;
        cnt[v] += lr[v].first;
        return make_pair(c[v], v);
    }
    pair<int, int> s = dfs2(big, v);
    cnt[v] += cnt[big];
    for (int i : g[v]) {
        if (i == p) continue;
        if (i == big) continue;
        pair<int, int> tmp = dfs2(i, v);
        cnt[v] += cnt[i];
        if (tmp.first < s.first) {
            s = tmp;
        }
    }
    if (s.first > c[v]) {
        s = {c[v], v};
    }
    if (cnt[v] >= lr[v].first) {
        return s;
    }
    int u = s.second;
    int need = lr[v].first - cnt[v];
    a[u] += need;
    cnt[v] += need;
    return s;
}

void build(int v, int p) {
    cnt[v] = a[v];
    for (int i : g[v]) {
        if (i == p) continue;
        build(i, v);
        cnt[v] += cnt[i];
    }
}

set<pair<int, int>> dfs(int v, int p) {
    int big = -1, mx = 0;
    for (int i : g[v]) {
        if (i == p) continue;
        if (sz[i] > mx) {
            mx = sz[i];
            big = i;
        }
    }
    if (big == -1) {
        set<pair<int, int>> s;
        int cur = v;
        a[cur] += lr[v].first;
        int toBan = -1;
        while (cur != -1) {
            cnt[cur] += lr[v].first;
            if (cnt[cur] >= lr[cur].second) {
                toBan = cur;
            }
            cur = pr[cur];
        }
        if (toBan != -1) bansub(toBan, pr[toBan]);
        s.insert({c[v], v});
        return s;
    }
    set<pair<int, int>> s = dfs(big, v);
    for (int i : g[v]) {
        if (i == p) continue;
        if (i == big) continue;
        set<pair<int, int>> tmp = dfs(i, v);
        for (auto j : tmp) s.insert(j);
    }
    s.insert({c[v], v});
    if (cnt[v] >= lr[v].first) {
        return s;
    }
    while (!s.empty()) {
        pair<int, int> cur = *s.begin();
        s.erase(cur);
        if (banned[cur.second]) continue;
        int maxcan = INF;
        int u = cur.second;
        while (u != -1) {
            maxcan = min(maxcan, lr[u].second - cnt[u]);
            u = pr[u];
        }
        if (maxcan >= lr[v].first - cnt[v]) {
            if (maxcan > lr[v].first - cnt[v])
                s.insert(cur);
            int u = cur.second;
            int toBan = -1;
            int need = lr[v].first - cnt[v];
            a[u] += need;
            while (u != -1) {
                cnt[u] += need;
                if (cnt[u] >= lr[u].second) {
                    toBan = u;
                }
                u = pr[u];
            }
            if (toBan != -1) bansub(toBan, pr[toBan]);
            break;
        }
        u = cur.second;
        int toBan = -1;
        int need = maxcan;
        a[u] += need;
        while (u != -1) {
            cnt[u] += need;
            if (cnt[u] >= lr[u].second) {
                toBan = u;
            }
            u = pr[u];
        }
        if (toBan != -1) bansub(toBan, pr[toBan]);
    }
    return s;
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, t = 1;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        banned[i] = 0;
        lr[i] = {0, 0};
        c[i] = 0;
        cnt[i] = 0;
        a[i] = 0;
        pr[i] = 0;
        sz[i] = 0;
    }
    pr[0] = -1;
    for (int i = 2; i <= n; ++i) {
        int v;
        cin >> v;
        g[i - 1].push_back(v - 1);
        g[v - 1].push_back(i - 1);
        pr[i - 1] = v - 1;
    }
    for (int i = 0; i < n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].first >> lr[i].second;
        if (lr[i].second != 1000000000) t = 0;
    }
    preDfs(0, 0);
    if (t == 1) dfs2(0, 0);
    else
        dfs(0, 0);
    build(0, 0);
    bool ok = 1;
    for (int i = 0; i < n; ++i) {
        if (cnt[i] < lr[i].first || cnt[i] > lr[i].second) ok = 0;
    }
    if (ok) {
        int res = 0;
        for (int i = 0; i < n; ++i) {
            res += (c[i] * a[i]);
        }
        cout << res << '\n';
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ' ';
        }
        cout << '\n';
    }
    else
        cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T;
    cin >> T;
    while (T--) solve();
}
//Please 100 pts uwu
