#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
typedef int_fast32_t ll;

using namespace std;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
        if (a < b) {
                a = b;
                return true;
        }       
        return false;
}

struct segment_tree {
	vector<ll> tree;
	ll size;
	segment_tree(ll n) {
		n++;
		size = n;
		tree.resize(size, 0);
	}
	ll get(ll l, ll r) {
		return get(r) - get(l);
	}
	ll get(ll x) {
		ll ans = 0;
		for (; x > 0; x -= x & -x) {
			ans += tree[x];
		}
		return ans;
	}
	void change(ll x) {
		x++;
		for (; x < size; x += x & -x) {
			tree[x]++;
		}
	}
};

struct segment_tree_min {
	vector<ll> tree;
        ll size;
        segment_tree_min(vector<ll> arr) {
                size = arr.size();
                while (size < arr.size()) {
                        size *= 2;
                }
                tree.resize(size * 4, INF);
		build(1, 0, size, arr);
        }
	void build(ll v, ll l, ll r, vector<ll>& arr) {
		if (r - l == 1) {
			tree[v] = arr[l];
			return;
		}
		ll mid = (l + r) / 2;
		build(v * 2, l, mid, arr);
		build(v * 2 + 1, mid, r, arr);
		tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
	}
        ll get(ll l, ll r) {
                return get(1, 0, size, l, r);
        }
        ll get(ll v, ll l, ll r, ll ql, ll qr) {
                if (ql <= l && r <= qr) {
                        return tree[v];
                }
                if (qr <= l || r <= ql) {
                        return INF;
                }
                ll mid = (l + r) / 2;
                return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
        }
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	vector<ll> qq(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> qq[i];
		qq[i]--;
	}
	segment_tree_min stm(qq);
	ll q;
	cin >> q;
	vector<ll> l(q * 2, -1), r(q * 2, n);
	vector<ll> c(q * 2), rr(q * 2);
	vector<vector<ll>> qs(n);
	for (ll i = 0; i < q; i++) {
		cin >> c[i * 2] >> rr[i * 2];
		cin >> c[i * 2 + 1] >> rr[i * 2 + 1];
		ll mid = (l[0] + r[0]) / 2;
		qs[mid].push_back(i * 2);
		qs[mid].push_back(i * 2 + 1);
	}
	ll log = 20;
	for (ll i = 0; i < log; i++) {
		segment_tree st(n);
		for (ll j = 0; j < n; j++) {
			st.change(qq[j]);
			while (!qs[j].empty()) {
				ll k = qs[j].back();
				qs[j].pop_back();
				if ((c[k] - st.get(0, c[k])) < rr[k]) {
					r[k] = j;
				} else {
					l[k] = j;
				}
				if (r[k] - l[k] > 1) {
					ll mid = (r[k] + l[k]) / 2;
					qs[mid].push_back(k);
				}
			}
		}
	}
	vector<vector<pair<ll, ll>>> ans(n + 1);
	for (ll i = 0; i < q; i++) {
		if (l[i * 2 + 1] < l[i * 2]) {
			swap(l[i * 2 + 1], l[i * 2]);
		}
		ans[l[i * 2] + 1].push_back(make_pair(min(min(c[i * 2], c[i * 2 + 1]), stm.get(l[i * 2] + 1, l[i * 2 + 1] + 1)), i));
	}
	segment_tree st(n);
	vector<pair<ll, pair<ll, ll>>> a;
	for (ll i = 0; i <= n; i++) {
		for (auto[j, k] : ans[i]) {
			a.push_back(make_pair(k, make_pair(j, j - st.get(0, j))));
		}
		if (i != n) {
			st.change(qq[i]);
		}
	}
	sort(a.begin(), a.end());
	for (auto[_, aa] : a) {
		cout << aa.first << ' ' << aa.second << '\n';
	}
}
