#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <numeric>
#include <map>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = unsigned int;
using int64 = long long;
using uint64 = unsigned long long;

const int64 INF = (int64)1e18 + 2;

void solve() {
	int n, w, h; cin >> n >> w >> h;
	vector <pair <int, int>> v(n);
	for (auto& [f, s] : v) cin >> f >> s;

	sort(rall(v));
	vector <pair <int, int>> st;
	for (auto& x : v) {
		while (!st.empty() && st.back().second >= x.second) {
			st.pop_back();
		}
		st.push_back(x);
	}
	v = st;
	n = v.size();

	int64 ans = 0;
	int64 pr = w;
	for (auto& [x, y] : v) {
		ans += (pr - x) * (h - y);
		pr = x;
	}

	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int k; cin >> k;
	vector <int> bipki(k);
	for (auto x : bipki) cin >> x;

	int q = 1; cin >> q;
	while (q--) {
		solve();
		cout << "\n\n";
	}
}