#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
//#pragma optimize("Ofast")
//#pragma optimize("unroll-loops")


vector<vector<int>> g;
vector<ll> c;
vector<pair<ll, ll>> bord;
bool bad = false;
const ll inf = (int) 2e9;


vector<int> euler;
vector<pair<int, int>> euler_ind;
vector<ll> sub_sum;
vector<ll> min_path;
vector<ll> cur;


void dfs0(int v) {
    euler_ind[v].first = euler.size();
    euler.push_back(v);
    for (int u: g[v]) dfs0(u);
    euler_ind[v].second = euler.size();
    euler.push_back(v);
}


void dfs2(int v, ll value) { // TODO: replace with fking segment tree
    min_path[v] = min(value, min_path[v]);
    for (int u: g[v]) dfs2(u, value);
}


void dfs(int v) {
    sub_sum[v] = 0;
    for (int u: g[v]) {
        dfs(u);
        sub_sum[v] += sub_sum[u];
    }
    cur[v] = 0;

    if (sub_sum[v] > bord[v].second) {
        bad = true;
    }
    if (bad) return;


    while (sub_sum[v] < bord[v].first) {
        min_path[v] = bord[v].second - sub_sum[v];
        for (int i = euler_ind[v].first; i < euler_ind[v].second; i++) { // TODO: Segment Tree
            min_path[euler[i]] = min(min_path[v], min_path[euler[i]]);
        }
        int ind = -1;
        for (int i = euler_ind[v].first; i < euler_ind[v].second; i++) { // TODO: Segment Tree
            int old = ((ind != -1) ? euler[ind] : 0);
            int tmp = euler[i];
            if (min_path[tmp]) {
                if (ind == -1 || c[old] > c[tmp]) ind = i;
            }
        }
        if (ind == -1) {
            bad = true;
            return;
        }
        ll tmp = min(min_path[euler[ind]], bord[v].first - sub_sum[v]);
        cur[euler[ind]] += tmp;
        sub_sum[v] += tmp;
        min_path[euler[ind]] -= tmp;
        dfs2(euler[ind], min_path[euler[ind]]);
    }
}


void solve() {
    bad = false;
    int n;
    cin >> n;
    g = vector<vector<int>>(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    c = vector<ll>(n);
    bord = vector<pair<ll, ll>>(n);
    for (int i = 0; i < n; i++) cin >> c[i];
    for (int i = 0; i < n; i++) cin >> bord[i].first >> bord[i].second;

    euler = {};
    sub_sum = vector<ll>(n);
    min_path = vector<ll>(n, inf);
    cur = vector<ll>(n);
    euler_ind = vector<pair<int, int>>(n);

    dfs0(0);
    dfs(0);
    if (bad) {
        cout << -1;
        return;
    }
    ll res = 0;
    for (int i = 0; i < n; i++) {
        res += (cur[i] * c[i]);
    }
    cout << res << '\n';
    for (ll i: cur) {
        cout << i << ' ';
    }
}


int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}