#pragma GCC optimize("O3")
#pragma GCC target("avx512f,bmi,lzcnt")
// #include <cassert>
// #include <iostream>
// constexpr int MEM = 5e8;
// int ptr = 0;
// char data[MEM];
// void *operator new(size_t s) {
//     ptr += s;
//     assert(ptr <= MEM);
//     return data + ptr - s;
// }
// void operator delete(void *) {
//     ;
// }
#include <bits/stdc++.h>

struct SG {
    std::vector<int> data;
    int size;

    SG(const std::vector<int> &vec) {
        size = 1 << 32 - __builtin_clz(vec.size() - 1);
        data.assign(2 * size, 1e9);
        std::copy(vec.begin(), vec.end(), data.begin() + size);
        for (int i = size - 1; i > 0; i--) {
            data[i] = std::min(data[2 * i], data[2 * i + 1]);
        }
    }

    int get(int l, int r) {
        int res = 1e9;
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l % 2) {
                res = std::min(res, data[l++]);
            }
            if (r % 2) {
                res = std::min(res, data[--r]);
            }
        }
        return res;
    }
};

struct ST {
    std::vector<int> data;
    int n;

    ST() = default;

    ST(int n) {
        data.assign(n + 2, 0);
        this->n = n + 1;
    }

    void clear() {
        std::fill(data.begin(), data.end(), 0);
    }

    void add(int i, int dlt) {
        for (i++; i <= n; i += i & -i) {
            data[i] += dlt;
        }
    }

    int get(int i) {
        int res = i;
        for (i++; i > 0; i -= i & -i) {
            res += data[i];
        }
        return res;
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<int> input(n);
    for (int &i : input) {
        std::cin >> i;
    }
    int q;
    std::cin >> q;
    std::vector<std::array<int, 4>> quer(q);
    std::vector<std::pair<int, int>> bin(q), pos(q);
    for (int i = 0; i < q; i++) {
        auto &[r1, c1, r2, c2] = quer[i];
        std::cin >> r1 >> c1 >> r2 >> c2;
        auto &[beg, end] = bin[i];
        beg = 0;
        end = std::min(r1, r2) + 1;
    }

    ST st(n);

    std::vector<std::vector<int>> help(n + 1);
    {
        std::vector<std::pair<int, int>> sch(2 * q, std::pair<int, int>(0, n + 1)), rc(2 * q);
        std::vector<bool> rs(2 * q);
        for (int i = 0; i < q; i++) {
            rc[2 * i] = {quer[i][0], quer[i][1]};
            rc[2 * i + 1] = {quer[i][2], quer[i][3]};
        }
        auto get = [&](int r, int c, int i) {
            auto &[beg, end] = sch[i];
            int mid = (beg + end) >> 1;
            help[mid].push_back(i);
        };
        for (int k = 0; (1 << k) <= n; k++) {
            for (auto &v : help) {
                v.clear();
            }
            for (int i = 0; i < q; i++) {
                auto &[r1, c1, r2, c2] = quer[i];
                auto &[p1, p2] = pos[i];
                get(r1, c1, 2 * i);
                get(r2, c2, 2 * i + 1);
            }
            st.clear();
            for (int i = 0; i <= n; i++) {
                for (int v : help[i]) {
                    auto &[beg, end] = sch[v];
                    int mid = (beg + end) >> 1;
                    auto &[r, c] = rc[v];
                    if (st.get(r) >= c) {
                        beg = mid;
                    } else {
                        end = mid;
                    }
                }
                if (i != n)
                    st.add(input[i], -1);
            }
        }
        for (int i = 0; i < q; i++) {
            pos[i] = {sch[2 * i].first, sch[2 * i + 1].first};
        }
    }
    std::vector<int> ans(q, -1);
    {
        SG sg(input);
        for (int i = 0; i < q; i++) {
            auto &[p1, p2] = pos[i];
            auto &[beg, end] = bin[i];
            int mn = sg.get(std::min(p1, p2), std::max(p1, p2));
            mn = std::min(mn, end);
            beg = std::max(0, mn - 1);
            end = std::min({n + 1, mn, end});
        }

        for (auto &v : help) {
            v.clear();
        }
        for (int i = 0; i < q; i++) {
            auto &[beg, end] = bin[i];
            auto &[p1, p2] = pos[i];
            help[p1].push_back(i);
            help[p2].push_back(i);
        }
        std::vector<int> cum(q);
        for (int k = 0; k < 1; k++) {
            st.clear();
            cum.assign(q, -1);
            for (int i = 0; i <= n; i++) {
                for (int v : help[i]) {
                    auto &[beg, end] = bin[v];
                    int mid = (beg + end) / 2;
                    int val = st.get(mid);
                    if (cum[v] == -1) {
                        cum[v] = val;
                    } else {
                        if (cum[v] == val) {
                            beg = mid;
                            ans[v] = val;
                        } else {
                            end = mid;
                        }
                    }
                }
                if (i != n)
                    st.add(input[i], -1);
            }
        }
    }

    for (int i = 0; i < q; i++) {
        auto &[beg, end] = bin[i];
        auto &[p1, p2] = pos[i];
        std::cout << beg << " " << ans[i] << "\n";
    }

    return 0;
}
