#include <bits/stdc++.h>

struct ST {
    std::vector<int> data;
    int n;

    ST() = default;

    ST(int n) {
        data.assign(n + 1, 0);
        this->n = n + 1;
    }

    void clear() {
        std::fill(data.begin(), data.end(), 0);
    }

    void add(int i, int dlt) {
        for (; i < n; i |= i + 1) {
            data[i] += dlt;
        }
    }

    int get(int i) {
        int res = i;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += data[i];
        }
        return res;
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<int> input(n);
    for (int &i : input) {
        std::cin >> i;
    }
    int q;
    std::cin >> q;
    std::vector<std::array<int, 4>> quer(q);
    std::vector<std::pair<int, int>> bin(q), pos(q);
    for (int i = 0; i < q; i++) {
        auto &[r1, c1, r2, c2] = quer[i];
        std::cin >> r1 >> c1 >> r2 >> c2;
        auto &[beg, end] = bin[i];
        beg = 0;
        end = std::min(r1, r2) + 1;
    }

    ST st(n);

    std::vector<std::vector<int>> help(n + 1);
    {
        std::vector<std::pair<int, int>> sch(2 * q, std::pair<int, int>(0, n + 1)), rc(2 * q);
        std::vector<bool> rs(2 * q);
        for (int i = 0; i < q; i++) {
            rc[2 * i] = {quer[i][0], quer[i][1]};
            rc[2 * i + 1] = {quer[i][2], quer[i][3]};
        }
        auto get = [&](int r, int c, int i) {
            auto &[beg, end] = sch[i];
            int mid = (beg + end) >> 1;
            help[mid].push_back(i);
        };
        for (int k = 0; (1 << k) <= n; k++) {
            for (auto &v : help) {
                v.clear();
            }
            for (int i = 0; i < q; i++) {
                auto &[r1, c1, r2, c2] = quer[i];
                auto &[p1, p2] = pos[i];
                get(r1, c1, 2 * i);
                get(r2, c2, 2 * i + 1);
            }
            st.clear();
            for (int i = 0; i <= n; i++) {
                for (int v : help[i]) {
                    auto &[beg, end] = sch[v];
                    int mid = (beg + end) >> 1;
                    auto &[r, c] = rc[v];
                    if (st.get(r) >= c) {
                        beg = mid;
                    } else {
                        end = mid;
                    }
                }
                if (i != n)
                    st.add(input[i], -1);
            }
        }
        for (int i = 0; i < q; i++) {
            pos[i] = {sch[2 * i].first, sch[2 * i + 1].first};
        }
    }
    std::vector<int> ans(q, 0);
    {
        for (auto &v : help) {
            v.clear();
        }
        for (int i = 0; i < q; i++) {
            auto &[beg, end] = bin[i];
            auto &[p1, p2] = pos[i];
            help[p1].push_back(i);
            help[p2].push_back(i);
        }

        std::vector<int> cum(q);
        for (int k = 0; (1 << k) <= n; k++) {
            st.clear();
            cum.assign(q, -1);
            for (int i = 0; i <= n; i++) {
                for (int v : help[i]) {
                    auto &[beg, end] = bin[v];
                    int mid = (beg + end) / 2;
                    if (cum[v] == -1) {
                        cum[v] = st.get(mid);
                    } else {
                        if (cum[v] == st.get(mid)) {
                            beg = mid;
                            ans[v] = st.get(mid);
                        } else {
                            end = mid;
                        }
                    }
                }
                if (i != n)
                    st.add(input[i], -1);
            }
        }
    }

    for (int i = 0; i < q; i++) {
        auto &[beg, end] = bin[i];
        auto &[p1, p2] = pos[i];
        std::cout << beg << " " << ans[i] << "\n";
    }

    return 0;
}
