#pragma GCC optimize("O3")
#pragma GCC target("avx512f,fma,avx512vl,avx512dq,avx512ifma")
#include <bits/stdc++.h>

struct Vector {
    int x, y;

    Vector() : x(0), y(0) {
        ;
    }

    Vector(int x, int y) : x(x), y(y) {
        ;
    }

    Vector operator+(const Vector& other) const {
        return Vector(x + other.x, y + other.y);
    }

    Vector operator-(const Vector& other) const {
        return Vector(x - other.x, y - other.y);
    }

    int64_t surf() const {
        return (x * 1LL * y);
    }

    bool operator<(const Vector& other) const {
        return std::pair{x, y} < std::pair{other.x, other.y};
    }
};

int64_t uni(std::vector<std::pair<Vector, Vector>>& vec, const std::vector<int>& vy) {
    int m = vy.size() - 1;
    static std::vector<int> cum;
    cum.assign(m, 0);
    static std::vector<std::array<int, 4>> ev;
    ev.clear();
    for (auto& [v1, v2] : vec) {
        if (v1.x > v2.x) {
            std::swap(v1.x, v2.x);
        }
        if (v1.y > v2.y) {
            std::swap(v1.y, v2.y);
        }

        int it1 = std::lower_bound(vy.begin(), vy.end(), v1.y) - vy.begin();
        int it2 = std::lower_bound(vy.begin(), vy.end(), v2.y) - vy.begin();
        ev.push_back({v1.x, 1, it1, it2});
        ev.push_back({v2.x, -1, it1, it2});
    }
    std::sort(ev.begin(), ev.end());
    int64_t ans = 0;
    for (int i = 0; i < ev.size(); i++) {
        auto [x1, d, l, r] = ev[i];
        int64_t rs = 0;
        for (int i = 0; i < m; i++) {
            rs += (vy[i + 1] - vy[i]) * 1LL * bool(cum[i]);
        }
        if (i > 0) {
            ans += rs * (x1 - ev[i - 1].front());
        }
        for (int i = l; i < r; i++) {
            cum[i] += d;
        }
    }
    return ans;
}

std::mt19937 rnd(13);

int64_t solve(Vector r, std::vector<Vector> vec) {
    if (vec.empty()) {
        return 0;
    }
    auto it = std::min_element(vec.begin(), vec.end(), [&](auto a, auto b) { return a.y < b.y; }) - vec.begin();
    std::vector<Vector> vec1, vec2;
    int64_t mn1 = 1e9, mn2 = 1e9;
    for (auto& v : vec) {
        if (v.x <= vec[it].x) {
            mn1 = std::min<int>(mn1, v.y);
        }
        if (v.x >= vec[it].x) {
            mn2 = std::min<int>(mn2, v.y);
        }
    }

    for (auto& v : vec) {
        if (v.x < vec[it].x && v.y < mn2) {
            vec1.push_back(v);
        }
        if (v.x > vec[it].x && v.x < mn1) {
            vec2.push_back(v);
        }
    }

    Vector r1 = Vector(vec[it].x, mn2);
    Vector r2 = Vector(r.x - vec[it].x, mn1);
    for (auto& v : vec2) {
        v.x -= vec[it].x;
    }
    int64_t ans1 = r.surf() - r1.surf() + solve(r1, vec1);
    int64_t ans2 = r.surf() - r2.surf() + solve(r2, vec2);
    return std::max(ans1, ans2);
}
std::vector<Vector> input;

void solve() {
    int n;
    Vector r;
    std::cin >> n;
    input.assign(n, Vector());
    std::cin >> r.x >> r.y;
    for (auto& [x, y] : input) {
        std::cin >> x >> y;
    }

    std::sort(input.begin(), input.end());

    int64_t ans = solve(r, input);

    std::cout << ans << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int k;
    std::cin >> k;
    std::vector<int> inp_dir(k);
    for (int& i : inp_dir) {
        std::cin >> i;
        i--;
    }

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
