#include <iostream>
#include<vector>
#include<algorithm>
#include<set>
using namespace std;

#define int long long

vector<int> answ;
vector<int> cost;
vector<int> l, r;
vector<int> need, cur;
vector<vector<int>> g;
vector<vector<int>> d;
vector<int> pred;

bool dfs(int i, int p, int deep) {
	d[deep].push_back(i);
	if (!g[i].size()) {
		cur[i] = l[i];
		need[i] = 0;
		answ[i] = l[i];
		return 0;
	}

	bool is = 0;
	for (int j : g[i]) {
		if (j != p) {
			pred[j] = pred[i];
			is |= dfs(j, i, deep + 1);
		}
	}

	if (is) {
		return 1;
	}

	int tmp = 0;
	for (int j : g[i]) {
		if (j != p) {
			tmp += cur[j];
		}
	}

	if (tmp > r[i]) {
		return 1;
	}

	cur[i] = tmp;
	need[i] = max(0, l[i] - cur[i]);

	return 0;
}

struct elem {
	int ind;
	bool operator<(const elem other) const {
		return pair<int, int>{cost[ind], ind} < pair<int, int>{cost[other.ind], other.ind};
	}
};

int tum = 0;

set<elem>* solve(int i, int p) {
	if (!g[i].size()) {
		set<elem>* st = new set<elem>;
		if (r[i] != l[i])
			st->insert(elem{i});

		return st;
	}

	vector<set<elem>*> vec;
	for (int j : g[i]) {
		if (j != p) {
			vec.push_back(solve(j, i));
		}
	}

	if (tum) {
		return new set<elem>;
	}

	sort(vec.begin(), vec.end(), [](set<elem>* a, set<elem>* b) {
		return a->size() < b->size();
		});

	auto ans = *(vec.begin());
	vec.erase(vec.begin());

	for (int i = 0; i < vec.size(); i++) {
		set<elem> st = *vec[i];
		for (auto j : st) {
			ans->insert(j);
		}
	}

	if (answ[i] < r[i]) {
		ans->insert(elem{ i });
	}

	while (need[i] != 0) {
		if (ans->size() == 0) {
			tum = 1;
			break;
		}

		auto k = (*(ans->begin()));
		if (answ[k.ind] < r[k.ind]) {
			int tmpp = need[i];
			need[i] -= min(tmpp, (-answ[k.ind] + r[k.ind]));
			answ[k.ind] += min(tmpp, (-answ[k.ind] + r[k.ind]));
		}
		else {
			ans->erase(k);
		}
	}

	return ans;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int z = 0; z < t; z++) {
		int n;
		cin >> n;

		cost.clear();
		//dp.clear();
		l.clear();
		r.clear();
		cur.assign(n, 0);
		need.assign(n, 0);
		g.assign(n, {});
		d.assign(n, {});
		pred.assign(n, 0);
		tum = 0;
		answ.assign(n, 0);

		for (int i = 0; i < n - 1; i++) {
			int a;
			cin >> a;
			a--;

			g[a].push_back(i + 1);
		}

		for (int i = 0; i < n; i++) {
			int a;
			cin >> a;

			cost.push_back(a);
		}

		for (int i = 0; i < n; i++) {
			int a, b;
			cin >> a >> b;

			l.push_back(a);
			r.push_back(b);
		}

		bool is = dfs(0, 0, 0);
		if (is) {
			cout << -1 << "\n";
			continue;
		}

		solve(0, 0);
		int all = 0;
		for (int i = 0; i < n; i++) {
			all += answ[i] * cost[i];
		}

		cout << all << "\n";
		for (int i = 0; i < n; i++) {
			cout << answ[i] << ' ';
		}
		cout << "\n";
	}
}

/*

//////////////////////////////////////////
5
5 2 4 1 3
10
2 1 6 8 3 5 9 10 7 4
2
2 1


/////////////////////////////////////////
3
3
1 1 
3 1 2
5 7
1 2
2 4
2
1
5 5
0 1
2 2
10
1 1 2 2 2 6 6 3 3
1 2 3 4 5 6 7 8 9 10
50 100
10 20
5 10
5 10
5 10
5 10
5 10
5 10
5 10
5 10
*/