#include "bits/stdc++.h"

using namespace std;


#define ll long long
#define vi vector<ll>
#define pii pair<ll, ll>
#define all(x) x.begin(), x.end()

const ll MAXN = 5e5 + 10;
const ll INF = 2e9;

struct tree_search {
    ll t[4 * MAXN];

    void add(ll v, ll tl, ll tr, ll pos) {
        if (tl + 1 == tr) return void(t[v] = 1);
        ll tm = (tl + tr) / 2;
        if (pos < tm) add(2 * v, tl, tm, pos);
        else add(2 * v + 1, tm, tr, pos);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    ll ask(ll v, ll tl, ll tr, ll l, ll r) {
        if (tl >= r || l >= tr) return 0;
        if (l <= tl && tr <= r) return t[v];
        ll tm = (tl + tr) / 2;
        return ask(2 * v, tl, tm, l, r) + ask(2 * v + 1, tm, tr, l, r);
    }

    ll find_pos(ll v, ll tl, ll tr, ll x) {
        if (t[v] <= x) return tr;
        if (tl + 1 == tr) return tl;
        ll tm = (tl + tr) / 2;
        if (t[2 * v] > x) return find_pos(2 * v, tl, tm, x);
        else return find_pos(2 * v + 1, tm, tr, x - t[2 * v]);
    }
};

struct tree_min {
    ll t[4 * MAXN];

    void build(ll v, ll tl, ll tr, vi &a) {
        if (tl + 1 == tr) return void(t[v] = a[tl]);
        ll tm = (tl + tr) / 2;
        build(2 * v, tl, tm, a);
        build(2 * v + 1, tm, tr, a);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    ll ask(ll v, ll tl, ll tr, ll l, ll r) {
        if (tl >= r || l >= tr) return INF;
        if (l <= tl && tr <= r) return t[v];
        ll tm = (tl + tr) / 2;
        return min(ask(2 * v, tl, tm, l, r), ask(2 * v + 1, tm, tr, l, r));
    }
};

tree_search t_find;
tree_search t_ans;
tree_min t_pref;

struct query {
    ll r1, c1, r2, c2;
    query(ll r1, ll c1, ll r2, ll c2): r1(r1), c1(c1), r2(r2), c2(c2) {}
    query() = default;
};

struct point {
    ll r, c, ind;
    point(ll r, ll c, ll ind): r(r), c(c), ind(ind) {}
    point() = default;
};

query qs[MAXN];
vector<point> prefs[MAXN];
ll t[2 * MAXN];
ll len[MAXN];
vector<pii> ask[MAXN];
ll ans[MAXN];

void solve() {
    ll n; cin >> n;
    vi a(n); for (ll &i : a) cin >> i, --i;
    vector<pii> sort_a(n);
    for (ll i = 0; i < n; ++i) {
        sort_a[i] = make_pair(a[i], i);
    }
    sort(all(sort_a));
    ll q; cin >> q;
    for (ll i = 0; i < q; ++i) {
        ll r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        c1 = r1 - c1, c2 = r2 - c2;
        prefs[r1].push_back(point(r1, c1, 2 * i));
        prefs[r2].push_back(point(r2, c2, 2 * i + 1));
        qs[i] = query(r1, c1, r2, c2);
    }
    for (ll i = 0; i < n + 1; ++i) {
        for (auto pt: prefs[i]) {
            t[pt.ind] = t_find.find_pos(1, 0, n, pt.c);
        }
        if (i != n) t_find.add(1, 0, n, sort_a[i].second);
    }
    t_pref.build(1, 0, n, a);
    for (ll i = 0; i < q; ++i) {
        if (t[2 * i] > t[2 * i + 1]) swap(t[2 * i], t[2 * i + 1]);
        len[i] = t_pref.ask(1, 0, n, t[2 * i], t[2 * i + 1]);
        if (t[2 * i] != t[2 * i + 1]) ask[t[2 * i]].push_back(make_pair(len[i], i));
    }
    for (ll i = 0; i <= n; ++i) {
        for (auto l : ask[i]) {
            ans[l.second] = t_ans.ask(1, 0, n, 0, l.first);
        }
        if (i != n) t_ans.add(1, 0, n, a[i]);
    }
    for (ll i = 0; i < q; ++i) {
        if (t[2 * i] == t[2 * i + 1]) {
            if (qs[i].r1 < qs[i].r2) cout << qs[i].r1 << " " << qs[i].r1 - qs[i].c1 << "\n";
            else cout << qs[i].r2 << " " << qs[i].r2 - qs[i].c2 << "\n";
        } else {
            cout << len[i] << " " << len[i] - ans[i] << "\n";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif

    //ll t; cin >> t;
    //while (t--)
    solve();
}
