#include <bits/stdc++.h>

using num = long long;

struct Vertex
{
    num r, c;
    num p;
    std::vector<num> children;
};
std::vector<Vertex> graph;

num count(num r)
{
    return (r+1)*r/2;
}

num coords_to_ind(num r, num c)
{
    return count(r) + c;
}

void build_path(std::vector<bool> const& to_right)
{
    num curr = 0;
    num r = 0, c = 0;

    for(num i = 0; i < to_right.size(); i++)
    {
        r++;
        if(to_right[i])
            c++;
        const num next = coords_to_ind(r, c);
        graph[curr].children.push_back(next);
        graph[next].p = curr;
        curr = next;
    }
}

int main()
{
    num n;
    std::cin >> n;
    const num size = count(n+1);

    graph.resize(size);
    for(num i = 0, r = 0; r <= n; r++)
    {
        for(num c = 0; c <= r; c++, i++)
        {
            graph[i].r = r;
            graph[i].c = c;
        }
    }

    std::vector<bool> to_right(n, true);
    build_path(to_right);

    for(num i = 0; i < n; i++)
    {
        num a;
        std::cin >> a;
        to_right[a-1] = false;
        build_path(to_right);
    }

    num q;
    std::cin >> q;
    while(q--)
    {
        num r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        if(r1 > r2)
        {
            std::swap(r1, r2);
            std::swap(c1, c2);
        }

        num p1 = coords_to_ind(r1, c1), p2 = coords_to_ind(r2, c2);
        while(r1 < r2)
        {
            p1 = graph[p1].p;
            r1++;
        }

        while(p1 != p2)
        {
            p1 = graph[p1].p;
            p2 = graph[p2].p;
        }

        std::cout << graph[p1].r << ' ' << graph[p1].c << '\n';
    }
}