#include <bits/stdc++.h>

using num = int;

const num lg2 = std::__lg(500'000);

struct Vertex
{
    num r, c;
    std::vector<num> children;
    num up[lg2] {-1};
    num timein, timeout;
};
std::vector<Vertex> graph;

num count(num r)
{
    return (r+1)*r/2;
}

num coords_to_ind(num r, num c)
{
    return count(r) + c;
}

void build_path(std::vector<bool> const& to_right)
{
    num curr = 0;
    num r = 0, c = 0;

    for(bool bit : to_right)
    {
        r++;
        if(bit)
            c++;
        const num next = coords_to_ind(r, c);
        if(graph[next].up[0] == -1) {
            graph[curr].children.push_back(next);
            graph[next].up[0] = curr;
        }
        curr = next;
    }
}

num diag(num r, num c)
{
    return r - c;
}

num t = 0;
void dfs(num v)
{
    graph[v].timein = t++;

    for(num i = 1; i < lg2; i++)
        graph[v].up[i] = graph[graph[v].up[i-1]].up[i-1];

    for(auto u : graph[v].children)
        dfs(u);

    graph[v].timeout = t++;
}

bool is_above(num v, num u)
{
    return graph[v].timein <= graph[u].timein && graph[v].timeout >= graph[u].timeout;
}

num lca(num v, num u)
{
    if(is_above(v, u))
        return v;
    if(is_above(u, v))
        return u;

    for(num i = lg2-1; i >= 0; i--)
        if(!is_above(graph[v].up[i], u))
            v = graph[v].up[i];

    return graph[v].up[0];
}

int main()
{
    num n;
    std::cin >> n;

    // <на 3>
    if(n > 3000) {
        for (num i = 0; i < n; i++) {
            num a;
            std::cin >> a;
        }

        num q;
        std::cin >> q;
        while (q--) {
            num r1, c1, r2, c2;
            std::cin >> r1 >> c1 >> r2 >> c2;
            if (r1 > r2) {
                std::swap(r1, r2);
                std::swap(c1, c2);
            }

            if (diag(r1, c1) == diag(r2, c2)) {
                std::cout << r1 << ' ' << c1 << '\n';
                continue;
            }

            std::cout << std::min(diag(r1, c1), diag(r2, c2)) << " 0\n";
        }

        return 0;
    }
    // </на 3>

    const num size = count(n+1);

    graph.resize(size);
    for(num i = 0, r = 0; r <= n; r++)
    {
        for(num c = 0; c <= r; c++, i++)
        {
            graph[i].r = r;
            graph[i].c = c;
        }
    }

    std::vector<bool> to_right(n, true);
    build_path(to_right);

    for(num i = 0; i < n; i++)
    {
        num a;
        std::cin >> a;
        to_right[a-1] = false;
        build_path(to_right);
    }

    graph[0].up[0] = 0;
    dfs(0);

    num q;
    std::cin >> q;
    while(q--)
    {
        num r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        if(r1 > r2)
        {
            std::swap(r1, r2);
            std::swap(c1, c2);
        }

        num p1 = coords_to_ind(r1, c1), p2 = coords_to_ind(r2, c2);
        p1 = lca(p1, p2);

        std::cout << graph[p1].r << ' ' << graph[p1].c << '\n';
    }
}