#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

#define all(a) (a).begin(), (a).end()


void dfs(int u, int v, vector < int >& g, vector < vector < int > >& p) {
	if (u == g.size())
		return;

	p[u + 1][v + g[u]] = v;
	dfs(u + 1, v + g[u], g, p);
}


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;

	bool ch = true;
	vector < int > a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];

		ch = ch && a[i] == i + 1;
	}

	if (ch) {
		int q;
		cin >> q;

		for (; q; q--) {
			int r1, c1, r2, c2;
			cin >> r1 >> c1 >> r2 >> c2;

			if (r1 < r2) {
				swap(r1, r2);
				swap(c1, c2);
			}

			if (r1 - c1 != r2 - c2) {
				int l = min(r1 - c1, r2 - c2);

				cout << l << " 0\n";
			}
			else
				cout << r2 << " " << c2 << "\n";

		}

		return 0;
	}

	vector < vector < int > > p(n + 1, vector < int >(n + 1));
	vector < int > ord(n, 1);
	dfs(0, 0, ord, p);
	for (int el : a) {
		ord[el - 1] = 0;
		dfs(0, 0, ord, p);
	}

	int q;
	cin >> q;

	for (; q; q--) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;

		if (r1 < r2) {
			swap(r1, r2);
			swap(c1, c2);
		}

		for (; r1 > r2; c1 = p[r1][c1], r1--) {}

		for (; c1 != c2; c1 = p[r1][c1], c2 = p[r2][c2], r1--, r2--) {}

		cout << r1 << " " << c1 << "\n";
	}

	return 0;
}