#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

#define all(a) (a).begin(), (a).end()


struct Point {
	ll x, y;
	int id;

	Point(int x = 0, int y = 0, int id = -1) {
		this->x = x;
		this->y = y;
		this->id = id;
	}
};


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int k;
	cin >> k;

	vector < int > can(k);
	for (int& el : can)
		cin >> el;

	int t;
	cin >> t;

	for (; t; t--) {
		int n;
		ll w, h;
		cin >> n >> w >> h;

		vector < Point > p(n);
		for (int i = 0; i < n; i++) {
			cin >> p[i].x >> p[i].y;

			p[i].id = i;
		}
		sort(all(p), [&](Point a, Point b) {
			return a.x > b.x || a.x == b.x && a.y < b.y;
		});

		ll sm = 0;
		vector < Point > st;
		for (Point cur : p) {
			for (; !st.empty() && cur.y <= st.back().y; ) {
				ll cur_sm = (w - st.back().x) * (h - st.back().y), cur_y = st.back().y;
				st.pop_back();
				if (!st.empty())
					cur_sm -= (w - st.back().x) * (h - cur_y);
				sm -= cur_sm;
			}
			
			ll cur_sm = (w - cur.x) * (h - cur.y);
			if (!st.empty())
				cur_sm -= (w - st.back().x) * (h - cur.y);
			sm += cur_sm;
			st.push_back(cur);
		}

		if (k == 1) {
			cout << sm << "\n";
			continue;
		}
	}

	return 0;
}