
#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MAXN = 5000 + 10;
const int INF = 1e14 + 7;


vector<int> graph[MAXN];
vector<vector<int>> p[MAXN];

int dp[MAXN][MAXN];
int l[MAXN], r[MAXN];
int c[MAXN];

int sum_l[MAXN], sum_r[MAXN];


void dfs(int v) {
    for (int u: graph[v]) {
        dfs(u);
        sum_l[v] += l[u];
        sum_r[v] += r[u];
    }
    l[v] = max(sum_l[v], l[v]);
    for (int i = 0; i <= r[v] - sum_l[v]; ++i) {
        dp[v][i] = i * c[v];
    }
    p[v].resize(graph[v].size(), vector<int>(min(r[v], MAXN - 1) + 1));
    for (int i = 0; i < graph[v].size(); ++i) {
        int u = graph[v][i];
        for (int w = min(r[v], MAXN - 1); w >= l[u]; --w) {
            int best = INF;
            int best_p = -1;
            for (int w2 = l[u]; w2 <= min(w, r[u]); ++w2) {
                if (dp[v][w - w2] + dp[u][w2] < best) {
                    best = dp[v][w - w2] + dp[u][w2];
                    best_p = w2;
                }
            }
            p[v][i][w] = best_p;
            dp[v][w] = best;
        }
    }
}

int res[MAXN];

void ans(int v, int w) {
    for (int i = ((int) graph[v].size()) - 1; i >= 0; --i) {
        ans(graph[v][i], p[v][i][w]);
        w -= p[v][i][w];
    }
    res[v] = w;
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;

    while (t-- > 0) {
        int n;
        cin >> n;
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            --p;
            graph[p].push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        dfs(0);
        int mn = INF;
        int best_w = -1;
        for (int i = l[0]; i <= r[0]; ++i) {
            if (dp[0][i] < mn) {
                mn = dp[0][i];
                best_w = i;
            }
        }
        if (best_w != -1)
            ans(0, best_w);
        if (best_w != -1) {
            cout << mn << "\n";
            for (int i = 0; i < n; ++i) {
                cout << res[i] << " ";
            }
            cout << "\n";
        } else
            cout << "-1\n";
        for (int i = 0; i < n; ++i) {
            graph[i].clear();
            p[i].clear();
            sum_l[i] = 0;
            sum_r[i] = 0;
            for (int j = 0; j <= min(MAXN - 1, r[i]); ++j) {
                dp[i][j] = 0;
            }
        }
    }
    return 0;
}
