#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>


#define int long long
#define ll long long


using namespace std;

const int MAXN = 5000 + 10;
const ll INF = 1e14 + 7;


vector<int> graph[MAXN];
vector<vector<int>> p[MAXN];

ll dp[MAXN][MAXN];
int l[MAXN], r[MAXN];
ll c[MAXN];

int sum_l[MAXN], sum_r[MAXN];

ll get_dp(int v, int w) {
    int mx = min({r[v], MAXN - 1, sum_r[v]});
    if (w < mx) return dp[v][w];
    return dp[v][mx] + max(0ll, w - mx) * c[v];
}


void dfs(int v) {
    for (int u: graph[v]) {
        r[u] = min(r[u], r[v]);
        dfs(u);
        sum_r[v] += r[u];
    }
    int mx_size = min({sum_r[v], r[v], MAXN - 1});
    for (int i = 0; i <= mx_size; ++i) {
        dp[v][i] = i * c[v];
    }
    p[v].resize(graph[v].size(), vector<int>(mx_size + 1));
    for (int i = 0; i < graph[v].size(); ++i) {
        int u = graph[v][i];
        for (int w = mx_size; w >= 0; --w) {
            ll best = INF;
            int best_p = -1;
            for (int w2 = l[u]; w2 <= min({w, r[u]}); ++w2) {
                if (dp[v][w - w2] + get_dp(u, w2) < best) {
                    best = dp[v][w - w2] + get_dp(u, w2);
                    best_p = w2;
                }
            }
            p[v][i][w] = best_p;
            dp[v][w] = best;
        }
    }
}

int res[MAXN];

void ans(int v, int w) {
    int mx = min({r[v], MAXN - 1, sum_r[v]});
    if (w > mx) {
        res[v] += w - mx;
        w = mx;
    }
    for (int i = ((int) graph[v].size()) - 1; i >= 0; --i) {
        ans(graph[v][i], p[v][i][w]);
        w -= p[v][i][w];
    }
    res[v] += w;
}

void ansss(int v, int w) {
    for (int i = ((int) graph[v].size()) - 1; i >= 0; --i) {
        ansss(graph[v][i], p[v][i][w]);
        w -= p[v][i][w];
    }
    res[v] = w;
}

void dfssss(int v) {
    for (int u: graph[v]) {
        r[u] = min(r[u], r[v]);
        dfssss(u);
        sum_l[v] += l[u];
    }
    l[v] = max(sum_l[v], l[v]);
    for (int i = 0; i <= r[v] - sum_l[v]; ++i) {
        dp[v][i] = i * c[v];
    }
    p[v].assign(graph[v].size(), vector<int>(min(r[v], MAXN - 1) + 1));
    int mn_sum = 0;
    for (int i = 0; i < graph[v].size(); ++i) {
        int u = graph[v][i];
        mn_sum += l[u];
        for (int w = min(r[v], MAXN - 1); w >= max(mn_sum, l[u]); --w) {
            ll best = INF;
            int best_p = -1;
            for (int w2 = l[u]; w2 <= min({w, r[u], r[v]}) && w - w2 >= mn_sum - l[u]; ++w2) {
                if (dp[v][w - w2] + dp[u][w2] < best) {
                    best = dp[v][w - w2] + dp[u][w2];
                    best_p = w2;
                }
            }
            p[v][i][w] = best_p;
            dp[v][w] = best;
        }
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;

    while (t-- > 0) {
        int n;
        cin >> n;
        for (int i = 1; i < n; ++i) {
            int p;
            cin >> p;
            --p;
            graph[p].push_back(i);
        }
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
//        dfs(0);
//        ll mn = INF;
//        int best_w = -1;
//        for (int i = l[0]; i <= r[0]; ++i) {
//            if (get_dp(0, i) < mn) {
//                mn = get_dp(0, i);
//                best_w = i;
//            }
//        }
        dfssss(0);
        ll mnss = INF;
        int best_wss = -1;
        for (int i = l[0]; i <= r[0]; ++i) {
            if (dp[0][i] < mnss) {
                mnss = dp[0][i];
                best_wss = i;
            }
        }

        if (best_wss != -1)
            ansss(0, best_wss);
        if (best_wss != -1) {
            cout << mnss << "\n";
            for (int i = 0; i < n; ++i)
                cout << res[i] << " ";
            cout << "\n";
        } else
            cout << "-1\n";
        for (int i = 0; i < n; ++i) {
            graph[i].clear();
            p[i].clear();
            sum_r[i] = 0;
        }
    }
    return 0;
}