#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define endl '\n'

const int Base = 4000;

int n, q;
int changes[Base];
string moves[Base];
int mv[Base][Base];
//pair<int, int> breakPoints[Base];

void fillMv(int id)
{
	int x, y;
	x = 0;
	y = 0;
	for (int i = 0; i < n; i++)
	{
		if (mv[x][y] == -1)
		{
			mv[x][y] = id;
		}
		x++;
		y += moves[id][i] - '0';
	}
	if (mv[x][y] == -1)
	{
		mv[x][y] = id;
	}
}

int getMove(int x, int y)
{
	return mv[x][y];
}

int getMoveERR(int x, int y)
{
	if (x - y == 0)
	{
		return 0;
	}
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		if (changes[i] <= x)
		{
			cnt++;
			if (cnt == x - y)
			{
				return i + 1;
			}
		}
	}

	exit(-1);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;

	for (int i = 0; i <= n; i++)
	{
		for (int j = 0; j <= n; j++)
		{
			mv[i][j] = -1;
		}
	}

	moves[0] = "";
	for (int i = 0; i < n; i++)
	{
		moves[0] += "1";
	}
	fillMv(0);
	//breakPoints[0] = make_pair(0, 0);
	for (int i = 0; i < n; i++)
	{
		cin >> changes[i];
		moves[i + 1] = moves[i];
		moves[i + 1][changes[i] - 1] = '0';
		fillMv(i + 1);
		/*int cnt = 0;
		for (int j = 0; j < i; j++)
		{
			if (changes[j] < changes[i])
			{
				cnt++;
			}
		}
		breakPoints[i + 1] = make_pair(changes[i] - 1, changes[i] - 1 - cnt);*/
	}

	cin >> q;
	while (q--)
	{
		int a1, b1, a2, b2;
		cin >> a1 >> b1 >> a2 >> b2;

		int m1 = getMove(a1, b1);
		int m2 = getMove(a2, b2);

		int x = 0, y = 0;
		if (m1 != m2)
		{
			int id = 0;
			while (moves[m1][id] == moves[m2][id])
			{
				x++;
				y += moves[m1][id] - '0';
				id++;
			}
		}
		else
		{
			x = a2;
			y = b2;
			if (a1 < a2)
			{
				x = a1;
				y = b1;
			}
		}

		cout << x << ' ' << y << endl;
	}

	return 0;
}