#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <math.h>
using namespace std;
#define vll vector<ll>
#define sll set<ll>
#define vvll vector<vll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvpll vector<vpll>
#define siz(x) ((ll)(x.size()))
#define all(x) x.begin(), x.end()
#define INF 30000000000000
#define mp make_pair
typedef long long ll;
ll _ = 1, n;
ll dad[300000]; // ancestor
ll c[300000]; // cost
ll boundl[300000]; // leftest node in a subtree in ST
ll boundr[300000]; // rightest node in a subtree in ST
ll l[300000]; // minimum allowed quantity of a subtree
ll r[300000]; // maximum allowed quantity of a subtree
ll newname[300000]; // number of node after renaming
ll newdad[300000]; // new dad node
ll quantree[300000];
struct stnode {
	ll c;
	ll q;
	ll i;
	ll contr;
	stnode() {
		c = 0;
		q = 0;
		i = 0;
		contr = 0;
	}
	stnode(ll cc, ll qq, ll ii) {
		c = cc;
		q = qq;
		i = ii;
		contr = 0;
	}
};
bool operator <(stnode a, stnode b) {
	if (a.c == b.c) {
		if (a.q == b.q) {
			return (a.i < b.i);
		}
		return (a.q < b.q);
	}
	return (a.c < b.c);
}
bool operator >(stnode a, stnode b) {
	if (a.c == b.c) {
		if (a.q == b.q) {
			return (a.i > b.i);
		}
		return (a.q > b.q);
	}
	return (a.c > b.c);
}
sll USED;
stnode st[300000]; // segment tree of pairs, pair is (cost, filled quantity, index)
ll k; // power of 2
bool possible; // global flag
vvll a(300000);
ll INPTIME;
void renamedfs(ll cur, ll dadnew) {
	newname[cur] = INPTIME;
	newdad[cur] = dadnew;
	boundl[newname[cur]] = INPTIME;
	for (int i = 0; i < siz(a[cur]); i++)
	{
		if (a[cur][i] == cur) continue;
		INPTIME++;
		renamedfs(a[cur][i], newname[cur]);
	}
	boundr[newname[cur]] = INPTIME;
}
void updatest(ll i, stnode newval) {
	i += k;
	st[i] = newval;
	i /= 2;
	while (i > 0) {
		st[i] = min(st[i * 2], st[i * 2 + 1]);
		i /= 2;
	}
}
stnode getst(ll i, ll j) {
	i += k;
	j += k;
	stnode res = stnode(INF, INF, INF);
	while (i <= j) {
		if (i % 2 == 1) res = min(res, st[i]), i++;
		if (j % 2 == 0) res = min(res, st[j]), j--;
		i /= 2;
		j /= 2;
	}
	return res;
}
ll getquan(ll i, ll j) {
	i += k;
	j += k;
	ll res = 0;
	while (i <= j) {
		if (i % 2 == 1) res = res += quantree[i], i++;
		if (j % 2 == 0) res = res += quantree[j], j--;
		i /= 2;
		j /= 2;
	}
	return res;
}
void subdfs(ll cur) {
	USED.insert(cur);
	if (not possible) return;
	ll bl = boundl[newname[cur]];
	ll br = boundr[newname[cur]];

	ll threshold = l[cur];
	stnode qwe = getst(newname[cur], newname[cur]);
	ll curq = qwe.q;
	while (curq < threshold) {
		stnode t = getst(bl, br);
		if (t.c == INF) {
			possible = false;
			return;
		}
		ll toaddmini = threshold - curq;
		ll p = t.i;

		sll used;
		while (p != cur) {
			if (used.find(p) != used.end()) break;
			used.insert(p);
			toaddmini = min(toaddmini, r[p] - st[newname[p] + k].q);
			if (dad[p] == p) break;
			p = dad[p];
		}
		if (toaddmini == 0) { // min node does not fit
			t.c = INF;
			updatest(newname[t.i], t);
		}
		else {
			t.contr += toaddmini;
			updatest(newname[t.i], t);


			p = t.i;
			used.clear();
			while (p != cur) {
				if (used.find(p) != used.end()) break;
				used.insert(p);
				stnode prevval = st[newname[p] + k];
				prevval.q += toaddmini;
				updatest(newname[p], prevval);
				if (dad[p] == p) break;
				p = dad[p];
			}
			stnode prevval = st[newname[cur] + k];
			prevval.q += toaddmini;
			updatest(newname[cur], prevval);
			curq = prevval.q;
		}
	}
	for (int i = 0; i < siz(a[cur]); i++) {
		if (a[cur][i] == cur or USED.find(a[cur][i]) != USED.end()) continue;
		subdfs(a[cur][i]);
	}
}
void solve() {
	USED.clear();
	possible = true;
	cin >> n;
	k = 1;
	while (k < n) k *= 2;
	for (int i = 1; i < n; i++)
	{
		cin >> dad[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> c[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}
	for (int i = 0; i < n; i++)
	{
		a[i].clear();
	}
	for (int i = 1; i < n; i++)
	{
		dad[i]--;
	}

	for (int i = 0; i < n; i++)
	{
		a[dad[i]].push_back(i);
	}

	INPTIME = 0;
	renamedfs(0, 0);

	for (ll i = 0; i < n; i++)
	{
		st[newname[i] + k] = stnode(c[i], 0ll, i);
	}
	for (int i = n; i <= k; i++)
	{
		st[i + k] = stnode(INF, INF, INF);
	}
	for (int i = 1; i < k; i++)
	{
		st[i] = min(st[i * 2], st[i * 2 + 1]);
	}
	subdfs(0);
	for (int i = 0; i <= 2 * k; i++)
	{
		quantree[i] = 0;
	}
	for (int i = 0; i < n; i++)
	{
		quantree[newname[i] + k] = st[newname[i] + k].contr;
	}
	for (int i = 0; i < k; i++)
	{
		quantree[i] = quantree[i * 2] + quantree[i * 2 + 1];
	}
	for (int i = 0; i < n; i++)
	{
		ll qwe = getquan(boundl[newname[i]], boundr[newname[i]]);
		if (qwe > r[i] or qwe < l[i]) {
			cout << -1 << endl;
			return;
		}
	}
	ll res = 0;
	for (int i = 0; i < n; i++)
	{
		res += st[newname[i] + k].contr * c[i];
	}
	cout << res << endl;
	for (int i = 0; i < n; i++)
	{
		cout << st[newname[i] + k].contr << " ";
	}
	cout << endl;
}
int main() {
	//freopen("in.txt", "r", stdin);
	cin >> _;
	while (_--) {
		solve();
	}
}