#include <bits/stdc++.h>

#define all(q) q.begin(), q.end()

using namespace std;
constexpr int MAXN = 3000;
constexpr int MAXV = MAXN * (MAXN + 1);
constexpr int MAXLOG = 25;
int par[MAXLOG + 1][MAXV + 100];
int n;

int get_idx(int r, int c) {
    return r * (n + 1) + c;
}

pair<int, int> get_coord(int idx) {
    int c = idx % (n + 1);
    int r = idx / (n + 1);
    return pair{ r, c };
}

void build() {
    int mx = get_idx(n, n);
    for (int i = 0; i < MAXLOG; ++i) {
        for (int v = 0; v <= mx; ++v) {
            par[i + 1][v] = par[i][par[i][v]];
        }
    }
}

int level_ancestor(int v, int k) {
    for (int i = 0; k > 0; k >>= 1, ++i) {
        if (k & 1) {
            v = par[i][v];
        }
    }
    return v;
}

int lca(int a, int b) {
    int da = get_coord(a).first;
    int db = get_coord(b).first;
    if (da < db) {
        swap(a, b);
        swap(da, db);
    }
    a = level_ancestor(a, da - db);

    for (int i = MAXLOG; i >= 0; --i) {
        if (par[i][a] != par[i][b]) {
            a = par[i][a];
            b = par[i][b];
        }
    }
    if (a != b) {
        a = par[0][a];
    }
    return a;
}

void apply_path(const string& path) {
    int r_prev = 0, c_prev = 0;
    int r = 0, c = 0;
    for (const char& dir : path) {
        ++r;
        c += dir - '0';

        par[0][get_idx(r, c)] = get_idx(r_prev, c_prev);

        r_prev = r;
        c_prev = c;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    cin >> n;
    string cur_path(n, '1');
    apply_path(cur_path);
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        cur_path[a - 1] = '0';
        apply_path(cur_path);
    }

    build();

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;

        auto[r, c] = get_coord(lca(get_idx(r1, c1), get_idx(r2, c2)));
        cout << r << ' ' << c << '\n';
    }

    return 0;
}
