
#pragma GCC optimize("-O3")

#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <set>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front



//#define int long long




using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;



int n;


vector<int> com;


int get_vert(int x, int y) {
    return x * (x + 1) / 2 + y;
}


vector<vector<int> > g;


inline void get_down(int x, int y) {

    //cout << "GO " << x << " " << y << "\n";


    if (x == n) {
        return;
    }


    int xN = x + 1, yN = y;
    if (com[x] == 1) {
        yN++;
    }

    int v = get_vert(x, y);
    int u = get_vert(xN, yN);

    //cout << "!!!!!! " << v << " "<< u << "\n";

    g[v].pub(u);
    g[u].pub(v);



    get_down(xN, yN);
}



vector<int> d;
const int NMAX = 10000000;


struct segtree {
    int a[NMAX];
    int n;

    int tree[4 * NMAX];


    inline int her(int v, int l, int r, int ql, int qr) {
        if (l == ql && r == qr) {
            return tree[v];
        }

        int m = (l + r) >> 1;
        if (qr <= m) {
            return her(2 * v + 1, l, m, ql, qr);
        } else if (ql >= m) {
            return her(2 * v + 2, m, r, ql, qr);
        }

        int a = her(2 * v + 1, l, m, ql, m);
        int b = her(2 * v + 2, m, r, m, qr);

        if (d[a] < d[b]) {
            return a;
        }
        return b;
    }


    inline int query(int l, int r) {
        return her(0, 0, n, l, r);
    }


    inline void build(int v, int l, int r) {
        if (l + 1 == r) {
            tree[v] = a[l];
            return;
        }

        int m = (l + r) >> 1;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);

        if (d[tree[2 * v + 1]] < d[tree[2 * v + 2]]) {
            tree[v] = tree[2 * v + 1];
        } else {
            tree[v] = tree[2 * v + 2];
        }
    }

    void init() {

        build(0, 0, n);
    }
}  ;



segtree t;








vector<int> first_occ;

inline void dfs_euler(int v, int p, int d) {
    ::d[v] = d;
    first_occ[v] = t.n;
    t.a[t.n++] = v;



    for (int u : g[v]) {
        if (u == p) {
            continue;
        }

        dfs_euler(u, v, d + 1);
         t.a[t.n++] = v;
    }
}






void build_LCA() {
    d.resize((n + 1) * (n + 2) / 2);
    first_occ.resize((n + 1) * (n + 2) / 2);

    t.n = 0;
    dfs_euler(0, -1, 0);

   // cout << "OK\n";





    t.init();
   // cout << "OK\n";

    /*
    cout << "euler = \n";
    for (int i : euler) {
        cout <<i << " ";
    }
    cout << "\n";

    */


}



int get_lca(int v, int u) {
    if (v == u) {
        return v;
    }

    int l = first_occ[v], r = first_occ[u];

    if (l > r) {
        swap(l, r);
    }
    return t.query(l, r);
}




vector<int> a;

bool check_pizda3() {
    for (int i = 0; i < n; i++) {
        if (a[i] != i) {
            return false;
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;


        pii a{x1, y1}, b{x2, y2};



        if (x1 - y1 == x2 - y2) {
            cout << min(x1, x2) << " " <<  min(y1, y2) << "\n";
            continue;
        }



        a.x -= y1;
        a.y -= y1;

        b.x -= y2;
        b.y -= y2;




        pii ans = min(a, b);

        cout << ans.x << " " << ans.y << "\n";
    }



    return true;
}






void solve_solve_solve() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    int pizda = 0;
    pii acc[(n + 1) * (n + 2) / 2];
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            acc[pizda] = {i, j};
            pizda++;
        }
    }


    if (check_pizda3()) {
        exit(0);
    }

    g.resize((n + 1) * (n + 2) / 2);


    com.resize(n, 1);
    get_down(0, 0);

    for (int i = 0; i < n; i++) {
        com[a[i]] = 0;
        get_down(0, 0);
    }

    for (auto& it : g) {
        sort(all(it));
        it.erase(unique(all(it)), it.end());
    }


    build_LCA();


    int q;
    cin >> q;

    vector<pii> v(q), u(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i].x >> v[i].y;
        cin >> u[i].x >> u[i].y;

        int V = get_vert(v[i].x, v[i].y);
        int U = get_vert(u[i].x, u[i].y);

        int res = get_lca(V, U);

        pii it = acc[res];

        cout << it.x << " " << it.y << "\n";
    }


}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
