#pragma GCC optimize("-O3")

#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <set>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front



//#define int long long




using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;


const int INF = (int)2e9 + 109;


const int N = 3001;
const int SQ = (N + 1) * (N + 2) / 2;

int n;


int com[N];


int get_vert(int x, int y) {
    return x * (x + 1) / 2 + y;
}




vector<int> g[SQ];


inline void get_down(int x, int y) {

    //cout << "GO " << x << " " << y << "\n";


    if (x == n) {
        return;
    }


    int xN = x + 1, yN = y;
    if (com[x] == 1) {
        yN++;
    }

    int v = get_vert(x, y);
    int u = get_vert(xN, yN);

    //cout << "!!!!!! " << v << " "<< u << "\n";

    g[v].pub(u);
    g[u].pub(v);



    get_down(xN, yN);
}



int d[SQ];
const int NMAX = 10000000;
const int SQRT = 1000;




struct segtree {
    int a[NMAX];
    int n;

    int v[NMAX / SQRT];

    int query(int l, int r) {
       // cout << "QUERY " << l << " " << r << "\n";

        int res = a[l];
        while (l < r && l % SQRT) {
            if (d[a[l]] < d[res]) {
                res = a[l];
            }

            l++;
        }

        //cout << "res1 = " << res << "\n";



        while (l + SQRT <= r) {
            if (d[v[l / SQRT]] < d[res]) {
                res = v[l / SQRT];
            }
            l += SQRT;
        }

        //cout << "res2 = " << res << "\n";

        while (l < r) {
            if (d[a[l]] < d[res]) {
                res = a[l];
            }

            l++;
        }



        return res;
    }



    void init() {
        fill(v, v + NMAX / SQRT, INF);

        for (int i = 0; i < n; i++) {
            //cout << "!!! " << i << " " << n << "\n";

            //break;

            int ind = i / SQRT;
            if (v[ind] == INF || d[a[i]] < d[v[ind]]) {
                v[ind] = a[i];
            }
        }
    }

}  ;



segtree t;








int first_occ[SQ];

inline void dfs_euler(int v, int p, int d) {
    ::d[v] = d;
    first_occ[v] = t.n;
    t.a[t.n++] = v;



    for (int u : g[v]) {
        if (u == p) {
            continue;
        }

        dfs_euler(u, v, d + 1);
         t.a[t.n++] = v;
    }
}






void build_LCA() {
    //d.resize((n + 1) * (n + 2) / 2);
    //first_occ.resize((n + 1) * (n + 2) / 2);

    t.n = 0;
    dfs_euler(0, -1, 0);

    //cout << "OK\n";





    t.init();
    //cout << "OK\n";

    /*
    cout << "euler = \n";
    for (int i : euler) {
        cout <<i << " ";
    }
    cout << "\n";

    */


}



int get_lca(int v, int u) {
    if (v == u) {
        return v;
    }

    int l = first_occ[v], r = first_occ[u];

    if (l > r) {
        swap(l, r);
    }
    return t.query(l, r);
}





vector<int> a;

bool check_pizda3() {
    for (int i = 0; i < n; i++) {
        if (a[i] != i) {
            return false;
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;


        pii a{x1, y1}, b{x2, y2};



        if (x1 - y1 == x2 - y2) {
            cout << min(x1, x2) << " " <<  min(y1, y2) << "\n";
            continue;
        }



        a.x -= y1;
        a.y -= y1;

        b.x -= y2;
        b.y -= y2;




        pii ans = min(a, b);

        cout << ans.x << " " << ans.y << "\n";
    }



    return true;
}




bool check_pizda4() {

    return false;
}



void solve_solve_solve() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    if (check_pizda3()) {
        exit(0);
    }

    if (check_pizda4()) {
        exit(0);
    }

    int pizda = 0;
    pii acc[(n + 1) * (n + 2) / 2];
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            acc[pizda] = {i, j};
            pizda++;
        }
    }




    //g.resize((n + 1) * (n + 2) / 2);


    //com.resize(n, 1);
    fill(com, com + N, 1);
    get_down(0, 0);

    for (int i = 0; i < n; i++) {
        com[a[i]] = 0;
        get_down(0, 0);
    }

    for (auto& it : g) {
        sort(all(it));
        it.erase(unique(all(it)), it.end());
    }


    build_LCA();


    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1;;
        cin >> x2 >> y2;

        int V = get_vert(x1, y1);
        int U = get_vert(x2, y2);

        int res = get_lca(V, U);

        pii it = acc[res];

        cout << it.x << " " << it.y << "\n";
    }


}


signed main() {
    //ios_base::sync_with_stdio(false);
   // cin.tie(0); cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
