#include <iostream>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>


#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front



#define int long long




using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;



int n;


vector<int> com;


map<pair<pii, pii>, int> used;



int get_vert(int x, int y) {
    return x * (x + 1) / 2 + y;
}


pii get_pair(int v) {
    int x = n;

    while (x * (x + 1) / 2 > v) {
        x--;
    }

    return {x, v - x * (x + 1) / 2};
}



vector<vector<int> > g;



void get_down(int x, int y) {

    //cout << "GO " << x << " " << y << "\n";


    if (x == n) {
        return;
    }


    int xN = x + 1, yN = y;
    if (com[x] == 1) {
        yN++;
    }

    int v = get_vert(x, y);
    int u = get_vert(xN, yN);

    //cout << "!!!!!! " << v << " "<< u << "\n";

    g[v].pub(u);
    g[u].pub(v);



    get_down(xN, yN);
}




vector<int> euler;
vector<int> d;
vector<int> first_occ;

void dfs_euler(int v, int p, int d) {
    ::d[v] = d;
    first_occ[v] = sz(euler);
    euler.pub(v);



    for (int u : g[v]) {
        if (u == p) {
            continue;
        }

        dfs_euler(u, v, d + 1);
        euler.pub(v);
    }
}



void build_LCA() {
    d.resize((n + 1) * (n + 2) / 2);
    first_occ.resize((n + 1) * (n + 2) / 2);

    dfs_euler(0, -1, 0);


    /*
    cout << "euler = \n";
    for (int i : euler) {
        cout <<i << " ";
    }
    cout << "\n";

    */


}


int get_lca(int v, int u) {
    int l = first_occ[v], r = first_occ[u];

    if (l > r) {
        swap(l, r);
    }

    int opt = l;
    for (int i = l; i <= r; i++) {
        if (d[euler[i]] < d[euler[opt]]) {
            opt = i;
        }
    }

    //cout << "LCA " << v << " " << u << " "  << l << " " << r << " " << opt << " " << d[opt] << "\n";

    return euler[opt];
}




vector<int> a;

bool check_pizda3() {
    for (int i = 0; i < n; i++) {
        if (a[i] != i) {
            return false;
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;


        pii a{x1, y1}, b{x2, y2};



        if (x1 - y1 == x2 - y2) {
            cout << min(x1, x2) << " " <<  min(y1, y2) << "\n";
            continue;
        }



        a.x -= y1;
        a.y -= y1;

        b.x -= y2;
        b.y -= y2;




        pii ans = min(a, b);

        cout << ans.x << " " << ans.y << "\n";
    }



    return true;
}






void solve_solve_solve() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }


    if (check_pizda3()) {
        exit(0);
    }

    g.resize((n + 1) * (n + 2) / 2);


    com.resize(n, 1);
    get_down(0, 0);

    for (int i = 0; i < n; i++) {
        com[a[i]] = 0;
        get_down(0, 0);
    }

    for (auto& it : g) {
        sort(all(it));
        it.erase(unique(all(it)), it.end());
    }


    build_LCA();


    int q;
    cin >> q;

    vector<pii> v(q), u(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i].x >> v[i].y;
        cin >> u[i].x >> u[i].y;

        int V = get_vert(v[i].x, v[i].y);
        int U = get_vert(u[i].x, u[i].y);

        int res = get_lca(V, U);

        pii it = get_pair(res);

        cout << it.x << " " << it.y << "\n";
    }


}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
