#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

#define len(a) (int)a.size()

typedef long long ll;

const int INF = (int)1e9;

using namespace std;

void run();

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

vector< vector<int> > graph;
vector<int> costs;
vector< pair<int, int> > borders;
vector< priority_queue< tuple<int, int, int>, vector< tuple<int, int, int> >, greater< tuple<int, int, int> > > > sts;
vector<int> counts;

pair<int, ll> dfs(int v)
{
    int sum_count;
    ll sum_cost;
    sum_cost = sum_count = 0;
    int max_sts = v;
    for (int to : graph[v])
    {
        auto [count, cost] = dfs(to);
        if (count == -1)
        {
            return {-1, -1};
        }
        sum_count += count;
        sum_cost += cost;
        if (len(sts[to]) > len(sts[max_sts]))
        {
            max_sts = to;
        }
    }
    if (sum_count > borders[v].second)
    {
        return {-1, -1};
    }
    for (int to : graph[v])
    {
        if (to == max_sts)
        {
            continue;
        }
        while (!sts[to].empty())
        {
            sts[max_sts].push(sts[to].top());
            sts[to].pop();
        }
    }
    sts[max_sts].push({costs[v], borders[v].second - sum_count, v});
    swap(sts[max_sts], sts[v]);
    while (sum_count < borders[v].first)
    {
        auto [cost, left, i] = sts[v].top();
        sts[v].pop();
        int spend = min(borders[v].first - sum_count, left);
        sum_count += spend;
        left -= spend;
        counts[i] += spend;
        sum_cost += (ll)spend * cost;
        if (left)
        {
            sts[v].push({cost, left, i});
        }
    }
    return {sum_count, sum_cost};
}

void solve_test()
{
    int n;
    cin >> n;
    graph.assign(n, vector<int>());
    for (int i = 1; i < n; ++i)
    {
        int parent;
        cin >> parent;
        graph[parent - 1].push_back(i);
    }
    costs.resize(n);
    borders.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> costs[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> borders[i].first >> borders[i].second;
    }

    sts.assign(n, priority_queue< tuple<int, int, int>, vector< tuple<int, int, int> >, greater< tuple<int, int, int> > >());
    counts.assign(n, 0);
    cout << dfs(0).second << '\n';
    for (int i : counts)
    {
        cout << i << ' ';
    }
    cout << '\n';
}

void run()
{
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}
