//#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,avx512f,avx512dq,bmi2")
#include <iostream>
#include <random>
#include <vector>
#include <climits>
#include <map>
#include <algorithm>

std::array<std::vector<int>, 13> parent;
std::vector<char> insn;
std::vector<int> triag;
std::vector<std::vector<int>> children;
int N = 0;
void dfs(int r, int c, int prev = 0)
{
	// pairing function: triangular numbers plus c
	int i = triag[r] + c;
	parent[0][i] = prev;
	if(r == N) return;
	int nr = r+1, nc = c;
	//printf("r=%d, c=%d\n", r, c);
	if(insn[r] == 1) nc++;
	int ni = triag[nr]+nc;
	if(std::find(children[i].begin(), children[i].end(), ni) == children[i].end())
		children[i].push_back(ni);
	dfs(nr, nc, i);
}
std::vector<int> t_in, t_out;
int cur_t = 0;
void dfs2(int i)
{
	t_in[i] = cur_t++;
	for(int to : children[i])
		dfs2(to);
	t_out[i] = cur_t++;
}

bool is_parent(int i1, int i2)
{
	return t_in[i1] <= t_in[i2] && t_out[i2] <= t_out[i1];
}
int main()
{
	// binary lifting
	std::cin >> N;
	triag.resize(N+1);
	int gsz = (N+2) * (N+1) / 2;
	parent[0].resize(gsz);
	for(int i = 1; i < N+1; i++)
		triag[i] = i + triag[i-1];
	std::vector<int> a(N);
	insn.resize(N, 1);
	t_in.resize(gsz);
	t_out.resize(gsz);
	children.resize(gsz);
	for(int& x : a) scanf("%d", &x), x--;
	for(int i = 0; i < N; i++)
	{
		dfs(0, 0);
		insn[a[i]] = 0;
	}
	dfs(0, 0);
	dfs2(0);
	//for(int i = 0; i < gsz; i++)
	//{
	//	printf("%d: ", i); for(int x : children[i]) printf("%d ", x); printf("\n");
	//}
	children = {};
	//for(int i = 1; i < 13; i++) parent[i].resize(gsz);
	//for(int i = 1; i < 13; i++)
	//for(int j = 0; j < gsz; j++)
	//	parent[i][j] = parent[i-1][parent[i-1][j]];
	//printf("exiting\n");
	//for(int x : t_in) printf("%d ", x); printf("\n");
	//for(int x : t_out) printf("%d ", x); printf("\n");
	int q; std::cin >> q;
	while(q --> 0)
	{
		int r1,c1,r2,c2; scanf("%d%d%d%d", &r1,&c1,&r2,&c2);
		int i1 = triag[r1] + c1;
		int i2 = triag[r2] + c2;
		//printf("%d %d\n", i1, i2);
		while(!is_parent(i1,i2))
			i1 = parent[0][i1];
		//for(int i = 13; i --> 0;)
		//{
		//	int l = parent[i][i1];
		//	//printf("%d %d l=%d\n", i1, i2, l);
		//	if(!is_parent(l, i2))
		//		i1 = l;
		//}
		//if(!is_parent(i1, i2)) i1 = parent[0][i1];
		int r = std::lower_bound(triag.begin(), triag.end(), i1+1) - triag.begin() - 1;
		int c = i1 - triag[r];
		//printf("%d\n", i1);
		printf("%d %d\n", r, c);
	}
}
