#define _GLIBCXX_DEBUG
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,avx512f,avx512dq,bmi2")
#include <iostream>
#include <random>
#include <vector>
#include <climits>
#include <map>
#include <algorithm>

struct tree
{
	tree* l, *r;
	int64_t sum;
	int dval = -1;
	void mkl() { if(!l) l = new tree { nullptr, nullptr, 0, -1 }; };
	void mkr() { if(!r) r = new tree { nullptr, nullptr, 0, -1 }; };
	void push()
	{
		mkl(); mkr();
		if(dval != -1)
		{
			l->dval = dval;
			l->sum = sum / 2;
			r->dval = dval;
			r->sum = sum / 2;
			dval = -1;
		}
	}
	void update(int cl, int cr)
	{
		sum = l->sum + r->sum;
	}
	void set(int L, int R, int max, int cl, int cr)
	{
		//printf("set [%d,%d) to %d\n", L, R, max);
		if(cl >= R || cr <= L) return;
		if(L <= cl && cr <= R)
		{
			dval = std::max(dval, max);
			sum = dval * 1ll * (cr - cl);
			return;
		}
		push();
		l->set(L,R,max, cl, (cl+cr)/2);
		r->set(L,R,max, (cl+cr)/2, cr);
		update(cl, cr);
	}
};
int main()
{
	// assume the lowest projector projects right
	// projectors covered by it must project left
	int k; std::cin >> k;
	if(k != 1) return 0;
	int _; std::cin >> _;
	int T; std::cin >> T;
	while(T --> 0)
	{
		tree* t = new tree { nullptr, nullptr, 0, -1};
		int n,w,h; std::cin >> n >> w >> h;
		int ub = 1<<30;
		while(n --> 0)
		{
			int x,y; scanf("%d%d", &x, &y);
			//printf("setting [%d,%d) to %d\n", x,w, h-y);
			t->set(x, w, h-y, 0, ub); 
			//printf("s=%lld\n", t->sum);
		}
		printf("%lld\n", t->sum);
	}
	
}
