#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef __int64_t bigll;

int n;
vector<int> parent;
vector<vector<int>> g;

vector<ll> c;
vector<ll> left_bound;
vector<ll> right_bound;

vector<int> topsort;

void dfs(int v, int p = -1) {
	for ( int to : g[v] ) {
		if ( to == p ) continue;
		dfs(to, v);
	}

	topsort.push_back(v);
}

vector<ll> real_L;
vector<ll> real_R;
vector<ll> base_cost;
vector<deque<pair<ll, pair<ll, int>>>> lines;

void run() {
	cin >> n;

	parent = vector<int>(n, -1);
	g = vector<vector<int>>(n, vector<int>(0));

	c = vector<ll>(n, 0);
	left_bound = vector<ll>(n, 0);
	right_bound = vector<ll>(n, 0);

	for ( int i = 1; i < n; ++i ) {
		cin >> parent[i];
		parent[i]--;

		g[i].push_back(parent[i]);
		g[parent[i]].push_back(i);
	}

	for ( int i = 0; i < n; ++i ) cin >> c[i];
	for ( int i = 0; i < n; ++i ) cin >> left_bound[i] >> right_bound[i];

	topsort = vector<int>(0);
	dfs(0);

	real_L = vector<ll>(n, -1);
	real_R = vector<ll>(n, -1);
	base_cost = vector<ll>(n, -1);
	lines = vector<deque<pair<ll, pair<ll, int>>>>(n, deque<pair<ll, pair<ll, int>>>(0));

	vector<ll> ans(n, 0);

	bool flag = false;
	ll base_k;

	if ( n == 1 ) {
		cout << left_bound[0] * c[0] << endl;
		cout << left_bound[0] << endl;
		return;
	}

	for ( int v : topsort ) {
		if ( (g[v].size() == 1) && (v != 0) ) {
			real_L[v] = left_bound[v];
			real_R[v] = right_bound[v];
			base_cost[v] = left_bound[v] * c[v];
			ans[v] += real_L[v];
			if ( left_bound[v] < right_bound[v] )
				lines[v].push_back({c[v], {right_bound[v] - left_bound[v], v}});
			continue;
		}

		real_L[v] = 0;
		base_cost[v] = 0;

		for ( int to : g[v] ) {
			if ( to == parent[v] ) continue;

			real_L[v] += real_L[to];
			base_cost[v] += base_cost[to];

			for ( pair<ll, pair<ll, int>> line : lines[to] )
				lines[v].push_back(line);
		}

		sort(lines[v].begin(), lines[v].end());

		if ( real_L[v] > right_bound[v] ) { flag = true; break; }
		
		while ( (!lines[v].empty()) && (lines[v].back().first > c[v]) ) {
			lines[v].pop_back();
		}

		base_k = 0;
		for ( pair<ll, pair<ll, int>> line : lines[v] ) base_k += line.second.first;

		if ( real_L[v] + base_k < right_bound[v] ) { lines[v].push_back({c[v], {right_bound[v] - real_L[v] - base_k, v}}); }
		else if ( real_L[v] + base_k > right_bound[v] ) {
			while ( real_L[v] + base_k > right_bound[v] ) {
				if ( real_L[v] + base_k - lines[v].back().second.first >= right_bound[v] ) {
					base_k -= lines[v].back().second.first;
					lines[v].pop_back();
				} else {
					lines[v].back().second.first -= real_L[v] + base_k - right_bound[v];
					base_k = right_bound[v] - real_L[v];
				}
			}
		}

		while ( real_L[v] < left_bound[v] ) {
			if ( real_L[v] + lines[v][0].second.first <= left_bound[v] ) {
				real_L[v] += lines[v][0].second.first;
				base_cost[v] += lines[v][0].first * lines[v][0].second.first;
				ans[lines[v][0].second.second] += lines[v][0].second.first;	
				lines[v].pop_front();
			} else {
				base_cost[v] += (left_bound[v] - real_L[v]) * lines[v][0].first;
				ans[lines[v][0].second.second] += left_bound[v] - real_L[v];
				lines[v][0].second.first -= left_bound[v] - real_L[v];
				real_L[v] = left_bound[v];
			}
		}
		real_R[v] = right_bound[v];
	}

	if ( flag ) {
		cout << -1 << endl;
		return;
	}

	cout << base_cost[0] << endl;
	for ( int v = 0; v < n; ++v ) cout << ans[v] << " ";
	cout << endl;
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	cin >> t;

	for ( int i = 0; i < t; ++i ) {
		run();
	}
	return 0;
}