#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll INF = 1e18;

typedef __int64_t bigll;

int n;
vector<int> parent;
vector<vector<int>> g;

vector<ll> c;
vector<ll> left_bound;
vector<ll> right_bound;

vector<int> topsort;

void dfs(int v, int p = -1) {
	for ( int to : g[v] ) {
		if ( to == p ) continue;
		dfs(to, v);
	}

	topsort.push_back(v);
}

vector<ll> real_L;
vector<ll> real_R;
vector<ll> base_cost;
vector<deque<pair<ll, pair<ll, int>>>> lines;

void run() {
	cin >> n;

	parent = vector<int>(n, -1);
	g = vector<vector<int>>(n, vector<int>(0));

	c = vector<ll>(n, 0);
	left_bound = vector<ll>(n, 0);
	right_bound = vector<ll>(n, 0);

	for ( int i = 1; i < n; ++i ) {
		cin >> parent[i];
		parent[i]--;

		g[i].push_back(parent[i]);
		g[parent[i]].push_back(i);
	}

	for ( int i = 0; i < n; ++i ) cin >> c[i];
	for ( int i = 0; i < n; ++i ) cin >> left_bound[i] >> right_bound[i];

	topsort = vector<int>(0);
	dfs(0);

	real_L = vector<ll>(n, -1);
	real_R = vector<ll>(n, -1);
	base_cost = vector<ll>(n, -1);
	lines = vector<deque<pair<ll, pair<ll, int>>>>(n, deque<pair<ll, pair<ll, int>>>(0));

	vector<ll> ans(n, 0);

	bool flag = false;
	ll base_k;

	vector<pair<ll, int>> min_sub(n, {INF, -1});

	if ( n == 1 ) {
		cout << left_bound[0] * c[0] << endl;
		cout << left_bound[0] << endl;
		return;
	}

	ll total_cost = 0;
	
	for ( int v : topsort ) {
		if ( (g[v].size() == 1) && (v != 0) ) {
			min_sub[v] = {c[v], v};
			real_L[v] = left_bound[v];
			ans[v] = left_bound[v];
			total_cost += left_bound[v] * c[v];
			continue;
		} else {
			min_sub[v] = {c[v], v};
			real_L[v] = 0;
			for ( int to : g[v] ) {
				if ( to == parent[v] ) continue;
				min_sub[v] = min(min_sub[to], min_sub[v]);
				real_L[v] += real_L[to];
			}
			if ( real_L[v] < left_bound[v] ) {
				total_cost += (left_bound[v] - real_L[v]) * min_sub[v].first;
				ans[min_sub[v].second] += left_bound[v] - real_L[v];
				real_L[v] = left_bound[v];
			}
		}
	}

	if ( flag ) {
		cout << -1 << endl;
		return;
	}

	cout << total_cost << endl;
	for ( int v = 0; v < n; ++v ) cout << ans[v] << " ";
	cout << endl;

	return;
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t;
	cin >> t;

	for ( int i = 0; i < t; ++i ) {
		run();
	}
	return 0;
}