#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

#define int long long
using namespace std;

using vi = vector<int>;
using vvi = vector<vector<int>>;
using vb = vector<bool>;
using pi = pair<int, int>;
using db = double;

#define mp make_pair
#define rep(n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()

const int INF = 1e18 + 2;
int n;
vvi graph;
vector<vvi> p;
vvi dp, xx;
vi l, r, c, ans;

void dfs(int v) {
	dp[v].assign(r[v] + 1, INF);
	xx[v].assign(r[v] + 1, 0);
	for (auto& to : graph[v])
		dfs(to);
	vvi opt;
	p[v].resize(graph[v].size() + 1);
	opt.resize(graph[v].size() + 1);
	for (int i = 0; i < opt.size(); i++) {
		opt[i].assign(r[v] + 1, INF);
		p[v][i].assign(r[v] + 1, 0);
	}
	if (graph[v].empty()) {
		for (int k = l[v]; k <= r[v]; k++) {
			dp[v][k] = k * c[v];
			xx[v][k] = k;
		}
		return;
	}
	for (int k = l[graph[v][0]]; k <= r[graph[v][0]] && k <= r[v]; k++)
		opt[0][k] = k * c[graph[v][0]];
	for (int i = 1; i < opt.size() - 1; i++) {
		for (int j = 1; j <= r[v]; j++) {
			int to = graph[v][i];
			for (int k = l[to]; k <= r[to] && k <= j; k++) {
				if (opt[i][j] > opt[i - 1][j - k] + dp[to][k]) {
					opt[i][j] = opt[i - 1][j - k] + dp[to][k];
					p[v][i][j] = j - k;
				}
			}
		}
	}
	for (int j = 0; j <= r[v]; j++) {
		for (int k = 0; j + k <= r[v]; k++) {
			if (opt.back()[j + k] > opt[(int)opt.size() - 2][j] + k * c[v]) {
				opt.back()[j + k] = opt[(int)opt.size() - 2][j] + k * c[v];
				xx[v][j + k] = k;
			}
		}
	}
	for (int j = 0; j < l[v]; j++)
		opt.back()[j] = INF;
	for (int j = 0; j <= r[v]; j++) dp[v][j] = opt.back()[j];
}

void restore(int v, int k) {
	ans[v] = xx[v][k];
	k -= xx[v][k];
	for (int i = (int)graph[v].size() - 1; i >= 0; i--) {
		assert(k != -1);
		restore(graph[v][i], k - p[v][i][k]);
		k = p[v][i][k];
	}
}

void solve() {
	cin >> n;
	graph.resize(n + 1);
	l.resize(n + 1);
	r.resize(n + 1);
	c.resize(n + 1);
	dp.resize(n + 1);
	xx.resize(n + 1);
	ans.resize(n + 1);
	p.resize(n + 1);
	rep(n - 1) {
		int pp; cin >> pp;
		graph[pp].push_back(i + 2);
	}
	rep(n) cin >> c[i + 1];
	rep(n) cin >> l[i + 1] >> r[i + 1];
	dfs(1);
	int res = INF;
	int k = -1;
	for (int i = l[1]; i <= r[1]; i++) {
		if (res > dp[1][i]) {
			res = dp[1][i];
			k = i;
		}
	}
	if (res == INF) {
		cout << "-1\n";
		return;
	}
	restore(1, k);
	cout << res << "\n";
	for (int i = 1; i <= n; i++) cout << ans[i] << " ";
	cout << "\n";
	graph.clear();
	xx.clear();
	l.clear();
	r.clear();
	c.clear();
	dp.clear();
	ans.clear();
	p.clear();
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t; cin >> t;
	while (t--) solve();
}