#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;

const int MAXN = 3001;

int n;
bitset<MAXN> lower[MAXN];
bitset<MAXN> upper[MAXN];
bitset<MAXN> counts[MAXN];

vi p;

void initSets() {
    lower[0].set(0);
    upper[0] = ~upper[0];
    for (int i = 1; i < n; i++) {
        lower[i] |= lower[i - 1];
        lower[i].set(i);
        upper[i] = ~lower[i - 1];
    }
}

int countLess(int l, int r, int x) {
    if (x == 0)
        return 0;
    int k = (counts[r] & lower[x - 1]).count();
    if (l > 0)
        k -= (counts[l - 1] & lower[x - 1]).count();
    return k;
}

int countGreater(int l, int r, int x) {
    int k = (counts[r] & upper[x + 1]).count();
    if (l > 0)
        k -= (counts[r] & upper[x + 1]).count();
    return k;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    initSets();
    p.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        counts[i].set(p[i] - 1);
    }
    for (int i = 1; i < n; i++)
        counts[i] |= counts[i - 1];
    ll answer = 0;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++) {
            ll curr = j - i;
            for (int l = 0; l < n; l++)
                for (int r = l + 1; r < n; r++) {
                    if ((i < l && j > r) || (j < l) || (i > r))
                        continue;
                    int newi = i;
                    if (i >= l)
                        newi = l + countLess(l, r, p[i] - 1);
                    int newj = j;
                    if (j <= r)
                        newj = l + countLess(l, r, p[j] - 1);
                    curr = max(curr, ll(abs(newj - newi)));
                }
            //printf("i = %d, j = %d, curr = %d\n", i, j, curr);
            answer += curr;
        }
    cout << answer;
}