#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct fenwick {
    void init(int n) {
        sz = n;
        t.resize(sz + 1, 0);
    }

    int get(int l, int r) {
        return get(r) - get(l);
    }

    void set(int ind) {
        for (int i = ind + 1; i <= sz; i += i & -i) ++t[i];
    }

 private:
    vector<int> t;
    int sz;

    int get(int r) {
        int res = 0;
        for (int i = r; i > 0; i -= i & -i) res += t[i];
        return res;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    ll ans = 0;
    for (auto &elem : p) {
        cin >> elem;
        --elem;
    }
    auto ps = p;
    sort(all(ps));
    vector<int> pps(n);
    for (int i = 0; i < n; ++i) pps[ps[i]] = i;

    vector<int> ls(n), gt(n);

    fenwick fw1, fw2;
    fw1.init(n);
    fw2.init(n);
    for (int i = 0; i < n; ++i) {
        gt[i] = fw1.get(p[i], n);
        fw1.set(p[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        ls[i] = fw2.get(0, p[i]);
        fw2.set(p[i]);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int cur = j - i;
            int dst = j - i;
//            auto pp = p;
//            sort(all(pp));
            cur = max(cur, abs(pps[p[i]] - pps[p[j]]));
//            pp = p;
//            sort(pp.begin(), pp.begin() + i + 1);
//            cur = max(cur, abs(int(find(all(pp), p[i]) - pp.begin()) - int(find(all(pp), p[j]) - pp.begin())));
            cur = max(cur, dst + gt[i]);
//            pp = p;
//            sort(pp.begin() + j, pp.end());
//            cur = max(cur, abs(int(find(all(pp), p[i]) - pp.begin()) - int(find(all(pp), p[j]) - pp.begin())));
            cur = max(cur, dst + ls[j]);
            ans += cur;
//            cout << p[i] + 1 << ' ' << p[j] + 1 << ' ' << cur << en;
        }
    }
    cout << ans;
}

int32_t main() {
    io();
    solve();
    return 0;
}