//#define _GLIBCXX_DEBUG

#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <cassert>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
//#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int N = 3000;
const int LG = 15;
bool g[N][N][2];
int up[LG][N][N];

void dfs(int x, int y, int py) {
    up[0][x][y] = py;
    for (int k = 1; k < LG; ++k) {
        up[k][x][y] = up[k - 1][x - (1 << (k - 1))][up[k - 1][x][y]];
    }
    if (g[x][y][0]) {
        dfs(x + 1, y, y);
    }
    if (g[x][y][1]) {
        dfs(x + 1, y + 1, y);
    }
}

pair<int, int> lca(int ax, int ay, int bx, int by) {
    if (ax < bx) {
        swap(ax, bx);
        swap(ay, by);
    }
    for (int k = LG - 1; k >= 0; --k) {
        if ((ax - bx) >= (1 << k)) {
            ay = up[k][ax][ay];
            ax -= (1 << k);
        }
    }
    if (ay == by) return {ax, ay};
    for (int k = LG - 1; k >= 0; --k) {
        if (up[k][ax][ay] != up[k][bx][by]) {
            ay = up[k][ax][ay];
            ax -= (1 << k);
            by = up[k][bx][by];
            bx -= (1 << k);
        }
    }
    return {ax - 1, up[0][ax][ay]};
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &elem : a) {
        cin >> elem;
        --elem;
    }
    vector<char> cur(n, true);
    for (int i = 0; i <= n; ++i) {
        if (i != 0) {
            cur[a[i - 1]] ^= true;
        }
        for (int x = 0, y = 0; x < n; ++x) {
            if (cur[x]) {
                g[x][y][1] = true;
                ++y;
            } else {
                g[x][y][0] = true;
            }
        }
    }
    dfs(0, 0, 0);
    int q;
    cin >> q;
    while (q-- > 0) {
        int ax, ay, bx, by;
        cin >> ax >> ay >> bx >> by;

        auto [nx, ny] = lca(ax, ay, bx, by);
        cout << nx << ' ' << ny << en;
    }
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}