//#define _GLIBCXX_DEBUG

#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <cassert>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
//#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int N = 3001;
const int LG = 15;
bool g[N][N][2];
int up[LG][N][N];

void dfs(int x, int y, int py) {
    up[0][x][y] = py;
    for (int k = 1; k < LG; ++k) {
        up[k][x][y] = up[k - 1][x - (1 << (k - 1))][up[k - 1][x][y]];
    }
    if (g[x][y][0]) {
        dfs(x + 1, y, y);
    }
    if (g[x][y][1]) {
        dfs(x + 1, y + 1, y);
    }
}

pair<int, int> lca(int ax, int ay, int bx, int by) {
    if (ax < bx) {
        swap(ax, bx);
        swap(ay, by);
    }
    for (int k = LG - 1; k >= 0; --k) {
        if ((ax - bx) >= (1 << k)) {
            ay = up[k][ax][ay];
            ax -= (1 << k);
        }
    }
    if (ay == by) return {ax, ay};
    for (int k = LG - 1; k >= 0; --k) {
        if (up[k][ax][ay] != up[k][bx][by]) {
            ay = up[k][ax][ay];
            ax -= (1 << k);
            by = up[k][bx][by];
            bx -= (1 << k);
        }
    }
    return {ax - 1, up[0][ax][ay]};
}

pair<int, int> get(int ax, int ay, int bx, int by) {
    if (ax - ay == bx - by) {
        return {min(ax, bx), min(ay, by)};
    } else {
        return {min(ax - ay, bx - by), 0};
    }
}

pair<int, int> get2(int ax, int ay, int bx, int by) {
    if (ay == by) {
        return {min(ax, bx), min(ay, by)};
    } else {
        return {min(ay, by), min(ay, by)};
    }
}

pair<int, int> get3(int ax, int ay, int bx, int by, int k) {
    if (ax - ay == bx - by) {
        return min(make_pair(ax, ay), make_pair(bx, by));
    } else {
        int as = (ax - ay) - k;
        int bs = (bx - by) - k;
        if (as == 0 && bs == 0) {
            return min(make_pair(ax, ay), make_pair(bx, by));
        } else if (max(as, bs) <= 0) {
            return get(ax, ay, bx, by);
        } else if (min(as, bs) >= 0) {
            auto rs = get2(ax - k, ay, bx - k, by);
            rs.first += k;
            return rs;
        } else {
            if (as > 0) {
                ax = k, ay = 0;
            } else {
                bx = k, by = 0;
            }
            return get(ax, ay, bx, by);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    int k = -1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        if (k == -1 && a[i] != i) {
            k = i;
        }
    }
    if (k == -1) k = n;
    vector<char> cur(n, true);
    if (n <= 3000) {
        for (int i = 0; i <= n; ++i) {
            if (i != 0) {
                cur[a[i - 1]] ^= true;
            }
            for (int x = 0, y = 0; x < n; ++x) {
                if (cur[x]) {
                    g[x][y][1] = true;
                    ++y;
                } else {
                    g[x][y][0] = true;
                }
            }
        }
        dfs(0, 0, 0);
    }
    int q;
    cin >> q;
//    for (int ax = 0; ax <= n; ++ax) {
//        for (int ay = 0; ay <= ax; ++ay) {
//            for (int bx = 0; bx <= n; ++bx) {
//                for (int by = 0; by <= bx; ++by) {
//                    auto lx = lca(ax, ay, bx, by), rx = get3(ax, ay, bx, by, k);
//                    if (lx != rx) {
//                        cout << ax << ' ' << ay << ' ' << bx << ' ' << by << en;
//                        cout << lx.first << ' ' << lx.second << en;
//                        cout << rx.first << ' ' << rx.second << en << en;
//                    }
//                }
//            }
//        }
//    }
    while (q-- > 0) {
        int ax, ay, bx, by;
        cin >> ax >> ay >> bx >> by;
        if (n <= 3000) {
            auto[nx, ny] = lca(ax, ay, bx, by);
            cout << nx << ' ' << ny << en;
        } else {
            auto rs = get3(ax, ay, bx, by, k);
            cout << rs.first << ' ' << rs.second << en;
        }
    }
}

int32_t main() {
//    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}