#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

typedef deque<pair<int, pair<int,int>>> dpint;

struct res {
	long long cost;
	long long ls;
	long long vk;
	dpint add; // cost, num, id

	res() {}
};

dpint merge(dpint a, dpint b) {
	while (!b.empty()) {
		a.push_back(b.back());
		b.pop_back();
	}
	sort(a.begin(), a.end());
	return a;
}

bool err = 0;

res dfs(vector<vector<int>>& g, vector<int>& l, vector<int>& r, vector<int>& c, vector <int>& a, int x) {
	long long ls = 0;
	dpint add;
	long long vk = 0;
	long long cost = 0;
	for (int v : g[x]) {
		res cr = dfs(g, l, r, c, a, v);
		if (err) {
			return res();
		}
		ls += cr.ls;
		vk += cr.vk;
		cost += cr.cost;
		add = merge(add, cr.add);
	}
	int L = l[x];
	if (ls < L) {
		dpint cv;
		cv.push_back({ c[x], {r[x], x} });
		add = merge(add, cv);

		while (ls < L && !add.empty()) {
			auto pp = add.front();
			int cc = pp.first;
			int id = pp.second.second;
			int num = pp.second.first;
			if (ls + num > L) {
				num = L - ls;
				add.front().second.first -= num;
			}
			else
				add.pop_front();
			ls += num;
			a[id] += num;
			vk -= num;
			cost += num * cc;
		}
	}

	else {
		if (ls > r[x]) {
			err = 1;
			return res();
		}
	}

	int d = r[x] - l[x];
	while (vk > d) {
		auto pp = add.back();
		int num = pp.second.first;
		if (vk - num < d) {
			num = vk - d;
			add.back().second.first -= num;
		}
		else
			add.pop_back();
		vk -= num;
	}

	res cr;
	cr.add = add;
	cr.cost = cost;
	cr.ls = ls;
	cr.vk = vk;
	return cr;
}

int main() {
	/*vpint a = { {1,0},{3,6},{7,0} };
	vpint b = { {0,2},{4,0},{8,5} };
	vpint c = merge(a, b);
	for (auto i : c)
		cout << i.first << " ";
	cout << endl;*/

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<vector<int>> g(n);
		vector <int> p(n);
		for (int i = 1; i < n; i++) {
			int pv;
			cin >> pv;
			pv--;
			p[i] = pv;
			g[pv].push_back(i);
		}

		vector <int> l(n), r(n), c(n);
		for (int i = 0; i < n; i++)
			cin >> c[i];
		for (int i = 0; i < n; i++)
			cin >> l[i] >> r[i];

		vector <int> a(n);
		res cr = dfs(g, l, r, c, a, 0);
		if (err) {
			cout << -1 << endl;
		}
		else {
			cout << cr.cost << endl;
			for (int i : a)
				cout << i << " ";
			cout << endl;
		}
	}
}
