#include<bits/stdc++.h>

using namespace std;

//#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define forn(i, n) for (int i = 0; i < n; i++)
#define ld long double
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()

struct node {
    int x, d = 0, l = 0, r = 0;
    node() {}
};

const int M = 2e7;
node mas[M];
int c = 0;
vector<int> root;

int create() {
    c++;
    mas[c].d = 0;
    return c;
}

void push(int v, int l, int r) {
    if (l + 1 != r) {
        int L = mas[v].l, R = mas[v].r;
        mas[v].l = create(), mas[v].r = create();
        mas[mas[v].l] = mas[L];
        mas[mas[v].r] = mas[R];
        mas[mas[v].l].x += mas[v].d;
        mas[mas[v].r].x += mas[v].d;
        mas[mas[v].l].d += mas[v].d;
        mas[mas[v].r].d += mas[v].d;
    }
    mas[v].d = 0;
}

void pull(int v) {
    mas[v].x = max(mas[mas[v].l].x, mas[mas[v].r].x);
}

int build(int l, int r) {
    int v = create();
    if (l + 1 == r) {
        mas[v].x = l;
        return v;
    }
    int m = (l + r) / 2;
    mas[v].l = build(l, m);
    mas[v].r = build(m, r);
    pull(v);
    return v;
}

int update(int v, int l, int r, int l1, int r1) {
    int u = create();
    push(v, l, r);
    mas[u] = mas[v];
    if (l1 >= r || l >= r1) {
        return u;
    }
    if (l1 <= l && r <= r1) {
        mas[u].d -= 1;
        mas[u].x -= 1;
        return u;
    }
    int m = (l + r) / 2;
    mas[u].l = update(mas[v].l, l, m, l1, r1);
    mas[u].r = update(mas[v].r, m, r, l1, r1);
    pull(u);
    return u;
}

int get(int v, int l, int r, int i) {
    push(v, l, r);
    if (l + 1 == r) {
        //cout << v << "F" << endl;
        return mas[v].x;
    }
    int m = (l + r) / 2;
    if (i < m) {
        return get(mas[v].l, l, m, i);
    } else {
        return get(mas[v].r, m, r, i);
    }
}

const int N = 500022, K = 20;
int n, q, a[N];
pii dp[N][K]
int lg[N];

int get(pii x) {
    if (x.se == x.fi) {
        return 0;
    }
    int l = 0, r = n;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (get(root[m], 0, n + 1, x.fi) > x.se) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

int get2(pii x) {
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (get(root[m], 0, n + 1, x.fi) >= x.se) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

pii getmin(int l, int r) {
    int g = lg[r - l + 1];
    return min(dp[l][g], dp[r - (1 << g) + 1][g]);
}

int slowget(pii x) {
    vector<int> tmp(n + 1);
    iota(all(tmp), 0);
    if (tmp[x.fi] <= x.se) {
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = a[i - 1]; j <= n; j++) tmp[j]--;
        if (tmp[x.fi] <= x.se) {
            return i;
        }
    }
}

int slowget2(pii x) {
    int last = 0;
    vector<int> tmp(n + 1);
    iota(all(tmp), 0);
    for (int i = 1; i <= n; i++) {
        for (int j = a[i - 1]; j <= n; j++) tmp[j]--;
        if (tmp[x.fi] == x.se) {
            last = max(last, i);
        }
    }
    return last;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    root.pb(build(0, n + 1));
    //forn (i, n + 1) cout << get(root[0], 0, n + 1, i) << " "; cout << endl;
    forn (i, n) {
        cin >> a[i];
        int v = update(root.back(), 0, n + 1, a[i], n + 1);
        dp[i][0] = get(root.back(), 0, n + 1, a[i] - 1);
        root.pb(v);
    }
    //for (auto v : root) {
        //forn (i, n + 1) cout << get(v, 0, n + 1, i) << " "; cout << endl;
    //}
    //return 0;
    for (int i = 2; i < N; i++) lg[i] = lg[i / 2] + 1;
    for (int j = 1; j <= lg[n]; j++) {
        for (int i = 0; i + (1 << j) - 1 < n; i++) {
            dp[i][j] = min(dp[i][j - 1], dp[i + (1 << (j - 1))][j - 1]);
        }
    }
    cin >> q;
    forn (i, q) {
        pii v, u;
        cin >> v.fi >> v.se >> u.fi >> u.se;
        if (v.fi > u.fi) swap(v, u);
        int t = get(v), t2 = get(u);
        assert(t == slowget(v));
        assert(t2 == slowget(u));
        //cout << v.fi << " " << v.se << " " << t << endl;
        //cout << u.fi << " " << u.se << " " << t2 << endl;
        if (t == t2) {
            cout << v.fi << " " << v.se << '\n';
            continue;
        }
        if (t > t2) {
            swap(t, t2);
            swap(v, u);
        }
        t = get2(v);
        assert(t == slowget2(v));
        //cout << v.fi << " A " << v.se << endl;
        //cout << t << " " << t2 << endl;
        int L = t, R = t2 - 1;
        pii ans = getmin(L, R);
        cout << ans.fi << " " << ans.se << '\n';
    }
}
