#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

#define int long long

const int SIZE = 100010;

vector <int> g[SIZE];
int anses[SIZE];
int c[SIZE];
int  l[SIZE];
int r[SIZE];

struct Sel
{
public:
    int cost;
    int num;
    int ind;

    bool operator<(const Sel & rhs) const
    {
        if (this->cost == rhs.cost)
        {
            if (this->num == rhs.num)
            {
                if (this->ind == rhs.ind)
                {
                    return false;
                }
                return this->ind < rhs.ind;
            }
            return this->num < rhs.num;
        }
        return this->cost < rhs.cost;
    }

    Sel(int cost_, int num_, int ind_)
    {
        cost = cost_;
        num = num_;
        ind = ind_;
    }
};

struct Rel
{
public:
    int cost;
    int left;
    int right;
    set <Sel> s;

    Rel()
    {
        cost = 0;
        left = 0;
        right = 0;
        s = set<Sel>();
    }
};

Rel Go(int v)
{
    Rel rel;
    rel.left = 0;
    rel.s.insert(Sel(c[v], r[v], v));
    rel.right = r[v];
    for (int to : g[v])
    {
        auto pp = Go(to);
        if (pp.cost == -1)
        {
            rel.cost = -1;
            return rel;
        }
        rel.cost += pp.cost;
        rel.left += pp.left;
        rel.right += pp.right;
        if (rel.s.size() < pp.s.size())
        {
            swap(rel.s, pp.s);
        }
        for (auto el : pp.s)
        {
            rel.s.insert(el);
        }
    }
    while (rel.s.size() && rel.left < l[v])
    {
        auto ptr = rel.s.begin();
        if (ptr->num <= l[v] - rel.left)
        {
            anses[ptr->ind] += ptr->num;
            rel.left += ptr->num;
            rel.cost += ptr->num * ptr->cost;
            rel.s.erase(rel.s.begin());
        }
        else
        {
            anses[ptr->ind] += l[v] - rel.left;
            rel.cost += (l[v] - rel.left) * ptr->cost;
            Sel sl = (*ptr);
            rel.s.erase(rel.s.begin());
            sl.num -= (l[v] - rel.left);
            rel.s.insert(sl);
            rel.left += (l[v] - rel.left);
        }
    }

    while (rel.s.size() && rel.right > r[v])
    {
        auto ptr = --rel.s.end();
        if (ptr->num <= rel.right - r[v])
        {
            rel.right -= ptr->num;
            rel.s.erase(--rel.s.end());
        }
        else
        {
            Sel sl = (*ptr);
            rel.s.erase(--rel.s.end());
            sl.num -= (rel.right - r[v]);
            rel.s.insert(sl);
            rel.right -= (rel.right - r[v]);
        }
    }

    if (rel.left < l[v] || rel.right > r[v])
    {
        rel.cost = -1;
        return rel;
    }
    return rel;
}

signed main()
{
    //freopen("C:\\Users\\roi\\CLionProjects\\zad1\\input.txt", "r", stdin);

    int t;
    cin >> t;
    while (t --> 0)
    {
        int n;
        cin >> n;
        for (int i = 1; i < n; ++i)
        {
            int p;
            cin >> p;
            p--;
            g[p].push_back(i);
        }

        for (int i = 0; i < n; ++i)
        {
            cin >> c[i];
        }
        for (int i = 0; i < n; ++i)
        {
            cin >> l[i] >> r[i];
        }

        auto ans = Go(0);

        if (ans.cost == -1)
        {
            cout << -1 << '\n';
        }
        else
        {
            cout << ans.cost << '\n';
            for (int i = 0; i < n; ++i)
            {
                cout << anses[i] << ' ';
            }
            cout << '\n';
        }

        for (int i = 0; i < n; ++i)
        {
            g[i].clear();
            anses[i] = 0;
            c[i] = 0;
            l[i] = 0;
            r[i] = 0;
        }
    }

    return 0;
}
