#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;

using ll = long long;

const int inf = 2e9;


struct MinSegTree {
    vector<pair<int, int>> tree;
    int n;

    MinSegTree() {}

    MinSegTree(vector<int>& a) {
        n = ssize(a);
        tree.resize(2 * n);
        for (int i = 0; i < n; ++i) {
            tree[i + n] = {a[i], i};
        }
        for (int i = n - 1; i > 0; --i) {
            tree[i] = min(tree[2 * i], tree[2 * i + 1]);
        }
    }

    pair<int, int> get(int l, int r) {
        pair<int, int> res = {inf, -1};
        l += n;
        r += n;
        while (l < r) {
            if (l & 1) {
                res = min(res, tree[l++]);
            }
            if (r & 1) {
                res = min(res, tree[--r]);
            }
            l /= 2;
            r /= 2;
        }
        return res;
    }

    void update(int pos, int val) {
        int v = pos + n;
        tree[v].first = val;
        v /= 2;
        while (v > 0) {
            tree[v] = min(tree[2 * v], tree[2 * v + 1]);
            v /= 2;
        }
    }
};

int n;
vector<vector<int>> g;
vector<int> p;
vector<int> c;
vector<int> al;
vector<int> ar;
vector<int> tin;
vector<int> tout;
vector<int> euler;
MinSegTree min_st;
vector<int> rest;
vector<int> b;
bool conflict;
int timer;
ll ans;

void dfs1(int v) {
    tin[v] = timer++;
    euler.push_back(v);

    for (int u: g[v]) {
        dfs1(u);
    }

    tout[v] = timer;
}

void dfs2(int v) {
    for (int u : g[v]) {
        dfs2(u);
    }

    if (conflict) {
        return;
    }

    while (ar[v] - rest[v] < al[v]) {
        pair<int, int> min_cost = min_st.get(tin[v], tout[v]);
        if (min_cost.first == inf) {
            conflict = true;
            return;
        }
        int u = euler[min_cost.second];

        int min_rest = rest[u];
        for (int t = u; t != -1; t = p[t]) {
            min_rest = min(min_rest, rest[t]);
        }

        if (min_rest == 0) {
            min_st.update(tin[u], inf);
            continue;
        }

        int need = al[v] - (ar[v] - rest[v]);
        int buy = min(need, min_rest);

        assert(buy > 0);

        ans += (ll)buy * min_cost.first;
        b[u] += buy;

        for (int t = u; t != -1; t = p[t]) {
            rest[t] -= buy;
        }
    }
}


void solve() {
    cin >> n;
    g.assign(n, vector<int>());
    c.assign(n, 0);
    al.assign(n, 0);
    ar.assign(n, 0);
    p.assign(n, 0);
    b.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    rest.assign(n, 0);
    conflict = false;

    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
     for (int i = 0; i < n; ++i) {
         cin >> c[i];
     }
     for (int i = 0; i < n; ++i) {
         cin >> al[i] >> ar[i];
     }

     for (int v = 0; v < n; ++v) {
         rest[v] = ar[v];
     }

     timer = 0;
     dfs1(0);

     vector<int> reorder_c(n);
     for (int v = 0; v < n; ++v) {
         reorder_c[tin[v]] = c[v];
     }
     min_st = MinSegTree(reorder_c);

     ans = 0;
     dfs2(0);

     if (conflict) {
         cout << "-1\n";
     } else {
         cout << ans << "\n";
         for (int v = 0; v < n; ++v) {
             cout << b[v] << " ";
         }
         cout << "\n";
     }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
