#include <bits/stdc++.h>

#define ssize(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

#define int long long

using namespace std;

using ll = long long;

struct Pt {
    int x;
    int y;
};

ll find_area(int n, int w, int h, vector<Pt> pts) {
    sort(all(pts), [](Pt a, Pt b) {
        if (a.y == b.y) {
            return a.x < b.x;
        }
        return a.y < b.y;
    });
    int min_x = w;
    ll area = 0;
    for (int i = 0; i < n; ++i) {
        if (pts[i].x < min_x - 1) {
            min_x = pts[i].x;
            int ny;
            if (i == n - 1) {
                ny = h;
            } else {
                ny = pts[i + 1].y;
            }
            area += (ll)(ny - pts[i].y) * (w - min_x);
        } else {
            area += (ll)w * (h - pts[i].y);
            break;
        }
    }
    return area;
}

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<Pt> pts(n);
    for (int i = 0; i < n; ++i) {
        cin >> pts[i].x >> pts[i].y;
    }

    sort(all(pts), [](Pt a, Pt b) {
        return a.y < b.y;
    });

    ll ans = 0;

    vector<tuple<int, int, ll>> states;
    states.push_back({-1, w, 0});
    for (int i = 0; i < n; ++i) {
        int ny;
        if (i == n - 1) {
            ny = h;
        } else {
            ny = pts[i + 1].y;
        }
        vector<tuple<int, int, ll>> new_states;
        for (auto [min_x, max_x, area] : states) {
            if (pts[i].x <= min_x + 1) {
                ans = max(ans, area + (ll)(h - pts[i].y) * w);
            } else if (pts[i].x >= max_x - 1) {
                ans = max(ans, area + (ll)(h - pts[i].y) * w);
            } else {
                new_states.push_back({pts[i].x, max_x,
                                      area + (ll)(pts[i].x + 1 + w - max_x)  * (ny - pts[i].y)});
                new_states.push_back({min_x, pts[i].x,
                                      area + (ll)(min_x + 1 + w - pts[i].x) * (ny - pts[i].y)});
            }
        }
        states = new_states;
    }

    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int k;
    cin >> k >> k >> k;

    int t;
    cin >> t;
    while (t--) {
        solve();
    }



    return 0;
}
