#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e3 + 10;
const int LG = 13;

vector<pair<int, int>> graph[MAXN][MAXN];
pair<int, int> up[LG][MAXN][MAXN];
int used[MAXN][MAXN];
int tin[MAXN][MAXN];
int tout[MAXN][MAXN];
int a[MAXN];
int dir[MAXN];

void dfs(int x, int y) {
    static int t = 0;
    used[x][y] = 1;
    tin[x][y] = t++;
    for (auto [a, b] : graph[x][y]) {
        if (!used[a][b]) {
            up[0][a][b] = {x, y};
            dfs(a, b);
        }
    }
    tout[x][y] = t++;
}

bool is_par(int x1, int y1, int x2, int y2) {
    return tin[x1][y1] <= tin[x2][y2] && tout[x2][y2] <= tout[x1][y1];
}

pair<int, int> lca(int x1, int y1, int x2, int y2) {
    if (is_par(x1, y1, x2, y2)) return {x1, y1};
    if (is_par(x2, y2, x1, y1)) return {x2, y2};
    for (int l = LG - 1; l >= 0; --l) {
        // cerr << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
        auto [a, b] = up[l][x1][y1];
        if (!is_par(a, b, x2, y2)) {
            x1 = a;
            y1 = b;
        }
    }
    return up[0][x1][y1];
}

signed main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        dir[i] = 1;
    }
    a[n] = n + 1;
    for (int i = 0; i <= n; ++i) {
        int y = 0;
        for (int j = 0; j < n; ++j) {
            graph[j][y].push_back({j + 1, y + dir[j]});
            y += dir[j];
            // up[0][j + 1][y + dir[j]] = {j, y};
        }
        dir[a[i] - 1]--;
    }
    dfs(0, 0);
    up[0][0][0] = {0, 0};
    for (int l = 1; l < LG; ++l) {
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                auto [a, b] = up[l - 1][i][j];
                up[l][i][j] = up[l - 1][a][b];
            }
        }
    }
    // for (int i = 0; i <= n; ++i) {
    //     for (int j = 0; j <= i; ++j) {
    //         cerr << up[0][i][j].first << ' ' << up[0][i][j].second << ": ";
    //     }cerr << endl;
    // }
    // for (int i = 0; i < n; ++i) {
    //     for (int j = 0; j <= i; ++j) {
    //         cerr << tout[i][j] << ' ';
    //     }cerr << endl;
    // }
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        auto [a, b] = lca(x1, y1, x2, y2);
        cout << a << ' ' << b << '\n';
    }
    return 0;
}