#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <numeric>
#include <cmath>
#include <deque>
#include <sstream>
#include <bitset>
#include <ctime>
#include <random>
#include <functional>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
constexpr int inf = 1e9 + 7;
constexpr double eps = 1e-6;

pair<int, int> DFS(int v, auto &children, auto &costs, auto &L, auto &res) {
    int s_min = 0, best = v;
    for (int u : children[v]) {
        auto [s_min_, best_] = DFS(u, children, costs, L, res);
        s_min += s_min_;
        if (costs[best_] < costs[best]) {
            best = best_;
        }
    }

    if (s_min < L[v]) {
        res[best] += L[v] - s_min;
        s_min = L[v];
    }
    return {best, s_min};
}

void Solve3(istream &in, ostream &out) {
    int t;
    in >> t;
    while (t--) {
        int n;
        in >> n;
        vector<vector<int>> children(n);
        for (int v = 1; v < n; ++v) {
            int p;
            in >> p;
            --p;
            children[p].push_back(v);
        }
        vector<int> costs(n);
        for (int &c_i : costs) {
            in >> c_i;
        }
        vector<int> L(n), R(n);
        for (int v = 0; v < n; ++v) {
            in >> L[v] >> R[v];
        }
        vector<int> res(n, 0);
        DFS(0, children, costs, L, res);
        ll s_cost = 0;
        for (int v = 0; v < n; ++v) {
            s_cost += static_cast<ll>(res[v]) * costs[v];
        }
        out << s_cost << '\n';
        for (int res_i : res) {
            out << res_i << ' ';
        }
        out << '\n';
    }
}


using Solution = function<void (istream &, ostream &)>;
using TestGenerator = function<void (ostream &)>;

void StressTest(Solution smart, Solution stupid, TestGenerator generator, ostream &result_out = cout) {
    static constexpr int N_EPOCHS = 10'000;
    for (int i = 0; i < N_EPOCHS; ++i) {
        ostringstream test;
        generator(test);
        istringstream in_smart(test.str()), in_stupid(test.str());
        ostringstream out_smart, out_stupid;
        smart(in_smart, out_smart);
        stupid(in_stupid, out_stupid);
        if(out_smart.str() != out_stupid.str()) {
            result_out << "Test:\n";
            result_out << test.str() << '\n';
            result_out << "Smart:\n";
            result_out << out_smart.str() << '\n';
            result_out << "Stupid\n";
            result_out << out_stupid.str() << '\n';
            return;
        }
    }
    result_out << "OK\n";
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve3(cin, cout);
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    return 0;
}
