#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <numeric>
#include <cmath>
#include <deque>
#include <sstream>
#include <bitset>
#include <ctime>
#include <random>
#include <functional>

using namespace std;
// #define int long long
using ll = long long;
using ld = long double;
constexpr int inf = 1e9 + 7;
constexpr double eps = 1e-6;


void DFS(pair<int, int> v, auto &G, auto &used) {
    used[v.first][v.second] = true;
    for (auto u : G[v.first][v.second]) {
        if (used[u.first][u.second]) {
            continue;
        }
        DFS(u, G, used);
    }
}

void Solve(istream &in, ostream &out) {
    int n;
    in >> n;
    vector<bool> order(n, true);
    set<pair<pair<int, int>, pair<int, int>>> E;
    auto add_order = [&E](vector<bool> &order) {
        int c = 0;
        for (int r = 1; r <= order.size(); ++r) {
            int c_ = c + order[r - 1];
            E.insert({{r - 1, c}, {r, c_}});
            c = c_;
        }
    };
    add_order(order);
    for (int i = 0; i < n; ++i) {
        int a;
        in >> a;
        --a;
        order[a] = false;
        add_order(order);
    }
    vector<vector<vector<pair<int, int>>>> G(n + 1, vector<vector<pair<int, int>>>(n + 1));
    for (auto [a, b] : E) {
        G[b.first][b.second].push_back(a);
//        cerr << b.first << ' ' << b.second << ' ' << a.first << ' ' << a.second << '\n';
    }
    int q;
    in >> q;
    while (q--) {
        int r1, c1, r2, c2;
        in >> r1 >> c1 >> r2 >> c2;
        vector<vector<bool>> used1(n + 1, vector<bool>(n + 1, false));
        vector<vector<bool>> used2(n + 1, vector<bool>(n + 1, false));
        DFS({r1, c1}, G, used1);
        DFS({r2, c2}, G, used2);
        for (int r = n; r >= 0; --r) {
            for (int c = 0; c <= r; ++c) {
                if (used1[r][c] && used2[r][c]) {
                    out << r << ' ' << c << '\n';
                    r = -1;
                    break;
                }
            }
        }
    }
}


using Solution = function<void (istream &, ostream &)>;
using TestGenerator = function<void (ostream &)>;

void StressTest(Solution smart, Solution stupid, TestGenerator generator, ostream &result_out = cout) {
    static constexpr int N_EPOCHS = 10'000;
    for (int i = 0; i < N_EPOCHS; ++i) {
        ostringstream test;
        generator(test);
        istringstream in_smart(test.str()), in_stupid(test.str());
        ostringstream out_smart, out_stupid;
        smart(in_smart, out_smart);
        stupid(in_stupid, out_stupid);
        if(out_smart.str() != out_stupid.str()) {
            result_out << "Test:\n";
            result_out << test.str() << '\n';
            result_out << "Smart:\n";
            result_out << out_smart.str() << '\n';
            result_out << "Stupid\n";
            result_out << out_stupid.str() << '\n';
            return;
        }
    }
    result_out << "OK\n";
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve(cin, cout);
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    return 0;
}
