#include <bits/stdc++.h>

using namespace std;

#define int long long


class LiChaoTree {
	vector<int> xx;
	vector<pair<int, int>> line;
	vector<bool> mod;
	int n;

public:
	LiChaoTree(vector<int> xx): xx(xx) {
		n = xx.size();
		line.resize(4 * n);
		mod.resize(4 * n);
	}

	void push(int v, int vl, int vr) {
		if(mod[v]) {
			if(vr - vl > 1) {
				mod[v * 2] = true;
				line[v * 2] = make_pair(0, -1000000000000000000);
				mod[v * 2 + 1] = true;
				line[v * 2 + 1] = make_pair(0, -1000000000000000000);
			}
			mod[v] = false;
		}
	}

	void set(int v, int vl, int vr, int l, int r, pair<int, int> ln) {
		if(vl == l && vr == r) {
			mod[v] = true;
			line[v] = ln;
		} else {
			push(v, vl, vr);
			int vm = (vl + vr) / 2;
			max_eq(v * 2, vl, vm, vl, vm, line[v]);
			max_eq(v * 2 + 1, vm, vr, vm, vr, line[v]);
			line[v] = make_pair(0, -1000000000000000000);
			if(r <= vm) {
				set(v * 2, vl, vm, l, r, ln);
			} else if(l >= vm) {
				set(v * 2 + 1, vm, vr, l, r, ln);
			} else {
				set(v * 2, vl, vm, l, vm, ln);
				set(v * 2 + 1, vm, vr, vm, r, ln);
			}
		}
	}
	void set(int l, int r, pair<int, int> ln) {
		if(l == r) {
			return;
		}
		set(1, 0, n, l, r, ln);
	}

	void max_eq(int v, int vl, int vr, int l, int r, pair<int, int> ln) {
		if(vl == l && vr == r) {
			push(v, vl, vr);

			int old_at_start = line[v].first * xx[vl] + line[v].second;
			int new_at_start = ln.first * xx[vl] + ln.second;

			int old_at_end = line[v].first * xx[vr - 1] + line[v].second;
			int new_at_end = ln.first * xx[vr - 1] + ln.second;

			if(old_at_start <= new_at_start && old_at_end <= new_at_end) {
				line[v] = ln;
			} else if(old_at_start >= new_at_start && old_at_end >= new_at_end) {
				// pass
			} else {
				if(old_at_start >= new_at_start) {
					swap(ln, line[v]);
				}

				int vm = (vl + vr) / 2;
				int old_at_mid = line[v].first * xx[vm] + line[v].second;
				int new_at_mid = ln.first * xx[vm] + ln.second;

				if(old_at_mid <= new_at_mid) {
					max_eq(v * 2 + 1, vm, vr, vm, vr, line[v]);
					line[v] = ln;
				} else {
					max_eq(v * 2, vl, vm, vl, vm, ln);
				}
			}
		} else {
			push(v, vl, vr);
			int vm = (vl + vr) / 2;
			if(r <= vm) {
				max_eq(v * 2, vl, vm, l, r, ln);
			} else if(l >= vm) {
				max_eq(v * 2 + 1, vm, vr, l, r, ln);
			} else {
				max_eq(v * 2, vl, vm, l, vm, ln);
				max_eq(v * 2 + 1, vm, vr, vm, r, ln);
			}
		}
	}
	void max_eq(int l, int r, pair<int, int> ln) {
		if(l == r) {
			return;
		}
		max_eq(1, 0, n, l, r, ln);
	}

	int get(int v, int vl, int vr, int i) {
		if(vr - vl == 1) {
			return line[v].first * xx[i] + line[v].second;
		} else {
			push(v, vl, vr);
			int cur = line[v].first * xx[i] + line[v].second;
			int vm = (vl + vr) / 2;
			if(i < vm) {
				return max(get(v * 2, vl, vm, i), cur);
			} else {
				return max(get(v * 2 + 1, vm, vr, i), cur);
			}
		}
	}
	int get(int i) {
		return get(1, 0, n, i);
	}
};

vector<int> directions;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}
	sort(pts.begin(), pts.end(), [](auto p1, auto p2) {
		return make_pair(p1.first, -p1.second) < make_pair(p2.first, -p2.second);
	});

	vector<int> xx;
	for(auto [x, y]: pts) {
		xx.push_back(x);
	}
	xx.push_back(0);
	xx.push_back(w);
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());

	vector<int> yy;
	for(auto [x, y]: pts) {
		yy.push_back(y);
	}
	yy.push_back(0);
	yy.push_back(h);
	sort(yy.begin(), yy.end());
	yy.erase(unique(yy.begin(), yy.end()), yy.end());

	vector<vector<vector<vector<int>>>> dp(
		xx.size() + 1,
		vector<vector<vector<int>>>(
			yy.size() + 1,
			vector<vector<int>>(
				xx.size() + 1,
				vector<int>(yy.size() + 1, 0)
			)
		)
	);

	for(int dx = 1; dx <= xx.size(); dx++) {
		for(int dy = 1; dy <= yy.size(); dy++) {
			for(int x1 = 0; x1 + dx <= xx.size(); x1++) {
				int x2 = x1 + dx;
				for(int y1 = 0; y1 + dy <= yy.size(); y1++) {
					int y2 = y1 + dy;

					vector<pair<int, int>> pts_inside_rect;
					for(auto [x, y]: pts) {
						if(xx[x1] <= x && x <= xx[x2] && yy[y1] <= y && y <= yy[y2]) {
							x = lower_bound(xx.begin(), xx.end(), x) - xx.begin();
							y = lower_bound(yy.begin(), yy.end(), y) - yy.begin();
							pts_inside_rect.emplace_back(x, y);
						}
					}

					if(pts_inside_rect.empty()) {
						continue;
					}

					// Has increasing?
					bool updated = false;
					for(int i = 1; i < pts_inside_rect.size(); i++) {
						auto p1 = pts_inside_rect[i - 1];
						auto p2 = pts_inside_rect[i];
						if(p1.second <= p2.second) {
							auto& box1 = dp[x1][p2.second][p1.first][y2];
							auto& box2 = dp[p2.first][y1][x2][p1.second];
							int self = (
								(xx[x2] - xx[x1]) * (yy[y2] - yy[y1])
								- (xx[p1.first] - xx[x1]) * (yy[y2] - yy[p2.second])
								- (xx[x2] - xx[p2.first]) * (yy[p1.second] - yy[y1])
							);
							dp[x1][y1][x2][y2] = self + box1 + box2;
							// cerr << "(" << xx[p1.first] << " " << yy[p1.second] << "  " << xx[p2.first] << " " << yy[p2.second] << ") -> " << dp[x1][y1][x2][y2] << " " << self << endl;
							updated = true;
						}
					}
					if(!updated) {
						auto p = pts_inside_rect[0];
						// cerr << "(" << xx[p.first] << " " << yy[p.second] << ")" << endl;
						dp[x1][y1][x2][y2] = max(
							(xx[x2] - xx[p.first]) * (yy[y2] - yy[p.second]) + dp[x1][y1][x2][p.second - 1],
							(xx[p.first] - xx[x1]) * (yy[p.second] - yy[y1]) + dp[p.first + 1][y1][x2][y2]
						);
					}

					// cerr << xx[x1] << ".." << xx[x2] << ", " << yy[y1] << ".." << yy[y2] << ": " << dp[x1][y1][x2][y2] << " / " << updated << endl;
				}
			}
		}
	}

	cout << dp[0][0][xx.size() - 1][yy.size() - 1] << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}