#include <bits/stdc++.h>

using namespace std;

#define int long long


vector<int> directions;

void solve() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> pts(n);
	for(auto& [x, y]: pts) {
		cin >> x >> y;
	}

	sort(pts.begin(), pts.end(), [](auto p1, auto p2) {
		return p1.second < p2.second;
	});

	vector<int> xx;
	for(auto [x, y]: pts) {
		xx.push_back(x);
	}
	xx.push_back(0);
	xx.push_back(w);
	sort(xx.begin(), xx.end());
	xx.erase(unique(xx.begin(), xx.end()), xx.end());

	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(xx.size(), vector<int>(xx.size())));
	for(int i = n - 1; i >= 0; i--) {
		auto [x, y] = pts[i];
		int x_id = lower_bound(xx.begin(), xx.end(), x) - xx.begin();
		for(int l = 0; l < xx.size(); l++) {
			dp[i][l][l] = 0;
			for(int r = l + 1; r < xx.size(); r++) {
				if(x < xx[l] || x > xx[r]) {
					dp[i][l][r] = (xx[r] - xx[l]) * (h - y);
				} else {
					dp[i][l][r] = max(
						(xx[r] - x) * (h - y) + dp[i + 1][l][x_id],
						(x - xx[l]) * (h - y) + dp[i + 1][x_id][r]
					);
				}
			}
		}
	}

	cout << dp[0][0][xx.size() - 1] << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	{
		int k;
		cin >> k;
		directions.resize(k);
		for(int& d: directions) {
			cin >> d;
		}
	}

	int t;
	cin >> t;
	while(t --> 0) {
		solve();
	}

	return 0;
}