#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int n;
	cin >> n;
	vector<int> p(n);
	for (auto &x : p) {
		cin >> x;
		x--;
	}
	vector<int> where(n);
	for (int i = 0; i < n; i++) {
		where[p[i]] = i;
	}

	vector<vector<int>> ans(n, vector<int>(n));
	vector<vector<int>> pref(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		if (i) {
			pref[i] = pref[i - 1];
		}
		for (int j = 0; j < p[i]; j++) {
			pref[i][j]++;
		}
	}

	vector<vector<int>> suf(n, vector<int>(n));
	for (int i = n - 1; i >= 0; i--) {
		if (i != n - 1) {
			suf[i] = suf[i + 1];
		}
		for (int j = p[i] + 1; j < n; j++) {
			suf[i][j]++;
		}
	}

	for (int x = 0; x < n; x++) {
		for (int y = x + 1; y < n; y++) {
			int p1 = where[x], p2 = where[y];
			ans[x][y] = max(ans[x][y], abs(p1 - p2));
			ans[x][y] = max(ans[x][y], abs(x - y));
			int xx = x, yy = y;
			if (p1 > p2) {
				swap(p1, p2);
				swap(xx, yy);
			}
			for (int pos = p1 + 1; pos <= p2; pos++) {
				ans[x][y] = max(ans[x][y], suf[pos][yy] + (pos - p1));
			}
			for (int pos = p1; pos < p2; pos++) {
				ans[x][y] = max(ans[x][y], pref[pos][xx] + (p2 - pos));
			}
		}
	}

	ll res = 0;
	for (int x = 0; x < n; x++) {
		for (int y = x + 1; y < n; y++) {
			res += ans[x][y];
            // cout << "(" << x << ", " << y << "): " << ans[x][y] << endl;
		}
	}
	cout << res << '\n';
}
