#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> g(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		g[p - 1].push_back(i);
	}
	vector<int> c(n);
	for (auto &x : c) {
		cin >> x;
	}
	vector<int> l(n), r(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}

	{
		bool ok = true;
		auto initial_l = l;

		y_combinator([&](auto dfs, int v) -> void {
			ll sum_l = 0;
			for (auto u : g[v]) {
				dfs(u);
				sum_l += l[u];
			}
			if (sum_l > r[v]) {
				ok = false;
			}
			if (sum_l > l[v]) {
				l[v] = sum_l;
			}
		})(0);

		if (!ok) {
			cout << "-1\n";
			return;
		}
		l = initial_l;
	}

	vector<int> tin(n), tout(n), order;
	int timer = 0;

	y_combinator([&](auto dfs, int v) -> void {
		tin[v] = timer++;
		order.push_back(v);
		for (auto u : g[v]) {
			dfs(u);
		}
		tout[v] = timer;
	})(0);

	vector<int> ans(n), can(n);

	y_combinator([&](auto dfs, int v) -> int {
		if (g[v].empty()) {
			can[v] = r[v] - l[v];
			ans[v] += l[v];
			return l[v];
		}

		int tot = 0;
		for (auto u : g[v]) {
			tot += dfs(u);
		}
		assert(tot <= r[v]);

		can[v] = r[v];
		for (int pos = tin[v]; pos < tout[v]; pos++) {
			int u = order[pos];
			can[v] = min(can[v], r[v] - tot);
		}

		int delta = max(0, l[v] - tot);
		while (delta > 0) {
			int id = -1;
			for (int pos = tin[v]; pos < tout[v]; pos++) {
				int u = order[pos];
				if (can[u] > 0 && (id == -1 || c[id] > c[u])) {
					id = u;
				}
			}
			assert(id != -1);

			int here = min(delta, can[id]);
			ans[id] += here;
			delta -= here;
			for (int pos = tin[id]; pos < tout[id]; pos++) {
				can[order[pos]] -= here;
			}
		}
		tot += delta;
		return tot;
	})(0);

	ll cost = 0;
	for (int i = 0; i < n; i++) {
		cost += 1ll * ans[i] * c[i];
	}
	cout << cost << '\n';
	for (int i = 0; i < n; i++) {
		cout << ans[i] << " \n"[i == n - 1];
	}
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
