#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
	const Fun fun;

	y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

	template<typename... Args>
	decltype(auto) operator()(Args&&... args) const {
		return fun(ref(*this), forward<Args>(args)...);
	}
};

void solve() {
	int n, w, h;
	cin >> n >> w >> h;
	vector<pair<int, int>> a(n);
	for (auto &[x, y] : a) {
		cin >> x >> y;
		x = w - x;
		y = h - y;
	}

	sort(all(a));

	struct data {
		int x, y;
		ll res;
	};
	vector<data> st;

	auto query = [&](int i) {
		return 1ll * (st[i].first - (i == 0 ? 0 : st[i - 1].first)) * st[i].second;
	};

	for (auto &[x, y] : a) {
		while (!st.empty() && st.back().y <= y) {
			st.pop_back();
		}
		st.push_back({x, y, st.empty() ? 0 : st.back().res});
		st.back().res += query(len(st) - 1);
	}

	cout << st.back().res << '\n';
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int k;
	cin >> k;
	vector<int> valid(k);
	for (auto &x : valid) {
		cin >> x;
	}
	assert(k == 1 && valid[0] == 1);

	int tests;
	cin >> tests;
	while (tests--) {
		solve();
	}
}
