#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

#define long long long int

struct uma {
    int f, s;

    uma(int _f, int _s) : f(_f), s(_s) { }

    uma() { }
};

void out(uma a) {
    cout << a.f << " " << a.s << endl;
}

int code(int a, int b) {
    return a * (a + 1) / 2 + b;
}

int code(uma m) {
    return code(m.f, m.s);
}

uma encode(int a) {
    int pcr = 0, cr = 0;
    int i = 1;
    while (cr <= a) {
        cr += i;
        i++;
    }
    return uma(i - 2, a - cr + i - 1);
}

void build_graph(vector<int> &pp, vector<set<int>> &a, int n) {
    vector<int> ci(n, 0);
    for (int i = 0;i < n;i++) {
        int cur = 0;
        for (int j = 0;j < n;j++) {
            if (ci[j] == 0) {
                uma kl = encode(cur);
                kl.f += 1; kl.s += 1;
                int ncur = code(kl);
                a[cur].insert(ncur);
                a[ncur].insert(cur);
                cur = ncur;
            }
            else {
                uma kl = encode(cur);
                kl.f += 1;
                int ncur = code(kl);
                a[cur].insert(ncur);
                a[ncur].insert(cur);
                cur = ncur;
            }
        }
        ci[pp[i] - 1] = 1;
        //for (auto pi : ci) cout << pi << " ";
        //cout << endl;
    }
    int cur = 0;
    for (int j = 0;j < n;j++) {
            if (ci[j] == 0) {
                uma kl = encode(cur);
                kl.f += 1; kl.s += 1;
                int ncur = code(kl);
                a[cur].insert(ncur);
                a[ncur].insert(cur);
                cur = ncur;
            }
            else {
                uma kl = encode(cur);
                kl.f += 1;
                int ncur = code(kl);
                a[cur].insert(ncur);
                a[ncur].insert(cur);
                cur = ncur;
            }
        }
}

bool dfs(int v, int &mmax, int stop, int pre, vector<set<int>> &a) {
    // cout << "d" << endl;
    if (v == stop) {
        mmax = min(mmax, v);
        return true;
    }
    for (auto i : a[v]) {
        if (i != pre) {
            if (dfs(i, mmax, stop, v, a) == true) {
                mmax = min(mmax, v);
                return true;
            }
        }
    }
    return false;
}

int lca(int a, int b, vector<set<int>> &a1) {
    int mmax = 1e9;
    dfs(a, mmax, b, a, a1);
    return mmax;
}

int main() {
    int n;
    cin >> n;
    vector<int> pp(n);
    for (int i = 0;i < n;i++) cin >> pp[i];
    if (n > 3000) {
        int q;
        cin >> q;
        for (int i = 0;i < q;i++) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            if (a - b == c - d) {
                if (a < c) cout << a << " " << b << endl;
                else cout << c << " " << d << endl;
            }
            else {
                a -= b; c -= d;
                b = 0; d = 0;
                if (a < c) cout << a << " " << 0 << endl;
                else cout << c << " " << 0 << endl;
            }
        }
    }
    else {
        vector<set<int>> a((n + 1) * (n + 2) / 2, set<int>());
        build_graph(pp, a, n);
        int q;
        cin >> q;
        for (int i = 0;i < q;i++) {
                int c1, c2, c3, c4;
            cin >> c1 >> c2 >> c3 >> c4;
            int k, l;
            int res = lca(code(c1, c2), code(c3, c4), a);
            out(encode(res));
        }
    }
}
