#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e : v) o << e << " ";
    return o;
}
template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}
template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}
template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e : v) o >> e;
    return o;
}






using Seg = pair<ll, ll>;
vector<vector<int>> graph;
vector<int> c, parent;
vector<Seg> limits;

const Seg EMPTY = {-1, -1};

using Store = set<pair<int, int>>; // price, v
ll total_price = 0;
vector<ll> bought;
vector<ll> a;
vector<ll> available;

ll min_from(int v) {
    ll limit = INT32_MAX;
    while (v != -1) {
        limit = min(available[v], limit);
        v = parent[v];
    }
    return limit;
}

void do_buy(int v, ll cnt) {
    while (v != -1) {
        available[v] -= cnt;
        a[v] += cnt;
        v = parent[v];
    }
}

bool dfs(int v, Store &store) {
    store.insert({c[v], v});
    auto[l, r] = limits[v];

    for (int u: graph[v]) {
        Store new_store;
        if (!dfs(u, new_store)) return false;
        store.merge(new_store);
    }

    while (!store.empty() && a[v] < l) {
        auto it = store.begin();
        auto[price, u] = *it;
        ll can_buy = min_from(u);

        if (can_buy == 0) {
            store.erase(it);
            continue;
        }

        ll buy = min(can_buy, l - a[v]);
        can_buy -= buy;
        do_buy(u, buy);
        total_price += price * buy;
        bought[u] += buy;
        if (can_buy == 0) store.erase(it);
    }

    if (a[v] < l) return false;

    return true;
}

void solve() {
    int n;
    cin >> n;
    graph.assign(n, {});
    parent.assign(n, -1);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        parent[i] = p;
        graph[p].push_back(i);
    }

    c.assign(n, 0), limits.assign(n, {});
    cin >> c;
    cin >> limits;
    dbg(c);
    dbg(limits);

    available.resize(n);
    for (int i = 0; i < n; ++i) {
        available[i] = limits[i].second;
    }

    Store store;
    total_price = 0;
    a.assign(n, 0);
    bought.assign(n, 0);
    auto res = dfs(0, store);

    if (!res) {
        cout << "-1\n";
    } else {
        cout << total_price << "\n";
        cout << bought << "\n";
    }
}

int main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while(q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int q;
    cin >> q;
    while (q--) solve();
#endif
    return 0;
}
