#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) (o).begin(), (o).end()
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

template<typename T, typename Q>
ostream &operator<<(ostream &o, const pair<T, Q> &v) {
    o << v.first << " " << v.second;
    return o;
}

template<typename T, typename Q>
istream &operator>>(istream &o, pair<T, Q> &v) {
    o >> v.first >> v.second;
    return o;
}

template<typename T>
istream &operator>>(istream &o, vector<T> &v) {
    for (auto &e: v) o >> e;
    return o;
}

const int MN = 1 << 19;

struct MergeSortTree {
    vector<vector<int>> f;
    int mx;

    explicit MergeSortTree(const vector<int> &p) : f(MN * 2, vector<int>()), mx(int(p.size())) {
        for (int i = 0; i < p.size(); ++i) {
            f[i + MN] = {p[i]};
        }
        for (int i = MN - 1; i > 0; --i) {
            f[i].resize(f[i * 2].size() + f[i * 2 + 1].size());
            merge(all(f[i * 2]), all(f[i * 2 + 1]), f[i].begin());
        }
    }

    int order(int ub, int x) {
        int i = 1;
        while (i < MN) {
            int cnt = int(lower_bound(all(f[i * 2]), ub) - f[i * 2].begin());
            if (x >= cnt) {
                x -= cnt;
                i = i * 2 + 1;
            } else {
                i = i * 2;
            }
        }
        return min(mx, i - MN);
    }

    int count(int ub, int l, int r, int tl = 0, int tr = MN, int v = 1) {
        if (r - l < 1) return 0;
        if (l == tl && r == tr) {
            return int(lower_bound(all(f[v]), ub) - f[v].begin());
        }
        int m = (tl + tr) / 2;
        int c1 = count(ub, l, min(r, m), tl, m, v * 2);
        int c2 = count(ub, max(l, m), r, m, tr, v * 2 + 1);
        return c1 + c2;
    }

    int get_min(int l, int r, int tl = 0, int tr = MN, int v = 1) {
        if (r - l < 1) return INT32_MAX;
        if (l == tl && r == tr) {
            return f[v][0];
        }
        int m = (tl + tr) / 2;
        int c1 = get_min(l, min(r, m), tl, m, v * 2);
        int c2 = get_min(max(l, m), r, m, tr, v * 2 + 1);
        return min(c1, c2);
    }
};

void solve() {
    int n;
    cin >> n;
    n++;
    vector<int> p(n - 1);
    cin >> p;
    for (int i = 0; i < n - 1; ++i) p[i]--;

    MergeSortTree mst(p);

    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        c1 = r1 - c1, c2 = r2 - c2;
        int i1 = mst.order(r1, c1), i2 = mst.order(r2, c2);

        int lcp = mst.get_min(min(i1, i2), max(i1, i2));
        lcp = min({r1, r2, lcp});

        dbg(lcp);
        dbg("    ");

        int cnt = mst.count(lcp, 0, i1);

        cout << lcp << " " << lcp - cnt << "\n";
    }
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << "###########################\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
#endif
    return 0;
}
