#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5 + 100;
int arr[MAXN];

int treemin[MAXN * 4];

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        treemin[v] = arr[vl];
        return;
    }
    int vm = (vl + vr) / 2;
    build(v * 2, vl, vm);
    build(v * 2 + 1, vm, vr);
    treemin[v] = min(treemin[v * 2], treemin[v * 2 + 1]);
}

int get_first(int v, int vl, int vr, int l, int r, int k) {
    if (l >= vr || r <= vl) return -1;
    if (treemin[v] > k) return -1;
    if (vr - vl == 1) return vl;
    int vm = (vl + vr) / 2;
    int res = get_first(v * 2, vl, vm, l, r, k);
    if (res != -1) return res;
    return get_first(v * 2 + 1, vm, vr, l, r, k);
}

int get_last(int v, int vl, int vr, int l, int r, int k) {
    if (l >= vr || r <= vl) return -1;
    if (treemin[v] > k) return -1;
    if (vr - vl == 1) return vl;
    int vm = (vl + vr) / 2;
    int res = get_last(v * 2 + 1, vm, vr, l, r, k);
    if (res != -1) return res;
    return get_last(v * 2, vl, vm, l, r, k);
}

int get_min(int v, int vl, int vr, int l, int r) {
    if (l >= vr || r <= vl) return MAXN;
    if (l <= vl && r >= vr) return treemin[v];
    int vm = (vl + vr) / 2;
    int res1 = get_min(v * 2, vl, vm, l, r);
    int res2 = get_min(v * 2 + 1, vm, vr, l, r);
    return min(res1, res2);
}

vector<int> g[MAXN];
int par[MAXN];

int n;

map<array<int, 2>, int> cr;

int get_v(int r, int c) {
    /**int ind = -1;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (arr[i] < r) {
            cnt++;
            if (cnt == c) {
                ind = i;
            }
        }
    }
    cr[{r, r - c}] = ind;*/
    int ind = cr[{r, r - c}];
    int jnd = get_first(1, 0, n, ind + 1, n, r - 1);
    if (jnd == -1) jnd = n;
    if (jnd - ind <= 1) {
        if (ind == -1) {
            return arr[jnd];
        }
        if (jnd == n) {
            return arr[ind];
        }
        return max(arr[ind], arr[jnd]);
    }
    return get_min(1, 0, n, ind + 1, jnd);
}

vector<int> euler;
const int MAXLN = 20;
int sp[MAXLN][MAXN];
int tin[MAXN], lg[MAXN];

void dfs(int v) {
    tin[v] = euler.size();
    euler.push_back(v);
    for (auto u : g[v]) {
        dfs(u);
        euler.push_back(v);
    }
}
int lca(int u, int v) {
    u = tin[u]; v = tin[v];
    if (u > v) swap(u, v);
    v++;
    int lvl = lg[v - u];
    return min(sp[lvl][u], sp[lvl][v - (1 << lvl)]);
}

int ans_c[MAXN];

int tree[MAXN * 4];

void update(int v, int vl, int vr, int ind) {
    if (ind >= vr || ind < vl) return;
    if (vr - vl == 1) {
        tree[v]++;
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, ind);
    update(v * 2 + 1, vm, vr, ind);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

int get_sum(int v, int vl, int vr, int l, int r) {
    if (l >= vr || r <= vl) return 0;
    if (l <= vl && r >= vr) return tree[v];
    int vm = (vl + vr) / 2;
    int res1 = get_sum(v * 2, vl, vm, l, r);
    int res2 = get_sum(v * 2 + 1, vm, vr, l, r);
    return res1 + res2;
}

int get_ind(int v, int vl, int vr, int l, int r, int k) {
    if (l >= vr || r <= vl) return -1;
    if (tree[v] < k) return -1;
    if (vr - vl == 1) return vl;
    int vm = (vl + vr) / 2;
    int res = get_ind(v * 2, vl, vm, l, r, k);
    if (res != -1) return res;
    k -= tree[v * 2];
    return get_ind(v * 2 + 1, vm, vr, l, r, k);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    vector<array<int, 3>> ev;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        arr[i]--;
        ev.push_back({arr[i], 0, i});
    }
    build(1, 0, n);
    for (int i = 0; i < n; ++i) {
        if (arr[i] == 0) continue;
        int a = get_first(1, 0, n, i + 1, n, arr[i]);
        int b = get_last(1, 0, n, 0, i, arr[i]);
        int p;
        if (a == -1) {
            p = arr[b];
        } else if (b == -1) {
            p = arr[a];
        } else {
            p = max(arr[a], arr[b]);
        }
        g[p].push_back(arr[i]);
        par[arr[i]] = p;
    }
    dfs(0);
    int esz = euler.size();
    lg[1] = 0;
    for (int i = 2; i <= esz; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
    for (int i = 0; i < esz; ++i) {
        sp[0][i] = euler[i];
    }
    for (int i = 1; i < MAXLN; ++i) {
        for (int j = 0; j + (1 << i) < esz; ++j) {
            sp[i][j] = min(sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);
        }
    }
    int q;
    cin >> q;
    vector<array<int, 4>> query;
    for (int i = 0; i < q; ++i) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        query.push_back({r1, c1, r2, c2});
        ev.push_back({r1, -1, r1 - c1});
        ev.push_back({r2, -1, r2 - c2});
    }
    sort(ev.begin(), ev.end());
    for (auto elem : ev) {
        if (elem[1] == 0) {
            int i = elem[2];
            ans_c[elem[0]] = get_sum(1, 0, n, 0, i);
            update(1, 0, n, i);
        } else {
            if (elem[2] == 0) {
                cr[{elem[0], elem[0] - elem[2]}] = -1;
                continue;
            }
            cr[{elem[0], elem[0] - elem[2]}] = get_ind(1, 0, n, 0, n, elem[2]);
        }
    }
    for (int i = 0; i < q; ++i) {
        int r1 = query[i][0], c1 = query[i][1], r2 = query[i][2], c2 = query[i][3];
        int u = get_v(r1, r1 - c1), v = get_v(r2, r2 - c2);
        if (cr[{r1, c1}] == cr[{r2, c2}]) {
            if (r1 < r2) {
                cout << r1 << " " << c1 << '\n';
            } else {
                cout << r2 << " " << c2 << '\n';
            }
        } else {
            u = lca(u, v);
            if (r1 <= u && r1 <= r2) {
                cout << r1 << " " << c1 << '\n';
            } else if (r2 <= u && r2 <= r1) {
                cout << r2 << " " << c2 << '\n';
            } else {
                int cnt = ans_c[u];
                cout << u << " " << u - cnt << '\n';
            }
        }
    }
    return 0;
}
