#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e5 + 100;
int arr[MAXN];

int treemin[MAXN * 4];

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        treemin[v] = arr[vl];
        return;
    }
    int vm = (vl + vr) / 2;
    build(v * 2, vl, vm);
    build(v * 2 + 1, vm, vr);
    treemin[v] = min(treemin[v * 2], treemin[v * 2 + 1]);
}

int get_first(int v, int vl, int vr, int l, int r, int k) {
    if (l >= vr || r <= vl) return -1;
    if (treemin[v] > k) return -1;
    if (vr - vl == 1) return vl;
    int vm = (vl + vr) / 2;
    int res = get_first(v * 2, vl, vm, l, r, k);
    if (res != -1) return res;
    return get_first(v * 2 + 1, vm, vr, l, r, k);
}

int get_last(int v, int vl, int vr, int l, int r, int k) {
    if (l >= vr || r <= vl) return -1;
    if (treemin[v] > k) return -1;
    if (vr - vl == 1) return vl;
    int vm = (vl + vr) / 2;
    int res = get_last(v * 2 + 1, vm, vr, l, r, k);
    if (res != -1) return res;
    return get_last(v * 2, vl, vm, l, r, k);
}

int get_min(int v, int vl, int vr, int l, int r) {
    if (l >= vr || r <= vl) return MAXN;
    if (l <= vl && r >= vr) return treemin[v];
    int vm = (vl + vr) / 2;
    int res1 = get_min(v * 2, vl, vm, l, r);
    int res2 = get_min(v * 2 + 1, vm, vr, l, r);
    return min(res1, res2);
}

vector<int> g[MAXN];
int par[MAXN];

int n;

map<array<int, 2>, int> cr;

int get_v(int r, int c) {
    int ind = -1;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (arr[i] < r) {
            cnt++;
            if (cnt == c) {
                ind = i;
            }
        }
    }
    cr[{r, r - c}] = ind;
    int jnd = get_first(1, 0, n, ind + 1, n, r);
    if (jnd == -1) jnd = n;
    /**if (jnd - ind <= 1) {
        if (ind == -1) {
            return arr[jnd];
        }
        if (jnd == n) {
            return arr[ind];
        }
        return max(arr[ind], arr[jnd]);
    }
    int res = MAXN;
    for (int i = ind + 1; i < jnd; ++i) {
        if (arr[i] >= r) {
            res = min(res, arr[i]);
        } else {
            assert(0);
        }
    }
    return res;*/
    int res = 0;
    if (ind != -1) {
        res = max(res, arr[ind]);
    }
    if (jnd != n) {
        res = max(res, arr[jnd]);
    }
    return res;
}

namespace slow {
    const int MAXN = 3e3 + 100;
    int par[MAXN * MAXN];
    int cnt[MAXN * MAXN];
    int p[MAXN];

    int gln;

    int get(int r, int c) {
        int v = r * (gln + 1) + c;
        while (cnt[v] != 2) v = par[v];
        return v / (gln + 1);
    }

    void solve(int n) {
        gln = n;
        for (int i = 1; i <= n; ++i) {
            par[i * (n + 1) + i] = (i - 1) * (n + 1) + i - 1;
        }
        vector<int> cur(n + 1);
        for (int i = 0; i <= n; ++i) {
            cur[i] = i;
        }
        for (int i = 0; i < n; ++i) {
            int x = arr[i];
            x++;
            for (int j = x; j <= n; ++j) {
                cur[j]--;
                par[j * (n + 1) + cur[j]] = (j - 1) * (n + 1) + cur[j - 1];
            }
        }
        for (int i = 1; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                int v = i * (n + 1) + j;
                cnt[par[v]]++;
            }
        }
        for (int i = 1; i <= n; ++i) {
            for (int j = 0; j <= i; ++j) {
                int v = i * (n + 1) + j;
                if (cnt[v] == 2) {
                    v = par[v];
                    while (cnt[v] != 2) v = par[v];
                    p[i] = v / (n + 1);
                }
            }
        }
        /**int q;
        cin >> q;
        while (q--) {
            int r1, c1, r2, c2;
            cin >> r1 >> c1 >> r2 >> c2;
            int u = (r1 * (n + 1) + c1), v = (r2 * (n + 1) + c2);
            while (u / (n + 1) < v / (n + 1)) {
                v = par[v];
            }
            while (u / (n + 1) > v / (n + 1)) {
                u = par[u];
            }
            while (u != v) {
                u = par[u]; v = par[v];
            }
            cout << u / (n + 1) << " " << u % (n + 1) << endl;
        }
        return 0;*/
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        arr[i]--;
    }
    slow::solve(n);
    build(1, 0, n);
    for (int i = 0; i < n; ++i) {
        if (arr[i] == 0) continue;
        /// int a = get_first(1, 0, n, i + 1, n, arr[i]);
        /// int b = get_last(1, 0, n, 0, i, arr[i]);
        int a = -1;
        for (int j = i + 1; j < n; ++j) {
            if (arr[j] < arr[i]) {
                a = j;
                break;
            }
        }
        int b = -1;
        for (int j = i - 1; j >= 0; --j) {
            if (arr[j] < arr[i]) {
                b = j;
                break;
            }
        }
        int p;
        if (a == -1) {
            p = arr[b];
        } else if (b == -1) {
            p = arr[a];
        } else {
            p = max(arr[a], arr[b]);
        }
        g[p].push_back(arr[i]);
        par[arr[i]] = p;
        assert(p == slow::p[arr[i]]);
    }
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int u = get_v(r1, r1 - c1), v = get_v(r2, r2 - c2);
        if (cr[{r1, c1}] == cr[{r2, c2}]) {
            if (r1 < r2) {
                cout << r1 << " " << c1 << endl;
            } else {
                cout << r2 << " " << c2 << endl;
            }
        } else {
            while (u > v) u = par[u];
            while (u < v) v = par[v];
            while (u != v) {
                u = par[u]; v = par[v];
            }
            if (r1 <= u && r1 <= r2) {
                cout << r1 << " " << c1 << endl;
            } else if (r2 <= u && r2 <= r1) {
                cout << r2 << " " << c2 << endl;
            } else {
                int cnt = 0;
                for (int i = 0; i < n; ++i) {
                    if (arr[i] == u) break;
                    if (arr[i] < u) cnt++;
                }
                cout << u << " " << u - cnt << endl;
            }
        }
    }
    return 0;
}
