#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <queue>
using namespace std;

#define all(sp) sp.begin(), sp.end()
#define rall(sp) sp.begin(), sp.end()
#define mp make_pair

#define int long long

int n;
char bad;
vector < vector < int > > g, dp;
vector < vector < pair < int, int > > > prd;
vector < int > cost, suml, sumr;
vector < pair < int, int > > border;

void dfs1(int u, int pred=-1) {
    char leaf = true;
    for (int &v : g[u]) {
        if (v != pred) {
            dfs1(v, u);
            suml[u] += border[v].first;
            sumr[u] += border[v].second;
            leaf = false;
        }
    }
    if (!leaf && (suml[u] > border[u].second || sumr[u] < border[u].first)) {
        bad = true;
    }
}

void dfs2(int u, int pred=-1) {
    char leaf = true;
    for (int &v : g[u]) {
        if (v != pred) {
            dfs2(v, u);
            leaf = false;
        }
    }
    dp[u].resize(border[u].second + 1, 1e18);
    prd[u].resize(border[u].second + 1, mp(-1, 0));
    if (leaf) {
        for (int x = 0; x <= border[u].second; ++x) {
            dp[u][x] = cost[u] * x;
            prd[u][x] = mp(u, 0);
        }
    } else {
        dp[u][0] = 0;
        for (int &v : g[u]) {
            if (v == pred) {
                continue;
            }
            for (int x = border[u].second; x >= 0; --x) {
                for (int vx = border[v].first; vx <= border[v].second && x - vx >= 0; ++vx) {
                    if (dp[u][x - vx] != 1e18) {
                        if (dp[u][x] > dp[u][x - vx] + dp[v][vx]) {
                            dp[u][x] = dp[u][x - vx] + dp[v][vx];
                            prd[u][x] = mp(v, vx);
                        }
                    }
                }
            }
        }
        for (int x = border[u].second; x >= 0; --x) {
            for (int ux = 1; ux <= border[u].second && x - ux >= 0; ++ux) {
                if (dp[u][x - ux] != 1e18) {
                    if (dp[u][x] > dp[u][x - ux] + cost[u] * x) {
                        dp[u][x] = dp[u][x - ux] + cost[u] * x;
                        prd[u][x] = mp(u, x);
                    }
                }
            }
        }
    }
}

void solve() {
    cin >> n;
    g.resize(n);
    for (int u = 1; u < n; ++u) {
        int v;
        cin >> v;
        --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    cost.resize(n);
    for (auto &el : cost) {
        cin >> el;
    }
    border.resize(n);
    for (auto &[l, r] : border) {
        cin >> l >> r;
    }
    bad = false;
    suml.resize(n, 0);
    sumr.resize(n, 0);
    dfs1(0);
    if (bad) {
        cout << -1;
        cout << endl;
        g.clear();
        cost.clear();
        suml.clear();
        sumr.clear();
        border.clear();
        return;
    }
    dp.resize(n);
    prd.resize(n);
    dfs2(0);
    int v = 0, cnt = border[0].first;
    for (int x = border[0].first; x <= border[0].second; ++x) {
        if (dp[0][x] < dp[0][cnt]) {
            cnt = x;
        }
    }
    cout << dp[0][cnt] << endl;
    vector < int > ans(n);
    queue < pair < int, int > > q;
    q.push(mp(v, cnt));
    while (!q.empty()) {
        auto p = q.front();
        q.pop();
        v = p.first;
        cnt = p.second;
        int nv = prd[v][cnt].first;
        int ncnt = prd[v][cnt].second;
        if (v == nv) {
            ans[nv] += cnt;
            cnt = ncnt;
            if (cnt > 0) {
                q.push(mp(v, cnt));
            }
        } else {
            q.push(mp(nv, ncnt));
            cnt -= ncnt;
            if (cnt > 0) {
                q.push(mp(v, cnt));
            }
        }
    }
    for (auto &el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
    g.clear();
    cost.clear();
    suml.clear();
    sumr.clear();
    border.clear();
    prd.clear();
    dp.clear();
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt=1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
