#undef LOCAL
#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;

#include <bits/extc++.h>
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ldb;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int MAXMEM = 3e8;
char memo[MAXMEM];
size_t pos = 0;

void *operator new(size_t sz) {
    assert((pos += sz) <= MAXMEM);
    return (void*)(memo + pos - sz);
}

void operator delete(void *) {}
void operator delete(void *, size_t) {}


#define endl '\n'

#define all(v) (v).begin(),(v).end()

const int INF = 1e9 + 228;

const int MAXN = 5e5 + 228;

int n;
int arr[MAXN];

int tree1[4 * MAXN];

void build1(int v, int l, int r) {
    if (l + 1 == r) {
        tree1[v] = arr[l];
    } else {
        int m = (l + r) / 2;
        build1(2 * v + 1, l, m);
        build1(2 * v + 2, m, r);
        tree1[v] = min(tree1[2 * v + 1], tree1[2 * v + 2]);
    }
}

int get1(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return INF;
    }
    if (ql <= l && r <= qr) {
        return tree1[v];
    }
    int m = (l + r) / 2;
    return min(get1(2 * v + 1, l, m, ql, qr), get1(2 * v + 2, m, r, ql, qr));
}

vector<int> tree2[4 * MAXN];
vector<int> from_left[4 * MAXN];

void build2(int v, int l, int r) {
    if (l + 1 == r) {
        tree2[v] = {arr[l]};
    } else {
        int m = (l + r) / 2;
        build2(2 * v + 1, l, m);
        build2(2 * v + 2, m, r);
        tree2[v].resize(r - l);
        merge(all(tree2[2 * v + 1]), all(tree2[2 * v + 2]), tree2[v].begin());
        int a = 0;
        from_left[v].resize(r - l + 1);
        for (int i = 0; i < r - l; i++) {
            if (a < (int) tree2[2 * v + 1].size() && tree2[v][i] == tree2[2 * v + 1][a]) {
                from_left[v][i + 1] = from_left[v][i] + 1;
                a++;
            } else {
                from_left[v][i + 1] = from_left[v][i];
            }
        }
    }
}

int get2(int v, int l, int r, int ql, int qr, int val) {
    if (l >= qr || ql >= r) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        auto it = lower_bound(tree2[v].begin(), tree2[v].end(), val);
        return int(it - tree2[v].begin());
    }
    int m = (l + r) / 2;
    return get2(2 * v + 1, l, m, ql, qr, val) + get2(2 * v + 2, m, r, ql, qr, val);
}

int countless(int t, int val) {
    return get2(0, 0, n, 0, t, val);
}

int get_in_time(int t, int r) {
    return r - countless(t, r + 1);
}

int down(int v, int l, int r, int val, int cnt, int cntt) {
    if (cnt == 0) {
        return l;
    }
    int cnt2 = from_left[v][cntt];
    int m = (l + r) / 2;
    if (cnt2 <= cnt) {
        return down(2 * v + 2, m, r, val, cnt - cnt2, cntt - cnt2);
    }
    return down(2 * v + 1, l, m, val, cnt, cnt2);
}

int get_time(int r, int c) {
    if (c == 0)
        return n;
    return down(0, 0, n, r + 1, r - c, r);
}

int get_mn(int l, int r) {
    return get1(0, 0, n, l, r);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    build1(0, 0, n);
    build2(0, 0, n);
    int q;
    cin >> q;
    vector<array<int, 4>> qq(q);
    vector<pair<pair<int, int>, int>> vers;
    vector<int> get_timem(2 * q);
    for (int i= 0; i < q; i++) {
        for (int j = 0; j < 4; j++) {
            cin >> qq[i][j];
        }
        vers.push_back({{qq[i][0], qq[i][1]}, 2 * i});
        vers.push_back({{qq[i][2], qq[i][3]}, 2 * i + 1});
    }
    sort(vers.begin(), vers.end());
    int cur_ind = 0;
    ordered_set set;
    vector<int> rarr(n + 1);
    for (int i = 0; i < n; i++) {
        rarr[arr[i]] = i + 1;
    }
    for (int cur = 0; cur <= n; cur++) {
        while (cur_ind < (int) vers.size() && vers[cur_ind].first.first == cur) {
            if (cur == 0) {
                get_timem[vers[cur_ind].second] = 0;
            } else {
                int cnt = vers[cur_ind].first.first - vers[cur_ind].first.second;
                if (cnt == 0) {
                    get_timem[vers[cur_ind].second] = 0;
                } else if (vers[cur_ind].second == 0) {
                    get_timem[vers[cur_ind].second] = n;
                } else {
                    int lst = *set.find_by_order(cnt - 1);
                    get_timem[vers[cur_ind].second] = lst;
                }
            }
            cur_ind++;
        }
        if (cur != n) {
            set.insert(rarr[cur + 1]);
        }
    }
    for (int i= 0; i < q; i++) {
        int r1 = qq[i][0];
        int c1 = qq[i][1];
        int r2 = qq[i][2];
        int c2 = qq[i][3];
        /*int t1 = 1;
        int t2 = n - 1;/**/
        int t1 = get_timem[2 * i];
        int t2 = get_timem[2 * i + 1];
        /*int t1 = get_time(r1, c1);
        int t2 = get_time(r2, c2);/**/
        if (t2 < t1) {
            swap(t1, t2);
            swap(r1, r2);
            swap(c1, c2);
        }
        int mn = get_mn(t1, t2);
        if (mn <= min(r1, r2)) {
            cout << mn - 1 << " " << get_in_time(t1, mn - 1) << endl;
            //cout << mn - 1 << " " << 0 << endl;
        } else {
            if (r1 < r2) {
                cout << r1 << " " << c1 << endl;
            } else {
                cout << r2 << " " << c2 << endl;
            }
        }
    } 
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
