#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

ll k;
vector<ll> good;

ll calc(ll x1, ll y1, ll x2, ll y2) {
	return (x1 - x2) * (y1 - y2);
}

struct rect {
	ll x1, y1, x2, y2;
};

rect inter(rect a, rect b) {
	return { max(a.x1, b.x1), max(a.y1, b.y1), min(a.x2, b.x2), min(a.y2, b.y2) };
}

ll surf(rect a) {
	if (a.x1 > a.x2 || a.y1 > a.y2) return 0;

	return (a.x2 - a.x1) * (a.y2 - a.y1);
}

rect norm(rect a) {
	if (a.x1 > a.x2) swap(a.x1, a.x2);
	if (a.y1 > a.y2) swap(a.y1, a.y2);
	return a;
}

bool gd[4];
ll sol() {
	srand(53453);
	ll n, w, h;
	cin >> n >> w >> h;

	if (n >= 4) {
		ll x1, y1, x2, y2, x3, y3;
		
		vector<pair<ll, ll>> why(n);
		for (int i = 0; i < n; i++) {
			cin >> why[i].first >> why[i].second;
		}
		random_shuffle(why.begin(), why.end());
		x1 = why[0].first;
		y1 = why[0].second;
		x2 = why[1].first;
		y2 = why[1].second;
		x3 = why[2].first;
		y3 = why[2].second;
		ll ans = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				for (int k = 0; k < 4; k++) {
					if (!(gd[i] && gd[j] & gd[k])) continue;
					ll a1 = w, b1 = h;
					ll a2 = w, b2 = h;
					ll a3 = w, b3 = h;

					if (i % 2 == 0) a1 = 0;
					if (i / 2 == 0) b1 = 0;

					if (j % 2 == 0) a2 = 0;
					if (j / 2 == 0) b2 = 0;

					if (k % 2 == 0) a3 = 0;
					if (k / 2 == 0) b3 = 0;

					rect fst = { x1, y1, a1, b1 };
					rect snd = { x2, y2, a2, b2 };
					rect tr = { x3, y3, a3, b3 };
					fst = norm(fst);
					snd = norm(snd);
					tr = norm(tr);

					ans = max(ans, surf(fst) + surf(snd) + surf(tr) - surf(inter(fst, snd)) - surf(inter(snd, tr)) - surf(inter(tr, fst)) + surf(inter(inter(fst, snd), tr)));
				}
			}

		}
			

			return ans;
	}

	if (n == 2) {
		ll x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		ll ans = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (!(gd[i] && gd[j])) continue;
				ll a1 = w, b1 = h;
				ll a2 = w, b2 = h;

				if (i % 2 == 0) a1 = 0;
				if (i / 2 == 0) b1 = 0;

				if (j % 2 == 0) a2 = 0;
				if (j / 2 == 0) b2 = 0;

				rect fst = { x1, y1, a1, b1 };
				rect snd = { x2, y2, a2, b2 };
				fst = norm(fst);
				snd = norm(snd);

				ans = max(ans, surf(fst) + surf(snd) - surf(inter(fst, snd)));
			}
		}

		return ans;
	}

	if (n == 3) {
		ll x1, y1, x2, y2, x3, y3;
		cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
		ll ans = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				for (int k = 0; k < 4; k++) {
					if (!(gd[i] && gd[j] & gd[k])) continue;
					ll a1 = w, b1 = h;
					ll a2 = w, b2 = h;
					ll a3 = w, b3 = h;

					if (i % 2 == 0) a1 = 0;
					if (i / 2 == 0) b1 = 0;

					if (j % 2 == 0) a2 = 0;
					if (j / 2 == 0) b2 = 0;

					if (k % 2 == 0) a3 = 0;
					if (k / 2 == 0) b3 = 0;

					rect fst = { x1, y1, a1, b1 };
					rect snd = { x2, y2, a2, b2 };
					rect tr = { x3, y3, a3, b3 };
					fst = norm(fst);
					snd = norm(snd);
					tr = norm(tr);

					ans = max(ans, surf(fst) + surf(snd) + surf(tr) - surf(inter(fst, snd)) - surf(inter(snd, tr)) - surf(inter(tr, fst)) + surf(inter(inter(fst, snd), tr)));
				}
			}
		}

		return ans;

	}

	if (n == 1) {
		ll x1, y1;
		cin >> x1 >> y1;
		ll ans = 0;
		for (int i = 0; i < 4; i++) {
			//for (int j = 0; j < 4; j++) {
				if (!(gd[i])) continue;
				ll a1 = w, b1 = h;
				ll a2 = w, b2 = h;

				if (i % 2 == 0) a1 = 0;
				if (i / 2 == 0) b1 = 0;

				rect fst = { x1, y1, a1, b1 };
				fst = norm(fst);

				ans = max(ans, surf(fst));
			
		}

		return ans;
	}

	return 0;
}

int main() {
	fastInp;

	cin >> k;
	good.resize(k);
	for (auto c : good) gd[c - 1] = 1;
	for (auto& c : good) cin >> c;
	sort(good.begin(), good.end());
	ll t;
	cin >> t;

	while (t--) {
		cout << sol() << endl;
	}

	return 0;
}

/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2
*/