#include <iostream>
#include <vector>

using namespace std;

struct segTree {
    int s, lb, rb;
    segTree *l = nullptr, *r = nullptr;
    segTree() = default;
    segTree(segTree *t1, segTree *t2) {
        l = t1, r = t2;
        lb = l->lb, rb = r->rb;
        s = l->s + r->s;
    }
    segTree(int le, int ri): lb(le), rb(ri) {
        s = 0;
        if (le != ri - 1) {
            int m = (le + ri) / 2;
            l = new segTree(le, m), r = new segTree(m, ri);
        }
    }
    int sum(int le, int ri) {
        if (le >= rb || ri <= lb) return 0;
        if (le <= lb && rb <= ri) return s;
        return l->sum(le, ri) + r->sum(le, ri);
    }

    void inc(int pos) {
        if (lb == rb - 1) s++;
        else {
            int m = (lb + rb) / 2;
            if (pos < m) l->inc(pos);
            else r->inc(pos);
            s = l->s + r->s;
        }
    }
};

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& el: a) {
        cin >> el;
        el--;
    }
    int ans[n][n];
    segTree *cnti = new segTree(0, n);
    for (int i = 0; i < n; i++) {
        cnti->inc(a[i]);
        segTree *cntj = new segTree(0, n);
        for (int j = n - 1; j > i; j--) {
            cntj->inc(a[j]);
            int s1 = cnti->sum(a[i] + 1, n), s2 = cntj->sum(0, a[j]);
            ans[a[i]][a[j]] = max(j - i + max(s1, s2), abs(a[j] - a[i]));
            ans[a[j]][a[i]] = ans[a[i]][a[j]];
        }
    }
    int q = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) q += ans[i][j];
    }
    cout << q << endl;
}
