#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;

int getu(int r, int c) {
	return r * (r + 1) / 2 + c;
}

const int K = 15;
int N, n;
vector <int> b;
vector <set <int>> g;
vector <vector <int>> anc;
vector <int> deep;
vector <pair <int, int>> obr;

void build() {
	int r = 0, c = 0;
	int u = 0;
	for (int i = 0; i < N; i++) {
		int v = getu(r + 1, c + b[i]);
		g[u].insert(v);

		u = v;
		r = r + 1;
		c = c + b[i];
	}
}

void dfs(int u) {
	for (auto v : g[u]) {
		deep[v] = deep[u] + 1;
		anc[v][0] = u;
		dfs(v);
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	cin >> N;
	vector <int> a(N);
	for (int i = 0; i < N; i++) {
		cin >> a[i]; a[i]--;
	}

	n = (N + 1) * (N + 2) / 2;
	g.resize(n);

	b.resize(N, 1);
	build();
	for (int i = 0; i < N; i++) {
		b[a[i]] = 0;
		build();
	}

	anc.resize(n, vector <int>(K));
	deep.resize(n);
	dfs(0);
	for (int i = 1; i < K; i++) {
		for (int u = 0; u < n; u++) {
			anc[u][i] = anc[anc[u][i - 1]][i - 1];
		}
	}

	obr.resize(n);
	for (int r = 0; r <= N; r++) {
		for (int c = 0; c <= r; c++) {
			obr[getu(r, c)] = { r, c };
		}
	}

	int q; cin >> q;
	while (q--) {
		int r1, c1, r2, c2; cin >> r1 >> c1 >> r2 >> c2;
		int u = getu(r1, c1);
		int v = getu(r2, c2);

		if (deep[u] < deep[v])
			swap(u, v);
		if (deep[u] != deep[v]) {
			for (int j = K - 1; j >= 0; j--) {
				int ut = anc[u][j];
				if (deep[ut] >= deep[v])
					u = ut;
			}
		}
		if (u != v) {
			for (int j = K - 1; j >= 0; j--) {
				int ut = anc[u][j];
				int vt = anc[v][j];
				if (ut != vt) {
					u = ut;
					v = vt;
				}
			}
			u = v = anc[u][0];
		}
		auto e = obr[u];
		cout << e.first << ' ' << e.second << '\n';
	}

	return 0;
}
