#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

#include <unordered_map>
#include <cassert>

using namespace std;

#define sz(x) ((ll)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const ll inf = 1e18;

const ll N = 3000 * 3000 + 3001;

ll n;
vector<ll> g[N];
void add(vector<bool>& path) {
	ll r = 0, c = 0;
	for (auto t : path) {
		ll new_r = r + 1, new_c = c + t;
		if (g[r * n + c].size() == 0 || g[r * n + c].back() != new_r * n + new_c)
			g[r * n + c].push_back(new_r * n + new_c);
		r = new_r, c = new_c;
	}
}

ll tin[N], tout[N];
vector<ll> up[N];

ll timer = 0, L = 0;
void dfs(ll v, ll p = 0) {
	up[v].assign(L, 0);
	up[v][0] = p;

	tin[v] = timer;
	timer++;
	for (auto to : g[v]) {
		dfs(to, v);
	}
	tout[v] = timer;
	timer++;
}

void build_up(ll v) {
	for (ll j = 1; j < L; j++) {
		ll pred = up[v][j - 1];
		up[v][j] = up[pred][j - 1];
	}

	for (auto to : g[v]) {
		build_up(to);
	}
}

bool is_upper(ll a, ll b) {
	return tin[a] <= tin[b] &&
		tout[b] <= tout[a];
}

ll get_lca(ll a, ll b) {
	if (is_upper(a, b))
		return a;
	if (is_upper(b, a))
		return b;
	while (!is_upper(b, a)) {
		b = up[b][0];
	}
	return b;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	cin >> n;
	vector<bool> path(n, 1);
	add(path);
	for (ll i = 0; i < n; i++) {
		//ll pos;  cin >> pos;
		//pos--;
		ll pos = i;
		path[pos] = 0;
		add(path);
	}

	while ((1 << L) <= n + 1) {
		L++;
	}

	dfs(0);
	build_up(0);

	ll q; cin >> q;
	while (q--) {
		pair<ll, ll> a; cin >> a.first >> a.second;
		pair<ll, ll> b; cin >> b.first >> b.second;

		ll l = get_lca(a.first * n + a.second, b.first * n + b.second);
		cout << l / n << ' ' << l % n << '\n';
	}

	return 0;
}