#include <iostream>
#include <iomanip>

#include <algorithm>

#include <vector>
#include <string>
#include <set>
#include <map>

#include <unordered_map>

using namespace std;

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;

const ll inf = 1e18;

const int N = 3000 * 3000;

int n;
vector<pair<int, int>> g[N];
void add(vector<bool>& path) {
	int r = 0, c = 0;
	for (auto t : path) {
		int new_r = r + 1, new_c = c + t;
		if (g[r * n + c].size() == 0 || g[r * n + c].back() != make_pair(new_r, new_c))
			g[r * n + c].push_back({ new_r, new_c });
		r = new_r, c = new_c;
	}
}

int tin[N], tout[N];
vector<pair<int, int>> up[N];

int timer = 0, L = 0;
void dfs(pair<int, int> v, pair<int, int> p = { 0, 0 }) {
	up[v.first * n + v.second].assign(L, { 0, 0 });
	up[v.first * n + v.second][0] = p;

	tin[v.first * n + v.second] = timer;
	timer++;
	for (auto to : g[v.first * n + v.second]) {
		dfs(to, v);
	}
	tout[v.first * n + v.second] = timer;
	timer++;
}

void build_up(pair<int, int> v) {
	for (int j = 1; j < L; j++) {
		pair<int, int> pred = up[v.first * n + v.second][j - 1];
		up[v.first * n + v.second][j] = up[pred.first * n + pred.second][j - 1];
	}

	for (auto to : g[v.first * n + v.second]) {
		build_up(to);
	}
}

bool is_upper(pair<int, int> a, pair<int, int> b) {
	return tin[a.first * n + a.second] <= tin[b.first * n + b.second] &&
		tout[b.first * n + b.second] <= tout[a.first * n + a.second];
}

pair<int, int> get_lca(pair<int, int> a, pair<int, int> b) {
	if (is_upper(a, b))
		return a;
	if (is_upper(b, a))
		return b;
	while (!is_upper(b, a)) {
		b = up[b.first * n + b.second][0];
	}
	return b;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	cin >> n;
	vector<bool> path(n, 1);
	add(path);
	for (int i = 0; i < n; i++) {
		int pos;  cin >> pos;
		pos--;
		path[pos] = 0;
		add(path);
	}

	while ((1 << L) <= n + 1) {
		L++;
	}

	dfs({ 0, 0 });
	build_up({ 0, 0 });

	int q; cin >> q;
	while (q--) {
		pair<int, int> a; cin >> a.first >> a.second;
		pair<int, int> b; cin >> b.first >> b.second;

		pair<int, int> l = get_lca(a, b);
		cout << l.first << ' ' << l.second << '\n';
	}

	return 0;
}