#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<int> p, c, l, r, a, sum_a;
vector<vector<int>> gr;

int get_cheapest(int v) {
	if (sum_a[v] == r[v]) {
		return -1;
	}
	int ans = v;
	for (int u : gr[v]) {
		int w = get_cheapest(u);
		if (w == -1) {
			continue;
		}
		if (c[w] < c[ans]) {
			ans = w;
		}
	}
	return ans;
}

pair<int, ll> dfs_ans(int v) {
	int cnt = 0;
	ll sum = 0;
	for (int u : gr[v]) {
		auto res = dfs_ans(u);
		if (res.first == -1) {
			return { -1, -1 };
		}
		cnt += res.first;
		sum += res.second;
	}
	while (cnt < l[v]) {
		int u = get_cheapest(v);
		if (u == -1) {
			return { -1, -1 };
		}
		cnt++;
		sum += c[u];
		a[u]++;
		while (u) {
			sum_a[u]++;
			u = p[u];
		}
		sum_a[u]++;
	}
	if (cnt > r[v]) {
		return { -1, -1 };
	}
	return { cnt, sum };
}

void solve() {
	int n;
	cin >> n;
	p.resize(n), c.resize(n), l.resize(n), r.resize(n), gr.assign(n, {});
	p[0] = 0;
	for (int i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		gr[p[i]].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	a.assign(n, 0), sum_a.assign(n, 0);
	auto ans = dfs_ans(0);
	if (ans.first == -1) {
		cout << -1 << "\n";
		return;
	}
	cout << ans.second << "\n";
	for (int i = 0; i < n; i++) {
		cout << a[i] << " ";
	}
	cout << "\n";
}

int main() {
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}
