#include <iostream>
#include <vector>

using namespace std;

const int INF = int(1e9) + 7;

int b, n;
vector<int> tree, a;

void build_tree() {
	b = 1;
	while (b < n) {
		b *= 2;
	}
	tree.assign(2 * b, -1);
	for (int i = 0; i < n; i++) {
		tree[b + i] = i;
	}
	for (int t = b - 1; t > 0; t--) {
		if (tree[t * 2 + 1] == -1 || (tree[t * 2] != -1 && a[tree[t * 2]] < a[tree[t * 2 + 1]])) {
			tree[t] = tree[t * 2];
		}
		else {
			tree[t] = tree[t * 2 + 1];
		}
	}
}

int get_min(int t, int tl, int tr, int left, int right) {
	if (left >= right) {
		return -1;
	}
	if (tl == left && tr == right) {
		return tree[t];
	}
	int mid = (tl + tr) / 2;
	int i = get_min(t * 2, tl, mid, left, min(right, mid));
	int j = get_min(t * 2 + 1, mid, tr, max(left, mid), right);
	if (i == -1 || j == -1) {
		return (i == -1 ? j : i);
	}
	if (a[i] < a[j]) {
		return i;
	}
	else {
		return j;
	}
}

struct node {
	int l, r, cnt;
	node(): l(0), r(0), cnt(0) {}
};

vector<node> time_tree;
vector<int> state;

int new_node(int val) {
	time_tree.push_back(node());
	time_tree.back().cnt = val;
	return time_tree.size() - 1;
}

int copy(int t) {
	time_tree.push_back(node());
	time_tree.back().l = time_tree[t].l;
	time_tree.back().r = time_tree[t].r;
	time_tree.back().cnt = time_tree[t].cnt;
	return time_tree.size() - 1;
}

void change_val(int& t, int tl, int tr, int pos) {
	t = copy(t);
	time_tree[t].cnt++;
	if (tr - tl == 1) {
		return;
	}
	int mid = (tl + tr) / 2;
	if (pos < mid) {
		change_val(time_tree[t].l, tl, mid, pos);
	}
	else {
		change_val(time_tree[t].r, mid, tr, pos);
	}
}

void build_time_tree() {
	int st = 1;
	state.push_back(st);
	
	for (int i = 0; i < b; i++) {
		new_node(0);
		time_tree[i].l = i * 2;
		time_tree[i].r = i * 2 + 1;
	}
	for (int i = 0; i < b; i++) {
		new_node(0);
	}

	for (int i = 0; i < n; i++) {
		change_val(st, 0, b, a[i]);
		state.push_back(st);
	}
}

int get_count(int t, int tl, int tr, int left, int right) {
	// cout << "get_count(" << t << ", " << tl << ", " << tr << ", " << left << ", " << right << ")\n";
	if (left >= right) {
		return 0;
	}
	if (tl == left && tr == right) {
		return time_tree[t].cnt;
	}
	int mid = (tl + tr) / 2, cnt = 0;
	cnt += get_count(time_tree[t].l, tl, mid, left, min(right, mid));
	cnt += get_count(time_tree[t].r, mid, tr, max(left, mid), right);
	// cout << "get_count(" << t << ", " << tl << ", " << tr << ", " << left << ", " << right << ") = " << cnt << "\n";
	return cnt;
}

pair<int, int> get_times(int r, int c) {
	int tin, tout, left, right;
	left = -1, right = n;
	while (right - left > 1) {
		int mid = (left + right) / 2;
		if (get_count(state[mid], 0, b, 0, r) < c) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	tin = right;
	left = 0, right = n + 1;
	while (right - left > 1) {
		int mid = (left + right) / 2;
		if (get_count(state[mid], 0, b, 0, r) <= c) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	tout = left;
	return { tin, tout };
}

void print_ans(int r, int c) {
	cout << r << " " << r - c << "\n";
}

int main() {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	build_tree();
	build_time_tree();
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		c1 = r1 - c1;
		c2 = r2 - c2;
		auto t1 = get_times(r1, c1), t2 = get_times(r2, c2);
		// cout << "t1 = {" << t1.first << ", " << t1.second << "}\n";
		// cout << "t2 = {" << t2.first << ", " << t2.second << "}\n";
		if (max(t1.first, t2.first) <= min(t1.second, t2.second)) {
			if (r1 > r2) {
				print_ans(r2, c2);
			}
			else {
				print_ans(r1, c1);
			}
		}
		else {
			int l = min(t1.second, t2.second), r = max(t1.first, t2.first);
			int j = get_min(1, 0, b, l, r);
			int c = get_count(state[j], 0, b, 0, a[j]);
			print_ans(a[j], c);
		}
	}
}
