#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <cassert>
#include <algorithm>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

#define int ll

const int INF = 4e18 + 1;

vector<vector<int>> g;
vector<pair<int, int>> bor;
vector<ll> c;
vector<int> cnt;

struct val {
	ll c;
	int r, in;
	val() {}
	val(ll c, int r, int in) : c(c), r(r), in(in) {}
	bool operator<(const val& obj) const {
		if (c == obj.c && r == obj.r) return in < obj.in;
		if (c == obj.c) return r < obj.r;
		return c < obj.c;
	}
};

int ddfs(int v, int pr = -1) {
	int mn = 0;
	for (auto& i : g[v]) {
		if (i == pr) continue;
		mn += ddfs(i, v);
		mn = min(mn, INF);
	}
	if (mn > bor[v].second) return INF;
	if (mn > bor[v].first) bor[v].first = mn;
	if (mn < bor[v].first) mn = bor[v].first;
	return mn;
}

pair<set<val>*, ll> dfs(int v, int pr = -1) {
	set<val>* it = nullptr;
	int br = 0;
	ll ans = 0;
	for (auto& i : g[v]) {
		if (i == pr) continue;
		auto ress = dfs(i, v);
		br += bor[i].first;
		ans += ress.second;
		auto res = ress.first;
		if (!res) continue;
		if (!it) {
			it = res;
			continue;
		}
		if (it->size() < res->size()) {
			swap(res, it);
		}
		for (const auto& i : *res)
			it->emplace(i);
	}
	if (!it) it = new set<val>;
	assert(br <= bor[v].first);
	if (br != bor[v].first) {
		while (br < bor[v].first) {
			if (it->empty()) break;
			auto res = *it->begin();
			if (res.c > c[v]) break;
			it->erase(res);
			if (res.r > bor[v].first - br) {
				ans += (bor[v].first - br) * res.c;
				cnt[res.in] += (bor[v].first - br);
				res.r -= (bor[v].first - br);
				br = bor[v].first;
				it->emplace(res);
			}
			else {
				ans += (res.r) * res.c;
				cnt[res.in] += res.r;
				br += res.r;
			}
		}
		if (br != bor[v].first) {
			ans += (c[v]) * (bor[v].first - br);
			cnt[v] += (bor[v].first - br);
			br = bor[v].first;
		}
	}
	if (bor[v].second - br != 0)
		it->emplace(c[v], bor[v].second - br, v);
	set<val>* nn = new set<val>();
	if (bor[v].second - br != 0)
		for (auto& i : *it) {
			int t = min(i.r, bor[v].second - br);
			nn->emplace(i.c, t, i.in);
		}
	return { nn, ans };
}

void solve() {
	int n, a;
	cin >> n;
	g.assign(n, {});
	c.assign(n, 0);
	bor.assign(n, {});
	cnt.assign(n, 0);
	for (int i = 1; i < n; ++i) {
		cin >> a;
		--a;
		g[i].emplace_back(a);
		g[a].emplace_back(i);
	}
	for (int i = 0; i < n; ++i)
		cin >> c[i];
	for (int i = 0; i < n; ++i)
		cin >> bor[i].first >> bor[i].second;
	if (ddfs(0) == INF) {
		cout << -1;
		return;
	}
	cout << dfs(0).second << '\n';
	for (auto& i : cnt)
		cout << i << " ";
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	int t;
	cin >> t;
	while (t-- > 0) {
		solve();
		cout << '\n';
	}
	return 0;
}