#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 100;
const int INF = 1e9;

int arr[MAXN];
int pos[MAXN];
int n;

int fwtree[MAXN];

int get(int i) {
    int res = 0;
    for (; i > 0; i -= i & -i) {
        res += fwtree[i];
    }
    return res;
}

void upd(int i, int x) {
    for (; i < MAXN; i += i & -i) {
        fwtree[i] += x;
    }
}

int mag[MAXN];

void calcmag() {
    for (int i = 0; i < n; ++i) {
        mag[i] = get(arr[i]);
        upd(arr[i] + 1, 1);
    }
}

const int LOG = 21;
int tree[MAXN][LOG];

void buildsparse() {
    for (int i = n - 1; i >= 0; --i) {
        tree[i][0] = i;
        for (int b = 1; b < LOG; ++b) {
            int j = min(n - 1, i + (1 << (b - 1)));
            int ai = tree[i][b - 1];
            int bi = tree[j][b - 1];
            if (arr[ai] < arr[bi])
                tree[i][b] = ai;
            else
                tree[i][b] = bi;
        }
    }
}

int getminsparse(int l, int r) {
    if (l + 1 == r)
        return tree[l][0];
    int lg = 31 - __builtin_clz(r - l - 1);
    int a = tree[l][lg];
    int b = tree[r - (1 << lg)][lg];
    if (arr[a] < arr[b])
        return a;
    return b;
}

struct Node {
    int l = -1, r = -1;
    int sm = 0;
};

Node nds[MAXN * 30];
int ndsz = 0;
int build(int v, int l, int r) {
    ndsz = max(v, ndsz + 1);
    if (l + 1 == r) {
        nds[v].sm = 0;
        return v;
    }
    int m = (l + r) / 2;
    nds[v].l = build(2 * v + 1, l, m);
    nds[v].r = build(2 * v + 2, m, r);
    return v;
}
int update(int v, int l, int r, int qi) {
    if (qi < l || r <= qi)
        return v;
    if (l + 1 == r) {
        int u = ndsz++;
        nds[u] = nds[v];
        nds[u].sm++;
        return u;
    }
    int m = (l + r) / 2;
    int u = ndsz++;
//    nds[u] = nds[v];
    nds[u].l = update(nds[v].l, l, m, qi);
    nds[u].r = update(nds[v].r, m, r, qi);
    nds[u].sm = nds[nds[u].l].sm + nds[nds[u].r].sm;
    return u;
}

int roots[MAXN];

void buildkpor() {
    roots[0] = build(0, 0, n);
    for (int i = 0; i < n; ++i) {
        roots[i + 1] = update(roots[i], 0, n, pos[i]);
    }
}

int getkpordo(int v, int l, int r, int k) {
    if (l + 1 == r)
        return l;
    int m = (l + r) / 2;
    if (nds[nds[v].l].sm <= k)
        return getkpordo(nds[v].r, m, r, k - nds[nds[v].l].sm);
    return getkpordo(nds[v].l, l, m, k);
}

int getkpor(int r, int k) {
    if (r == k)
        return n;
    int t = getkpordo(roots[r], 0, n, k);
    return t;
}

int getmintime(int r, int c) {
    int left = r - c;
    int t = getkpor(r, left);
    return t;
}


pair<int, int> lca(int r1, int c1, int r2, int c2) {
    if (r1 > r2)
        swap(r1, r2), swap(c1, c2);
    int l = getmintime(r1, c1);
    int r = getmintime(r2, c2);
    if (r < l)
        swap(l, r);
    if (l == r)
        return {r1, c1};
    int mndi = getminsparse(l, r);
    int mnd = arr[mndi];
    if (mnd > r1) {
        return {r1, c1};
    }
    int cnt = mag[mndi];
    return {mnd, mnd - cnt};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        arr[i]--;
        pos[arr[i]] = i;
    }
    calcmag();
    buildsparse();
//    calcmintime();
    buildkpor();
    int q;
    cin >> q;
    for (int qq = 0; qq < q; ++qq) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto[r3, c3] = lca(r1, c1, r2, c2);
        cout << r3 << ' ' << c3 << '\n';
    }
}