#include <vector>
#include <ios>
#include <iostream>
#include <set>
#include <map>
#include <random>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <math.h>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;

#define all(x) ((x).begin()), ((x).end())
#define rall(x) ((x).rbegin()), ((x).rend())
#define nl '\n'

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cout << fixed << setprecision(16);

	int n;
	cin >> n;
	vi a(n);

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	vi minLeft(n), maxRight(n);

	for (int i = 0; i < n; i++)
	{
		minLeft[i] = i;
		for (int j = 0; j < i; j++)
		{
			if (a[j] > a[i]) {
				minLeft[i]--;
			}
		}
		maxRight[i] = i;
		for (int j = i + 1; j < n; j++)
		{
			if (a[j] < a[i]) {
				maxRight[i]++;
			}
		}
	}

	ll answer = 0;

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			int ans = abs(a[i] - a[j]);
			int v1 = maxRight[j] - i;
			int v2 = j - minLeft[i];
			ans = max(ans, max(v1, v2));
			answer += ans;
		}
	}
	cout << answer << endl;
	return 0;
}