#include <vector>
#include <ios>
#include <iostream>
#include <set>
#include <map>
#include <random>
#include <iomanip>
#include <algorithm>
#include <fstream>
#include <math.h>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;

#define all(x) ((x).begin()), ((x).end())
#define rall(x) ((x).rbegin()), ((x).rend())
#define nl '\n'

void solve_1() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> points;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		points.push_back({ x, y });
	}

	sort(all(points));

	ll answer = 0;

	int minH = h;
	for (auto pt : points)
	{
		if (pt.second >= minH) {
			continue;
		}

		answer += (ll)(w - pt.first) * (ll)(minH - pt.second);
		minH = pt.second;
	}

	cout << answer << endl;
}

void solve_13() {
	int n, w, h;
	cin >> n >> w >> h;

	vector<pair<int, int>> points;
	vector<bool> directions;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		points.push_back({ x, y });
		directions.push_back(false);
	}
	vector<pair<int, int>> up, down;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			if ((points[j].first < points[i].first && points[j].second <= points[i].second) ||
				(points[j].first <= points[i].first && points[j].second < points[i].second)) {
				directions[i] = true;
				break;
			}
		}
		if (directions[i]) {
			down.push_back(points[i]);
		}
		else {
			up.push_back(points[i]);
		}
	}

	sort(all(up));
	sort(rall(down));

	vi maxH(down.size() + 1, 0), minH(up.size() + 1, h);
	ll answer = 0;
	for (int i = 0; i < up.size(); i++)
	{
		auto pt = up[i];
		minH[i + 1] = pt.second;
		if (pt.second >= minH[i]) {
			continue;
		}

		answer += (ll)(w - pt.first) * (ll)(minH[i] - pt.second);
	}

	for (int i = 0; i < down.size(); i++)
	{
		auto pt = down[i];
		maxH[i + 1] = pt.second;
		if (pt.second <= maxH[i]) {
			continue;
		}

		answer += (ll)(pt.first) * (ll)(pt.second - maxH[i]);
		
	}

	for (int i = 0; i < up.size(); i++)
	{
		for (int j = 0; j < down.size(); j++)
		{
			if (up[i].second >= down[j].second) continue;
			if (minH[i] <= maxH[j]) continue;
			if (up[i].first >= down[j].first) continue;
			int upper = min(down[j].second, minH[i]);
			int lower = max(up[i].second, maxH[j]);
			answer += (ll)(upper - lower) * (ll)(up[i].first - down[j].first);
		}
	}
	cout << answer << nl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cout << fixed << setprecision(16);

	int k;
	cin >> k;

	set<int> granted;
	for (int i = 0; i < k; i++)
	{
		int q;
		cin >> q;
		granted.insert(q);
	}
	int t;
	cin >> t;
	while (t--)
	{
		if (granted.size() == 1 && *granted.begin() == 1) {
			solve_1();
		}
		if (granted.size() == 2 && granted.find(3) != granted.end() && granted.find(1) != granted.end()) {
			solve_13();
		}
	}
	cout.flush();

	return 0;
}