#include <iostream>
#include <vector>
#include <algorithm>

int n;

long long toIdx(long long r, long long c)
{
	return r * (r + 1) / 2 + c;
}

std::pair<int, int> fromIdx(long long idx)
{
	int r = 0;
	while (r * (r + 1) / 2 <= idx) r++;
	r--;
	int c = idx - r * (r + 1) / 2;
	return std::make_pair(r, c);
}

int main()
{
	std::cin >> n;
	n++;
	std::vector<std::vector<int>> paths(n * (n + 1) / 2);
	std::vector<bool> turns(n + 2, false);
	for (int i = 0; i < n; i++)
	{
		std::vector<int> prev;
		int r = 0;
		int c = 0;
		while (r < n)
		{
			prev.push_back(toIdx(r, c));
			paths[toIdx(r, c)] = prev;
			r++;
			if (!turns[r]) c++;
		}
		if (i != n - 1)
		{
			int a;
			std::cin >> a;
			turns[a] = true;
		}
	}
	int q;
	std::cin >> q;
	for (int i = 0; i < q; i++)
	{
		int r1, c1, r2, c2;
		std::cin >> r1 >> c1 >> r2 >> c2;
		std::vector<int> a = paths[toIdx(r1, c1)];
		std::vector<int> b = paths[toIdx(r2, c2)];
		int idx;
		for (int i = 0; i < std::min(a.size(), b.size()); i++)
		{
			idx = i;
			if (a[i] != b[i])
			{
				idx--;
				break;
			}
		}
		std::pair<int, int> ans = fromIdx(a[idx]);
		std::cout << ans.first << " " << ans.second << std::endl;
	}
	return 0;
}