#include <iostream>
#include <vector>
#include <algorithm>

int n;

long long toIdx(long long r, long long c)
{
	return r * (r + 1) / 2 + c;
}

std::pair<int, int> fromIdx(long long idx)
{
	int r = 0;
	while (r * (r + 1) / 2 <= idx) r++;
	r--;
	int c = idx - r * (r + 1) / 2;
	return std::make_pair(r, c);
}

int main()
{
	std::cin >> n;
	n++;
	std::vector<int> paths(n * (n + 1) / 2);
	std::vector<bool> turns(n + 2, false);
	for (int i = 0; i < n; i++)
	{
		int prev = toIdx(0, 0);
		int r = 0;
		int c = 0;
		while (r < n)
		{
			paths[toIdx(r, c)] = prev;
			prev = toIdx(r, c);
			r++;
			if (!turns[r]) c++;
		}
		if (i != n - 1)
		{
			int a;
			std::cin >> a;
			turns[a] = true;
		}
	}
	int q;
	std::cin >> q;
	for (int i = 0; i < q; i++)
	{
		int r1, c1, r2, c2;
		std::cin >> r1 >> c1 >> r2 >> c2;
		int a = toIdx(r1, c1);
		int b = toIdx(r2, c2);
		while (fromIdx(a).first > fromIdx(b).first) a = paths[a];
		while (fromIdx(a).first < fromIdx(b).first) b = paths[b];
		while (a != b)
		{
			a = paths[a];
			b = paths[b];
		}
		std::pair<int, int> ans = fromIdx(a);
		std::cout << ans.first << " " << ans.second << std::endl;
	}
	return 0;
}