#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,sse4,popcnt")

#include <bits/stdc++.h>

#define sq(x) ((x)*(x))
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& i : (x)) cerr << (i) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int i = 0; i < (n); ++i) cerr << (x)[i] << ", "; cerr << "]\n";}
#define errf() cerr << "\n\n"

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
inline ll getrnd(ll l, ll r) {
    return uniform_int_distribution<ll>(l, r)(rng);
}

template <typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template <typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// ::::::::::::::::::::::::::::::::::

const int LOG = 20, N = 5e5 + 5;

struct tree_lca {
    int n, timer, root;
    vector<int> tin, tout;
    vector<vector<int>> par;
    vector<vector<int>> graph;

    tree_lca(vector<vector<int>>& gr, int rt) : graph(gr), n(gr.size()), root(rt) {
        timer = 0;
        tin.resize(n);
        tout.resize(n);
        par.resize(LOG, vector<int>(n));
        dfs(root, root);
    }

    void dfs(int v, int p) {
        tin[v] = timer++;
        par[0][v] = p;
        for (int i = 0; i + 1 < LOG; ++i)
            par[i + 1][v] = par[i][par[i][v]];
        for (int to : graph[v]) {
            if (to == p) continue;
            dfs(to, v);
        }
        tout[v] = timer++;
    }

    inline bool ispar(int a, int b) {
        return tin[a] <= tin[b] && tout[b] <= tout[a];
    }

    int lca(int a, int b) {
        if (ispar(a, b)) return a;
        if (ispar(b, a)) return b;
        for (int i = LOG - 1; i >= 0; --i)
            if (!ispar(par[i][a], b))
                a = par[i][a];
        return par[0][a];
    }
};

struct seg_tree_mnpos {
    vector<ll> lazy;
    vector<pair<ll, ll>> tree;

    seg_tree_mnpos(int n) : tree(4 * n), lazy(4 * n) {
        build(1, 0, n - 1);
    }

    void build(int v, int tl, int tr) {
        if (tl == tr) {
            tree[v] = {0, tl};
            return;
        }
        int tm = (tl + tr) / 2;
        build(2 * v, tl, tm);
        build(2 * v + 1, tm + 1, tr);
        tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
    }

    void upd(int v, ll x) {
        tree[v].first += x;
        lazy[v] += x;
    }

    void push(int v) {
        if (lazy[v] != 0) {
            upd(2 * v, lazy[v]);
            upd(2 * v + 1, lazy[v]);
            lazy[v] = 0;
        }
    }

    pair<ll, ll> merge(pair<ll, ll> a, pair<ll, ll> b) {
        if (a.first < b.first) return a;
        return b;
    }

    void update(int v, int tl, int tr, int l, int r, ll x) {
        if (l > r) return;
        if (tl == l && tr == r) {
            upd(v, x);
        } else {
            int tm = (tl + tr) / 2;
            push(v);
            update(2 * v, tl, tm, l, min(r, tm), x);
            update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, x);
            tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
        }
    }
};

struct seg_tree_add {
    vector<ll> sum;
    seg_tree_add(int n) : sum(4 * n) {}

    void update(int v, int tl, int tr, int l, int r, ll x) {
        if (l > r) return;
        if (tl == l && tr == r) {
            sum[v] += x;
        } else {
            int tm = (tl + tr) / 2;
            update(2 * v, tl, tm, l, min(r, tm), x);
            update(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, x);
        }
    }

    ll get(int v, int tl, int tr, int pos) {
        if (tl == tr) {
            return sum[v];
        }
        int tm = (tl + tr) / 2;
        if (pos <= tm)
            return sum[v] + get(2 * v, tl, tm, pos);
        else
            return sum[v] + get(2 * v + 1, tm + 1, tr, pos);
    }
};

int a[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    int q;
    cin >> q;
    vector<pair<int, int>> ans(q);
    vector<tuple<int, int, int, int>> qs;
    vector<tuple<int, int, int>> tmp;
    vector<vector<pair<int, int>>> vs(q);
    for (int i = 0; i < q; ++i) {
        int r1, r2, c1, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        qs.emplace_back(r1, c1, r2, c2);
        tmp.emplace_back(r1, c1, i);
        tmp.emplace_back(r2, c2, i);
    }
    sort(tmp.begin(), tmp.end());
    vector<int> qs_rs;
    for (auto [x, y, ind] : tmp)
        qs_rs.emplace_back(x);

    int m = tmp.size();
    seg_tree_mnpos tr2(m);
    for (int i = 0; i < m; ++i) {
        auto [x, y, ind] = tmp[i];
        tr2.update(1, 0, m - 1, i, i, x - y);
    }
    vector<pair<int, int>> tmpres(m, make_pair(-1, -1));

    seg_tree_add tr_add(n + 1);
    for (int i = 0; i <= n; ++i)
        tr_add.update(1, 0, n, i, i, i);
    vector<pair<int, int>> verts;
    vector<int> par;
    set<pair<int, int>> curs;
    set<pair<int, int>> waits;
    for (int i = 1; i <= n; ++i) {
        int idleaf = verts.size();
        verts.emplace_back(n, tr_add.get(1, 0, n, n));
        curs.emplace(verts[idleaf].first, idleaf);
        par.emplace_back(-1);

//        err(1);
        while (true) {
            auto [mn, mnpos] = tr2.tree[1];
            if (mn > 0) break;
//            assert(mn == 0);
            tr2.update(1, 0, m - 1, mnpos, mnpos, 1e9);
            auto [r1, c1, ind] = tmp[mnpos];
            waits.emplace(r1, mnpos);
        }
//        err(2);

        int id = verts.size();
        verts.emplace_back(a[i] - 1, tr_add.get(1, 0, n, a[i] - 1));
        par.emplace_back(-1);
        curs.emplace(verts[id].first, id);
        int h = verts[id].first;
        vector<int> ord;
        while (!curs.empty()) {
            auto pt = prev(curs.end());
            auto [curh, curid] = *pt;
            ord.emplace_back(curid);
            if (curh == h) {
                break;
            }
            while (!waits.empty()) {
                auto pt2 = prev(waits.end());
                auto [wh, wid] = *pt2;
                if (wh <= curh) {
                    if (pt == curs.begin() || prev(pt)->first < wh) {
                        if (wh == curh) {
                            tmpres[wid] = {curid, 0};
                        } else {
                            tmpres[wid] = {curid, 1};
                        }
                    } else {
                        break;
                    }
                } else {
                    break;
                }
                waits.erase(pt2);
            }
            curs.erase(pt);
        }
//        err(3);
//        errv(ord);
        for (int i = 1; i < ord.size(); ++i)
            par[ord[i - 1]] = ord[i];

        tr_add.update(1, 0, n, a[i], n, -1);
        auto pt = lower_bound(qs_rs.begin(), qs_rs.end(), a[i]) - qs_rs.begin();
        tr2.update(1, 0, m - 1, pt, m - 1, -1);
    }
//    err(4);

    int idleaf = verts.size();
    verts.emplace_back(n, tr_add.get(1, 0, n, n));
    curs.emplace(verts[idleaf].first, idleaf);
    par.emplace_back(-1);

    while (true) {
        auto [mn, mnpos] = tr2.tree[1];
        if (mn > 0) break;
//        assert(mn == 0);
        tr2.update(1, 0, m - 1, mnpos, mnpos, 1e9);
        auto [r1, c1, ind] = tmp[mnpos];
        waits.emplace(r1, mnpos);
    }

    vector<int> ord;
    while (!curs.empty()) {
        auto pt = prev(curs.end());
        auto [curh, curid] = *pt;
        ord.emplace_back(curid);
        while (!waits.empty()) {
            auto pt2 = prev(waits.end());
            auto [wh, wid] = *pt2;
            if (wh <= curh) {
                if (pt == curs.begin() || prev(pt)->first < wh) {
                    if (wh == curh) {
                        tmpres[wid] = {curid, 0};
                    } else {
                        tmpres[wid] = {curid, 1};
                    }
                } else {
                    break;
                }
            } else {
                break;
            }
            waits.erase(pt2);
        }
        curs.erase(pt);
    }
    for (int i = 1; i < ord.size(); ++i)
        par[ord[i - 1]] = ord[i];

//    err(waits.size());
    for (int i = 0; i < m; ++i) {
        auto [r1, c1, ind] = tmp[i];
        vs[ind].emplace_back(tmpres[i]);
    }

    int root = 0;
    for (int i = 0; i < verts.size(); ++i) {
        if (verts[i].first == 0)
            root = i;
//        cerr << verts[i].first << ' ' << verts[i].second << '\n';
    }
//    err(root);
//    errv(par);

    int k = verts.size();
    vector<vector<int>> graph(k);
    for (int i = 0; i < k; ++i) {
        if (par[i] != -1) {
            graph[par[i]].emplace_back(i);
            graph[i].emplace_back(par[i]);
        }
    }
    tree_lca lc(graph, root);

    for (int i = 0; i < q; ++i) {
//        cout << ans[i].first << ' ' << ans[i].second << '\n';
//        for (auto [id, t] : vs[i]) {
//            cerr << id << ' ' << t << '\n';
//        }
        auto [id1, t1] = vs[i][0];
        auto [id2, t2] = vs[i][1];

        pair<int, int> res;
        if (lc.ispar(id1, id2) || lc.ispar(id2, id1)) {
            auto [r1, c1, r2, c2] = qs[i];
            if (r1 < r2) {
                res = {r1, c1};
            } else {
                res = {r2, c2};
            }
        } else {
            if (t1 == 1) id1 = par[id1];
            if (t2 == 1) id2 = par[id2];
            res = verts[lc.lca(id1, id2)];
        }
        cout << res.first << ' ' << res.second << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}



