#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC traget("avx2,popcnt")

#include <iostream>
#include <bits/stdc++.h>

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

using namespace std;

typedef long long ll;
#define all(a) (a).begin(), (a).end()
typedef pair<int, int> P;
#define x second
#define y first

const ll INF = 2e9;

void solve(int t);
int main() {
    int t = 1;
    cin >> t;
    range(i, t) {
        solve(i);
    }
    return 0;
}

struct PAP {
    ll price = INF, amount = 0, pos = 0;
    bool operator<(const PAP &o) const {
        return tie(price, amount, pos) < tie(o.price, o.amount, o.pos);
    }
};
struct DO {
    vector<PAP> bestPAP;
    vector<ll *> max_buy;
    static PAP apply_max_buy(PAP p, ll max_buy) {
        p.amount = min(p.amount, max_buy);
        if (p.amount == 0) {
            p.price = INF;
        }
        return p;
    }
    PAP get_best_PAP(int i, int l, int r, int lq, int rq) {
        if (lq <= l && r <= rq) {
            return bestPAP[i];
        }
        int m = (l + r) / 2;
        PAP ans;
        if (lq <= l && r <= rq) {
            ans = bestPAP[i];
        } else if (rq <= m) {
            ans = get_best_PAP(2 * i, l, m, lq, rq);
        } else if (m <= lq) {
            ans = get_best_PAP(2 * i + 1, m, r, lq, rq);
        } else {
            ans = max(get_best_PAP(2 * i, l, m, lq, m), get_best_PAP(2 * i + 1, m, r, m, rq));
        }
        return apply_max_buy(ans, *max_buy[i]);
    }
    void update(int i, int l, int r) {
        bestPAP[i] = apply_max_buy(bestPAP[i], *max_buy[i]);
        if (r - l > 1 && bestPAP[i].amount == 0) {
            bestPAP[i] = min(bestPAP[2 * i], bestPAP[2 * i + 1]);
        }
    }

    void buy_on_pos(int i, int l, int r, int amount, int pos) {
        if (r - l == 1) {
            *max_buy[i] -= amount;
            bestPAP[i] = apply_max_buy(bestPAP[i], *max_buy[i]);
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            buy_on_pos(2 * i, l, m, amount, pos);
        } else  {
            buy_on_pos(2 * i + 1, m, r, amount, pos);
        }

    }
};
const int MAXN = 1e5 + 10;
int ls[MAXN];
int rs[MAXN];
int cs[MAXN];
vector<int> graph[MAXN];
ll cnt_buyed[MAXN];

bool bad = false;
pair<pair<ll, ll>, set<PAP>> dfs(int v) {
    ll cost = 0;
    ll buyed = 0;
    set<PAP> ans;
    ll can_buy = 0;
    for (auto u : graph[v]) {
        auto [cb, a] = dfs(u);
        if (bad) {
            return {{0, 0}, ans};
        }
        cost += cb.first;
        buyed += cb.second;
        for (auto p : a) {
            ans.insert(p);
            can_buy += p.amount;
        }
    }
    if (buyed > rs[v]) {
        bad = true;
        return {{0, 0}, ans};
    }
    if (buyed != rs[v]) {
        ans.insert({cs[v], rs[v] - buyed, v});
        can_buy += rs[v] - buyed;
    }
    while (buyed < ls[v]) {
        auto p = *ans.begin();
        ans.erase(ans.begin());
        ll bb = min(p.amount, ls[v] - buyed);
        p.amount -= bb;
        cost += p.price * bb;
        cnt_buyed[p.pos] += bb;
        buyed += bb;
        can_buy -= bb;
        if (p.amount > 0) {
            ans.insert(p);
        }
    }
    while (can_buy > (rs[v] - buyed)) {
        auto p = *ans.rbegin();
        ans.erase(--ans.end());
        ll bb = min(p.amount, can_buy - (rs[v] -buyed));
        p.amount -= bb;
        can_buy -= bb;
        if (p.amount > 0) {
            ans.insert(p);
        }
    }
    return {{cost, buyed}, ans};
}

void solve(int t) {
    int n; cin >> n;
    fill(cnt_buyed, cnt_buyed + n, 0);
    fill(graph, graph + n, vector<int>());
    bad = false;
    for (int i = 1; i < n; ++i) {
        int v; cin >> v; --v;
        graph[v].push_back(i);
    }
    range(i, n) {
        cin >> cs[i];
    }
    range(i, n) {
        cin >> ls[i] >> rs[i];
    }
    auto [cb, _] = dfs(0);
    if (bad) {
        cout << -1 << '\n';
        return;
    }
    cout << cb.first << '\n';
    range(i, n) {
        cout << cnt_buyed[i] << ' ';
    }
    cout << '\n';
}
