
#include <iostream>
#include <bits/stdc++.h>

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

using namespace std;

typedef long long ll;
#define all(a) (a).begin(), (a).end()
typedef pair<int, int> P;

void solve(int t);
int main() {
    solve(0);
    return 0;
}
const int MAXN = 5e5 + 10;
typedef pair<int, int> POS;
#define r first
#define c second

//POS poses[MAXN];

struct DD {
    struct Node {
        int v;
        int y;
        Node *l;
        Node *r;
        int size;
        Node(int v) : v(v) {
            y = rand();
            size = 1;
            l = nullptr;
            r = nullptr;
        }
    };
private:
    Node *root = nullptr;
    int get_size(Node *n) {
        return (n == nullptr?0:n->size);
    }
    void upd_n(Node *n) {
        if (n == nullptr) return;
        n->size = get_size(n->l) + get_size(n->r) + 1;
    }
    Node *merge(Node *l, Node *r) {
        if (!l) return r;
        if (!r) return l;
        if (l->y > r->y) {
            l->r = merge(l->r, r);
            upd_n(l);
            return l;
        } else {
            r->l = merge(l, r->l);
            upd_n(r);
            return r;
        }
    }
    pair<Node *, Node *> split(Node *n, int left_s) {
        if (n == nullptr) return {nullptr, nullptr};
        if (get_size(n) == left_s) return {n, nullptr};
        if (get_size(n->l) < left_s) {
            auto [rl, rr] = split(n->r, left_s - get_size(n->l) - 1);
            n->r = rl;
            upd_n(n);
            return {n, rl};
        } else {
            auto [ll, lr] = split(n->l, left_s);
            n->l = lr;
            upd_n(n);
            return {ll, n};
        }
    }
    pair<Node *, Node *> split_by_v(Node *n, int v) {
        if (n == nullptr) return {nullptr, nullptr};
        if (n->v < v) {
            auto [rl, rr] = split_by_v(n->r, v);
            n->r = rl;
            upd_n(n);
            return {n, rl};
        } else {
            auto [ll, lr] = split_by_v(n->l, v);
            n->l = lr;
            upd_n(n);
            return {ll, n};
        }
    }

public:
    void ins_value(int v) {
        auto[l, r] = split_by_v(root, v);
        root = merge(l, merge(new Node(v), r));
    }
    int get_v_with(int left_s) {
        if (left_s == 0) return -1;
        auto[l, r] = split(root, left_s);
        // l->size == left_s
        auto[ll, lr] = split(l, left_s - 1);
        int ans =  lr->v;
        root = merge(merge(ll, lr), r);
        return ans;
    }
};



void solve(int t) {
    int n; cin >> n;
    vector<int> changes(n);
    vector<int> when_changed(n);
    range(i, n) {
        cin >> changes[i];
        changes[i]--;
        when_changed[changes[i]] = i;
    }
    int q; cin >> q;
    vector<POS> poses(2 * q);
    vector<pair<POS, int>> sorted_poses;
    range(i, 2 * q) {
        cin >> poses[i].r >> poses[i].c;
        sorted_poses.emplace_back(poses[i], i);
    }
    sort(all(sorted_poses));
    vector<int> first_enter(2 * q);
    auto it = sorted_poses.begin();
//    DD dd;
    vector<int> inserted;
    range(level, n + 1) {
        if (level != 0) {
            int v = when_changed[level - 1];
            inserted.insert(lower_bound(all(inserted), v), v);
//            dd.ins_value(when_changed[level - 1]);
        }
        while(it->first.first < level) {++it;}
        while(it->first.first == level) {
//            first_enter[it->second] = dd.get_v_with(it->first.first - it->first.second);
            int size = it->first.r - it->first.c;
            if (size == 0) {
                first_enter[it->second] = -1;
            } else {
                first_enter[it->second] = inserted[size - 1];
            }
            ++it;
        }
    }
    range(i, q) {
        int a = first_enter[2 * i];
        int b = first_enter[2 * i + 1];
        if (a > b) {
            swap(a, b);
        }
        int r, c;
        int min_s;
        if (a == b) {
            r = min(poses[2 * i].r, poses[2 * i + 1].r);
            min_s = a + 1;
        } else {
            min_s = b;
            for (int j = a + 1; j < b; ++j) {
                if (changes[j] < changes[min_s]) {
                    min_s = j;
                }
            }
            if (changes[min_s] >= min(poses[2 * i].r, poses[2 * i + 1].r)) {
                r = min(poses[2 * i].r, poses[2 * i + 1].r);
                min_s = b;
            } else {
                r = changes[min_s];
            }
        }
        int cnt_l = 0;
        range(j, min_s) {
            if (changes[j] < r) {
                ++cnt_l;
            }
        }
        c = r - cnt_l;
        cout << r << ' ' << c << '\n';
    }
}