#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <sstream>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do { for (auto& e : a) cin >> e; } while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

#define int ll

mt19937_64 rnd(1231);

struct v {
	ll l;
	ll r;
	ll c;
};

vector<vector<int>> graph;
vector<v> arr;

vector<v> mins;

bool dfsMins(int v) {
	mins[v].l = arr[v].l;
	mins[v].r = arr[v].r;
	for (auto& other : graph[v]) {
		if (!dfsMins(other))
			return false;
	}
	if (!graph[v].empty()) {
		ll totall = 0;
		ll totalr = 0;
		for (auto& other : graph[v]) {
			totall += mins[other].l;
			totalr += mins[other].r;
		}
		mins[v].l = max(mins[v].l, totall);
		mins[v].r = min(mins[v].r, totalr);
	}
	return mins[v].l <= mins[v].r;
}


struct avaible {
	int at;
	int cost;
	int cnt;
};

bool operator<(avaible a, avaible b) {
	return a.cost < b.cost;
}

vector<int> cntBuy;
//    vertex(sorted by c) cost       
vector<vector<avaible>> toBuy; 
// chbuy
int dfsAns(int v) {
	toBuy[v].push_back({v, arr[v].c, (ll)2e9});
	ll chBuy = 0;
	for (auto& other : graph[v]) {
		int a = dfsAns(other);
		if (a == -1)
			return -1;
		chBuy += a;
	}
	if (chBuy > arr[v].r)
		return -1;
	for (auto& other : graph[v]) {
		for (auto& a : toBuy[other])
			toBuy[v].push_back(a);
	}
	auto& now = toBuy[v];
	sort(now.begin(), now.end());
	int i = 0;
	//cerr << v << ":\n";
	while (chBuy < arr[v].l) {
		if (i >= now.size())
			return -1;
		int cntLeft = arr[v].l - chBuy;
		if (now[i].cnt <= cntLeft) {
			//cerr << "buys " << now[i].cnt << " from " << now[i].at << "\n";
			cntBuy[now[i].at] += now[i].cnt;
			chBuy += now[i].cnt;
			now[i].cnt -= now[i].cnt;
			i++;
		}
		else {
			//cerr << "buys " << cntLeft << " from " << now[i].at << "\n";
			cntBuy[now[i].at] += cntLeft;
			chBuy += cntLeft;
			now[i].cnt -= cntLeft;
		}
	}
	int free = arr[v].r - chBuy;
	vector<avaible> newNow;
	for (int j = i; j < now.size(); j++) {
		if (now[j].cnt <= free) {
			free -= now[j].cnt;
			newNow.push_back(now[j]);
		}
		else {
			now[j].cnt = free;
			newNow.push_back(now[j]);
			break;
		}
	}
	toBuy[v] = newNow;
	return chBuy;
}

void solve() {
	int n;
	cin >> n;
	graph = vector<vector<int>>(n);
	arr = vector<v>(n);
	mins = vector<v>(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		graph[p].push_back(i);
	}
	for (auto& e : arr)
		cin >> e.c;
	for (auto& e : arr)
		cin >> e.l >> e.r;
	if (!dfsMins(0)) {
		cout << "-1\n";
		return;
	}



	cntBuy = vector<int>(n);
	toBuy = vector<vector<avaible>>(n);

	int a = dfsAns(0);
	if (a == -1) {
		cout << "-1\n";
	}
	else {
		ll ans = 0;
		for (int i = 0; i < n; i++) {
			ans += arr[i].c * cntBuy[i];
		}

		cout << ans << "\n";
		for (auto& e : cntBuy)
			cout << e << " ";
		cout << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t;
	cin >> t;
	while (t--)
		solve();
}