#include <bits/stdc++.h>

using namespace std;

struct Point
{
    int r, c;
    Point(int r=0, int c=0): r(r), c(c) {}

    Point pleft() {
        return {r - 1, c - 1};
    }
    Point pright() {
        return {r - 1, c};
    }

    friend bool operator==(Point& A, Point& B) {
        return {A.r == B.r && A.c == B.c};
    }
    friend bool operator!=(Point& A, Point& B) {
        return !(A == B);
    }

    friend istream& operator>>(istream& in, Point& P) {
        in >> P.r >> P.c;
        return in;
    }
    friend ostream& operator<<(ostream& out, Point P) {
        out << P.r << " " << P.c;
        return out;
    }
};

int n;
vector <int> fenwick;

int query(int idx)
{
    int res = 0;
    for (int i = idx; i > 0; i -= (i & (-i)))
        res += fenwick[i];
    return res;
}

void update(int idx)
{
    for (int i = idx; i < fenwick.size(); i += (i & (-i)))
        fenwick[i] += 1;
}

vector <int> lesses;

Point previ(Point& P)
{
    int rights = lesses[P.r] + 1;
    int lefts = (P.r + 1) - rights;
    if (P.c < lefts)
        return P.pright();
    else
        return P.pleft();
}

Point solve(Point A, Point B)
{
    if (B.r < A.r)
        swap(A, B);

    while (B.r > A.r) {
        B = previ(B);
    }
    while (A != B) {
        A = previ(A);
        B = previ(B);
    }
    return A;
}

signed main()
{
    cin >> n;
    vector <int> arr(n);
    for (auto& i: arr)
        cin >> i;

    fenwick.assign(n + 1, 0);
    lesses.assign(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        int cur = arr[i];
        lesses[cur] = query(cur - 1);
        update(cur);
    }

    int Q; cin >> Q;
    while (Q--) {
        Point A, B; cin >> A >> B;
        cout << solve(A, B) << "\n";
    }
}
