#include <bits/stdc++.h>

using namespace std;



int n;
vector <int> fenwick;
vector <int> lesses;

int query(int idx)
{
    int res = 0;
    for (int i = idx; i > 0; i -= (i & (-i)))
        res += fenwick[i];
    return res;
}

void update(int idx)
{
    for (int i = idx; i < fenwick.size(); i += (i & (-i)))
        fenwick[i] += 1;
}



struct Node
{
    int left, right;
    Node* child_left, * child_right;
    int x, add;
};

Node* build(int left, int right)
{
    if (left > right)
        return nullptr;
    Node* res = new Node;
    res->left = left;
    res->right = right;
    if (left == right) {
        res->child_left = res->child_right = nullptr;
        res->x = 0;
        res->add = 0;
    }
    else {
        int middle = (left + right) / 2;
        res->child_left = build(left, middle);
        res->child_right = build(middle + 1, right);
        res->x = 0;
        res->add = 0;
    }
    return res;
}

void add(Node* root, int left, int right, int x)
{
    if (right < root->left || left > root->right)
        return;
    if (left <= root->left && right >= root->right) {
        root->add += x;
        return;
    }

    add(root->child_left, left, right, x);
    add(root->child_right, left, right, x);
}

int dquery(Node* root, int idx)
{
    if (idx < root->left || idx > root->right)
        return 0;
    if (root->left == root->right)
        return root->x + root->add;
    return root->add + dquery(root->child_left, idx) + dquery(root->child_right, idx);
}

signed main()
{
    cin >> n;
    vector <int> arr(n);
    for (auto& i: arr)
        cin >> i;

    fenwick.assign(n + 1, 0);
    lesses.assign(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        int cur = arr[i];
        lesses[cur] = query(cur - 1);
        update(cur);
    }

    int Q; cin >> Q;
    vector <vector <pair <int, int>>> qrr(n + 1);
    for (int q = 0; q < Q; ++q) {
        int r1, c1; cin >> r1 >> c1;
        int r2, c2; cin >> r2 >> c2;
        qrr[r1].push_back({c1, 2 * q});
        qrr[r2].push_back({c2, 2 * q + 1});
    }

    Node* root = build(0, n);

    vector <pair <int, int>> ans(Q);

    vector <set <int>> data(n + 1);
    int level = n;
    while (level > -1) {
        //cout << level << "\n";

        for (auto [c, qid]: qrr[level]) {
            //cout << "? " << c << " " << qid << endl;
            int idx = c + dquery(root, c);
            //cout << idx << endl;
            if (data[idx].count(qid ^ 1)) {
                ans[qid / 2] = {level, c};
                data[idx].erase(qid ^ 1);
            }
            else
                data[idx].insert(qid);
        }

        //cout << "! " << level << "\n";

        if (level != 0) {
            int rights = lesses[level] + 1;
            int lefts = (level + 1) - rights;

            int a = lefts - 1, b = lefts;
            int a_idx = a + dquery(root, a), b_idx = b + dquery(root, b);
            if (data[a_idx].size() < data[b_idx].size()) {
                for (auto qid: data[a_idx]) {
                    if (data[b_idx].count(qid ^ 1)) {
                        ans[qid / 2] = {level - 1, a};
                        data[b_idx].erase(qid ^ 1);
                    }
                    else {
                        data[b_idx].insert(qid);
                    }
                }
                data[a_idx].clear();
                add(root, lefts - 1, n, 1);
            }
            else {
                for (auto qid: data[b_idx]) {
                    if (data[a_idx].count(qid ^ 1)) {
                        ans[qid / 2] = {level - 1, a};
                        data[a_idx].erase(qid ^ 1);
                    }
                    else {
                        data[a_idx].insert(qid);
                    }
                }
                data[b_idx].clear();
                add(root, lefts, n, 1);
            }
        }
        level -= 1;
    }

    for (auto [r, c]: ans)
        cout << r << " " << c << "\n";
}
