#include <bits/stdc++.h>

//#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int MAXN = 5e6, L = 12;

vector<pair<int, int>> g[MAXN];

void dfs(int v, string &s, int ind = 0) {
    if ((int) s.size() <= ind) {
        return;
    }
    if (s[ind] == '1') {
        g[v][1].second = 1;
        dfs(g[v][1].first, s, ind + 1);
    } else {
        g[v][0].second = 1;
        dfs(g[v][0].first, s, ind + 1);
    }
}

int timer_ = 0;
int tin[MAXN], tout[MAXN];
int up[MAXN][L];

void dfs2(int v, int p) {
    tin[v] = timer_++;
    up[v][0] = p;
    for (int i = 1; i < L; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto u: g[v]) {
        if (u.second == 1) {
            dfs2(u.first, v);
        }
    }
    tout[v] = timer_++;
}

bool is_anc(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca(int u, int v) {
    if (is_anc(u, v)) {
        return u;
    }
    for (int i = L - 1; i >= 0; i--) {
        if (!is_anc(up[u][i], v)) {
            u = up[u][i];
        }
    }
    return up[u][0];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &el: a) {
        cin >> el;
    }
    string s;
    for (int i = 0; i < n; i++) {
        s += '1';
    }
    int nv = 0;
    vector<int> prev;
    vector<pair<int, int>> rnn;
    for (int i = 0; i <= n; i++) {
        vector<int> prevv;
        for (int j = 0; j <= i; j++) {
            rnn.push_back({i, j});
            prevv.push_back(nv);
            if (j - 1 >= 0 && (int) prev.size() > j - 1) {
                g[prev[j - 1]].push_back({nv, 0});
            }
            if ((int) prev.size() > j) {
                g[prev[j]].push_back({nv, 0});
            }
            nv++;
        }
        swap(prev, prevv);
    }
    dfs(0, s);
    for (int i = 0; i < n; i++) {
        s[a[i] - 1] = '0';
        dfs(0, s);
    }
    dfs2(0, 0);
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        int v1 = lower_bound(all(rnn), make_pair(r1, c1)) - rnn.begin();
        int v2 = lower_bound(all(rnn), make_pair(r2, c2)) - rnn.begin();
        int v = lca(v1, v2);
        cout << rnn[v].first << ' ' << rnn[v].second << '\n';
    }
}

/*
3
2 3 1
5
3 3 3 0
2 2 2 1
1 0 3 1
3 1 3 2
2 2 2 2
 */
