#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 10, INF = 1e18;

struct segment_tree1 {
    pair<int, int> t[8 * N];
    int n;

    void build(int v, int l, int r, vector<pair<int, int>> &a) {
        if (l == r) {
            t[v] = a[l];
        } else {
            int m = (r + l) / 2;
            build(v * 2, l, m, a);
            build(v * 2 + 1, m + 1, r, a);
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    void build(vector<pair<int, int>> &a) {
        n = a.size();
        build(1, 0, n - 1, a);
    }

    pair<int, int> get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr || r < tl) {
            return {INF, 0};
        }
        int m = (r + l) / 2;
        return min(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m + 1, r, tl, tr));
    }

    pair<int, int> get(int l, int r) {
        return get(1, 0, n - 1, l, r);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (l == r) {
            t[v].first = val;
        } else {
            int m = (r + l) / 2;
            if (pos <= m) {
                update(v * 2, l, m, pos, val);
            } else {
                update(v * 2 + 1, m + 1, r, pos, val);
            }
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    void update(int pos, int val) {
        update(1, 0, n - 1, pos, val);
    }
};

struct segment_tree_hld {
    int t[4 * N], mod[4 * N];

    void push(int v, int l, int r) {
        if (mod[v] != 0) {
            t[v] += mod[v];
            if (l < r) {
                mod[v * 2] += mod[v];
                mod[v * 2 + 1] += mod[v];
            }
            mod[v] = 0;
        }
    }

    int get(int v, int l, int r, int tl, int tr) {
        int res = INF;
        for (int i = tl; i <= tr; i++) {
            res = min(res, t[i]);
        }
        return res;


        push(v, l, r);
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr || r < tl) {
            return INF;
        }
        int m = (r + l) / 2;
        return min(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m + 1, r, tl, tr));
    }

    void add(int v, int l, int r, int tl, int tr, int val) {
        for (int i = tl; i <= tr; i++) {
            t[i] += val;
        }
        return;


        push(v, l, r);
        if (l >= tl && r <= tr) {
            mod[v] += val;
            push(v, l, r);
            return;
        }
        if (l > tr || r < tl) {
            return;
        }
        int m = (r + l) / 2;
        add(v * 2, l, m, tl, tr, val);
        add(v * 2 + 1, m + 1, r, tl, tr, val);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        t[pos] = val;
        return;

        push(v, l, r);
        if (l == r) {
            t[v] = val;
        } else {
            int m = (r + l) / 2;
            if (pos <= m) {
                update(v * 2, l, m, pos, val);
            } else {
                update(v * 2 + 1, m + 1, r, pos, val);
            }
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }
};

int t, n, c[N], p[N], cnt[N], ans[N], d[N], l[N], r[N], tin[N], tout[N], ost[N], timer, root[N], sz[N];
vector<int> a[N];
segment_tree1 tree1;
segment_tree_hld tree;
bool ok;

void dfs(int v) {
    sz[v] = 1;
    for (int to : a[v]) {
        dfs(to);
        d[to] = d[v] + 1;
        sz[v] += sz[to];
    }
    for (int i = 1; i < a[v].size(); i++) {
        if (sz[a[v][i]] > sz[a[v][0]]) {
            swap(a[v][i], a[v][0]);
        }
    }
}

void dfs1(int v) {
    sz[v] = 1;
    tin[v] = timer++;
    int sl = 0;
    for (int i = 0; i < a[v].size(); i++) {
        int to = a[v][i];
        if (i == 0) {
            root[to] = root[v];
        } else {
            root[to] = to;
        }
        dfs1(to);
        sl += l[to];
    }
    l[v] = max(l[v], sl);
    if (l[v] > r[v]) {
        ok = false;
    }
    tout[v] = timer - 1;
}

int get(int f, int s) {
    int res = INF;
    while (true) {
        if (root[s] == s) {
            res = min(res, tree.get(1, 0, n - 1, tin[s], tin[s]));
            if (f == s) break;
            s = p[s];
        } else if (d[root[s]] > d[f]) {
//            res = min(res, tree.get(1, 0, n - 1, tin[s], tin[s]));
//            if (f == s) break;
//            s = p[s];
//            continue;
            assert(tin[root[s]] < tin[s]);
            res = min(res, tree.get(1, 0, n - 1, tin[root[s]], tin[s]));
            s = p[root[s]];
        } else {
            res = min(res, tree.get(1, 0, n - 1, tin[s], tin[s]));
            if (f == s) break;
            s = p[s];
            continue;

            res = min(res, tree.get(1, 0, n - 1, tin[f], tin[s]));
            break;
        }
    }
    return res;
}

void add(int f, int s, int val) {
    while (true) {
        if (root[s] == s) {
            tree.add(1, 0, n - 1, tin[s], tin[s], val);
            if (f == s) break;
            s = p[s];
        } else if (d[root[s]] > d[f]) {
            tree.add(1, 0, n - 1, tin[s], tin[s], val);
            if (f == s) break;
            s = p[s];
            continue;

            tree.add(1, 0, n - 1, tin[root[s]], tin[s], val);
            s = p[root[s]];
        } else {
            tree.add(1, 0, n - 1, tin[s], tin[s], val);
            if (f == s) break;
            s = p[s];
            continue;

            tree.add(1, 0, n - 1, tin[f], tin[s], val);
            break;
        }
    }
}

void update(int f, int val) {
    tree.update(1, 0, n - 1, tin[f], val);
}

void dfs2(int v) {
    int sc = 0;
    for (int to : a[v]) {
        dfs2(to);
        cnt[v] += cnt[to];
        sc += cnt[to];
    }
    update(v, r[v] - sc);

    while (cnt[v] < l[v]) {
        pair<int, int> z = tree1.get(tin[v], tout[v]);
        if (z.first == INF) break;
        int to = z.second;
        int cv = to;
        int mn = get(v, cv);
        if (mn <= l[v] - cnt[v]) {
            int ep = mn;
            ans[to] += ep;
            cv = to;
            cnt[v] += ep;
            add(v, cv, -ep);
            tree1.update(tin[z.second], INF);
        } else {
            int ep = l[v] - cnt[v];
            ans[to] += ep;
            cv = to;
            cnt[v] += ep;
            add(v, cv, -ep);
        }
    }
    if (cnt[v] < l[v]) {
        ok = false;
    }
}

void solve() {
    cin >> t;
    while (t--) {
        cin >> n;
        timer = 0;
        for (int i = 0; i < n; i++) {
            a[i].clear();
            ans[i] = 0;
            cnt[i] = 0;
        }
        p[0] = -1;
        ok = true;
        for (int i = 1; i < n; i++) {
            int pa;
            cin >> pa;
            pa--;
            p[i] = pa;
            a[pa].push_back(i);
        }
        for (int i = 0; i < n; i++) {
            cin >> c[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> l[i] >> r[i];
        }
        dfs(0);
        dfs1(0);
        if (!ok) {
            cout << -1 << '\n';
            continue;
        }
        vector<pair<int, int>> ba1(n);
        for (int i = 0; i < n; i++) {
            ba1[tin[i]] = {c[i], i};
        }
        tree1.build(ba1);
        dfs2(0);
        if (!ok) {
            cout << -1 << '\n';
            continue;
        }
        long long sum = 0;
        for (int i = 0; i < n; i++) {
            sum += ans[i] * c[i];
        }
        cout << sum << '\n';
        for (int i = 0; i < n; i++) {
            cout << ans[i] << " ";
        }
        cout << '\n';
    }
}
