#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define vi vector<int>
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back
//#define int ll

using namespace std;

const int maxn = 1e5;

struct mst {
    vector<vi> t;
    int n;
    mst(int n, vi &a) : n(n) {
        t.resize(4 * n);
        build(1, 0, n - 1, a);
    }
    void build(int v, int l, int r, vi &a) {
        if (l == r) {
            t[v] = {a[l]};
        } else {
            int tm = (l + r) / 2;
            build(2 * v, l, tm, a);
            build(2 * v + 1, tm + 1, r, a);
            merge(t[2 * v].begin(), t[2 * v].end(), t[2 * v + 1].begin(), t[2 * v + 1].end(), back_inserter(t[v]));
        }
    }
    int get(int v, int tl, int tr, int l, int r, int x) {
        if (l > tr || r < tl || l > r)
            return 0;
        if (tl >= l && tr <= r) {
            return upper_bound(t[v].begin(), t[v].end(), x) - t[v].begin();
        } else {
            int tm = (tl + tr) / 2;
            return get(2 * v, tl, tm, l, r, x) + get(2 * v + 1, tm + 1, tr, l, r, x);
        }
    }
    int get(int l, int r, int x) {
        return get(1, 0, n - 1, l, r, x);
    }

    int get2(int v, int tl, int tr, int cnt, int x) {
        if (tl == tr)
            return tl;
        int tm = (tl + tr) / 2;
        int y = upper_bound(t[2 * v].begin(), t[2 * v].end(), x) - t[2 * v].begin();
        if (y >= cnt)
            return get2(2 * v, tl, tm, cnt, x);
        else
            return get2(2 * v + 1, tm + 1, tr, cnt - y, x);
    }
    int get2(int cnt, int x) {
        return get2(1, 0, n - 1, cnt, x);
    }
};

struct st {
    vector<int> t;
    int n;
    st(int n, vi &a) : n(n) {
        t.resize(4 * n);
        build(1, 0, n - 1, a);
    }
    void build(int v, int l, int r, vi &a) {
        if (l == r) {
            t[v] = a[l];
        } else {
            int tm = (l + r) / 2;
            build(2 * v, l, tm, a);
            build(2 * v + 1, tm + 1, r, a);
            t[v] = min(t[2 * v], t[2 * v + 1]);
        }
    }
    int get(int v, int tl, int tr, int l, int r, int x) {
        if (l > tr || r < tl || l > r)
            return 1e9;
        if (tl >= l && tr <= r) {
            return t[v];
        } else {
            int tm = (tl + tr) / 2;
            return min(get(2 * v, tl, tm, l, r, x), get(2 * v + 1, tm + 1, tr, l, r, x));
        }
    }
    int get(int l, int r, int x) {
        return get(1, 0, n - 1, l, r, x);
    }
};

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for (auto &i : a)
        cin >> i;
    mst t(n, a);
    st t2(n, a);
    auto first_try = [&] (int R, int C) {
        if (R == C)
            return 0;
        return t.get2(R - C, R) + 1;
    };
    int q;
    cin >> q;
    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
//        first_try(r1, c1);
        int l = first_try(r1, c1), r = first_try(r2, c2);
//        cout << ' ' << l << ' ' << r << endl;
        if (l == r) {
            if (r1 > r2)
                swap(r1, r2), swap(c1, c2);
            cout << r1 << ' ' << c1 << '\n';
            continue;
        }
        if (l > r)
            swap(l, r);
        int mx = t2.get(l, r - 1, 0);
//        cout << mx << endl;

        if (mx > min(r1, r2)) {
            if (r1 > r2)
                swap(r1, r2), swap(c1, c2);
            cout << r1 << ' ' << c1 << '\n';
            continue;
        }
        int R = mx - 1;
        int C = mx - 1 - t.get(0, r - 1, R);
        cout << R << " " << C << '\n';
    }
}

signed main() {
    std::ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    while(t--)
        solve();

    return 0;
}
