#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define sz(x) (int)x.size()
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define pii pair<int, int>
#define fi first
#define se second

const int N = 3001;
const int L = 10;

int n;
vector<int> a;
vector<pii > g[N][N];
pii up[N][N][L];
int tin[N][N], tout[N][N];


void makeEdges(vector<int> &ord) {
    int x = 0, y = 0;

    for (int i = 0; i < n; ++i) {
        int nx = x + 1, ny = y + ord[i];
        g[x][y].emplace_back(nx, ny);
        x = nx, y = ny;
    }
}

int timer = 0;

void dfs(int i, int j) {
    tin[i][j] = timer++;
    for (auto &u: g[i][j]) {
        int ii = u.fi, jj = u.se;
        up[ii][jj][0] = {i, j};
        dfs(ii, jj);
    }
    tout[i][j] = timer++;
}

bool parent(pii x, pii y) {
    return tin[x.fi][x.se] <= tin[y.fi][y.se] && tout[y.fi][y.se] <= tout[x.fi][x.se];
}

pii lca(pii x, pii y) {
    if (parent(x, y))
        return x;
    if(parent(y, x))
        return y;

    for(int j = L - 1; j >= 0; --j){
        if(!parent(up[x.fi][x.se][j], y))
            x = up[x.fi][x.se][j];
    }
    return up[x.fi][x.se][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    a.resize(n);
    for (int &i: a) {
        cin >> i;
        --i;
    }

    vector<int> ord(n, 1);
    makeEdges(ord);

    for (int i: a) {
        ord[i] = 0;
        makeEdges(ord);
    }

    dfs(0, 0);

    for (int l = 1; l < L; ++l) {
        for (int i = 0; i < N; ++i) {
            for (int j = 0; j < N; ++j) {
                auto q = up[i][j][l - 1];
                up[i][j][l] = up[q.fi][q.se][l - 1];
            }
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        auto lc = lca({r1, c1}, {r2, c2});
        cout << lc.fi << " " << lc.se << '\n';
    }
}
