#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>

using namespace std;

#define int long long

mt19937 rnd(time(0));

using ll = long long;
using ld = long double;

vector<int> p, sz, glp, tin, eu;
vector<vector<int>> gr;
vector<ll> c, l, r, cntans, ves;
ll ans = 0;
int timer = 0,n = 0;

inline void clearall() {
	p.clear();
	gr.clear();
	c.clear();
	l.clear();
	r.clear();
	ans = 0;
	cntans.clear();
	ves.clear();
	sz.clear();
	glp.clear();
	tin.clear();
	timer = 0;
	eu.clear();
}

void dfs1(int v) {
	sz[v] = 1;
	for (int i = 0; i < (int)gr[v].size(); ++i) {
		int u = gr[v][i];
		dfs1(u);
		sz[v] += sz[u];
		if (sz[u] > sz[gr[v][0]]) {
			swap(gr[v][0], gr[v][i]);
		}
	}
}

void dfs2(int v) {
	tin[v] = eu.size();
	eu.push_back(v);
	if (!gr[v].empty()) {
		glp[gr[v][0]] = glp[v];
		dfs2(gr[v][0]);
	}
	for (int i = 1; i < (int)gr[v].size(); ++i) {
		int u = gr[v][i];
		glp[u] = u;
		dfs2(u);
	}
}

struct Node {
	ll c = 0;
	int v = 0;

	Node() {}
	Node(ll c, int v) : c(c), v(v) {}
};

inline bool operator < (const Node& a, const Node& b) {
	return a.c < b.c;
}

inline void merge(multiset<Node>& a, multiset<Node>& b) {
	for (auto& i : b) {
		a.insert(i);
	}
}

const ll INF = 1e9;

struct Seg_tree {
	int n = 0;
	vector<ll> t, c;

	Seg_tree() {}
	Seg_tree(int n) : n(n), t(4 * n, INF), c(4 * n, 0) {}

	inline void app(int v, ll x) {
		t[v] += x;
		c[v] += x;
	}

	inline void push(int v) {
		if (c[v]) {
			app(v * 2, c[v]);
			app(v * 2 + 1, c[v]);
			c[v] = 0;
		}
	}

	inline ll get(int v, int l, int r, int askl, int askr) {
		if (askr <= l || r <= askl || l >= r) {
			return INF;
		}
		else if (askl <= l && r <= askr) {
			return t[v];
		}
		else {
			push(v);
			int m = (r + l) / 2;
			return min(get(v * 2, l, m, askl, askr), get(v * 2 + 1, m, r, askl, askr));
		}
	}

	inline void up(int v, int l, int r, int askl, int askr, ll x) {
		if (askr <= l || r <= askl || l >= r) {
			return;
		}
		else if (askl <= l && r <= askr) {
			app(v, x);
		}
		else {
			push(v);
			int m = (r + l) / 2;
			up(v * 2, l, m, askl, askr, x);
			up(v * 2 + 1, m, r, askl, askr, x);
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}

	inline void locup(int v, int l, int r, int pos, ll x) {
		if (r - l == 1) {
			t[v] = x;
		}
		else {
			push(v);
			int m = (r + l) / 2;
			if (pos < m) {
				locup(v * 2, l, m, pos, x);
			}
			else {
				locup(v * 2 + 1, m, r, pos, x);
			}
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}
};

Seg_tree tree;

inline ll ask(int v, int u) {
	ll temp = INF;
	int v1 = glp[v];
	while (v != u) {
		int u1 = glp[u];
		if (v1 != u1) {
			temp = min(temp, tree.get(1, 0, n, tin[u1], tin[u] + 1));
			u = p[u1];
		}
		else {
			temp = min(temp, tree.get(1, 0, n, tin[v] + 1, tin[u] + 1));
			u = v;
			break;
		}
	}
	return temp;
}

inline void up(int v, int u, ll x) {
	int v1 = glp[v];
	while (v != u) {
		int u1 = glp[u];
		if (v1 != u1) {
			tree.up(1, 0, n, tin[u1], tin[u] + 1, x);
			u = p[u1];
		}
		else {
			tree.up(1, 0, n, tin[v] + 1, tin[u] + 1, x);
			u = v;
			break;
		}
	}
}

multiset<Node> dfs3(int v) {
	multiset<Node> ms;
	for (int u : gr[v]) {
		auto voz = dfs3(u);
		if (voz.size() > ms.size()) {
			swap(voz, ms);
		}
		for (auto& i : voz) {
			ms.insert(i);
		}
		ves[v] += ves[u];
	}
	if (ves[v] > r[v]) {
		cout << -1;
		exit(0);
	}
	while (ves[v] < l[v] && !ms.empty() && c[v] > ms.begin()->c) {
		auto fi = ms.begin();
		int u = fi->v;
		ll c = fi->c;
		ll temp = ask(v, u);
		ll temp2 = min(temp, l[v] - ves[v]);
		ans += temp2 * c;
		ves[v] += temp2;
		cntans[u] += temp2;
		up(v, u, -temp2);
		if (temp == temp2) {
			ms.erase(ms.begin());
		}
	}
	if (ves[v] < l[v]) {
		ans += (l[v] - ves[v]) * c[v];
		cntans[v] += l[v] - ves[v];	
		ves[v] = l[v];
	}
	tree.locup(1, 0, n, tin[v],  r[v] - ves[v]);
	if (ves[v] < r[v]) {
		ms.insert(Node(c[v], v));
	}
	return ms;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		clearall();
		cin >> n;
		p.resize(n, 0);
		gr.resize(n);
		c.resize(n);
		l.resize(n);
		r.resize(n);
		sz.resize(n, 0);
		cntans.resize(n, 0);
		ves.resize(n, 0);
		glp.resize(n, 0);
		tin.resize(n, 0);
		tree = Seg_tree(n);
		for (int i = 1; i < n; ++i) {
			cin >> p[i];
			--p[i];
			gr[p[i]].push_back(i);
		}
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		for (int i = 0; i < n; ++i) {
			cin >> l[i] >> r[i];
		}
		dfs1(0);
		dfs2(0);
		dfs3(0);
		cout << ans << '\n';
		for (int i = 0; i < n; ++i) {
			cout << cntans[i] << ' ';
		}
		cout << '\n';
	}
}