﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <map>
#include <set>
#include <climits>
using namespace std;
using s64 = long long;
#define all(obj) obj.begin(), obj.end()

vector<int> p;
vector<s64> c;
vector<s64> l, r;
vector<vector<int>> g;

// dp[v] = ответ для поддерева v
// dp[a[v]] = min cost
struct state {
	s64 cost;
	vector<int> ch;
};
vector<map<s64, state>> dp;

void build(int v) {
	for (int i = 0; i <= min(r[v], 100LL); i++) {
		dp[v][i].cost = c[v] * i;
		dp[v][i].ch.resize(g[v].size() + 1);
	}
	for (int i = max(0LL, r[v] - 100LL); i <= r[v]; i++) {
		dp[v][i].cost = c[v] * i;
		dp[v][i].ch.resize(g[v].size() + 1);
	}

	for(int e = 0; e < g[v].size(); e++){
		int to = g[v][e];
		build(to);
		map<s64, state> ndp;
		for(auto [x, state] : dp[v]) {
			for (auto [y, tostate] : dp[to]) {
				if (x + y <= r[v] && l[to] <= y) {
					if (!ndp.count(x + y) || ndp[x + y].cost > state.cost + tostate.cost) {
						ndp[x + y].cost = state.cost + tostate.cost;
						ndp[x + y].ch = state.ch;
						ndp[x + y].ch[e] = y;
					}
				}
			}
		}
		dp[v] = move(ndp);
		map<s64, state> l, r;
		for (auto it : dp[v]) {
			if (l.size() > 150) {
				break;
			}
			l.insert(it);
		}
		for (auto it = dp[v].rbegin(); it != dp[v].rend(); it++) {
			if (r.size() > 150) {
				break;
			}
			r.insert(*it);
		}
		dp[v] = l;
		for (auto& it : r) {
			dp[v].insert(it);
		}
	}
}

bool ok;

vector<s64> b, a;
void restore(int v, s64 x) {
	if (dp[v][x].ch.empty()) {
		ok = false;
		return;
	}
	a[v] = x;
	b[v] = x;
	for (int e = 0; e < g[v].size(); e++) {
		int to = g[v][e];
		restore(to, dp[v][x].ch[e]);
		b[v] -= a[to];
	}
}

void solve(istream& cin) {
	int n;
	{
		cin >> n;
		p.resize(n);
		g.assign(n, {});
		p[0] = -1;
		for (int i = 1; i < n; i++) {
			cin >> p[i];
			p[i]--;
			g[p[i]].push_back(i);
		}
		c.resize(n);
		for (int i = 0; i < n; i++) {
			cin >> c[i];
		}
		l.resize(n), r.resize(n);
		for (int i = 0; i < n; i++) {
			cin >> l[i] >> r[i];
		}
	}

	dp.clear();
	dp.resize(n);
	build(0);


	s64 best_cost = LLONG_MAX;
	vector<s64> ans;
	for(auto [i, state] : dp[0]) {
		if (l[0] <= i && i <= r[0] && best_cost > dp[0][i].cost) {
			a.assign(n, 0);
			b.assign(n, 0);
			ok = true;
			restore(0, i);
			if (ok) {
				best_cost = dp[0][i].cost;
				ans = b;
			}
		}
	}

	

	if (!ans.empty()) {
		cout << best_cost << "\n";
		for (int i = 0; i < n; i++) {
			cout << ans[i] << " ";
		}
		cout << "\n";
	}
	else {
		cout << "-1\n";
	}
}

int main() {
	//ifstream cin("input.txt");
	
	int t;
	cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}