﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <map>
#include <set>
#include <climits>
using namespace std;
using s64 = long long;
#define all(obj) obj.begin(), obj.end()

vector<bool> may;

void solve(istream& cin) {
	int n;
	s64 w, h;
	cin >> n >> w >> h;
	vector<s64> x(n), y(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
		y[i] = h - y[i];
	}

	auto calc = [&](vector<int> dir) {
		struct event {
			s64 x, y;
			bool up;
			bool open;
			bool operator < (const event& Rhs) const {
				if (x == Rhs.x) {
					return open > Rhs.open;
				}
				return x < Rhs.x;
			}
		};
		vector<event> evs;
		for (int i = 0; i < n; i++) {
			int left, top, right, bottom;
			if (dir[i] == 0) {
				evs.push_back({ x[i], y[i], true, true });
				evs.push_back({ w, y[i], true, false });
			}
			else if (dir[i] == 1) {
				evs.push_back({ 0, y[i], true, true });
				evs.push_back({ x[i], y[i], true, false });
			}
			else if (dir[i] == 2) {
				evs.push_back({ 0, y[i], false, true });
				evs.push_back({ x[i], y[i], false, false });
			}
			else {
				evs.push_back({ x[i], y[i], false, true });
				evs.push_back({ w, y[i], false, false });
			}
		}
		sort(all(evs));

		multiset<s64> upy, downy;
		s64 prev_x = -1;
		s64 area = 0;
		for (auto [x, y, up, open] : evs) {
			if (prev_x != x) {
				// calc area [prev_x, x)
				s64 z = 0;
				if (!upy.empty() && !downy.empty() && *upy.rbegin() >= *downy.begin()) {
					z = h;
				}
				else {
					if (!upy.empty()) {
						z += *upy.rbegin(); // +1?
					}
					if (!downy.empty()) {
						z += h - *downy.begin();
					}
				}

				area += z * (x - prev_x);
			}

			prev_x = x;

			if (open) {
				if (up) {
					upy.insert(y);
				}
				else {
					downy.insert(y);
				}
			}
			else {
				if (up) {
					upy.erase(upy.find(y));
				}
				else {
					downy.erase(downy.find(y));
				}
			}
		}
		return area;
	};

	s64 ans = 0;
	for (int j = 0; j < 4; j++) {
		if (may[j]) {
			ans = max(ans, calc(vector<int>(n, j)));
		}
	}
	cout << ans << "\n";
}

int main() {
	//ifstream cin("input.txt");
	
	int k;
	cin >> k;
	may.resize(4, false);
	while (k--) {
		int i;
		cin >> i;
		i--;
		may[i] = true;
	}

	int t = 1;
	cin >> t;
	while (t--) {
		solve(cin);
	}

	return 0;
}