#pragma GCC target("sse,sse2,sse3,sse4,fma,avx,avx2,popcnt")
#pragma GCC optimize("-Ofast,unroll-loops,fast-math")
#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <array>
#include <string>
#include <cstring>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <list>
#include <cassert>
#define ar array
std::mt19937 rnd(503);
using namespace std;
typedef long long ll;
const int N = 3e5 + 5;

struct segtr {
	struct node {
		int l = -1, r = -1, sum = 0;
		node() {}
	};
	vector<node> t;
	vector<int> vs = { 0 };
	int n;
	segtr(int n) : n(n) {
		t.resize(n * 4);
		for (int i = 0; i < n * 2 - 1; ++i) {
			t[i].l = 2 * i + 1, t[i].r = 2 * i + 2;
		}
	}
	int add(int v, int l, int r, int p) {
		int v0 = t.size();
		t.push_back({});
		if (l + 1 == r) {
			t[v0].sum = t[v].sum + 1;
		}
		else {
			int m = (l + r) / 2;
			if (p < m) {
				t[v0].l = add(t[v].l, l, m, p);
				t[v0].r = t[v].r;
			}
			else {
				t[v0].l = t[v].l;
				t[v0].r = add(t[v].r, m, r, p);
			}
			t[v0].sum = t[t[v0].l].sum + t[t[v0].r].sum;
		}
		return v0;
	} void add(int p) { vs.push_back(add(vs.back(), 0, n, p)); }
	int get(int v, int tl, int tr, int l, int r) {
		if (tr <= l || r <= tl) return 0;
		if (l <= tl && tr <= r) return t[v].sum;
		int tm = (tl + tr) / 2;
		return get(t[v].l, tl, tm, l, r) + get(t[v].r, tm, tr, l, r);
	} int get(int v, int l, int r) { return get(vs[v], 0, n, l, r); }
	/*int first_mom(int r, int c) {
		int L = -1, R = n;
		while (L + 1 < R) {
			int M = (L + R) / 2;
			if (get(M, 0, r) < r - c) L = M;
			else R = M;
		}
		return R;
	}*/
	int get_high(int v1, int v2, int l, int r) {
		if (l + 1 == r) return l;
		int m = (l + r) / 2, dif = t[t[v2].l].sum - t[t[v1].l].sum;
		if (dif > 0) return get_high(t[v1].l, t[v2].l, l, m);
		else return get_high(t[v1].r, t[v2].r, m, r);
	} int get_high(int v1, int v2) { return get_high(vs[v1], vs[v2], 0, n); }
	void print(int v, int l, int r) {
		if (l + 1 == r) {
			cout << t[v].sum << " ";
		}
		else {
			int m = (l + r) / 2;
			print(t[v].l, l, m);
			print(t[v].r, m, r);
		}
	} void print(int v) { print(vs[v],0,n); }
};

struct fenw {
	vector<ll> f1, f2;
	int n;
	fenw(int n) : n(n) {
		f1.assign(n + 1, 0);
		f2 = f1;
	}
	void upd(vector<ll>& f, int p, ll x) {
		for (++p; p <= n; p += (p & -p)) {
			f[p] += x;
		}
	}
	void rng_upd(int l, int r, ll x) {
		upd(f1, l, x), upd(f1, r, -x);
		upd(f2, l, x * l), upd(f2, r, -x * r);
	}
	ll sum(int p) {
		int p1 = p;
		ll ans = 0;
		for (; p; p -= (p & -p)) {
			ans += f1[p] * p1 - f2[p];
		}
		return ans;
	}
	int get(int p) {
		return sum(p + 1) - sum(p);
	}
};

int n, q, a[N], b[N];
ar<ar<int, 2>, 2> qs[N];
vector<int> col[N];
map<ar<int, 2>, int> mom;

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i]; --a[i];
		b[a[i]] = i;
	}
	segtr tr(n);
	for (int i = 0; i < n; ++i) {
		tr.add(a[i]);
	}
	cin >> q;
	for (int i = 0; i < q; ++i) {
		cin >> qs[i][0][0] >> qs[i][0][1];
		cin >> qs[i][1][0] >> qs[i][1][1];
		col[qs[i][0][0]].push_back(qs[i][0][1]);
		col[qs[i][1][0]].push_back(qs[i][1][1]);
	}
	fenw f(n + 1);
	for (int i = 0; i < n; ++i) {
		f.rng_upd(b[i] + 1, n + 1, 1);
		for (auto& x : col[i + 1]) {
			int L = -1, R = n;
			while (L + 1 < R) {
				int M = (L + R) / 2;
				if (f.get(M) < i + 1 - x) L = M;
				else R = M;
			}
			mom[{i + 1, x}] = R;
		}
	}
	for (int i = 0; i < q; ++i) {
		ar<int, 2> x = qs[i][0], y = qs[i][1];
		//int mox = tr.first_mom(x[0], x[1]);
		//int moy = tr.first_mom(y[0], y[1]);
		int mox = mom[x], moy = mom[y];
		if (mox > moy) {
			swap(x, y);
			swap(mox, moy);
		}
		if (mox == moy) {
			if (x[0] > y[0]) swap(x, y);
			cout << x[0] << " " << x[1] << "\n";
			continue;
		}
		int ed = tr.get_high(mox, moy);
		int changed_before = tr.get(b[ed], 0, ed);
		if (ed < x[0]) cout << ed << " " << ed - changed_before << "\n";
		else cout << x[0] << " " << x[1] << "\n";
	}
}

void clear() {
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t--) {
		solve();
		clear();
		cout << "\n";
	}
}

/*

3
3 2 1
1
1 1 3 2

*/