#include <iostream>
#include <set>

using namespace std;

int used[3010][3010];
pair <int, int> up[3010][3010][25];
set <int> s;
int tin[3010][3010];
int tout[3010][3010];
int tmr = 0;
int n;

void dfs(int i, int j, int pi = 0, int pj = 0, int cnt = 1)
{
    //cout << i << ' ' << j << '\n';
    used[i][j] = 1;
    up[i][j][0] = {pi, pj};
    for (int k = 1; k <= 20; k++)
        up[i][j][k] = up[up[i][j][k - 1].first][up[i][j][k - 1].second][k - 1];
    if (cnt == n + 1)
        return;
    if (s.find(cnt) != s.end())
        dfs(i + 1, j, i, j, cnt + 1);
    else
        dfs(i + 1, j + 1, i, j, cnt + 1);
}

void dfs2(int i, int j)
{
    // << '\n';
    //cout << i << ' ' << j << '\n';
   // cout << "---\n";
    tin[i][j] = ++tmr;
    used[i][j] = 2;
    if (up[i + 1][j][0] == make_pair(i, j))
        dfs2(i + 1, j);
    if (up[i + 1][j + 1][0] == make_pair(i, j))
        dfs2(i + 1, j + 1);
    tout[i][j] = ++tmr;
}

bool isAncestor(int x1, int y1, int x2, int y2)
{
    return (tin[x1][y1] <= tin[x2][y2] && tout[x2][y2] <= tout[x1][y1]);
}

pair <int, int> lca(int x1, int y1, int x2, int y2)
{
    if (isAncestor(x1, y1, x2, y2))
        return {x1, y1};
    if (isAncestor(x2, y2, x1, y1))
        return {x2, y2};
    for (int i = 20; i >= 0; i--)
    if (!isAncestor(up[x1][y1][i].first, up[x1][y1][i].second, x2, y2)){
        int nx = up[x1][y1][i].first, ny = up[x1][y1][i].second;
        x1 = nx;
        y1 = ny;
        //cout << x1 << ' ' << y1 << '\n';
    }
    return up[x1][y1][0];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    dfs(0, 0);
    for (int i = 1; i <= n; i++){
        int x;
        cin >> x;
        s.insert(x);
        tmr = 0;
        dfs(0, 0);
    }
    dfs2(0, 0);
    int q;
    cin >> q;
    while (q--){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        pair <int, int> ans = lca(x1, y1, x2, y2);
        cout << ans.first << ' ' << ans.second << '\n';
    }
    return 0;
}
