#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
using namespace std;
#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int inf = 1e18;
vector<int> a;
int n;
const int maxn = 5e5;
const int lg = 20;
int MN[maxn][lg];

struct node {
    int sum;
    node *L;
    node *R;

    node(int s) {
        sum = s;
        L = nullptr;
        R = nullptr;
    }
};

vector<node *> roots;

node *build(int tl, int tr) {
    if (tl == tr) {
        return new node(0);
    }
    int tm = (tl + tr) / 2;
    node *now = new node(0);
    now->L = build(tl, tm);
    now->R = build(tm + 1, tr);
    return now;
}

node *upd(node *v, int tl, int tr, int pos) {
    if (tl == tr) {
        return new node(1);
    }
    int tm = (tl + tr) / 2;
    node *y = new node(v->sum);
    y->L = v->L;
    y->R = v->R;
    if (pos <= tm) {
        y->L = upd(v->L, tl, tm, pos);
    } else {
        y->R = upd(v->R, tm + 1, tr, pos);
    }
    y->sum++;
    return y;
}

int get_sum(node *v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)return 0;
    if (l <= tl && tr <= r) {
        return v->sum;
    }
    int tm = (tl + tr) / 2;
    return get_sum(v->L, tl, tm, l, r) + get_sum(v->R, tm + 1, tr, l, r);
}

void calc_roots() {
    roots.push_back(build(0, n - 1));
    for (int i = 0; i < n; ++i) {
        roots.push_back(upd(roots.back(), 0, n - 1, a[i]));
    }
}

void calc_MN() {
    for (int i = n - 1; i >= 0; --i) {
        MN[i][0] = a[i];
        for (int j = 1; j < lg; ++j) {
            MN[i][j] = min(MN[i][j - 1], MN[min(n - 1, i + (1 << (j - 1)))][j - 1]);
        }
    }
}

int cnt_lower(int r, int val) {
    int ans = get_sum(roots[r + 1], 0, n - 1, 0, val - 1);
    return ans;
}

int get_min(int l, int r) {
    if (r >= n)assert(false);
    if (l > r) {
        assert(false);
    }
    int sz = r - l + 1;
    int L = __lg(sz);
    return min(MN[l][L], MN[l + (1 << L) - 1][L]);
}

int get_first(int x, int y) {
    int l = -2;
    int r = n - 1;
    while (l + 1 != r) {
        int mid = (l + r) / 2;
        int cnt = cnt_lower(mid, x);
        int right = x - y;
        if (cnt >= right) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return r;
}

int get_last(int x, int y) {
    int l = -1;
    int r = n;
    while (l + 1 != r) {
        int mid = (l + r) / 2;
        int cnt = cnt_lower(mid, x);
        int right = x - y;
        if (cnt > right) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return l;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    calc_roots();
    calc_MN();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int x1, y1;
        int x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        if (x1 > x2) {
            swap(x1, x2);
            swap(y1, y2);
        }
        int l1 = get_first(x1, y1);
        int r1 = get_last(x1, y1);
        int l2 = get_first(x2, y2);
        int r2 = get_last(x2, y2);
        if (l1 <= l2 && l2 <= r1 || l1 <= r2 && r2 <= r1) {
            cout << x1 << " " << y1 << "\n";
            continue;
        }
        int p1 = get_first(x1, y1);
        int p2 = get_first(x2, y2);
        int mn = get_min(min(p1, p2) + 1, max(p1, p2));
        int cnt = cnt_lower(p1, mn);
        int left = mn - cnt;
        cout << mn << " " << left << "\n";
    }
}