#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll

const int MAXN = 1e6 + 1000;
int mn[4 * MAXN + 4];
int add[4 * MAXN + 4];
vector<int> events[MAXN];
int sp[MAXN];
int t[4 * MAXN + 4];

void build_t(int i, int l, int r) {
    if (l + 1 == r) {
        t[i] = sp[l];
        return;
    }
    int m = (l + r) / 2;
    build_t(2 * i + 1, l, m);
    build_t(2 * i + 2, m, r);
    t[i] = min(t[2 * i + 1], t[2 * i + 2]);
}

int get_seg(int i, int l, int r, int q_l, int q_r) {
    //cout << i << " " << l << " " << r << " - " << q_l << " " << q_r << "\n";
    if (q_l <= l && r <= q_r) {
        //cout << "RETURN: " << t[i] << "\n";
        return t[i];
    }
    if (r <= q_l || q_r <= l) {
        return MAXN;
    }
    int m = (l + r) / 2;
    return min(get_seg(2 * i + 1, l, m, q_l, q_r), get_seg(2 * i + 2, m, r, q_l, q_r));
}

void push(int i) {
    add[2 * i + 1] += add[i];
    add[2 * i + 2] += add[i];
    mn[2 * i + 1] += add[i];
    mn[2 * i + 2] += add[i];
    add[i] = 0;
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        cout << l << " = " << events[l][0] - events[l][1] << " ( index = " << events[l][2] << ", row = " << events[l][0] << ")" << endl;
        mn[i] = events[l][0] - events[l][1];
        return;
    }
    int m = (l + r) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
}

void update(int i, int l, int r, int q_l, int q_r, int x) {
    if (q_l <= l && r <= q_r) {
        add[i] += x;
        mn[i] += x;
        return;
    }
    if (r <= q_l || q_r <= l) {
        return;
    }
    push(i);
    int m = (l + r) / 2;
    update(2 * i + 1, l, m, q_l, q_r, x);
    update(2 * i + 2, m, r, q_l, q_r, x);
    mn[i] = min(mn[2 * i + 1], mn[2 * i + 2]);
}

int get_min(int i, int l, int r) {
    if (mn[i] != 0) {
        return -1;
    }
    if (l + 1 == r) {
        return l;
    }
    push(i);
    int m = (l + r) / 2;
    if (mn[2 * i + 1] == 0) {
        return get_min(2 * i + 1, l, m);
    }
    return get_min(2 * i + 2, m, r);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> sp[i];
    }
    build_t(0, 0, n);
    int q;
    cin >> q;
    vector<vector<int> > req(q, vector<int>(4));
    for (int i = 0; i < q; ++i) {
        cin >> req[i][0] >> req[i][1] >> req[i][2] >> req[i][3];
    }
    for (int i = 0; i < q; ++i) {
        events[2 * i] = {req[i][0], req[i][1], i, 0};
        events[2 * i + 1] = {req[i][2], req[i][3], i, 1};
    }
    sort(events, events + 2 * q);
    build(0, 0, 2 * q);
    //return;
    vector<int> fst(n + 1, n + 1);
    for (int i = 0; i < 2 * q; ++i) {
        fst[events[i][0]] = min(fst[events[i][0]], i);
    }
    vector<pair<int, int> > r(q, {-n, -n});
    while(true) {
        cout << "get now!" << endl;
        int now = get_min(0, 0, 2 * q);
        cout << now << endl;
        if (now == -1) {
            break;
        }
        else {
            if (events[now][3] == 0) {
                r[events[now][2]].first = -1;
            }
            else {
                r[events[now][2]].second = -1;
            }
            update(0, 0, 2 * q, now, now + 1, n + 10);
        }
    }
    for (int i = 0; i < n; ++i) {
        /// make action: sp[i]
        cout << "update!" << endl;
        update(0, 0, 2 * q, fst[sp[i]], 2 * q, -1);
        cout << "OK! " << endl;
        while(true) {
            cout << "get now!" << endl;
            int now = get_min(0, 0, 2 * q);
            cout << now << endl;
            if (now == -1) {
                break;
            }
            else {
                cout << "OK " << i << endl;
                if (events[now][3] == 0) {
                    r[events[now][2]].first = i;
                }
                else {
                    r[events[now][2]].second = i;
                }
                update(0, 0, 2 * q, now, now + 1, n + 10);
            }
        }
    }
    cout << "OK r" << endl;
    for (int i = 0; i < q; ++i) {
        cout << i << ": " << r[i].first << " and " << r[i].second << "\n";
    }
    for (int i = 0; i < q; ++i) {
        if (r[i].first == r[i].second) {
            if (req[i][0] < req[i][2]) {
                cout << req[i][0] << " " << req[i][1] << "\n";
            }
            else {
                cout << req[i][2] << " " << req[i][3] << "\n";
            }
        }
        else {
            int mn = min(r[i].first, r[i].second);
            int mx = max(r[i].first, r[i].second);
            int now = get_seg(0, 0, n, mn + 1, mx + 1);
            cout << "** " << now << "\n";
            if (now <= req[i][0] && now <= req[i][2]) {
                int cnt = now - 1;
                for (int j = 0; j <= mn; ++j) {
                    if (sp[j] < now) {
                        --cnt;
                    }
                }
                cout << now - 1 << " " << cnt << "\n";
            }
            else {
                if (req[i][0] < req[i][2]) {
                    cout << req[i][0] << " " << req[i][1] << "\n";
                }
                else {
                    cout << req[i][2] << " " << req[i][3] << "\n";
                }
            }
        }
    }
    return;
}

/*
5
4 1 3 5 2
3
3 2 3 1
3 2 5 2
5 3 2 1
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}



