//#pragma GCC target ("avx,avx2,sse,sse2,sse3,sse4,fma,popcnt")
//#pragma GCC optimize ("-Ofast, unroll-loops, fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <random>

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

vector<vector<int>> gr;
vector<vector<pair<int, int>>> qr;
vector<int> used, r, p, ans, up;

int get(int u) {
	if (u == p[u])
		return u;
	return p[u] = get(p[u]);
}

void merge(int a, int b, int d) {
	a = get(a), b = get(b);
	if (a == b)
		return;
	if (r[a] < r[b])
		swap(a, b);
	if (r[a] == r[b])
		r[a]++;
	p[b] = a;
	up[a] = d;
}

void dfs(int u) {
	used[u] = 1;
	for (auto [v, ind] : qr[u])
		ans[ind] = up[get(v)];
	for (int v : gr[u]) {
		if (used[v])
			continue;
		dfs(v);
		merge(u, v, u);
	}
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q;
	cin >> n;
	vector<int> a(n);
	bool f = true;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		f &= (a[i] == i);
	}
	if (f) {
		cin >> q;
		while (q--) {
			int x1, y1, x2, y2;
			cin >> x1 >> y1 >> x2 >> y2;
			if (x1 - y1 == x2 - y2) {
				if (x1 < x2)
					cout << x1 << ' ' << y1 << '\n';
				else
					cout << x2 << ' ' << y2 << '\n';
			}
			else {
				cout << min(x1 - y1, x2 - y2) << " 0\n";
			}
		}
		return 0;
	}
	gr.resize((n + 1) * (n + 1));
	qr.resize((n + 1) * (n + 1));
	vector<int> ch(n, 1);
	vector<pair<int, int>> pth(n);
	for (int i = 0; i <= n; ++i) {
		int x, y;
		if (i) {
			ch[a[i - 1]] = 0;
			x = pth[a[i - 1]].first, y = pth[a[i - 1]].second;
		}
		else
			x = 0, y = 0;
		for (int j = (i == 0 ? 0 : a[i - 1]); j < n; ++j) {
			pth[j] = { x, y };
			gr[x * (n + 1) + y].push_back((x + 1) * (n + 1) + y + ch[j]);
			x++;
			y += ch[j];
		}
	}
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		int frst = x1 * (n + 1) + y1;
		int scnd = x2 * (n + 1) + y2;
		qr[frst].emplace_back(scnd, i);
		qr[scnd].emplace_back(frst, i);
	}
	r.resize((n + 1) * (n + 1), 1);
	p.resize((n + 1) * (n + 1));
	up.resize((n + 1) * (n + 1));
	ans.resize(q);
	for (int i = 0; i < (n + 1) * (n + 1); ++i) {
		p[i] = i;
		up[i] = i;
	}
	used.resize((n + 1) * (n + 1));
	dfs(0);
	for (int i : ans)
		cout << i / (n + 1) << ' ' << i % (n + 1) << '\n';
}