#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>

using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7, N = 10;

vector <vector <int>> g;
vector <int> lx, rx, c;
vector <vector <pair <int, int>>> need, add;
bool dfs(int v) {
	for (auto& u : g[v]) {
		if (!dfs(u)) return false;
		for (auto& x : need[u]) 
			need[v].push_back(x);
		for (auto& x : add[u])
			add[v].push_back(x);
	}
	for (int i = 0; i < rx[v]; ++i)
		add[v].push_back({ c[v], v });
	sort(add[v].rbegin(), add[v].rend());
	if (need[v].size() > rx[v]) return false;
	while (need[v].size() < lx[v]) {
		need[v].push_back(add[v].back());
		add[v].pop_back();
	}
	return true;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int tt; cin >> tt;
	while (tt-- > 0) {
		int n; cin >> n;
		g.assign(n + 1, {});
		lx.assign(n + 1, 0);
		rx.assign(n + 1, 0);
		c.assign(n + 1, 0);
		add.assign(n + 1, {});
		need.assign(n + 1, {});
		for (int i = 2; i <= n; ++i) {
			int p; cin >> p;
			g[p].push_back(i);
		}
		for (int i = 1; i <= n; ++i) cin >> c[i];
		for (int i = 1; i <= n; ++i)
			cin >> lx[i] >> rx[i];
		if (!dfs(1)) {
			cout << "-1\n";
			continue;
		}
		vector <int> cnt(n + 1);
		int sum = 0;
		for (auto& x : need[1])
			sum += x.first, cnt[x.second]++;
		cout << sum << '\n';
		for (int i = 1; i <= n; ++i)
			cout << cnt[i] << ' ';
		cout << '\n';
	}

}