#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <cassert>

using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';

const int mod = 1e9 + 7, N = 10;

int n, CNT = 0;
vector <vector <int>> g, subTree;
vector <int> lx, rx, c, par, need, ans, md;

void pl(int v, int x) {
	if (!x) return;
	need[v] += x;
	if (v == 1) return;
	pl(par[v], x);
}

void reCalc(int v) {
	if (v == 1) md[v] = mod * mod;
	md[v] = min(md[v], rx[v] - need[v]);
	for (auto& u : g[v]) {
		md[u] = md[v];
		reCalc(u);
	}
}


bool dfs(int v) {
	subTree[v].push_back(v);
	for (auto& u : g[v]) {
		if (!dfs(u)) return false;
		for (auto& x : subTree[u])
			subTree[v].push_back(x);

	}
	if (need[v] > rx[v]) return false;
	sort(subTree[v].begin(), subTree[v].end(), [&](int i, int j) {
		return c[i] < c[j];
		});
	reCalc(1);
	for (auto& x : subTree[v]) {
		if (need[v] == lx[v]) break;
		int add = md[x];
		if (add == 0) continue;
		ans[x] += min(add, lx[v] - need[v]);
		pl(x, min(add, lx[v] - need[v]));
		reCalc(1);
		CNT++;
		assert(CNT <= n);
	}
	if (need[v] < lx[v]) return false;
	return true;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);

	int tt; cin >> tt;
	while (tt-- > 0) {
		cin >> n;
		CNT = 0;
		g.assign(n + 1, {});
		lx.assign(n + 1, 0);
		rx.assign(n + 1, 0);
		c.assign(n + 1, 0);
		need.assign(n + 1, 0);
		par.assign(n + 1, 0);
		ans.assign(n + 1, 0);
		subTree.assign(n + 1, {});
		md.assign(n + 1, 0);
		for (int i = 2; i <= n; ++i) {
			int p; cin >> p;
			g[p].push_back(i);
			par[i] = p;
		}
		for (int i = 1; i <= n; ++i) cin >> c[i];
		for (int i = 1; i <= n; ++i)
			cin >> lx[i] >> rx[i];
		reCalc(1);
		if (!dfs(1)) {
			cout << "-1\n";
			continue;
		}
		int sum = 0;
		for (int i = 1; i <= n; ++i)
			sum += c[i] * ans[i];
		cout << sum << '\n';
		for (int i = 1; i <= n; ++i)
			cout << ans[i] << ' ';
		cout << '\n';
	}

}