#include <iostream>
#include <vector>

using namespace std;

#define endl '\n'

const int LG = 1;
int counter = 0;

pair<int, int> up[3001][3001];
vector<vector<vector<bool>>> used_edge;
vector<vector<int>> tin, tout;

vector<int> mas;

void dfs_way(int x, int y, int pos, int px, int py) {
    up[x][y] = {px, py};
    if (pos == mas.size()) return;
    used_edge[x][y][mas[pos]] = 1;
    if (mas[pos] == 0) {
        dfs_way(x + 1, y, pos + 1, x, y);
    } else {
        dfs_way(x + 1, y + 1, pos + 1, x, y);
    }
}

void dfs_t(int x, int y, int pos) {
    tin[x][y] = counter++;
    if (pos == mas.size()) {
        tout[x][y] = counter++;
        return;
    }
    for (int i = 0; i < 2; i++) {
        if (used_edge[x][y][i]) {
            if (i == 0) {
                dfs_t(x + 1, y, pos + 1);
            } else {
                dfs_t(x + 1, y + 1, pos + 1);
            }
        }
    }
    tout[x][y] = counter++;
}

bool upper(int x1, int y1, int x2, int y2) {
    return tin[x1][y1] <= tin[x2][y2] && tout[x1][y1] >= tout[x2][y2];
}

pair<int, int> get_lca(int x1, int y1, int x2, int y2) {
    while (!upper(x1, y1, x2, y2)) {
        auto t = up[x1][y1];
        x1 = t.first, y1 = t.second;
    }
    return {x1, y1};
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    mas.assign(n, 1);
    used_edge.resize(n + 1, vector<vector<bool>>(n + 1, vector<bool>(2)));
    tin.resize(n + 1, vector<int>(n + 1));
    tout.resize(n + 1, vector<int>(n + 1));
    dfs_way(0, 0, 0, 0, 0);
    for (int i = 0; i < n; i++) {
        mas[a[i]] = 0;
        dfs_way(0, 0, 0, 0, 0);
    }
    dfs_t(0, 0, 0);
    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        auto t = get_lca(x1, y1, x2, y2);
        cout << t.first << " " << t.second << endl;
    }
}
