#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
    return 0;
}

#define lower_index(v, x) lower_bound(v.begin(), v.end(), x) - v.begin()
#define upper_index(v, x) upper_bound(v.begin(), v.end(), x) - v.begin()

struct cell {
    int i, j;

    cell(int i, int j) : i(i), j(j) {}

    cell() = default;

    bool operator<(const cell &other) const {
        return pair{i, j} < pair{other.i, other.j};
    }
};

void solve(vector<int> a, vector<pair<cell, cell>> q) {
    int n = a.size();
    auto get = [&](int i, int j) -> int {
        if (j == i) return 0;
        int curJ = i;
        for (int k = 0; k < n; ++k) {
            if (a[k] < i) curJ--;
            if (curJ == j) return k + 1;
        }
        assert(false);
        return 0;
    };
    auto j = [&](int i, int c) -> int {
        int curJ = i;
        for (int k = 0; k < c; ++k) {
            if (a[k] < i) curJ--;
        }
        return curJ;
    };
    for (auto &[c1, c2]: q) {
        auto[i1, j1] = c1;
        auto[i2, j2] = c2;
        int idx1 = get(i1, j1);
        int idx2 = get(i2, j2);
        int ans = max(i1, i2);
        for (int i = min(idx2, idx1); i < max(idx1, idx2); ++i) {
            ans = min(ans, a[i]);
        }
        cout << ans << ' ' << j(ans, idx1) << '\n';
    }
}

void solve() {
    int n, q;
    cin >> n;
    vector<int> a(n);
    for (int &x: a) cin >> x;
    for (int &x: a) --x;
    cin >> q;
    vector<pair<cell, cell>> qu(q);
    for (auto &[c1, c2]: qu) {
        cin >> c1.i >> c1.j >> c2.i >> c2.j;
    }
    solve(a, qu);
}
