#define ll long long

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>

using namespace std;

struct el {
	ll val = 0, cnt = 0, i = 0;

	el(ll val1 = 0, ll cnt1 = 0, ll i1 = 0) {
		val = val1;
		cnt = cnt1;
		i = i1;
	}

	const bool operator<(const el &e) const {
		return tie(val, cnt, i) < tie(e.val, e.cnt, e.i);
	}
};

inline bool is(vector<vector<ll>> &gr, ll v, vector<ll> &l, vector<ll> &r, vector<ll> &mn) {
	bool ans = 1;

	if (gr[v].size() == 0) {
		mn[v] = l[v];
		return 1;
	}
	
	for (auto u : gr[v]) {
		ans = (ans & is(gr, u, l, r, mn));

		mn[v] += mn[u];
	}

	if (mn[v] > r[v]) {
		ans = 0;
	}

	mn[v] = max(mn[v], l[v]);

	return ans;
}

void merge(set<el>& a, set<el>& b) {
	if (a.size() < b.size()) {
		a.swap(b);
	}

	for (auto i : b) {
		a.insert(i);
	}
}

ll is_rt = 1;

inline void dfs(vector<vector<ll>>& gr, vector<set<el>> &st, ll v, vector<ll> &c, vector<ll>& l, vector<ll>& r,
	vector<ll>& cnt, vector<ll>& sum, vector<ll> &ans) {
	if (!is_rt) {
		return;
	}

	if (gr[v].size() == 0) {
		cnt[v] = l[v];
		sum[v] = l[v] * c[v];
		ans[v] += l[v];

		if (r[v] - l[v] > 0) {
			st[v].insert(el(c[v], r[v] - l[v], v));
		}
		return;
	}

	for (auto u : gr[v]) {
		dfs(gr, st, u, c, l, r, cnt, sum, ans);

		if (!is_rt) {
			return;
		}

		sum[v] += sum[u];
		cnt[v] += cnt[u];
		merge(st[v], st[u]);
	}

	if (cnt[v] > r[v]) {
		is_rt = 0;
		return;
	}

	st[v].insert(el(c[v], r[v], v));

	while (cnt[v] < l[v]) {
		if (st[v].begin()->cnt > (l[v] - cnt[v])) {
			el p = el(st[v].begin()->val, st[v].begin()->cnt - (l[v] - cnt[v]), st[v].begin()->i);
			ans[st[v].begin()->i] += (l[v] - cnt[v]);
			sum[v] += (l[v] - cnt[v]) * st[v].begin()->val;
			cnt[v] = l[v];
			st[v].erase(st[v].begin());
			st[v].insert(p);
		}
		else {
			sum[v] += st[v].begin()->cnt * st[v].begin()->val;
			cnt[v] += st[v].begin()->cnt;
			ans[st[v].begin()->i] += st[v].begin()->cnt;
			st[v].erase(st[v].begin());
		}
	}

	set<el> nwst;
	ll now = 0;

	while (now + cnt[v] < r[v]) {
		if (st[v].begin()->cnt + now + cnt[v] > r[v]) {
			el p = { st[v].begin()->val, r[v] - now - cnt[v], st[v].begin()->i };
			nwst.insert(p);
			now += p.cnt;
		}
		else {
			el p = { st[v].begin()->val, st[v].begin()->cnt, st[v].begin()->i };
			nwst.insert(p);
			now += p.cnt;
		}
	}

	st[v].swap(nwst);
}


void true_main() {
	ll n;
	cin >> n;
	is_rt = 1;

	vector<vector<ll>> gr(n);

	for (ll i = 1; i < n; i++) {
		ll p;
		cin >> p;

		p--;
		gr[p].push_back(i);
	}

	vector<ll> c(n);
	vector<ll> l(n);
	vector<ll> r(n);

	for (ll i = 0; i < n; i++) {
		cin >> c[i];
	}

	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}

	vector<set<el>> st(n);

	vector<ll> mn(n, 0);

	/*if (!is(gr, 0, l, r, mn)) {
		cout << -1;
		return;
	}*/

	vector<ll> cnt(n, 0);
	vector<ll> sum(n, 0);
	vector<ll> ans(n, 0);

	dfs(gr, st, 0, c, l, r, cnt, sum, ans);

	if (!is_rt) {
		cout << -1;
		return;
	}

	cout << sum[0] << "\n";

	for (ll i = 0; i < n; i++) {
		cout << ans[i] << " ";
	}


}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	ll t = 1;
	cin >> t;

	while (t--) {
		true_main();
		cout << "\n";
	}

}


/*
5
1 2 3 4
7 6 5 4 3
100 1000
2 10
2 10
2 10
3 10
*/