#define ll long long

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>

using namespace std;

int lg = 21;

int num(vector<int>& sm, int r, int c) {
	int ans = sm[r] + c;

	return ans;
}

void dfs(vector<vector<int>>& gr, vector<vector<int>>& bin_up, int v, int pred, vector<int>& tin, vector<int>& tout, int& tm,
	vector<bool>& used) {
	tin[v] = tm++;
	used[v] = 1;

	bin_up[v][0] = pred;

	for (int i = 1; i < lg; i++) {
		bin_up[v][i] = bin_up[bin_up[v][i - 1]][i - 1];
	}

	for (auto u : gr[v]) {
		if (u == pred || used[u]) {
			continue;
		}

		dfs(gr, bin_up, u, v, tin, tout, tm, used);
	}

	tout[v] = tm++;
}

bool is_pred(vector<int>& tin, vector<int>& tout, int v, int u) {
	return(tin[v] <= tin[u] && tout[v] >= tout[u]);
}

int lca(vector<vector<int>>& bin_up, vector<int>& tin, vector<int>& tout, int v, int u) {
	if (is_pred(tin, tout, v, u)) {
		return v;
	}

	if (is_pred(tin, tout, u, v)) {
		return u;
	}

	for (int i = lg - 1; i >= 0; i--) {
		if (!is_pred(tin, tout, bin_up[v][i], u)) {
			v = bin_up[v][i];
		}
	}

	return bin_up[v][0];
}

void merge(set<int>& a, set<int>& b, int v, vector<int>& ans) {
	if (b.size() > a.size()) {
		a.swap(b);
	}

	for (auto i : b) {
		if (a.find(i) != a.end()) {
			a.erase(i);
			ans[i] = v;
		}
		else {
			a.insert(i);
		}
	}
}

void dfs1(vector<vector<int>>& gr, int v, int pred, vector<int>& ans, vector<set<int>>& st, vector<bool>& used) {
	used[v] = 1;

	for (auto u : gr[v]) {
		if (u == pred || used[u]) {
			continue;
		}

		dfs1(gr, u, v, ans, st, used);
		merge(st[v], st[u], v, ans);
	}
}

void true_main() {
	int n = 6, q;
	cin >> n;

	n++;

	vector<int> a(n - 1);
	bool is = 1;

	//vector<bool> used1(n - 1, 0);

	for (int i = 0; i < n - 1; i++) {
		/*int y = rand() % (n - 1);

		while (used1[y]) {
			y = rand() % (n - 1);
		}

		used1[y] = 1;
		a[i] = y;*/

		cin >> a[i];
		a[i]--;
		if (a[i] != i) {
			is = 0;
		}
	}

	cin >> q;

	if (is) {
		for (int i = 0; i < q; i++) {
			int r1, c1, r2, c2;
			cin >> r1 >> c1 >> r2 >> c2;

			int l1 = r1 - c1;
			int l2 = r2 - c2;

			if (l1 == l2) {
				cout << min(r1, r2) << " " << min(c1, c2) << "\n";
			}
			else {
				int r = min(l1, l2);
				int c = 0;
				cout << r << " " << c << "\n";
			}
		}
		return;
	}

	if (n > 3000 || q > 3000) {
		int lb = 0;
		if (a[0] != n - 1) {
			for (int i = 1; i < n - 1; i++) {
				if (a[i] != a[i - 1]) {
					break;
				}
				lb++;
			}
		}

		for (int i = 0; i < q; i++) {
			int r1, c1, r2, c2;
			cin >> r1 >> c1 >> r2 >> c2;

			int l1 = r1 - c1;
			int l2 = r2 - c2;

			if (l1 <= lb && l2 <= lb) {
				if (l1 == l2) {
					cout << min(r1, r2) << " " << min(c1, c2) << "\n";
				}
				else {
					int r = min(l1, l2);
					int c = 0;
					cout << r << " " << c << "\n";
				}
			}
			else if (l1 > lb && l2 > lb) {
				if (c1 == c2) {
					cout << min(r1, r2) << " " << min(c1, c2) << "\n";
				}
				else {
					int r = lb + min(c1, c2);
					int c = min(c1, c2);
					cout << r << " " << c << "\n";
				}
			}
			else {
				cout << min(l1, l2) << " " << 0 << "\n";
			}
		}

		return;
	}

	vector<int> sm(n, 0);
	for (int i = 1; i < n; i++) {
		sm[i] = sm[i - 1] + i;
	}

	int sz = (n + 1) * (n + 1) / 2 + 3;

	vector<vector<int>> gr(sz);

	vector<int> now(n, 1);

	for (int i = 0; i < n; i++) {
		int r = 0, c = 0;

		for (int j = 0; j < n - 1; j++) {
			int v = num(sm, r, c);
			int u = num(sm, r + 1, c + now[j]);

			gr[v].push_back(u);
			gr[u].push_back(v);
			r++;
			c += now[j];
		}

		if (i < n - 1) {
			now[a[i]] = 0;
		}
	}

	vector<bool> used(sz, 0);

	vector<set<int>> st(sz);
	vector<int> ans(q);

	for (int i = 0; i < q; i++) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;

		int v = num(sm, r1, c1);
		int u = num(sm, r2, c2);

		if (u != v) {
			st[u].insert(i);
			st[v].insert(i);
		}
		else {
			ans[i] = v;
		}
	}

	dfs1(gr, 0, 0, ans, st, used);

	for (int i = 0; i < q; i++) {
		int w = ans[i];

		int j = 0;

		while (j < sm.size() && sm[j] <= w) {
			j++;
		}

		j--;

		int ra = j;
		int ca = w - sm[j];

		cout << ra << " " << ca << "\n";
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	ll t = 1;
	// cin >> t;

	while (t--) {
		// cout << t;
		true_main();
		cout << "\n";
	}

}


/*
2
5
1 2 1 3
4 6 4 7 1
1 7
4 6
1 4
1 5
0 2
*/