#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define vi vector<int>
#define vvi vector<vi>
#define vll vector<ll>
#define pll pair<ll, ll>
#define pi pair<int, int>
#define vpi vector<pi>
#define vpll vector<pll>

ll dfs(int v, vvi &adj, vpll &data, vi &cost, vector<map<pair<int, int>, int>> &perel, vll &cnt_for_perel, vi &result) {
    ll total = 0;
    for (int u: adj[v]) {
        ll tmp = dfs(u, adj, data, cost, perel, cnt_for_perel, result);
        if (tmp == -1) return -1;
        total += tmp;

        if (perel[u].size() > perel[v].size()) {
            swap(perel[u], perel[v]);
            swap(cnt_for_perel[u], cnt_for_perel[v]);
        }
        for (auto &el: perel[u]) {
            perel[v][el.first] += el.second;
            cnt_for_perel[v] += el.second;
        }
    }
    if (total < data[v].first) {
        perel[v][{cost[v], v}] += data[v].second - total;
        cnt_for_perel[v] += data[v].second - total;
        int need_to_collect = data[v].first - total;
        vpi to_erase;
        for (auto &el: perel[v]) {
            if (el.second >= need_to_collect) {
                result[el.first.second] += need_to_collect;
                el.second -= need_to_collect;
                cnt_for_perel[v] -= need_to_collect;
                total += need_to_collect;
                need_to_collect = 0;
                break;
            } else {
                result[el.first.second] += el.second;
                total += el.second;
                need_to_collect -= el.second;
                cnt_for_perel[v] -= el.second;
                to_erase.push_back(el.first);
            }
        }

        for (auto &i: to_erase) perel[v].erase(i);
        if (need_to_collect) return -1;
        int left = data[v].second - data[v].first;
        ll need_to_delete = cnt_for_perel[v] - left;

        to_erase.clear();
        if (!perel[v].empty()) {
            auto it = perel[v].end();
            it--;
            while (true) {
                if (need_to_delete == 0) break;
                if (it->second <= need_to_delete) {
                    need_to_delete -= it->second;
                    cnt_for_perel[v] -= it->second;
                    to_erase.push_back(it->first);
                } else {
                    it->second -= need_to_delete;
                    cnt_for_perel[v] -= need_to_delete;
                    need_to_delete = 0;
                }
                if (it == perel[v].begin()) break;
                it--;
            }
            for (auto &i: to_erase) perel[v].erase(i);
        }

        for (auto &i: to_erase) perel[v].erase(i);
        return total;
    } else if (total <= data[v].second) {
        perel[v][{cost[v], v}] += data[v].second - total;
        cnt_for_perel[v] += data[v].second - total;
        int left = data[v].second - total;
        ll need_to_delete = cnt_for_perel[v] - left;
        vpi to_erase;
        if (!perel[v].empty()) {
            auto it = perel[v].end();
            it--;
            while (true) {
                if (need_to_delete == 0) break;
                if (it->second <= need_to_delete) {
                    need_to_delete -= it->second;
                    cnt_for_perel[v] -= it->second;
                    to_erase.push_back(it->first);
                } else {
                    it->second -= need_to_delete;
                    cnt_for_perel[v] -= need_to_delete;
                    need_to_delete = 0;
                }
                if (it == perel[v].begin()) break;
                it--;
            }
            for (auto &i: to_erase) perel[v].erase(i);
        }
        return total;
    } else {
        return -1;
    }
}

void solve() {
    int n;
    cin >> n;
    vvi adj(n + 1);
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        adj[p].push_back(i);
    }
    vi cost(n + 1);
    vi result(n + 1, 0);
    for (int i = 1; i <= n; i++) cin >> cost[i];
    vpll data(n + 1);
    vll cnt_for_perel(n + 1, 0);
    for (int i = 1; i <= n; i++) cin >> data[i].first >> data[i].second;

    vector<map<pair<int, int>, int>> perel(n + 1);

    ll res = dfs(1, adj, data, cost, perel, cnt_for_perel, result);
    if (res == -1) {
        cout << -1 << '\n';
    } else {
        ll total = 0;
        for (int i = 1; i <= n; i++) {
            total += 1ll * result[i] * cost[i];
        }
        cout << total << '\n';
        for (int i = 1; i <= n; i++) {
            cout << result[i] << ' ';
        }
        cout << '\n';
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}