#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define vi vector<int>
#define vvi vector<vi>
#define vll vector<ll>
#define pll pair<ll, ll>
#define pi pair<int, int>
#define vpi vector<pi>
#define vpll vector<pll>
#define vb vector<bool>

void build_tree(vector<vector<int>> &has_pre, vb &right, int n) {
    int cur_x = 0, cur_y = 0;
    for (int i = 0; i < n; i++) {
        if (right[i]) cur_x++;
        cur_y++;
        if (right[i]) has_pre[cur_x][cur_y] = -1;
        else {
            assert(has_pre[cur_x][cur_y] != -1);
            has_pre[cur_x][cur_y] = 1;
        }
    }
}

const int MAXN = 3001;

int bin_up[13][MAXN][MAXN];


pair<int, int> lift_up(int h, int x2, int y2) {
    for (int p = 12; p >= 0; p--) {
        if ((1 << p) > h) continue;
        h -= (1 << p);
        int next_y = y2 - (1 << p);
        int next_x = x2 + bin_up[p][x2][y2];
        x2 = next_x, y2 = next_y;
    }
    return {x2, y2};
}

bool is_subtree(int x1, int y1, int x2, int y2) {
    if (y2 < y1) return false;
    int most_left = x1;
    int most_right = x1 + y2 - y1;
    return most_left <= x2 and x2 <= most_right;
}

void solve() {
    int n;
    cin >> n;
    vi a(n);
    bool fourth = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
        if (a[i] != i) fourth = false;
    }

    if (n <= 3000) {
        vector<vector<int>> has_pre(n + 1, vector<int>(n + 1, 0));
        vb right(n, true);
        build_tree(has_pre, right, n);
        for (int i = 0; i < n; i++) {
            right[a[i]] = false;
            build_tree(has_pre, right, n);
        }

        for (int p = 0; p < 13; p++) {
            for (int i = 0; i <= n; i++) {
                for (int j = 0; j <= n; j++) {
                    if (has_pre[j][i] == 0) {
                        bin_up[p][j][i] = 0;
                        continue;
                    } else {
                        int done = 0;
                        if (has_pre[j][i] == -1) done--;
                        if (p == 0) {
                            bin_up[p][j][i] = done;
                        } else {
                            int delta = bin_up[p - 1][j][i];
                            int next_x = j + delta;
                            int next_y = max(0, i - (1 << (p - 1)));
                            delta += bin_up[p - 1][next_x][next_y];
                            bin_up[p][j][i] = delta;
                        }
                    }
                }
            }
        }


        int q;
        cin >> q;
        while (q--) {
            int y1, x1, y2, x2;
            cin >> y1 >> x1 >> y2 >> x2;
            if (y1 > y2) {
                swap(y1, y2);
                swap(x1, x2);
            }
            auto res = lift_up(y2 - y1, x2, y2);
            x2 = res.first, y2 = res.second;
            if (x1 == x2 and y1 == y2) {
                cout << y1 << ' ' << x1 << '\n';
                continue;
            }
            for (int p = 12; p >= 0; p--) {
                int next_x1 = x1 + bin_up[p][x1][y1];
                int next_x2 = x2 + bin_up[p][x2][y2];
                if (next_x1 != next_x2) {
                    x1 = next_x1, x2 = next_x2;
                    y1 = y1 - (1 << p), y2 = y2 - (1 << p);
                }
            }
            cout << y1 - 1 << ' ' << min(x1, x2) << '\n';
        }
    } else if (fourth) {
        int q;
        cin >> q;
        while (q--) {
            int y1, x1, y2, x2;
            cin >> y1 >> x1 >> y2 >> x2;
            if (y1 - y2 == x1 - x2) {
                if (y1 < y2) {
                    cout << y1 << ' ' << x1 << '\n';
                } else {
                    cout << y2 << ' ' << x2 << '\n';
                }
            } else {
                y1 -= x1;
                y2 -= x2;
                x1 = 0, x2 = 0;
                if (y1 < y2) {
                    cout << y1 << ' ' << x1 << '\n';
                } else {
                    cout << y2 << ' ' << x2 << '\n';
                }
            }
        }
    } else {
        int k;
        for (int i = 0; i < n; i++) {
            if (a[i] != i) {
                k = i;
                break;
            }
        }
        int q;
        cin >> q;
        while (q--) {
            int y1, x1, y2, x2;
            cin >> y1 >> x1 >> y2 >> x2;
            bool first_ok = is_subtree(0, k, x1, y1);
            bool second_ok = is_subtree(0, k, x2, y2);
            if (first_ok and second_ok) {
                if (x1 == x2) {
                    cout << min(y1, y2) << ' ' << x1 << '\n';
                    continue;
                } else {
                    int left, right, medium;
                    left = 0, right = n + 1;
                    while (right - left > 1) {
                        medium = (left + right) / 2;
                        if (y1 - medium < 0) right = medium;
                        else if (!is_subtree(0, k, x1, y1 - medium)) right = medium;
                        else left = medium;
                    }
                    y1 -= left;
                    left = 0, right = n + 1;
                    while (right - left > 1) {
                        medium = (left + right) / 2;
                        if (y2 - medium < 0) right = medium;
                        else if (!is_subtree(0, k, x2, y2 - medium)) right = medium;
                        else left = medium;
                    }
                    y2 -= left;
                    if (y1 < y2) {
                        cout << y1 << ' ' << x1 << '\n';
                    } else {
                        cout << y2 << ' ' << x2 << '\n';
                    }
                }
            } else if (first_ok != second_ok) {
                if (!first_ok) {
                    swap(x1, x2);
                    swap(y1, y2);
                }
                y2 -= x2;
                x2 = 0;
                cout << y2 << ' ' << x2 << '\n';
            } else {
                if (y1 - y2 == x1 - x2) {
                    if (y1 < y2) {
                        cout << y1 << ' ' << x1 << '\n';
                    } else {
                        cout << y2 << ' ' << x2 << '\n';
                    }
                } else {
                    y1 -= x1;
                    y2 -= x2;
                    x1 = 0, x2 = 0;
                    if (y1 < y2) {
                        cout << y1 << ' ' << x1 << '\n';
                    } else {
                        cout << y2 << ' ' << x2 << '\n';
                    }
                }
            }
        }
    }
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    int tests = 1;
    //  cin >> tests;
    while (tests--) {
        solve();
    }
}

