#include <bits/stdc++.h>
//#define int int64_t
const int PASSIVE = 1e9;
struct node {
    int val = PASSIVE, mod = 0;
    node *left = nullptr, *right = nullptr;
    node() {}
    node(int vl, int vr) {
        if (vr - vl == 1)
            return;
        left = new node(vl, (vl + vr) >> 1);
        right = new node((vl + vr) >> 1, vr);
    }
    void push() {
        val += mod;
        if (left) {
            left->mod += mod;
            right->mod += mod;
        }
        mod = 0;
    }
    void pull() {
        if (left) {
            push();
            left->push();
            right->push();
            val = std::min(left->val, right->val);
        }
    }
    int get(int vl, int vr, int ql, int qr) {
        assert(ql < qr);
        push();
        if (vl == ql && vr == qr) {
            pull(); //-
            return val;
        }
        int vm = ((vl + vr) >> 1), ret = 0;
        if (qr <= vm)
            ret = left->get(vl, vm, ql, qr);
        else if (ql >= vm)
            ret = right->get(vm, vr, ql, qr);
        else
            ret = std::min(left->get(vl, vm, ql, vm), right->get(vm, vr, vm, qr));
        pull();
        return ret;
    }
    void change(int vl, int vr, int ql, int qr, int x) {
        assert(ql < qr);
        push();
        if (vl == ql && vr == qr) {
            mod += x;
            push();
            return;
        }
        int vm = ((vl + vr) >> 1);
        if (qr <= vm)
            left->change(vl, vm, ql, qr, x);
        else if (ql >= vm)
            right->change(vm, vr, ql, qr, x);
        else
            left->change(vl, vm, ql, vm, x), right->change(vm, vr, vm, qr, x);
        pull();
    }
};
void solve() {
    int n;
    std::cin >> n;
    std::vector<int> p(n, -1);
    std::vector<std::vector<int>> sons(n);
    for (int i = 1; i < n; ++i) {
        std::cin >> p[i], --p[i];
        sons[p[i]].emplace_back(i);
    }
    std::vector<int> c(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> c[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> l[i] >> r[i];
    }

    //////////////////////////////////////
    std::vector<int> sz(n);
    auto dfssz = [&] (auto &&dfssz, int ver) -> int {
        sz[ver] = 1;
        for (auto &to : sons[ver])
            sz[ver] += dfssz(dfssz, to);
        return sz[ver];
    };
    dfssz(dfssz, 0);
    std::vector<int> et, etpos(n), head(n);
    auto hldfs = [&] (auto &&hldfs, int ver, int curhead) -> void {
        etpos[ver] = et.size();
        et.emplace_back(ver);
        head[ver] = curhead;
        if (!sons[ver].empty()) {
            for (auto &to : sons[ver])
                if (sz[to] > sz[sons[ver][0]])
                    std::swap(sz[to], sons[ver][0]);
            for (auto &to : sons[ver]) {
                if (to == sons[ver][0])
                    hldfs(hldfs, sons[ver][0], curhead);
                else
                    hldfs(hldfs, to, to);
            }
        }
    };
    hldfs(hldfs, 0, 0);
    ///////////////////////
    node *lefts_tree = new node(0, n);
    std::vector<std::set<std::pair<int, int>>> queues(n);
    int is_bad = false;
    std::vector<int64_t> already(n), Ben(n);
    auto dfs = [&] (auto &&dfs, int ver) -> std::pair<int64_t, int64_t> { // NOLINT(misc-no-recursion)
        int64_t bought = 0, sum_cost = 0;
        queues[ver] = {{c[ver], ver}};
        for (auto &to : sons[ver]) {
            auto Leon = dfs(dfs, to);
            bought += Leon.first;
            sum_cost += Leon.second;
            if (queues[to].size() > queues[ver].size()) {
                queues[to].swap(queues[ver]);
            }
            for (auto &kek : queues[to])
                queues[ver].emplace(kek);
            queues[to] = {};
        }
        if (bought > r[ver])
            is_bad = true;
        lefts_tree->change(0, n, etpos[ver], etpos[ver] + 1, r[ver] - bought - PASSIVE); // ? bought ?
        while (bought < l[ver] && !queues[ver].empty()) {
            int ch_ver = queues[ver].begin()->second;
            int64_t hm_can = 1e9 + 9; // remember l[ver] - bought
            while (head[ch_ver] != head[ver]) {
                hm_can = std::min(hm_can, (int64_t)lefts_tree->get(0, n, etpos[head[ch_ver]], etpos[ch_ver] + 1));
                ch_ver = p[head[ch_ver]];
            }
            hm_can = std::min(hm_can, (int64_t)lefts_tree->get(0, n, etpos[ver], etpos[ch_ver] + 1));
            int _hm_can_cp = hm_can;
            hm_can = std::min(hm_can, l[ver] - bought);
            bought += hm_can;
            sum_cost += hm_can * queues[ver].begin()->first;
            ch_ver = queues[ver].begin()->second;
            Ben[ch_ver] += hm_can;
            while (head[ch_ver] != head[ver]) {
                lefts_tree->change(0, n, etpos[head[ch_ver]], etpos[ch_ver] + 1, -hm_can);
//                hm_can = std::min(hm_can, (int64_t)lefts_tree->get(0, n, etpos[head[ch_ver]], etpos[ch_ver]));
                ch_ver = p[head[ch_ver]];
            }
            lefts_tree->change(0, n, etpos[ver], etpos[ch_ver] + 1, -hm_can);
            if (hm_can == _hm_can_cp)
                queues[ver].erase(queues[ver].begin());
        }
        if (bought < l[ver])
            is_bad = true;
        already[ver] = bought;
        return std::pair{bought, sum_cost};
    };
    auto Nita = dfs(dfs, 0);
    if (is_bad)
        std::cout << "-1\n";
    else {
        std::cout << Nita.second << "\n";
        for (auto &x : Ben)
            std::cout << x << " ";
        std::cout << "\n";
    }
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int tests_num = 1;
    std::cin >> tests_num;
    while (tests_num--) {
        solve();
    }
    return 0;
}
