#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
//using ordered = tree<int, null_type, rb_tree_tag, null_node_update<>>;

struct fenwick {
    int n;
    std::vector<int64_t> t;
    fenwick() {}
    fenwick(int n) : n(n) {
        t.assign(n + 1, 0);
    }
    void add(int pos, int x) {
        for (; pos <= n; pos += pos & -pos)
            t[pos] += x;
    }
    int64_t get(int pos) {
        int64_t res = 0;
        for (; pos > 0; pos -= pos & -pos)
            res += t[pos];
        return res;
    }
};
signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    for (auto &x : a)
        std::cin >> x, --x;
    std::vector<int> where(n);
    fenwick mvtree(n);
    for (int i = 0; i < n; ++i)
        mvtree.add(i + 1, 1);
    for (int i = 0; i < n; ++i) {
        where[a[i]] = mvtree.get(a[i]);
        mvtree.add(a[i] + 1, -1);
    }
    int q;
    std::cin >> q;
    std::map<int, std::set<int>> que;
    for (int i = 0; i <= n; ++i)
        que[i] = std::set<int>{};
    std::vector<std::pair<int, int>> ans(q);
    std::vector<std::vector<std::pair<int, int>>> adds(n + 1);
    for (int q_ind = 0; q_ind < q; ++q_ind) {
        int r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        if (r1 == r2 && c1 == c2) {
            ans[q_ind] = std::pair{r1, c1};
        } else {
            adds[r1].emplace_back(c1, q_ind);
            adds[r2].emplace_back(c2, q_ind);
        }
    }
    fenwick post(n + 1);
    for (int i = 0; i <= n; ++i) {
        post.add(i + 1, 1);
    }
    for (int i = n; i >= 0; --i) {
        for (auto &[pos, ind] : adds[i]) {
            int left = 0, right = n + 1;
            while (right - left > 1) {
                int x = (left + right) >> 1;
                if (post.get(x) > pos)
                    right = x;
                else
                    left = x;
            }
            auto it = que.lower_bound(left);
//            for (int _ = 0; _ < pos; ++_)
//                ++it;
            if (it->second.count(ind)) {
                ans[ind] = {i, pos};
            } else {
                it->second.emplace(ind);
            }
        }
        if (i > 0) {
            int left = 0, right = n + 1;
            while (right - left > 1) {
                int x = (left + right) >> 1;
                if (post.get(x) > where[i - 1])
                    right = x;
                else
                    left = x;
            }
            auto it = que.lower_bound(left);
//            for (int _ = 0; _ < where[i - 1]; ++_) {
//                ++it;
//            }
            auto it1 = it, it2 = std::next(it);
            if (it1->second.size() < it2->second.size())
                std::swap(it1, it2);
            for (auto &ind : it2->second) {
                if (it1->second.count(ind)) {
                    ans[ind] = {i - 1, where[i - 1]};
                } else {
                    it1->second.emplace(ind);
                }
            }
            post.add(it2->first + 1, -1);
            que.erase(it2);
        }
    }
    for (auto &[r, c] : ans)
        std::cout << r << " " << c << "\n";
    return 0;
}
