#pragma GCC optimize("Ofast,fast-math,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

//const int MAX_MEM = 5e8;
//char MEM[MAX_MEM];
//int CUR_MEM = 0;
//void* operator new(size_t x) {
//    auto ret = MEM + CUR_MEM;
//    CUR_MEM += x;
//    return ret;
//}
//void operator delete(void*);
uint64_t hsh(uint64_t x) {
    return (uint64_t)x * x * 234892 + x * 327263 + 328912084; 
}
struct mmap {
    std::vector<std::vector<std::pair<int, int>>> tabl;
    std::vector<int> everything;
    int sz = 0;
    mmap() : tabl(5) {}
    void rehash() {
        std::vector<std::vector<std::pair<int, int>>> ntabl(tabl.size() * 1.5 + 3);
        for (auto xs : tabl) {
            for (auto &[x, cnt] : xs) {
                auto h = hsh(x);
                h %= ntabl.size();
                int added = false;
                for (auto &[xx, y] : ntabl[h]) {
                    if (xx == x) {
                        y += cnt;
                        added = true;
                        break;
                    }
                }
                if (!added) {
                    ntabl[h].emplace_back(x, cnt);
                }
            }
        }
        tabl = ntabl;
    }
    int& operator[](int x) {
        auto h = hsh(x);
        h %= tabl.size();
        if (tabl[h].size() > 5) {
            rehash();
        }
        h = hsh(x);
        h %= tabl.size();
        for (auto &[xx, y] : tabl[h]) {
            if (xx == x)
                return y;
        }
        ++sz;
        everything.emplace_back(x);
        tabl[h].emplace_back(x, 0);
        return tabl[h].back().second;
    }
    int size() {
        return sz;
    }
};

struct fenwick {
    int n;
    std::vector<int> t;
    fenwick() {}
    fenwick(int n) : n(n) {
        t.assign(n + 1, 0);
    }
    void add(int pos, int x) {
        for (; pos <= n; pos += pos & -pos)
            t[pos] += x;
    }
    int get(int pos) {
        int res = 0;
        for (; pos > 0; pos -= pos & -pos)
            res += t[pos];
        return res;
    }
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    for (auto &x : a)
        std::cin >> x, --x;
    std::vector<int> where(n);
    fenwick mvtree(n);
    for (int i = 0; i < n; ++i)
        mvtree.add(i + 1, 1);
    for (int i = 0; i < n; ++i) {
        where[a[i]] = mvtree.get(a[i]);
        mvtree.add(a[i] + 1, -1);
    }
    int q;
    std::cin >> q;
    std::map<int, mmap> que;
    for (int i = 0; i <= n; ++i)
        que[i] = mmap{};
    std::vector<std::pair<int, int>> ans(q);
    std::vector<std::vector<std::pair<int, int>>> adds(n + 1);
    for (int q_ind = 0; q_ind < q; ++q_ind) {
        int r1, c1, r2, c2;
        std::cin >> r1 >> c1 >> r2 >> c2;
        if (r1 == r2 && c1 == c2) {
            ans[q_ind] = std::pair{r1, c1};
        } else {
            adds[r1].emplace_back(c1, q_ind);
            adds[r2].emplace_back(c2, q_ind);
        }
    }
    fenwick post(n + 1);
    for (int i = 0; i <= n; ++i) {
        post.add(i + 1, 1);
    }
    for (int i = n; i >= 0; --i) {
        for (auto &[pos, ind] : adds[i]) {
            int left = 0, right = n + 1;
            int posit = 0;
            int cur = 0;
            for (int k = 19; k >= 0; --k) {
                if (posit + (1 << k) <= n + 1) {
                    if (cur + post.t[posit + (1 << k)] <= pos) {
                        cur += post.t[posit + (1 << k)];
                        posit += 1 << k;
                    }
                }
            }
//            while (right - left > 1) {
//                int x = (left + right) >> 1;
//                if (post.get(x) >= pos)
//                    right = x;
//                else
//                    left = x;
//            }
            left = posit;
            auto it = que.lower_bound(left);
//            for (int _ = 0; _ < pos; ++_)
//                ++it;
            if (it->second[(ind)]) {
                ans[ind] = {i, pos};
            } else {
                it->second[ind]++;
            }
        }
        if (i > 0) {
            int left = 0, right = n + 1;

            int posit = 0;
            int cur = 0;
            for (int k = 19; k >= 0; --k) {
                if (posit + (1 << k) <= n + 1) {
                    if (cur + post.t[posit + (1 << k)] <= where[i - 1]) {
                        cur += post.t[posit + (1 << k)];
                        posit += 1 << k;
                    }
                }
            }
            left = posit;
//            while (right - left > 1) {
//                int x = (left + right) >> 1;
//                if (post.get(x) > where[i - 1])
//                    right = x;
//                else
//                    left = x;
//            }
            auto it = que.lower_bound(left);
//            for (int _ = 0; _ < where[i - 1]; ++_) {
//                ++it;
//            }
            auto it1 = it, it2 = std::next(it);
            if (it1->second.size() < it2->second.size())
                std::swap(it1, it2);
            for (auto &ind : it2->second.everything) {
                if (it1->second[(ind)]) {
                    ans[ind] = {i - 1, where[i - 1]};
                } else {
                    it1->second[(ind)]++;
                }
            }
            post.add(it2->first + 1, -1);
            que.erase(it2);
        }
    }
    for (auto &[r, c] : ans)
        std::cout << r << " " << c << "\n";
    return 0;
}
