#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

mt19937 rnd(1337);

int randint(int L, int R) {
    return L + rnd()% (R - L + 1);
}

const int N = 1e5 + 5;
const int inf = 1e9 + 7;

int n, from[N];
vector<int> g[N];
int c[N];
pii a[N];

int max_depth[N], order[N], ptr, pos[N], spos[N], col[N], color;
int buy[N], answ[N];
int64 dp[N];
set<pii> rem[N];

int tree[4 * N], add[4 * N];

void clear_all() {
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
        buy[i] = 0;
        answ[i] = 0;
        dp[i] = 0;
        rem[i].clear();
        max_depth[i] = 0;
        order[i] = 0;
        pos[i] = 0;
        spos[i] = 0;
        col[i] = 0;
    }
    fill(tree, tree + 4 * n, 0);
    fill(add, add + 4 * n, 0);
    ptr = 0;
    color = 1;
}

void gen() {
    n = 100000;
    clear_all();
    for (int i = 2; i <= n; ++i) {
        from[i] = randint(1, i - 1);
        g[from[i]].emplace_back(i);
    }
    for (int i = 1; i <= n; ++i) c[i] = randint(1, 1000000000);
    for (int i = 1; i <= n; ++i) {
        a[i].fi = 1;
        a[i].se = 1000000000;
    }
}

void read() {
    cin >> n;
    clear_all();
    for (int i = 2; i <= n; ++i) {
        cin >> from[i];
        g[from[i]].emplace_back(i);
    }
    for (int i = 1; i <= n; ++i) cin >> c[i];
    for (int i = 1; i <= n; ++i) cin >> a[i].fi >> a[i].se;
}

void upd(int v, int delta) {
    tree[v] += delta;
    add[v] += delta;
}

void push(int v) {
    upd(v * 2 + 1, add[v]);
    upd(v * 2 + 2, add[v]);
    add[v] = 0;
}

void update(int v, int tl, int tr, int L, int R, int delta) {
    if (tl >= R || L >= tr) return;
    if (L <= tl && tr <= R) {
        upd(v, delta);
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    update(v * 2 + 1, tl, tm, L, R, delta);
    update(v * 2 + 2, tm, tr, L, R, delta);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

void update(int L, int R, int delta) {
    update(0, 0, n, L, R + 1, delta);
}

int get_min(int v, int tl, int tr, int L, int R) {
    if (tl >= R || L >= tr) return inf;
    if (L <= tl && tr <= R) return tree[v];
    push(v);
    int tm = (tl + tr) / 2;
    return min(get_min(v * 2 + 1, tl, tm, L, R), get_min(v * 2 + 2, tm, tr, L, R));
}

int get_min(int L, int R) {
    return get_min(0, 0, n, L, R + 1);
}

void build_hld(int v, int s) {
    col[v] = color;
    spos[v] = s;
    pos[v] = ptr;
    order[ptr++] = v;
    pii max_son = mp(0, 0);
    for (int u : g[v]) if (u != from[v]) {
        max_son = max(max_son, mp(max_depth[u], u));
    }
    if (max_son == mp(0, 0)) return;
    build_hld(max_son.se, s);
    for (int u : g[v]) if (u != from[v] && u != max_son.se) {
        color++;
        build_hld(u, ptr);
    }
}

bool dfs_precalc(int v) {
    max_depth[v] = 1;
    for (int u : g[v]) if (u != from[v]) {
        if (!dfs_precalc(u)) return false;
        buy[v] += buy[u];
        max_depth[v] = max(max_depth[v], max_depth[u] + 1);
    }
    buy[v] = max(buy[v], a[v].fi);
    return buy[v] <= a[v].se;
}

int get_min_up(int v, int up) {
    int res = inf;
    while (col[v] != col[up]) {
        int L = spos[v], R = pos[v];
        res = min(res, get_min(L, R));
        v = from[order[L]];
    }
    int L = pos[up] + 1, R = pos[v];
    if (L <= R) res = min(res, get_min(L, R));
    return res;
}

void update_up(int v, int up, int delta) {
    while (col[v] != col[up]) {
        int L = spos[v], R = pos[v];
        update(L, R, delta);
        v = from[order[L]];
    }
    int L = pos[up] + 1, R = pos[v];
    if (L <= R) update(L, R, delta);
}

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        tree[v] = a[order[tl]].se - buy[order[tl]];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
    tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int can_buy(int v, int up, int can_buy) {
    can_buy = min(can_buy, get_min_up(v, up));
    update_up(v, up, -can_buy);
    return can_buy;
}

void dfs_answer(int v) {
    int sum = 0;
    pii max_son = mp(0, 0);
    for (int u : g[v]) if (u != from[v]) {
        dfs_answer(u);
        sum += buy[u];
        dp[v] += dp[u];
        max_son = max(max_son, mp(sz(rem[u]), u));
    }
    if (max_son == mp(0, 0)) {
        answ[v] = buy[v];
        dp[v] = (int64) c[v] * answ[v];
        if (a[v].se - answ[v] > 0) rem[v].emplace(c[v], v);
        return;
    }
    rem[v].swap(rem[max_son.se]);
    for (int u : g[v]) if (u != from[v] && u != max_son.se) {
        for (auto &key : rem[u]) {
            rem[v].emplace(key);
        }
    }
    if (a[v].se > 0) rem[v].emplace(c[v], v);
    while (sum < buy[v]) {
        auto min_cost = *rem[v].begin();
        rem[v].erase(rem[v].begin());
        int curr_buy = can_buy(min_cost.se, v, buy[v] - sum);
        dp[v] += (int64) curr_buy * min_cost.fi;
        answ[min_cost.se] += curr_buy;
        sum += curr_buy;
        if (curr_buy) rem[v].emplace(min_cost);
    }
}

void solve() {
    if (!dfs_precalc(1)) {
        cout << "-1\n";
        return;
    }
    build_hld(1, 0);
    build(0, 0, n);
    dfs_answer(1);
    cout << dp[1] << "\n";
    for (int i = 1; i <= n; ++i) cout << answ[i] << " ";
    cout << "\n";
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        read();
        solve();
    }
    return 0;
}