#include<bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long int64;
typedef long double float64;
typedef pair<int, int> pii;

const int N = 3e3 + 5, Q = 3e3 + 5;

int n, a[N];
int q;
pii A[Q], B[Q], C[Q];

void read() {
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        cin >> A[i].x >> A[i].y >> B[i].x >> B[i].y;
    }
}

int col[N];
vector<int> g[N * N];

int get_sum(int k) {
    return k * (k + 1) / 2;
}

int get_id(int i, int j) {
    return get_sum(i) + j;
}

void update_tree(int srow) {
    for (int row = srow; row <= n; ++row) {
        int prev_id = get_id(row - 1, col[row - 1]),
            curr_id = get_id(row, col[row]);
        g[prev_id].emplace_back(curr_id);
    }
}

int tin[N * N], tout[N * N], timer = 0, from[N * N];

void dfs(int v, int p = 0) {
    tin[v] = timer++;
    from[v] = p;
    for (int u : g[v]) {
        dfs(u, v);
    }
    tout[v] = timer++;
}

bool is_anc(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int get_lca(int v, int u) {
    while (!is_anc(v, u)) v = from[v];
    return v;
}

pii by_id[N * N];

void solve() {
    for (int id = 0; id <= get_id(n, n); ++id) {
        g[id].clear();
    }
    for (int r = 0; r <= n; ++r) {
        for (int c = 0; c <= r; ++c) {
            by_id[get_id(r, c)] = mp(r, c);
        }
    }
    for (int row = 0; row <= n; ++row) {
        col[row] = row;
    }
    update_tree(1);
    for (int i = 1; i <= n; ++i) {
        for (int row = a[i]; row <= n; ++row) {
            --col[row];
        }
        update_tree(a[i]);
    }
    dfs(0);
    for (int i = 1; i <= q; ++i) {
        int idA = get_id(A[i].x, A[i].y);
        int idB = get_id(B[i].x, B[i].y);
        int idC = get_lca(idA, idB);
        C[i] = by_id[idC];
    }
}

void write() {
    for (int i = 1; i <= q; ++i) {
        cout << C[i].x << " " << C[i].y << "\n";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    write();
    return 0;
}