#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

//#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
const int N = 1 << 19;

int a[N];
int n;

struct tr {
	struct Node {
		int s;
		Node* pl;
		Node* pr;
		Node() {
			s = 0;
			pl = nullptr;
			pr = nullptr;
		}
		Node(int s): s(s) {
			pl = nullptr;
			pr = nullptr;
		}
		Node(Node* p1, Node* p2) {
			pl = p1;
			pr = p2;
			s = 0;
		}
		Node(Node* p1, Node* p2, int s): s(s) {
			pl = p1;
			pr = p2;
		}
	};
	vector<Node*> root;
	int ask(Node* v, int l, int r, int pos) {
		int ans = 0;
		while (true) {
			if (!v) return ans;
			ans += v->s;
			int m = (l + r) >> 1;
			if (pos < m) {
				r = m;
				v = v->pl;
			}
			else {
				l = m;
				v = v->pr;
			}
		}
	}
	Node* update(Node* v, int l, int r, int ql, int qr, int d) {
		if (r <= ql || qr <= l) return v;
		if (ql <= l && r <= qr) {
			return new Node(v->pl, v->pr, v->s + d);
		}
		int m = (l + r) >> 1;
		return new Node(update(v->pl, l, m, ql, qr, d), update(v->pr, m, r, ql, qr, d), v->s);
	}
	void build(Node* v, int l, int r) {
		if (r - l == 1) return;
		int m = (l + r) >> 1;
		v->pl = new Node();
		build(v->pl, l, m);
		v->pr = new Node();
		build(v->pr, m, r);
	}
	tr() {
		root.push_back(new Node());
	}
};

tr t1;

int tree[N * 2];

void build(int v, int l, int r) {
	if (r - l == 1) {
		tree[v] = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(v * 2, l, m);
	build(v * 2 + 1, m, r);
	tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

int ask(int v, int l, int r, int ql, int qr) {
	if (qr <= l || r <= ql) return 1e9;
	if (ql <= l && r <= qr) return tree[v];
	int m = (l + r) / 2;
	return min(ask(v * 2, l, m, ql, qr), ask(v * 2 + 1, m, r, ql, qr));
}

int findPath(int y, int x) {
	int l = -1;
	int r = n + 1;
	while (r - l > 1) {
		int m = (l + r) >> 1;
		int s = t1.ask(t1.root[m], 0, n, x + y - 1);
		if (s >= x) {
			r = m;
		}
		else {
			l = m;
		}
	}
	return r;
}

void solve() {
	cin >> n;
	t1.build(t1.root[0], 0, n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		t1.root.push_back(t1.update(t1.root.back(), 0, n, a[i], n, 1));
	}
	build(1, 0, n);
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int r1, c1, r2, c2;
		cin >> r1 >> c1 >> r2 >> c2;
		int x1 = r1 - c1;
		int y1 = c1;
		int x2 = r2 - c2;
		int y2 = c2;
		int p1 = findPath(y1, x1);
		int p2 = findPath(y2, x2);
		if (p1 > p2) {
			swap(p1, p2);
			swap(x1, x2);
			swap(y1, y2);
			swap(r1, r2);
			swap(c1, c2);
		}
		if (p1 == p2) {
			pi ans = min(make_pair(y1, x1), make_pair(y2, x2));
			cout << ans.first + ans.second << " " << ans.first << "\n";
		}
		else {
			int mn = ask(1, 0, n, p1, p2);
			int x = t1.ask(t1.root[p1], 0, n, mn);
			int y = mn - x;
			pi now = make_pair(y, x);
			pi ans = min(min(make_pair(y1, x1), make_pair(y2, x2)), now);
			cout << ans.first + ans.second << " " << ans.first << "\n";
		}
	}
}

signed main() {
	int t = 1;
	while (t--) {
		solve();
	}
}