#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <set>
#include <cstdlib>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll cst = 5e5 + 5;
const ll inf = (ll)1e18 + 228;

void operator delete(void*);

void ex(ll ec = 0) {
	cout.flush();
	exit(ec);
}

ll n;

ll a[cst];

ll q;

ll sp[20][cst];

ll mlg[cst];

vector<ll> st[4 * cst];

void build(ll v, ll tl, ll tr) {
	if (tl == tr - 1) {
		st[v].push_back(a[tl]);
		return;
	}
	ll tm((tl + tr) >> 1);
	build(2 * v, tl, tm);
	build(2 * v + 1, tm, tr);
	merge(all(st[2 * v]), all(st[2 * v + 1]), back_inserter(st[v]));
}

ll gl(ll v, ll tl, ll tr, ll l, ll r, ll x) {
	if (l >= r) return 0;
	if (l == tl && r == tr) {
		return lower_bound(all(st[v]), x) - st[v].begin();
	}
	ll tm((tl + tr) >> 1);
	ll g1 = gl(2 * v, tl, tm, l, min(r, tm), x);
	ll g2 = gl(2 * v + 1, tm, tr, max(l, tm), r, x);
	return g1 + g2;
}


ll getMin(ll l, ll r) {
	ll len = r - l + 1;
	ll lgl = mlg[len];
	return min(sp[lgl][l], sp[lgl][r - (1ll << lgl) + 1]);
}

ll getLess(ll l, ll r, ll x) {
	return gl(1, 1, n + 1, l, r + 1, x);
}

ll getP(ll x, ll y) {
	ll l = -1, r = n;
	while (r - l > 1) {
		ll m((l + r) >> 1);
		if (getLess(1, m, x) >= x - y) r = m;
		else l = m;
	}
	return r;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	mlg[1] = 0;
	for (ll i = 2; i < cst; i++) {
		mlg[i] = mlg[i - 1];
		if ((1ll << mlg[i]) * 2 == i) mlg[i]++;
	}
	cin >> n;
	for (ll i = 1; i <= n; i++) cin >> a[i];
	for (ll i = 1; i <= n; i++) {
		sp[0][i] = a[i];
	}
	for (ll lg = 1; lg < 20; lg++) {
		for (ll i = 1; i <= n - (1ll << lg) + 1; i++) {
			sp[lg][i] = min(sp[lg - 1][i], sp[lg - 1][i + (1ll << (lg - 1))]);
		}
	}
	build(1, 1, n + 1);
	cin >> q;
	while (q--) {
		ll a, b;
		ll c, d;
		cin >> a >> b >> c >> d;
		ll p1 = getP(a, b);
		ll p2 = getP(c, d);
		if (p1 == p2) {
			if (a > c) cout << a << " b" << endl;
			else cout << c << " " << d << endl;
			continue;
		}
		if (p1 > p2) swap(p1, p2); 
		ll mn = getMin(p1 + 1, p2);
		ll ax = mn - 1;
		ll ay = ax - getLess(1, p1, mn);
		cout << ax << " " << ay << endl;
	}
	ex();
}