#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fmi,bmi2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

#define endl '\n'
#define all(arr) arr.begin(), arr.end()
#define int long long
#define out(x) cout << (x) << endl, exit(0)

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef pair<int, int> ipair;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXN = 5050;
const int MAXK = MAXN << 1;
const int INF = 1e17;

struct node {
	node *left = nullptr, *right = nullptr;
	ipair min {INF, INF};
	bool prom = false;
};

int n, k;
vector<int> gr[MAXN];
int par[MAXN], arr[MAXN], lrr[MAXN], rrr[MAXN], cnt[MAXN], dp[MAXN], eul[MAXK], tin[MAXN], tout[MAXN];
node mem[MAXK << 1];
node *root, *mpos;

inline void push(node *v, int l, int r) {
	if (!v -> prom) return;
	v -> min = {INF, INF};
	if (r - l > 1) {
		v -> left -> prom = v -> prom;
		v -> right -> prom = v -> prom;
	}
	v -> prom = false;
}

inline void relax(node *v) {
	v -> min = min(v -> left -> min, v -> right -> min);
}

void build(node* &v, int l, int r) {
	if (v == nullptr) v = mpos++;
	v -> prom = false;
	if (r - l == 1) {
		v -> min = {arr[eul[l]], eul[l]};
		return;
	}
	int mid = (l + r) >> 1;
	build(v -> left, l, mid);
	build(v -> right, mid, r);
	relax(v);
}

void setquery(node *v, int l, int r, int ql, int qr) {
	push(v, l, r);
	if (qr <= l || r <= ql) return;
	if (ql <= l && r <= qr) {
		v -> prom = true;
		push(v, l, r);
		return;
	}
	int mid = (l + r) >> 1;
	setquery(v -> left, l, mid, ql, qr);
	setquery(v -> right, mid, r, ql, qr);
	relax(v);
}

ipair query(node *v, int l, int r, int ql, int qr) {
	push(v, l, r);
	if (qr <= l || r <= ql) return {INF, INF};
	if (ql <= l && r <= qr) return v -> min;
	int mid = (l + r) >> 1;
	auto lval = query(v -> left, l, mid, ql, qr);
	auto rval = query(v -> right, mid, r, ql, qr);
	return min(lval, rval);
}

void dfseul(int v) {
	eul[k] = v;
	tin[v] = k++;
	for (int u: gr[v])
		dfseul(u);
	eul[k] = v;
	tout[v] = k++;
}

void dfspar(int v, int stop) {
	if (++dp[v] == rrr[v])
		setquery(root, 0, k, tin[v], tout[v] + 1);
	if (v == stop) return;
	dfspar(par[v], stop);
}

void build() {
	k = 0;
	root = nullptr;
	mpos = mem;
	memset(cnt, 0, n * sizeof(int));
	memset(dp, 0, n * sizeof(int));
	for (int v = 0; v < n; ++v)
		gr[v].clear();
	for (int v = 1; v < n; ++v)
		gr[par[v]].push_back(v);
	dfseul(0);
	build(root, 0, k);
}

int dfs(int v) {
	int ans = 0;
	for (int u: gr[v]) {
		int ansu = dfs(u);
		if (ansu == -1) return -1;
		dp[v] += dp[u];
		ans += ansu;
	}
	if (dp[v] > rrr[v]) return -1;
	while (dp[v] < lrr[v]) {
		auto [mi, id] = query(root, 0, k, tin[v], tout[v] + 1);
		if (mi == INF) return -1;
		++cnt[id];
		dfspar(id, v);
		ans += mi;
	}
	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
	cout.setf(ios::fixed), cout.precision(10);
	int t; cin >> t;
	while (t--) {
		cin >> n;
		for (int v = 1; v < n; ++v)
			cin >> par[v], --par[v];
		for (int v = 0; v < n; ++v)
			cin >> arr[v];
		for (int v = 0; v < n; ++v)
			cin >> lrr[v] >> rrr[v];
		build();
		int ans = dfs(0);
		cout << ans << endl;
		if (ans == -1) continue;
		for (int v = 0; v < n; ++v)
			cout << cnt[v] << ' ';
		cout << endl;
	}
}