#include<bits/stdc++.h>

using namespace std;

#define int long long

mt19937 rnd(5757);
const int MAXN = 500000;
struct node{
	int y;
	int sz;
	int val;
	node* l;
	node* r;
	int pos_l;
	int pos_r;
	node() {
		y = rnd();
		sz = 1;
		val = 0;
		pos_r = 0;
		pos_l = 0;
		l = nullptr;
		r = nullptr;
	}
};

node* pull(node* T) {
	T->sz = 1;
	if (T->l != nullptr) {
		T->sz += T->l->sz;
	}
	if (T->r != nullptr) {
		T->sz += T->r->sz;
	}
	return T;
}

node* push(node* T) {
	return T;
}

node* merge(node* L, node* R) {
	if (L == nullptr) {
		return R;
	}
	if (R == nullptr) {
		return L;
	}
	L = push(L);
	R = push(R);

	if (L->y > R->y) {
		L->r = merge(L->r, R);
		return pull(L);
	} else {
		R->l = merge(L, R->l);
		return pull(R);
	}
}

pair<node*, node*> split_sz(node* T, int ind) {
	if (T == nullptr) {
		return make_pair(nullptr, nullptr);
	}
	int kek = 1;
	if (T->l != nullptr) {
		kek += T->l->sz;
	}
	T = push(T);
	if (kek > ind) {
		auto q = split_sz(T->l, ind);
		T->l = q.second;
		return make_pair(q.first, pull(T));
	} else {
		auto q = split_sz(T->r, ind - kek);
		T->r = q.first;
		return make_pair(pull(T), q.second);
	}
}

pair<node*, node*> split_val(node* T, int val) {
	if (T == nullptr) {
		return make_pair(nullptr, nullptr);
	}
	T = push(T);
	if (T->val >= val) {
		auto q = split_val(T->l, val);
		T->l = q.second;
		return make_pair(q.first, pull(T));
	} else {
		auto q = split_val(T->r, val);
		T->r = q.first;
		return make_pair(pull(T), q.second);
	}
}

void print(node* T) {
	if (T == nullptr) {
		return;
	}
	print(T->l);
	cout << T->val << " ";
	print(T->r);
}

void print1(node* T) {
	if (T == nullptr) {
		return;
	}
	print1(T->l);
	cout << T->pos_l << " " << T->pos_r << " | ";
	print1(T->r);
}

node* insert(node*T, int ind, int val) {
	auto kek = new node();
	kek->val = val;
	auto p = split_sz(T, ind);
	p.first = merge(p.first, kek);
	p.first = merge(p.first, p.second);
	return p.first;
}

node* insert_val(node*T, int ind, int val) {
	auto kek = new node();
	kek->val = val;
	auto p = split_val(T, ind);
	p.first = merge(p.first, kek);
	p.first = merge(p.first, p.second);
	return p.first;
}


//int l[4000][4000];
//int r[4000][4000];




int l3[MAXN];
int r3[MAXN];
int l4[MAXN];
int r4[MAXN];


void set_l(int val, int ind) {
	if (ind % 2) {
		l4[ind / 2] = val;
	} else {
		l3[ind / 2] = val;
	}
}

void set_r(int val, int ind) {
	if (ind % 2) {
		r4[ind / 2] = val;
	} else {
		r3[ind / 2] = val;
	}
}

vector<int> g[MAXN];

map<pair<int, int>, int> colour;
vector<pair<int, int>> obr(MAXN);


vector<pair<int, int>> get_ans(MAXN);

int up[200000][19];

int tin[200000];
int tout[200000];
int timer = 0;

void dfs(int v, int p) {
	tin[v] = timer++;
	up[v][0] = p;
	for (int i = 1; i < 19; i++) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto u: g[v]) {
		if (u == p) {
			continue;
		}
		//cout << v << "->" << u << endl;
		dfs(u, v);
	}
	tout[v] = timer++;
}

bool is_ancestor(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
	if (is_ancestor(a, b)) {
		return a;
	}
	if (is_ancestor(b, a)) {
		return b;
	}
	for (int l = 18; l >= 0; l--) {
		if (!is_ancestor(up[a][l], b)) {
			a = up[a][l];
		}
	}
	return up[a][0];
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> arr(n);
	vector<int> pos(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		arr[i]--;
		pos[arr[i]] = i;
	}
	vector<int> now(n);
	/*for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			l[i][j] = -1;
		}
	}
	set<pair<int, int>> kek;
	for (int _ = 0; _ <= n; _++) {
		int x = 0;
		int y = 0;
		for (int i = 0; i <= n; i++) {
			if (l[x][y] == -1) {
				l[x][y] = _;
			}
			r[x][y] = _;
			if (i != n) {
				if (now[i]) {
					x++;
				} else {
					x++;
					y++;
				}
			}
		}
		if (_ != n) {
			now[arr[_]] = 1;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			kek.insert(make_pair(l[i][j], r[i][j]));
		}
	}*/
	int q;
	cin >> q;
	vector<pair<pair<int, int>, pair<int, int>>> tasks;
	vector<pair<pair<int, int>, int>> need;
	for (int _ = 0; _ < q; _++) {
		int c1, rr1, c2, rr2;
		cin >> rr1 >> c1 >> rr2 >> c2;
		tasks.push_back(make_pair(make_pair(rr1, c1), make_pair(rr2, c2)));
		need.push_back(make_pair(make_pair(rr1, c1), _ * 2));
		need.push_back(make_pair(make_pair(rr2, c2), _ * 2 + 1));
		/*int l1 = l[rr1][c1];
		int r1 = r[rr1][c1];
		int l2 = l[rr2][c2];
		int r2 = r[rr2][c2];
		//cout << l1 << " " << r1 << "  " << l2 << " " << r2 << endl;
		if (r1 < l2 ||r2 < l1) {
			int x = 0;
			int y = 0;
			int L = min(r1, r2);
			int R = max(l1, l2);
			for (int i = 0; i < n; i++) {
				int l3 = l[x + 1][y + 1];
				int r3 = r[x + 1][y + 1];
				int l4 = l[x + 1][y];
				int r4 = r[x + 1][y];

				if (l3 <= L && r3 >= R) {
					x++;
					y++;
					continue;
				}
				if (l4 <= L && r4 >= R) {
					x++;
					continue;
				}
				break;
			}
			cout << x << " " << y << endl;
		} else {
			if (rr1 < rr2) {
				cout << rr1 << " " << c1 << endl;
			} else {
				cout << rr2 << " " << c2 << endl;
			}
		}*/
	}
	sort(need.begin(), need.end());
	node* T = nullptr;
	int ind = 0;
	for (int i = 0; i <= n; i++) {
		while (ind < need.size() && need[ind].first.first == i) {
			int rr = need[ind].first.first;
			int c = need[ind].first.second;
			int boba = need[ind].second;
			c = rr - c;
			{
				if (c == 0) {
					set_l(-1, boba);
				} else {
					auto p = split_sz(T, c - 1);
					auto q = split_sz(p.second, 1);
					if (q.first == nullptr) {
						//cout << "AM";
						set_l(-1, boba);
					} else {
						//cout << ": " << rr << " " << c << " " << q.first->val << endl;
						set_l(q.first->val, boba);
					}
					p.second = merge(q.first, q.second);
					T = merge(p.first, p.second);
				}
			}
			{
				auto p = split_sz(T, c + 0);
				auto q = split_sz(p.second, 1);
				if (q.first == nullptr) {
					set_r(n - 1, boba);
				} else {
					set_r(q.first->val - 1, boba);
				}
				p.second = merge(q.first, q.second);
				T = merge(p.first, p.second);
			}
			ind++;
		}
		if (i != n) {
			T = insert_val(T, pos[i], pos[i]);
		}
		//print(T);
		//cout << endl;

	}
	vector<int> gg(n);
	{
		T = nullptr;
		for (int i = 0; i < n; i++) {

			auto q = split_val(T, pos[i]);
			if (q.first == nullptr) {
				gg[i] = 0;
			} else {
				gg[i] = q.first->sz;
			}
			T = merge(q.first, q.second);

			T = insert_val(T, pos[i], pos[i]);
			//cout << gg[i] << " ";
		}
	}

	T = nullptr;

	int ooo = 0;
	for (int i = n; i >= 0; i--) {
		auto lol = new node();
		lol->pos_l = i;
		lol->pos_r = i;
		colour[make_pair(i, i)] = ooo;
		obr[ooo] = make_pair(i, i);
		get_ans[ooo] = make_pair(n, i);
		ooo++;
		T = merge(T, lol);
	}
	//cout << "STart";
	//cout << endl;
	//print1(T);
	//cout << endl;
	for (int i = n - 1; i >= 0; i--) {
		gg[i] = i - gg[i];
		auto p = split_sz(T, gg[i] + 1);
		auto q1 = split_sz(p.first, p.first->sz - 1);
		auto q2 = split_sz(p.second, 1);
		auto lol = new node();
		{
			int l5 = q1.second->pos_l;
			int r5 = q1.second->pos_r;
			int l6 = q2.first->pos_l;
			int r6 = q2.first->pos_r;
			lol->pos_l = l6;
			lol->pos_r = r5;
			colour[make_pair(l6, r5)] = ooo;
			obr[ooo] = make_pair(l6, r5);
			get_ans[ooo] = make_pair(i, gg[i]);
			g[ooo].push_back(colour[make_pair(l5, r5)]);
			g[ooo].push_back(colour[make_pair(l6, r6)]);
			ooo++;
			//cout << "add " << ooo - 1 << " " << colour[make_pair(l5, r5)] << "\n";

			//cout << "add " << ooo - 1 << " " << colour[make_pair(l6, r6)] << "\n";

		}
		T = merge(q1.first, lol);
		T = merge(T, q2.second);
		//print1(T);
		//cout << endl;
	}

	dfs(ooo - 1, ooo - 1);

	for (int i = 0; i < q; i++) {
		//cout << l3[i] + 1 << " " << r3[i] + 1 << " | " << l4[i] + 1 << " " << r4[i] + 1 << endl;
		if (r3[i] < l4[i] || r4[i] < l3[i]) {
			int v1 = colour[make_pair(l3[i] + 1, r3[i] + 1)];
			int v2 = colour[make_pair(l4[i] + 1, r4[i] + 1)];
			//cout << v1 << " " << v2 << endl;
			int ggg = lca(v1, v2);
			//cout << ggg << endl;
			cout << get_ans[ggg].first << " " << get_ans[ggg].second << endl;
		} else {
			int rr1 = tasks[i].first.first;
			int c1 = tasks[i].first.second;
			int rr2 = tasks[i].second.first;
			int c2 = tasks[i].second.second;
			if (rr1 < rr2) {
				cout << rr1 << " " << c1 << endl;
			} else {
				cout << rr2 << " " << c2 << endl;
			}
		}
	}
}