#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

vector<vector<int>> gr;
vector<int> cost;
vector<pair<int, int>> seg;
vector<int> ans, pr;
vector<set<pair<int, int>>> to_add;

vector<int> tin, tout, eul;
int tim = 0;

vector<int> fenw;

int ask(int r) {
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i+1)) - 1) {
        res += fenw[i];
    }
    return res;
}

int ask(int l, int r) {
    return ask(r) - (l == 0 ? 0 : ask(l-1));
}

void upd(int ind, int x) {
    for (int i = ind; i < fenw.size(); i = (i | (i+1))) {
        fenw[i] += x;
    }
}

void dfs0(int v) {
    eul.push_back(v);
    tin[v] = tim; tim++;
    for (int i : gr[v]) {
        dfs0(i);
    }
    tout[v] = tim-1;
}


void dfs(int v) {
    int mx = -1;
    for (int i : gr[v]) {
        dfs(i);
        if (mx == -1 || to_add[i].size() > to_add[mx].size()) {
            mx = i;
        }
    }
    if (mx != -1) {
        swap(to_add[v], to_add[mx]);
    }
    for (int i : gr[v]) {
        if (i != mx) {
            for (auto j : to_add[i]) {
                to_add[v].insert(j);
            }
        }
    }

    vector<pair<int, int>> sus;
    for (int i = tin[v]; i <= tout[v]; ++i) {
        sus.push_back({cost[eul[i]], eul[i]});
        //cout << cost[eul[i]] << ' ' << eul[i] << endl;
    }
    sort(all(sus));
    for (int k = 0; k < sus.size(); ++k) {
        int i = sus[k].se;
        //cout << i << endl;
        int ost = 1e18;//seg[i].se - ask(tin[i], tout[i]);
        for (int j = i; ; j = pr[j]) {
            ost = min(ost, seg[j].se - ask(tin[j], tout[j]));
            if (j == v) break;
        }
        if (seg[v].fi <= ask(tin[v], tout[v])) break;
        if (ost <= seg[v].fi - ask(tin[v], tout[v])) {
            ans[i] += ost;
            upd(tin[i], ost);
        } else {
            //out << ost << endl;
            ans[i] += seg[v].fi - ask(tin[v], tout[v]);
            upd(tin[i], seg[v].fi - ask(tin[v], tout[v]));
        }
    }
    /*
    to_add[v].insert({cost[v], v});
    int sum = ask(tin[v], tout[v]);
    while (sum < seg[v].fi && to_add[v].size()) {
        int i = to_add[v].begin()->se;
        int ost = 1e18;//seg[i].se - ask(tin[i], tout[i]);
        for (int j = i; ; j = pr[j]) {
            ost = min(ost, seg[j].se - ask(tin[j], tout[j]));
            if (j == v) break;
        }
        if (seg[v].fi - sum >= ost) {
            ans[i] += ost;
            upd(tin[i], ost);
            sum += ost;
            to_add[v].erase(to_add[v].begin());
        } else {
            ans[i] += seg[v].fi - sum;
            upd(tin[i], seg[v].fi - sum);
            sum = seg[v].fi;
            break;
        }
    }*/
}

void solve() {
    int n;
    cin >> n;
    eul.clear();
    to_add.assign(n, {});
    fenw.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    tim = 0;
    ans.assign(n, 0);
    gr.assign(n, {});
    cost.assign(n, 0);
    seg.assign(n, {});
    pr.assign(n, -1);
    for (int i = 0; i < n-1; ++i) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i+1);
        pr[i+1] = p;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].fi >> seg[i].se;
    }
    dfs0(0);
    dfs(0);
    int res = 0;
    for (int i = 0; i < n; ++i) {
        res += cost[i] * ans[i];
        if (ask(tin[i], tout[i]) < seg[i].fi || ask(tin[i], tout[i]) > seg[i].se) {
            cout << "-1\n";
            return;
        }
    }

    cout << res << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
}

/*
 * 1
5
1 1 2 2
5 4 3 2 1
9 15
4 5
0 4
2 3
1 2
 */

