#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <random>
#include <cassert>

using namespace std;

mt19937_64 rnd(12);
#define int int64_t
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

vector<vector<int>> gr;
vector<int> deep;
vector<int> eul, tin, tout;
int tim = 0;

void dfs(int v, int d) {
    tin[v] = tout[v] = eul.size();
    deep[v] = d;
    eul.push_back(v);
    for (int i : gr[v]) {
        dfs(i, d+1);
        tout[v] = eul.size();
        eul.push_back(v);
    }
}

vector<pair<int, int>> s;
void build(int l, int r, int v) {
    if (l == r-1) s[v] = {deep[eul[l]], eul[l]};
    else {
        int m = (l + r)/2;
        build(l, m, v+1);
        build(m, r, v+(m-l)*2);
        s[v] = min(s[v+1], s[v+(m-l)*2]);
    }
}

pair<int, int> ask(int l, int r, int lx, int rx, int v) {
    if (l >= rx || r <= lx) return {1e9, 1e9};
    if (l >= lx && r <= rx) return s[v];
    int m = (l + r) / 2;
    return min(ask(l, m, lx, rx, v+1), ask(m, r, lx, rx, v+(m-l)*2));
}

pair<int, int> ask(int l, int r) {
    return ask(0, eul.size(), l, r+1, 0);
}

int lca(int a, int b) {
    //cout << "sus " << endl;
    if (tin[a] > tin[b]) swap(a, b);
    //cout << a << ' ' << b << endl;
    //cout << tin[a] << ' ' << tout[b] << endl;
    return ask(tin[a], tout[b]).se;
}

void solve() {
    int n;
    cin >> n;
    int sz = (n+1) * (n+2) / 2;
    gr.assign(sz, {});
    tin.assign(sz, 0);
    tout.assign(sz, 0);
    deep.assign(sz, 0);
    s.assign(sz*4, {});
    vector<int> mas(n);
    for (int i = 0; i < n; ++i) {
        cin >> mas[i];
        mas[i]--;
    }
    vector<int> rt(n, 1);
    for (int i = 0; i < n+1; ++i) {
        int cur = 0;
        for (int j = 0; j < n; ++j) {
            if (!gr[cur].size() || gr[cur].back() != j+1 + cur + rt[j]) {
                gr[cur].push_back(j+1 + cur + rt[j]);
            }
            cur = j+1 + cur + rt[j];
        }
        if (i != n) rt[mas[i]] = 0;
    }
    dfs(0, 0);
    build(0, eul.size(), 0);

    int q;
    cin >> q;
    for (int t = 0; t < q; ++t) {
        int c1, r1, c2, r2;
        cin >> r1 >> c1 >> r2 >> c2;
        int u = r1 * (r1+1)/2 + c1;
        int v = r2 * (r2+1)/2 + c2;
        //cout << u << ' ' << v << endl;
        int lc = lca(u, v);
        int rr = lc - deep[lc] * (deep[lc] + 1) / 2;
        cout << deep[lc] << ' ' << rr << '\n';
    }
}

int32_t main() {
    //ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}

/*
 * 1
8
1 1 2 2 3 3 4
5 4 3 2 1 2 4 1
9 15
4 5
0 4
2 3
1 2
 2 4
 0 6
 1 2
 */

/*
 *
1
8
1 2 2 3 4 2 2
2 1 1 4 5 9 5 2
2 2
0 0
0 2
0 1
1 1
0 1
0 0
0 0
 */