#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <cassert>
#include <ctime>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e10, MOD = 1e9 + 1;

long long n, m;
vector<long long> g[500000];
set<pair<long long, long long>> edges;

void solve()
{
	cin >> n >> m;
	for (long long i = 0; i < m; i++)
	{
		long long a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
		edges.insert({ a, b });
		edges.insert({ b, a });
	}

	vector<vector<long long>> ans(n, vector<long long>(n, INF));
	ans[0][0] = 0;
	set<tuple<long long, long long, long long>> q = { { 0, 0, 0 } };
	while (q.size())
	{
		long long d = get<0>(*q.begin()), v = get<1>(*q.begin()), box = get<2>(*q.begin());
		q.erase(q.begin());

		if (v == box)
		{
			for (auto& i : g[v])
			{
				if (d + 1 < ans[v][i])
				{
					q.erase({ ans[v][i], v, i });
					ans[v][i] = d + 1;
					q.insert({ ans[v][i], v, i });
				}
			}
			continue;
		}

		if (edges.find({ v, box }) != edges.end())
		{
			if (d + 1 < ans[v][v])
			{
				q.erase({ ans[v][v], v, v });
				ans[v][v] = d + 1;
				q.insert({ ans[v][v], v, v });
			}
		}

		for (auto& i : g[v])
		{
			if (i != box)
			{
				if (d < ans[i][box])
				{
					q.erase({ ans[i][box], i, box });
					ans[i][box] = d;
					q.insert({ ans[i][box], i, box });
				}
			}
		}
	}

	for (long long i = 1; i < n; i++)
	{
		if (ans[i][i] == INF)
		{
			cout << -1 << " ";
		}
		else
		{
			cout << ans[i][i] << " ";
		}
	}
	cout << "\n";

	edges = {};
	for (long long i = 0; i < n; i++)
	{
		g[i] = {};
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long tests;
	cin >> tests;
	while (tests--)
	{
		solve();
	}

	return 0;
}

/*














*/
