#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(30);

  ll t;
  cin >> t;
  while (t--)
    solve();
}

bool debug =
#ifdef DEBUG
    true
#else
false
#endif
;

// --------

vvi gr;
vi used;
vi fup;
vi tin;
ll timer;
vi cmp;
vb is_s;

void find_nodes_s(ll v, ll parent = -1) {
  assert(used[v] == 0);
  used[v] = 1;

  tin[v] = fup[v] = timer++;

  bool has_children = false;

  bool ch_ok = true;

  for (auto u : gr[v]) {
    if (u == parent) continue;
    if (used[u] == 1) {
      fup[v] = min(fup[v], tin[u]);
    } else if (used[u] == 0) {
      has_children = true;
      find_nodes_s(u, v);
      fup[v] = min(fup[v], fup[u]);
      if (fup[u] > tin[v]) {
        ch_ok = false;
      }
      if (parent != -1 and fup[u] >= tin[v]) {
        ch_ok = false;
      }
    }
  }

  if (not ch_ok and gr[v].size() >= 2 and (has_children))
    is_s[v] = true;

  used[v] = 2;
}

void colorize(ll v, ll color = 1) {
  if (is_s[v]) {
    color += 1;
  } else {
    cmp[v] = color;
  }

  used[v] = 3;

  for (auto u : gr[v]) {
    if (used[u] == 2) colorize(u, color);
  }
}

void solve() {
  ll n, m;
  cin >> n >> m;
  gr.clear();
  gr.resize(n);
  used.clear();
  used.resize(n);
  tin.clear();
  tin.resize(n);
  fup.clear();
  fup.resize(n);
  is_s.clear();
  is_s.resize(n);
  cmp.clear();
  cmp.resize(n);
  timer = 0;
  for (int i = 0; i < m; ++i) {
    ll u, v;
    cin >> u >> v;
    --u, --v;
    gr[u].push_back(v);
    gr[v].push_back(u);
  }
  find_nodes_s(0);
  colorize(0);

  vi d1(n, 1e18), d2(n, 1e18);
  map<ll, map<ll, ll>> d1cmp;
  d2[0] = 0;
  deque<ii> q;
  q.emplace_back(0, -1);
  while (not q.empty()) {
    auto[v, par] = q.front();
    q.pop_front();
    if (par != -1) {
      bool ok = false;
      if ((d1[par] != (ll) 1e18 or is_s[par]) and (d2[v] == (ll) 1e18)) {
        if (is_s[par]) {
          if (d1cmp[par].count(cmp[v]) > 0) {
            d2[v] = d1cmp[par][cmp[v]] + 1;
            ok = true;
          }
        } else {
          d2[v] = d1[par] + 1;
          ok = true;

        }
      }
      if (d2[par] != (ll) 1e18 and (d1[v] == (ll) 1e18 or is_s[v])) {
        if (is_s[v]) {
          if (d1cmp[v].count(cmp[par]) == 0) {
            d1cmp[v][cmp[par]] = d2[par] + 1;
            ok = true;
          }
        } else {
          d1[v] = d2[par] + 1;
          ok = true;
        }
      }
      if (!ok) continue;
    }

    for (auto u : gr[v]) {
      if (not is_s[v]) {
        if ((d1[v] != (ll) 1e18 and d2[u] == (ll) 1e18)
            or (d2[v] != (ll) 1e18 and (d1[u] == (ll) 1e18 or is_s[u])))
          q.emplace_back(u, v);
      } else {
        if ((cmp[u] == cmp[par] and (d2[u] == (ll) 1e18))
            or (d2[v] != (ll) 1e18 and (d1[u] == (ll) 1e18)))
          q.emplace_back(u, v);
      }
    }
  }

  vi ans;
  for (int i = 1; i < n; ++i) {
    if (d2[i] != (ll) (1e18)) {
      ans.push_back(d2[i]);
    } else {
      ans.push_back(-1);
    }
  }
  cout << ans << endl;
}

/*

1
5 5
1 2
2 3
3 4
4 5
5 1

1
5 6
1 2
3 2
1 3
3 5
5 4
3 4


 */