#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <iomanip>
#include <string>
#include <assert.h>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;

#define int ll

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)

const int mod = 1e9 + 7;
const int N = 6000;

vector<int> g[N];
int dp[N];
char used[N];

bool check(int v, int w, int bl)
{
	used[v] = 1;
	if (v == w) return 1;
	for (auto& u : g[v])
	{
		if (!used[u])
		if (u != bl)
		{
			if (check(u, w, bl))
			{
				return 1;
			}
		}
	}
	return 0;
}

void solve()
{
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++)
	{
		g[i].clear();
		dp[i] = -1;
	}

	for (int i = 0; i < m; i++)
	{
		int v, u;
		cin >> v >> u;
		v--, u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}

	dp[0] = 0;

	queue<int> q;
	q.push(0);

	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (auto& u : g[v])
		{
			for (auto& k : g[u])
			{
				fill(used, used + n, 0);
				if (check(v, k, u))
				{
					if (dp[k] > dp[v] + 2 || dp[k] == -1)
					{
						dp[k] = dp[v] + 2;
						q.push(k);
					}
				}
			}
		}
	}

	for (int i = 1; i < n; i++)
		cout << dp[i] << " ";
	cout << '\n';
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;

	while (t--)
	{
		solve();
	}

	return 0;
}