#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;
#define int long long
const int MX = 1e18;
vector<vector<int> > gr;
vector<int> fup, tin, tout;
int timer = 0;
vector<bool> used;

vector<vector<int> > binup;
vector<int> hig;
void dfs(int v, int pr = -1, int hh = 0) {
    if(pr != -1)
        binup[0][v] = pr;
    else
        binup[0][v] = v;
    used[v] = 1;
    hig[v] = hh;
    tin[v] = timer++;
    fup[v] = tin[v];
    for (auto u: gr[v]) {
        if (u == pr)
            continue;
        if (used[u])
            fup[v] = min(fup[v], tin[u]);
        else {
            dfs(u, v, hh + 1);
            fup[v] = min(fup[v], fup[u]);
        }
    }
    tout[v] = timer++;
}

bool pred(int x, int y) {
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

bool check(int x, int y, int z) {
    vector<int> dist(gr.size(), -1);
    dist[x] = 0;
    queue<int> q;
    q.push(x);
    while (!q.empty()) {
        int top = q.front();
        q.pop();
        for (auto u: gr[top]) {
            if (u != z && dist[u] == -1) {
                dist[u] = 0;
                q.push(u);
            }
        }
    }
    return dist[y] == 0;
}

vector<vector<pair<int, int> > > gr2;
vector<vector<bool> > gr2used;

int jump(int x, int k){
    for(int i = (int)binup.size() - 1;i>=0;--i){
        if((1LL << i) <= k){
            k -= (1LL << i);
            x = binup[i][x];
        }
    }
    return x;
}

int lower_bound2(vector<pair<int, int> > &a, pair<int, int> val){
    int l = -1, r = (int)a.size();
    while(l + 1 < r){
        int mid = (l + r) >> 1;
        if(a[mid] < val)
            l = mid;
        else
            r = mid;
    }
    return r;
}

vector<int> getall(int pos, int u) {
    if (gr2used[u][pos])
        return {};
    pair<int, int> x = gr2[u][pos];
    if (x.first < tin[u]) {
        vector<int> now;
        for (int j = pos; j < (int) gr2[u].size(); ++j) {
            if (gr2[u][j].first < tin[u]) {
                if(gr2used[u][j] == 1)
                    exit(-1);
                now.push_back(gr2[u][j].second);
                gr2used[u][j] = 1;
            } else
                break;
        }
        for (int j = pos - 1; j >= 0; --j) {
            if (gr2[u][j].first < tin[u]) {
                if(gr2used[u][j] == 1)
                    exit(-1);
                now.push_back(gr2[u][j].second);
                gr2used[u][j] = 1;
            } else
                break;
        }
        return now;
    }
    else {
        vector<int> now;
        int y = jump(x.second, hig[x.second] - hig[u] - 1);
        pos = lower_bound2(gr2[u], make_pair(tin[y], -1));
        if(gr2used[u][pos] == 1)
            return {};
        for(int i = pos;i<(int)gr2[u].size();++i)
        {
            if(pred(y, gr2[u][i].second))
            {
                if(gr2used[u][i] == 1)
                    exit(-1);
                now.push_back(gr2[u][i].second);
                gr2used[u][i] = 1;
            }
            else
                break;
        }
        return now;
    }
}

void solve() {
    gr.clear();
    fup.clear();
    tin.clear();
    tout.clear();
    used.clear();
    binup.clear();
    hig.clear();
    timer = 0;
    int n, m;
    cin >> n >> m;
    binup.resize(17, vector<int> (n));
    hig.resize(n);
    gr.resize(n);
    fup.resize(n);
    tin.resize(n);
    tout.resize(n);
    used.resize(n, false);
    gr2.clear();
    gr2.resize(n);
    gr2used.clear();
    gr2used.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    dfs(0);
    for(int i = 1;i<(int)binup.size();++i){
        for(int j = 0;j<n;++j)
            binup[i][j] = binup[i - 1][binup[i - 1][j]];
    }
    vector<vector<int> > good(n);
    for (int i = 0; i < n; ++i) {
        for (auto u: gr[i]) {
            gr2[i].push_back({tin[u], u});
            gr2used[i].push_back(0);
            if (fup[u] < tin[i])
                good[i].push_back(u);
        }
        sort(gr2[i].begin(), gr2[i].end());
    }
    queue<int> q;
    vector<int> dist(n, -1);
    dist[0] = 0;
    q.push(0);
    vector<bool> block(n, 0);
    while (!q.empty()) {
        int top = q.front();
        q.pop();
        for (auto u: gr[top]) {
            if (tin[top] < tin[u]) {
                int pos = lower_bound2(gr2[u], make_pair(tin[top], -1));
                auto now = getall(pos, u);
                for (auto v: now) {
                    if (dist[v] == -1) {
                        dist[v] = dist[top] + 2;
                        q.push(v);
                    }
                }
                for (auto vv: good[u]) {
                    now.clear();
                    now = getall(lower_bound2(gr2[u], make_pair(tin[vv], -1)), u);
                    for (auto v: now) {
                        if (dist[v] == -1) {
                            dist[v] = dist[top] + 2;
                            q.push(v);
                        }
                    }
                }
                good[u].clear();
            } else {
                int pos = lower_bound2(gr2[u], make_pair(tin[top], -1));
                vector<int> now = getall(pos, u);
                for (auto v: gr[u]) {
                    if (check(top, v, u) && dist[v] == -1) {
                        dist[v] = dist[top] + 2;
                        q.push(v);
                    }
                }
                if(fup[top] < tin[u]){
                    for (auto vv: good[u]) {
                        now.clear();
                        now = getall(lower_bound2(gr2[u], make_pair(tin[vv], -1)), u);
                        for (auto v: now) {
                            if (dist[v] == -1) {
                                dist[v] = dist[top] + 2;
                                q.push(v);
                            }
                        }
                    }
                    good[u].clear();
                }
            }
        }
    }
    for (int i = 1; i < n; ++i)
        cout << dist[i] << " ";
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
