#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;
#define int long long
const int MX = 1e18;
vector<vector<int> > gr;
vector<int> fup, tin, tout;
int timer = 0;
vector<bool> used;

void dfs(int v, int pr = -1){
    used[v] = 1;
    tin[v] = timer++;
    fup[v] = tin[v];
    for(auto u : gr[v]){
        if(u == pr)
            continue;
        if(used[u])
            fup[v] = min(fup[v], tin[u]);
        else
        {
            dfs(u, v);
            fup[v] = min(fup[v], fup[u]);
        }
    }
    tout[v] = timer++;
}

bool pred(int x, int y){
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

bool check(int x, int y, int z){
    vector<int> dist(gr.size(), -1);
    dist[x] = 0;
    queue<int> q;
    q.push(x);
    while(!q.empty()){
        int top = q.front();
        q.pop();
        for(auto u : gr[top]){
            if(u != z && dist[u] == -1) {
                dist[u] = 0;
                q.push(u);
            }
        }
    }
    return dist[y] == 0;
}

void solve(){
    gr.clear();
    fup.clear();
    tin.clear();
    tout.clear();
    used.clear();
    timer = 0;
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    fup.resize(n);
    tin.resize(n);
    tout.resize(n);
    used.resize(n, false);
    for(int i = 0;i<m;++i)
    {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    dfs(0);
    queue<int> q;
    vector<int> dist(n, -1);
    dist[0] = 0;
    q.push(0);
    vector<bool> block(n, 0);
    while(!q.empty()){
        int top = q.front();
        q.pop();
        for(auto u : gr[top]){
                for(auto v : gr[u]){
                    if((fup[v] < tin[u] || (!pred(top, u) && !pred(v, u) && (pred(v, top) || pred(top, v)))) && dist[v] == -1)
                    {
                        dist[v] = dist[top] + 2;
                        q.push(v);
                    }
                }
        }
    }
    for(int i = 1;i<n;++i)
        cout << dist[i] << " ";
    cout << "\n";
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}
