#include <bits/stdc++.h>

using namespace std;
#define int long long

struct SegTree {
    int n, len;
    vector <int> t, p;

    SegTree(int n) : n(n) {
        len = 1 << (int)ceil(log2(n));
        t.resize(2 * len);
        p.resize(2 * len);
        build(1, 0, len - 1);
    }

    void build(int v, int l, int r) {
        if (l == r) {
            if (l < n) t[v] = n - l - 1;
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    inline void push(int v, int ln) {
        t[2 * v] += ln * p[v];
        t[2 * v + 1] += ln * p[v];
        p[2 * v] += p[v];
        p[2 * v + 1] += p[v];
        p[v] = 0;
    }

    void update(int v, int l, int r, int A, int B) {
        if (l > B || A > r) return;
        if (A <= l && r <= B) {
            t[v] -= r - l + 1;
            --p[v];
            return;
        }
        push(v, (r - l + 1) / 2);
        int m = (l + r) / 2;
        update(2 * v, l, m, A, B);
        update(2 * v + 1, m + 1, r, A, B);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    inline void upd(int i) {
        update(1, 0, len - 1, 0, i);
    }
};

struct node {
    node* l = nullptr;
    node* r = nullptr;
    int x, y, sum, sz;

    node(int x) : x(x), y(rand()), sum(x), sz(1) {}
};

inline int sz(node* a) {
    if (a == nullptr) return 0;
    return a->sz;
}

inline int sm(node* a) {
    if (a == nullptr) return 0;
    return a->sum;
}

inline void update(node* a) {
    a->sz = 1 + sz(a->l) + sz(a->r);
    a->sum = a->x + sm(a->l) + sm(a->r);
}

node* merge(node* a, node* b) {
    if (a == nullptr) return b;
    if (b == nullptr) return a;
    if (a->y < b->y) {
        a->r = merge(a->r, b);
        update(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        update(b);
        return b;
    }
}

pair <node*, node*> split(node* a, int x) {
    if (a == nullptr) return {nullptr, nullptr};
    if (a->x <= x) {
        auto now = split(a->r, x);
        a->r = now.first;
        update(a);
        return {a, now.second};
    } else {
        auto now = split(a->l, x);
        a->l = now.second;
        update(a);
        return {now.first, a};
    }
}

signed main() {
    srand(1303);
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    int n, q;
    cin >> n >> q;
    vector <int> a(n), aa;
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <int> ps;
    aa = a;
    vector <pair <int, int>> all_moments;
    sort(a.begin(), a.end());
    for (int i : aa) ps.push_back(lower_bound(a.begin(), a.end(), i) - a.begin());
    for (int i = 0; i < n - 1; ++i) {
        all_moments.emplace_back(a[i + 1] - a[i], i);
    }
    sort(all_moments.begin(), all_moments.end());
    vector <int> ans(q);
    vector <pair <int, int>> all2;
    vector <vector <pair <int, int>>> all3(n);
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            ans[i] = n - (upper_bound(all_moments.begin(), all_moments.end(), make_pair(k + 1, -1LL)) - all_moments.begin());
        } else if (type == 2) {
            int k;
            cin >> k;
            all2.emplace_back(k, i);
        } else {
            int pos, k;
            cin >> k >> pos; --pos;
            all3[ps[pos]].emplace_back(k, i);
        }
    }
    sort(all2.begin(), all2.end());
    int sum = 0, cura = 0, curq = 0, last = 0;
    SegTree t(n);
    while (curq < (int)all2.size()) {
        if (cura == n - 1 || (all_moments[cura].first >= all2[curq].first)) {
            ans[all2[curq].second] = sum + t.t[1] * (all2[curq].first - last);
            ++curq;
        } else {
            int nlast = all_moments[cura].first;
            sum += t.t[1] * (nlast - last);
            t.upd(all_moments[cura].second);
            last = nlast;
            ++cura;
        }
    }
    node* root = nullptr;
    for (int i = n - 1; i >= 0; --i) {
        for (auto j : all3[i]) {
            auto now = split(root, j.first);
            ans[j.second] = (n - i - 1) * j.first - (sz(now.first) * j.first - sm(now.first)) + a[i];
            root = merge(now.first, now.second);
        }
        if (i > 0) {
            int x = a[i] - a[i - 1];
            node* tmp = new node(x);
            auto now = split(root, x);
            root = merge(merge(now.first, tmp), now.second);
        }
    }
    for (int i : ans) cout << i << "\n";
    return 0;
}
