#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vi = vector<int>;

vi ten(10, 1);

int len(int n) {
    if (!n) {
        return 1;
    }
    for (int i = 9; i >= 0; --i) {
        if (ten[i] <= n) {
            return i + 1;
        }
    }
}

int integer(string s) {
    int res = 0;
    for (int i = 0; i < (int)s.size(); ++i) {
        res = res * 10 + (s[i] - '0');
    }
    return res;
}

int integer(const vi& s) {
    int res = 0;
    for (int i = 0; i < (int)s.size(); ++i) {
        res = res * 10 + s[i];
    }
    return res;
}

ll f(int x, int y, vi& p) {
    int k = 0, n = p.size();
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (p[j] < p[i]) {
                ++k;
            }
        }
    }
    return x - k * 1LL * y;
}

void enumerate(vi& p, vi& used, const int n, const int x, const int y, int& ans, int& win) {
    int xnew;
    if (p.size() == n) {
        xnew = 0;
        for (int i = 0; i < n; ++i) {
            xnew += x / ten[p[i]] % 10 * ten[i];
        }
        int curwin = f(xnew, y, p);
        if (curwin >= win && xnew > ans) {
            win = curwin;
            ans = xnew;
        }
        return;
    }

    int res = x;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }
        used[i] = 1;
        p.push_back(i);
        enumerate(p, used, n, x, y, ans, win);
        used[i] = 0;
        p.pop_back();
    }
}

int cntsame(const vi& a, const vi& b) {
    int n = min(a.size(), b.size());
    for (int i = 0; i < n; ++i) {
        if (a[i] != b[i]) {
            return i;
        }
    }
    return n;
}

vector<int> op(const vector<int>& a, int l, int r) {
    vi v(a);
    int x = v[r];
    for (int i = r; i > l; --i) {
        v[i] = v[i - 1];
    }
    v[l] = x;
    return v;
}

void solve() {
    string str;
    cin >> str;
    int n = str.size(), x = integer(str);
    vector<int> dig(n);
    for (int i = 0; i < n; ++i) {
        dig[i] = str[i] - '0';
    }
    vector<int> s(dig);
    sort(s.rbegin(), s.rend());
    ll y;
    cin >> y;

    vector<vector<int>> a(n * (n - 1) / 2 + 1);
    a[0] = dig;
    int ind;
    for (int i = 1; i < (int)a.size(); ++i) {
        a[i] = a[i - 1];
        ind = cntsame(s, a[i - 1]);
        if (ind == n) {
            continue;
        }
        for (int j = 0; j < i && ind + i - j < n; ++j) {
            a[i] = max(a[i], op(a[j], ind, ind + i - j));
        }
    }

    int win = x, ans = x, curwin, xnew;
    for (int i = 0; i < (int)a.size(); ++i) {
        xnew = integer(a[i]);
        curwin = xnew - i * y;
        if (curwin >= win && xnew > ans) {
            ans = xnew;
            win = curwin;
        }
    }

    for (int i = n - len(ans); i > 0; --i) {
        cout << 0;
    }
    cout << ans << '\n';
}

int main() {
    for (int i = 1; i < 10; ++i) {
        ten[i] = 10 * ten[i - 1];
    }
    solve();
    return 0;
}
