#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;

int cntdiff(const vector<ll>& v) {
    int n = v.size(), res = 1;
    for (int i = 1; i < n; ++i) {
        if (v[i - 1] != v[i]) {
            ++res;
        }
    }
    return res;
}

int q1(ll kq, const vector<vector<ll>>& c, const vector<ll>& k) {
    int i = --upper_bound(k.begin(), k.end(), kq) - k.begin();
    return cntdiff(c[i]);
}

ll q2(ll kq, const vector<vector<ll>>& c, const vector<ll>& k, const vector<ll>& sum) {
    int i = --upper_bound(k.begin(), k.end(), kq) - k.begin(),
        x = cntdiff(c[i]);
    ll res = sum[i] - sum[0];
    kq -= k[i];
    res += x * 1LL * (x - 1) / 2 * kq;
    return res;
}

ll q3(ll kq, const vector<vector<ll>>& c, const vector<ll>& k, int ind) {
    int i = --upper_bound(k.begin(), k.end(), kq) - k.begin(), n = c[0].size();
    kq -= k[i];
    for (int j = n - 2, cntdiff = 0; j >= 0; --i) {
        if (c[i][j] != c[i][j + 1]) {
            ++cntdiff;
        }
        if (j == ind) {
            return c[i][j] + cntdiff * kq;
        }
    }
    return -1;
}

void solve() {
    int n, q, sz = 1;
    ll mindiff;
    cin >> n >> q;
    vector<vector<ll>> c(sz, vector<ll>(n));
    vector<ll> sum(sz, 0), a(n), k(sz, 0);
    vector<int> wh(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum[0] += a[i];
    }
    c[0].assign(a.begin(), a.end());
    sort(c[0].begin(), c[0].end());
    for (int i = 0; i < n; ++i) {
        wh[i] = lower_bound(c[0].begin(), c[0].end(), c[i]) - c[0].begin();
    }

    while (c.back()[0] != c.back().back()) {
        c.push_back(c.back());
        ++sz;

        mindiff = c.back().back() - c.back()[0];
        for (int i = n - 1; i > 0; --i) {
            if (c.back()[i] != c.back()[i - 1]) {
                mindiff = min(mindiff, c.back()[i] - c.back()[i - 1]);
            }
        }
        k.push_back(k.back() + mindiff);
        for (int i = n - 2, cntdiff = 0; i >= 0; --i) {
            if (c[(int)c.size() - 2][i] != c[(int)c.size() - 2][i + 1]) {
                ++cntdiff;
            }
            c.back()[i] += cntdiff * mindiff;
        }

        sum.push_back(0);
        for (int i = 0; i < n; ++i) {
            sum.back() += c.back()[i];
        }
    }

    int t, iq;
    ll kq;
    for (; q; --q) {
        cin >> t;
        if (t == 1) {
            cin >> kq;
            cout << q1(kq, c, k) << '\n';
        } else if (t == 2) {
            cin >> kq;
            cout << q2(kq, c, k, sum) << '\n';
        } else {
            cin >> kq >> iq;
            wh[iq - 1];
            cout << q3(kq, c, k, iq) << '\n';
        }
    }
}

int main() {
    solve();
    return 0;
}
