#include <bits/stdc++.h>
#define int long long
using namespace std;

struct node {
    int sum = 0;
    int min = LLONG_MAX;
    int cnt_zeroes = 1;
//    int sum2 = 0;
//    int sum3 = 0;
    int push = 0;
    node *left= nullptr, *right= nullptr;

    node() = default;
    node(node* root) {
        sum = root->sum;
        min = root->min;
        cnt_zeroes = root->cnt_zeroes;
        push = root->push;
        left = root->left;
        right =  root->right;
    }
};

void build(node* root, int lx, int rx) {
    root->cnt_zeroes = rx - lx;
    if (rx - lx == 1) return;
    root->left = new node;
    root->right = new node;

    build(root->left, lx, (rx + lx) / 2);
    build(root->right, (rx + lx) / 2, rx);
}

void set_nopers(node *root, int i, int val, int lx, int rx) {
    if (rx - lx == 1) {
        root->sum = val;
        root->cnt_zeroes = (val == 0);
        root->min = (val == 0 ? LLONG_MAX : val);
//        root->sum2 = (val == 0 ? 0 : val);
//        root->sum3 = (val == 0 ? 0 : lx + 1);
        return;
    }
    if (i < (lx + rx) / 2) {
        set_nopers(root->left, i, val, lx, (lx + rx) / 2);
    }
    else {
        set_nopers(root->right, i, val, (lx + rx) / 2, rx);
    }
    root->min = min(root->left->min, root->right->min);
    root->sum = root->left->sum + root->right->sum;
    root->cnt_zeroes = root->left->cnt_zeroes + root->right->cnt_zeroes;
}

void push(node *root, int lx, int rx) {
    root->left->min -= root->push;
    root->right->min -= root->push;

    int len = (rx - lx) / 2;
    root->left->sum += (len - root->left->cnt_zeroes) * root->push;
    root->right->sum += (len - root->right->cnt_zeroes) * root->push;

    root->left->push += root->push;
    root->right->push += root->push;

    root->push = 0;
}

node* add(node* root, int val, int lx, int rx) {
    if (root->min == LLONG_MAX) {
        return root;
    }
    if (root->min > val) {
        node* new_root = new node(root);
        new_root->min -= val;
        new_root->push += val;
        new_root->sum -= val * (rx - lx - root->cnt_zeroes);
        return root;
    }
    if (rx - lx == 1) {
        return new node;
    }

    push(root, lx, rx);
    node* new_root = new node(root);

    new_root->left = add(root->left, val, lx, (lx + rx) / 2);
    new_root->right = add(root->right, val, (lx + rx) / 2, rx);

    new_root->min = min(new_root->left->min, new_root->right->min);
    new_root->sum = new_root->left->sum + new_root->right->sum;
    new_root->cnt_zeroes = new_root->left->cnt_zeroes + new_root->right->cnt_zeroes;
    return new_root;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n; cin >> n;
    int q; cin >> q;

    vector<int> a(n);
    int sum = 0;
    for (int &i : a) {
        cin >> i;
        sum += i;
    }

    vector<int> pos(n);
    iota(pos.begin(), pos.end(), 0);
    sort(pos.begin(), pos.end(), [&](int i, int j){
        return a[i] < a[j];
    });
    vector<int> get_index(n);
    for (int i = 0; i < n; i++) {
        get_index[pos[i]] = i;
    }

    sort(a.begin(), a.end());

    node* root = new node;
    build(root, 0, n - 1);

    for (int i = 0; i < n - 1; i++) {
        set_nopers(root, i, a[i + 1] - a[i], 0, n - 1);
    }

    map<int, node*> trees;
    map<int, int> sums;
    set<int> times;

    trees[0] = root;
    sums[0] = sum;
    times.insert(0);

    int last_k = 0;
    while (true) {
        int k = trees[last_k]->min;
        if (k == LLONG_MAX) {
            break;
        }
        else {
            int cnt = n - trees[last_k]->cnt_zeroes;
            sums[k] = sums[last_k] + (k - last_k) * (cnt - 1) * cnt / 2;
            trees[k] = add(trees[last_k], k, 0, n - 1);
            last_k = k;
            times.insert(k);
        }
    }

    while (q--) {
        int t, k; cin >> t >> k;

        int x = *--times.upper_bound(k);

        if (t == 1) {
            cout << n - trees[x]->cnt_zeroes << "\n";
        }
        if (t == 2) {
            cout << trees[k]->sum + (n - 1) * a.back() - sum << "\n";
        }
        if (t == 3) {
            cout << "skip\n";
        }
    }
    return 0;
}