#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double
#define ll __int128

using namespace std;

const int N = 3e5 + 10, INF = 1e18;
int par[N], sum[N], num[N], ind[N];
int bal = 0, n, q;

int find_set(int v) {
    if (v == par[v]) return v;
    else return par[v] = find_set(par[v]);
}

void union_set(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    assert(a != b);
    if (num[a] < num[b]) {
        swap(a, b);
    }
    if (num[a] > num[b]) {
        int val = num[a];
        for (int j = 0; j < n; j++) {
            if (num[j] >= val) {
                num[j]--;
                bal--;
            }
        }
    }
    par[b] = a;
    ind[a] = min(ind[a], ind[b]);
    num[a] = num[b];
    sum[a] += sum[b];
}

struct query{
    int t, k, i;
};

vector<int> solve(int nn, int qq, vector<pair<int,int>> c, vector<query> u) {
    bal = 0;
    n = nn, q = qq;
    for (int i = 0; i < N; i++) {
        par[i] = i;
        sum[i] = 1;
    }
    vector<array<int, 3>> m;
    vector<int> ans(q);
    sort(c.begin(), c.end());
    int cnt = 0;
    map<int,int> mp;
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n && c[i].first != c[i + 1].first) {
            cnt++;
        }
        mp[cnt] = c[i].first;
        num[c[i].second] = cnt;
        ind[c[i].second] = cnt;
        bal += cnt;
    }
    for (int i = 0; i + 1 < n; i++) {
        m.pb({c[i + 1].first - c[i].first, c[i].second, c[i + 1].second});
        u.pb({-1, c[i + 1].first - c[i].first, INF});
    }
    sort(m.begin(), m.end());
    sort(u.begin(), u.end(), [&](query a, query b){return a.k < b.k;});
    int j = 0, anss = 0;
    for (int i = 0; i < u.size(); i++) {
        while (j < m.size() && m[j][0] <= u[i].k) {
            union_set(m[j][1], m[j][2]);
            j++;
        }
        if (u[i].i != INF) {
            if (u[i].t == 1) {
                ans[u[i].i] = n - j;
            } else if (u[i].t == 2) {
                ans[u[i].i] = anss;
            } else {
                int val = ind[find_set(abs(u[i].t) - 1)];
                ans[u[i].i] = val * u[i].k + mp[val];
            }
        }
        if (i + 1 < u.size()) {
            anss += (u[i + 1].k - u[i].k) * bal;
        }
    }
    return ans;
}

vector<int> solvee(int n, int q, vector<pair<int,int>> c, vector<query> u) {
    int K_MAX = 10000 + 10;
    sort(c.begin(), c.end());
    vector<int> ind(n);
    for (int i = 0; i < n; i++) {
        ind[c[i].second] = i;
    }
    vector<vector<pair<int,int>>> all(K_MAX);
    for (auto to : u) {
        all[to.k].pb({to.t, to.i});
    }
    int beg = 0;
    vector<int> ans(q);
    for (auto to : c) beg += to.first;
    for (int i = 0; i < K_MAX; i++) {
        for (auto to : all[i]) {
            if (to.first == 1) {
                int cnt = 0;
                for (int j = 0; j + 1 < n; j++) {
                    if (c[j].first != c[j + 1].first) cnt++;
                }
                ans[to.second] = cnt + 1;
            } else if (to.first == 2) {
                int sum = 0;
                for (int j = 0; j < n; j++) {
                    sum += c[j].first;
                }
                ans[to.second] = sum - beg;
            } else {
                ans[to.second] = c[ind[abs(to.first) - 1]].first;
            }
        }
        int cnt = 0;
        for (int j = n - 1; j >= 0; j--) {
            if (j + 1 < n && c[j].first != c[j + 1].first - cnt) cnt++;
            c[j].first += cnt;
        }
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pair<int,int>> c(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i].first;
        c[i].second = i;
    }
    vector<query> u(q);
    for (int i = 0; i < q; i++) {
        cin >> u[i].t >> u[i].k;
        if (u[i].t == 3) {
            cin >> u[i].t;
            u[i].t *= -1;
        }
        u[i].i = i;
    }
    auto res = solvee(n, q, c, u);
    for (auto to : res) {
        cout << to << endl;
    }
    return 0;
}
