#include<bits/stdc++.h>

#define int long long
#define pb push_back
#define ld long double
#define ll __int128

using namespace std;

mt19937 rnd(51);

struct seg {
    int l, r, c, t;
};

int get_res(int n, int m, vector<int> a, vector<seg> u) {
    vector<vector<pair<int,int>>> add(n);
    vector<int> nxt(n, n);
    for (int i = 0; i < m; i++) {
        add[u[i].l].pb({u[i].r, u[i].c});
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i + 1 < n) {
            nxt[i] = nxt[i + 1];
            if (add[i + 1].size() > 0) nxt[i] = i + 1;
        }
    }
    multiset<pair<int,int>> st;
    int ans = 0;
    for (int i = 0; i < n;) {
        for (auto to : add[i]) {
            st.insert(to);
        }
        while (a[i] > 0 && st.size() > 0) {
            auto p = *st.begin();
            st.erase(st.find(p));
            if (p.first < i) continue;
            int val = min(a[i], p.second);
            a[i] -= val;
            p.second -= val;
            ans += val;
            if (p.second != 0) {
                st.insert(p);
            }
        }
        if (st.size() == 0) i = nxt[i];
        else i++;
    }
    return ans;
}

vector<int> solve(int n, int m, vector<int> a, vector<seg> u) {
    vector<int> ans;
    for (int x = 0; x < n; x++) {
        vector<seg> u_nw;
        for (int i = 0; i < m; i++) {
            if (u[i].t == 1) u_nw.pb({min(u[i].l, x), max(u[i].r, x), u[i].c, u[i].t});
            else u_nw.pb(u[i]);
        }
        ans.pb(get_res(n, m, a, u_nw));
    }
    return ans;
}

vector<int> solve_1(int n, int m, vector<int> a, vector<seg> u) {
    vector<bool> used(m);
    vector<int> cnt(m);
    vector<vector<pair<int,int>>> need(n);
    vector<vector<int>> add(n), del(n);
    sort(u.begin(), u.end(), [&](seg a, seg b){return a.l > b.l;});
    for (int i = 0; i < m; i++) {
        add[u[i].l].pb(i);
        del[u[i].r].pb(i);
    }
    multiset<pair<int,int>> st;
    int ans = 0, sum = 0;
    for (int i = 0; i < m; i++) {
        cnt[i] = u[i].c;
        for (int j = u[i].r; j >= 0; j--) {
            if (cnt[i] > 0 && a[j] > 0) {
                int val = min(cnt[i], a[j]);
                cnt[i] -= val;
                a[j] -= val;
                ans += val;
                need[j].pb({i, val});
            }
        }
    }
    vector<int> res;
    for (int x = 0; x < n; x++) {
        for (auto to : need[x]) {
            cnt[to.first] += to.second;
            ans -= to.second;
            a[x] += to.second;
            int j = to.first;
            if (u[j].l <= x) {
                for (int f = u[j].l; f <= x; f++) {
                    int val = min(cnt[j], a[f]);
                    a[f] -= val;
                    cnt[j] -= val;
                    ans += val;
                }
            }
        }
        for (auto j : add[x]) {
            st.insert({u[j].r, j});
        }
        for (auto j : del[x]) {
            sum += cnt[j];
        }
        int val = min(a[x], sum);
        a[x] -= val;
        sum -= val;
        ans += val;
        while (st.size() > 0 && a[x] > 0) {
            auto p = *st.begin();
            st.erase(st.find(p));
            if (p.first <= x) continue;
            int val = min(a[x], cnt[p.second]);
            a[x] -= val;
            cnt[p.second] -= val;
            ans += val;
            if (cnt[p.second] > 0) {
                st.insert(p);
            }
        }
        int can = 0;
        for (int j = 0; j < m; j++) {
            if (u[j].r > x) {
                can += cnt[j];
            }
        }
        res.pb(ans + min(a[x], can));
    }
    return res;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    while (0) {
        int n = rnd() % 10 + 1, m = rnd() % 10 + 1;
        vector<int> a(n);
        for (int i = 0; i < n; i++ ){
            a[i] = rnd() % 10 + 1;
        }
        vector<seg> u(m);
        for (int i = 0; i < m; i++) {
            u[i].l = rnd() % n, u[i].r = rnd() % n;
            if (u[i].l > u[i].r) swap(u[i].l, u[i].r);
            u[i].c = rnd() % 10 + 1;
            u[i].t = 1;
        }
        if (solve(n, m, a, u) != solve_1(n, m, a, u)) {
            cout << n << ' ' << m << endl;
            for (auto to : a) {
                cout << to << ' ';
            }
            cout << endl;
            for (auto to : u) {
                cout << to.l + 1 << ' ' << to.r + 1 << ' ' << to.c << ' ' << to.t << endl;
            }
            return 0;
        }
        cout << "OK" << endl;
    }
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> a(n);
        vector<seg> u(m);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        for (int i = 0; i < m; i++) {
            cin >> u[i].l >> u[i].r >> u[i].c >> u[i].t;
            u[i].l--, u[i].r--;
        }
        auto res = solve_1(n, m, a, u);
        for (auto to : res) {
            cout << to << " ";
        }
        cout << endl;
    }
    return 0;
}
