#include <iostream>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

#define All(x) (x).begin(), (x).end()
#define pii pair<ll, ll>
#define X first
#define Y second

const ll MERGE = -10;

struct event {
	ll x, type, i, j, id;

	event(ll x_, ll type_, ll i_, ll j_, ll id_) : x(x_), type(type_), i(i_), j(j_), id(id_) {}
	event() {}
};

bool cmp(event& a, event& b) {
	return (a.x == b.x ? a.type < b.type : a.x < b.x);
}

signed main()
{
	ll n, q, type, a, b, k;
	cin >> n >> q;
	vector<pii> c(n);
	for (ll i = 0; i < n; i++) {
		cin >> c[i].X;
		c[i].Y = i;
	}
	sort(All(c));
	vector<ll> p(n);
	for (ll i = 0; i < n; i++) {
		p[c[i].Y] = i;
	}
	vector<ll> cur(n);
	for (ll i = 0; i < n; i++)
		cur[i] = c[i].X;
	vector<event> events;
	for (ll i = 0; i < n - 1; i++) {
		ll dif = cur[i + 1] - cur[i];
		events.push_back(event(dif,MERGE,i,i+1,-1));
	}
	for (ll i = 0; i < q; i++) {
		cin >> type >> k;
		if (type <= 2) {
			events.push_back(event(k, type,-1,-1,i));
		}
		else {
			cin >> a;
			events.push_back(event(k, type, p[a-1], -1, i));
		}
	}
	sort(All(events), cmp);
	vector<ll> ans(q), add(n);
	for (ll i = 0; i < n; i++) {
		add[i] = n - i - 1;
	}
	ll last_merge = 0, diff = n;
	for (ll j = 0; j < events.size(); j++) {
		event ev = events[j];
		if (ev.type == MERGE) {
			diff--;
			ll dx = ev.x - last_merge;
			for (ll i = 0; i < n; i++) {
				cur[i] += add[i] * dx;
			}
			for (ll i = 0; i <= ev.i; i++)
				add[i]--;
			last_merge = ev.x;
		}
		else if (ev.type == 1) {
			ans[ev.id] = diff;
		}
		else if (ev.type == 2) {
			ll res = 0;
			for (ll i = 0; i < n; i++) {
				ll f = cur[i] + add[i] * (ev.x - last_merge);
				res += f - c[i].X;
			}
			ans[ev.id] = res;
		}
		else if (ev.type == 3) {
			ans[ev.id] = cur[ev.i] + add[ev.i] * (ev.x - last_merge);
		}
	}
	for (auto q : ans)
		cout << q << '\n';
}
