#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
    int n, q; cin >> n >> q;
    vector<int64_t> as(n);
    for (int i = 0; i < n; i++) {
        cin >> as[i];
    }
    vector<int64_t> as_copy = as;
    sort(as.begin(), as.end());
    // as.resize(unique(as.begin(), as.end()) - as.begin());

    vector<int64_t> current_deltas;
    map<int64_t, vector<int64_t>> deltas_map;
    for (int i = n - 1; i >= 0; i--) {
        deltas_map[as[i]] = current_deltas;
        if (i != 0) {
            current_deltas.push_back(as[i] - as[i - 1]);
        }
    }
    vector<pair<int64_t, int>> deltas;
    for (int i = 0; i < n - 1; i++) {
        deltas.emplace_back(as[i + 1] - as[i], i + 1);
    }
    sort(deltas.begin(), deltas.end());
    vector<int64_t> deltas_pref_sums(n);
    deltas_pref_sums[0] = 0;
    vector<int64_t> deltas_suff_sums_partial(n);
    deltas_suff_sums_partial[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        deltas_suff_sums_partial[i] = deltas_suff_sums_partial[i + 1] + deltas[i].second;
    }
    for (int i = 1; i < n; i++) {
        deltas_pref_sums[i] = deltas_pref_sums[i - 1] + (deltas[i - 1].second * 1ll * deltas[i - 1].first);
    }
    while (q--) {
        int t; cin >> t;
        if (t == 1) {
            int64_t k; cin >> k;
            int idx = upper_bound(deltas.begin(), deltas.end(), make_pair(k, n + 1488)) - deltas.begin();
            cout << n - idx << endl;
        } else if (t == 2) {
            int64_t k; cin >> k;
            int idx = upper_bound(deltas.begin(), deltas.end(), make_pair(k, n + 1488)) - deltas.begin();
            int64_t ans = deltas_pref_sums[idx] + deltas_suff_sums_partial[idx] * 1ll * k;
            cout << ans << endl;
        } else if (t == 3) {
            int64_t k; cin >> k;
            int i; cin >> i; i--;
            int64_t val = as_copy[i];
            const vector<int64_t> &our_deltas = deltas_map[val];
            int64_t ans = 0;
            for (int64_t d : our_deltas) {
                if (d < k) {
                    ans += d;
                } else {
                    ans += k;
                }
            }
            cout << ans + val << endl;
        }
    }
}
