#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 

using namespace std;
typedef long long ll;

vector<vector<int>>g;
void solveC(int n, int m) {
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	vector<int>d0(n, 1e9), d1(n, 1e9);
	set<pair<int, int>>q0, q1;
	q0.insert({ 0, 0 });
	d0[0] = 0;
	while (!q0.empty() || !q1.empty()) {
		if (!q0.empty()) {
			int v = q0.begin()->second;
			q0.erase(q0.begin());
			for (auto u : g[v]) {
				if (d0[v] + 1 < d1[u]) {
					q1.erase({ d1[u], u });
					d1[u] = d0[v] + 1;
					q1.insert({ d1[u], u });
				}
			}
		}
		else {
			int v = q1.begin()->second;
			q1.erase(q1.begin());
			for (auto u : g[v]) {
				if (d1[v] + 1 < d0[u]) {
					q0.erase({ d0[u], u });
					d0[u] = d1[v] + 1;
					q0.insert({ d0[u], u });
				}
			}
		}
	}
	for (int i = 1; i < n; i++) {
		if (d0[i] != 1e9)
			cout << d0[i] << ' ';
		else
			cout << "-1 ";
	}
	cout << '\n';
	g.clear();
}

struct cond {
	vector<ll>now, add;
	ll sum, addsum;
	cond() = default;
};

map<ll, cond> go(vector<ll>c2, vector<ll>c_orig) {
	map<ll, cond> ans;
	vector<ll>add(c2.size());
	ll addsum = 0;
	for (int i = 0; i < c2.size(); i++) {
		add[i] = c_orig.size() - (lower_bound(c_orig.begin(), c_orig.end(), c2[i]) - c_orig.begin() + 1);
		addsum += add[i];
	}
	ll time = 0, sum = 0;
	ans[time].sum = 0;
	ans[time].now = c2;
	ans[time].add = add;
	ans[time].addsum = addsum;
	while (c_orig.size() != 1) {
		ll d = 1e18;
		for (int i = 1; i < c_orig.size(); i++) {
			d = min(d, c_orig[i] - c_orig[i - 1]);
		}
		time += d;
		set<ll>new_orig;
		for (int i = 0; i < c2.size(); i++) {
			sum += add[i] * d;
			c2[i] += add[i] * d;
			new_orig.insert(c2[i]);
		}
		c_orig.clear();
		for (auto x : new_orig)
			c_orig.push_back(x);
		addsum = 0;
		for (int i = 0; i < c2.size(); i++) {
			add[i] = c_orig.size() - (lower_bound(c_orig.begin(), c_orig.end(), c2[i]) - c_orig.begin() + 1);
			addsum += add[i];
		}
		ans[time].sum = sum;
		ans[time].now = c2;
		ans[time].add = add;
		ans[time].addsum = addsum;
	}
	return ans;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll>c(n), c2;
	vector<ll>dop, c_orig;
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	c2 = c;
	sort(c.begin(), c.end());
	for (int i = 0; i < n; i++) {
		if (c_orig.empty() || c_orig.back() != c[i])
			c_orig.push_back(c[i]);
		if (i != 0 && c[i] != c[i - 1])
			dop.push_back(c[i] - c[i - 1]);
	}
	sort(dop.begin(), dop.end());
	map<ll, cond> conds = go(c2, c_orig);
	while (q--) {
		int t; cin >> t;
		if (t == 1) {
			ll k; cin >> k;
			int cnt = upper_bound(dop.begin(), dop.end(), k) - dop.begin();
			cout << c_orig.size() - cnt << '\n';
		}
		else {
			ll k; cin >> k;
			auto it = conds.upper_bound(k);
			if (t == 3) {
				int i;
				cin >> i;
				i--;
				if (it == conds.end()) {
					--it;
					cout << it->second.now[i] << '\n';
				}
				else {
					--it;
					k -= it->first;
					cout << it->second.now[i] + it->second.add[i] * k << '\n';
				}
			}
			if (t == 2) {
				if (it == conds.end()) {
					--it;
					cout << it->second.sum << '\n';
				}
				else {
					--it;
					k -= it->first;
					ll sum = it->second.sum + it->second.addsum * k;
					cout << sum << '\n';
				}
			}
		}
	}
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}