#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 

using namespace std;
typedef long long ll;

vector<vector<int>>g;
int memory[1000][1000];
vector<int>ans;
int inf = 1e9;

void brute(int box = 0) {
	memory[0][box] = 1;
	set<pair<int, pair<int, int>>>q;
	q.insert({ 1, {0, box} });
	while (!q.empty()) {
		int v = q.begin()->second.first;
		box = q.begin()->second.second;
		int cost = cost = memory[v][box];
		q.erase(q.begin());
		bool ok = false;
		for (auto u : g[v])
			if (u != box) {
				if (memory[u][box] > cost) {
					q.erase({ memory[u][box], {u, box} });
					memory[u][box] = cost;
					q.insert({ memory[u][box], {u, box} });
				}
			}
			else
				ok = true;
		if (ok) {
			if (ans[v] == -1 || ans[v] > cost + 1) {
				for (auto new_box : g[v]) {
					if (new_box != box) {
						if (memory[v][new_box] > cost + 2) {
							memory[v][new_box] = cost + 2;
							q.insert({ cost + 2, {v, new_box} });
						}
					}
				}
			}
		}
	}
}

void solveC(int n, int m) {
	g.resize(n);
	ans.resize(n, -1);
	ans[0] = 0;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	if (m == n - 1 || g[0].size() == 1) {
		for (int i = 0; i < n - 1; i++) {
			cout << "-1 ";
		}
		cout << '\n';
		g.clear();
		ans.clear();
		return;
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			memory[i][j] = inf;
	for (auto u : g[0]) {
		brute(u);
	}
	for (int i = 1; i < n; i++) {
		cout << ans[i] << ' ';
	}
	cout << '\n';
	g.clear();
	ans.clear();
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		if (n <= 5000)
			solveC(n, m);
	}
	return 0;
}