#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm> 
#include <deque>


using namespace std;
typedef long long ll;

struct bot {
	int l, r, t, c;
	bot() = default;
};

struct eve {
	int tme, type;
	int c, close, i;
	eve() = default;
	eve(int time, int t, int op) {
		tme = time;
		type = t;
		c = op;
	}
	eve(int time, int t, int have, int cl) {
		tme = time;
		type = t;
		c = have;
		close = cl;
	}
	bool operator<(eve b) {
		return tme < b.tme || (tme == b.tme && type < b.type);
	}
};

ll get_ans(vector<eve>& scan, int m) {
	sort(scan.begin(), scan.end());
	ll ans = 0;
	vector<ll>have(m);
	set<pair<int, pair<int, int>>>s;
	for (auto el : scan) {
		if (el.type == 0) {
			have[el.i] = el.c;
			s.insert({ el.close, {el.c, el.i} });
		}
		else if (el.type == 1) {
			ll can = el.c;
			while (can != 0 && !s.empty()) {
				int i = s.begin()->second.second, close = s.begin()->first;
				s.erase(s.begin());
				if (have[i] <= can)
					can -= have[i], ans += have[i], have[i] = 0;
				else {
					have[i] -= can;
					ans += can;
					can = 0;
					s.insert({ close, {have[i], i} });
				}
			}
		}
		else {
			s.erase({ el.tme, {have[el.i], el.i} });
		}
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll>a(n);
	vector<bot>bots(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> bots[i].l >> bots[i].r >> bots[i].c >> bots[i].t;
	}
	for (int x = 0; x < n; x++) {
		vector<eve>scan;
		for (int i = 0; i < n; i++) {
			scan.push_back(eve(i + 1, 1, a[i]));
		}
		for (int i = 0; i < m; i++) {
			int l = bots[i].l, r = bots[i].r;
			if (bots[i].t == 1)
				l = min(l, x + 1), r = max(r, x + 1);
			scan.push_back(eve(l, 0, bots[i].c, r));
			scan.back().i = i;
			scan.push_back(eve(r, 2, -1));
			scan.back().i = i;
		}
		cout << get_ans(scan, m) << ' ';
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}