#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <array>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <sstream>
#include <cassert>
#include <random>
#include <chrono>
#include <numeric>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

const int MAX_N = 500'000;

vector<int> graph[MAX_N];

vector<vector<int>> graph2;

int color[MAX_N];

void dfs(int v, int deleted_v) {
	for (int u : graph[v]) {
		if ((u != deleted_v) && (color[u] == -1)) {
			color[u] = color[v];
			dfs(u, deleted_v);
		}
	}
}

int new_v() {
	int len = graph2.size();
	graph2.resize(len + 1);
	return len;
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		graph[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v;
		--u;
		graph[v].push_back(u);
		graph[u].push_back(v);
	}
	graph2.clear();
	graph2.resize(n);
	for (int v = 0; v < n; ++v) {
		fill_n(color, n, -1);
		int col = 0;
		for (int u : graph[v]) {
			if (color[u] == -1) {
				color[u] = col++;
				dfs(u, v);
			}
		}
		vector<vector<int>> vertexes(col);
		for (int u : graph[v]) {
			vertexes[color[u]].push_back(u);
		}
		for (int c = 0; c < col; ++c) {
			int len = vertexes[c].size();
			int v = new_v();
			for (int i = 0; i < len; ++i) {
				graph2[vertexes[c][i]].push_back(v);
				graph2[v].push_back(vertexes[c][i]);
			}
		}
	}
	vector<int> dist(graph2.size(), -1);
	queue<int> que;
	dist[0] = 0;
	que.push(0);
	while (!que.empty()) {
		int v = que.front();
		que.pop();
		for (int u : graph2[v]) {
			if (dist[u] == -1) {
				dist[u] = dist[v] + 1;
				que.push(u);
			}
		}
	}
	for (int i = 1; i < n; ++i) {
		if (dist[i] >= 0) {
			//dist[i] *= 2;
		}
		cout << dist[i] << ' ';
	}
	cout << '\n';
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
}