#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <queue>
#include <algorithm>
#define all(x) x.begin(), x.end()
using namespace std;
#define int long long
const int inf = 1e9;
void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<vector<int>> dist(n, vector<int> (2, inf));
    dist[0][0] = 0;
    deque<pair<int, int>> q;
    q.push_back({ 0, 0 });
    while (!q.empty()) {
        auto [v, f] = q.front();
        q.pop_front();
        for (int u : g[v]) {
            if (dist[u][f ^ 1] > dist[v][f] + 1) {
                dist[u][f ^ 1] = dist[v][f] + 1;
                q.push_back({ u, f ^ 1});
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        if (dist[i][0] == inf) {
            cout << -1 << ' ';
        } else {
            cout << 2 * (dist[i][0] / 2) << ' ';
        }
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}