#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <queue>
#include <cassert>
#include <set>
#include <algorithm>
#define all(x) x.begin(), x.end()
using namespace std;

#define int long long

const int inf = 1e9;
const int maxn = 5000;

struct robot {
    int l, r, c, t;

    robot() {}
    robot(int l, int r, int c, int t): l(l), r(r), c(c), t(t) {}
};

const int f = 1;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<robot> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t;
    }
    for (int x = 1; x <= n; ++x) {
        map<int, vector<pair<int, int>>> r;
        map<int, vector<int>> c;
        vector<int> left;
        for (int j = 0; j < m; ++j) {
            left.push_back(b[j].c);
            if (b[j].t == f) {
                r[min(x, b[j].l)].push_back({ max(x, b[j].r), j });
                c[max(x, b[j].r)].push_back(j);
            } else {
                r[b[j].l].push_back({ b[j].r, j });
                c[b[j].r].push_back(j);
            }
        }
        int ans = 0;
        set<pair<int, int>> open;
        for (int i = 1; i <= n; ++i) {
            int have = a[i - 1];
            for (auto [a, b] : r[i]) {
                open.insert({ a, b });
            }
            while (have && !open.empty()) {
                int j = open.begin()->second;
                open.erase(open.begin());
                int can = min(have, left[j]);
                have -= can;
                left[j] -= can;
                ans += can;
                if (left[j]) {
                    if (b[j].t != f) {
                        open.insert({b[j].r, j});
                    } else {
                        open.insert({max(x, b[j].r), j});
                    }
                }
            }
            for (auto a : c[i]) {
                open.erase({ i, a });
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}