#include <iostream>
#include <vector>
#include <deque>
#include <numeric>
#include <map>
#include <queue>
#include <cassert>
#include <set>
#include <algorithm>
#define all(x) x.begin(), x.end()
using namespace std;

#define int long long

const int inf = 1e9;

struct robot {
    int l, r, c, t;

    robot() {}
    robot(int l, int r, int c, int t): l(l), r(r), c(c), t(t) {}
};

const int f = 1;
const int maxn = (1 << 16);
int tree[maxn];

void upd(int i, int x) {
    i += maxn / 2;
    tree[i] += x;
    while (i > 1) {
        i >>= 1;
        tree[i] += x;
    }
}

int get(int i = 1, int l = 0, int r = maxn / 2) {
    if (l + 1 == r) return l;
    int m = (l + r) / 2;
    if (tree[i * 2]) {
        return get(i * 2, l, m);
    }
    return get(i * 2 + 1, m, r);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<robot> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i].l >> b[i].r >> b[i].c >> b[i].t;
    }
    for (int x = 1; x <= n; ++x) {
        vector<vector<pair<int, int>>> r(n + 1);
        vector<vector<int>> c(n + 1);
        vector<int> left;
        for (int j = 0; j < m; ++j) {
            left.push_back(b[j].c);
            if (b[j].t == f) {
                r[min(x, b[j].l)].push_back({ max(x, b[j].r), j });
                c[max(x, b[j].r)].push_back(j);
            } else {
                r[b[j].l].push_back({ b[j].r, j });
                c[b[j].r].push_back(j);
            }
        }
        int ans = 0;
        vector<deque<int>> ids(n + 1);
        for (int i = 1; i <= n; ++i) {
            int have = a[i - 1];
            for (auto [a, b] : r[i]) {
                upd(a, 1);
                ids[a].push_back(b);
            }
            while (have && tree[1]) {
                int r = get();
                int j;
                while (!left[ids[r].front()]) ids[r].pop_front();
                j = ids[r].front();
                int can = min(have, left[j]);
                have -= can;
                left[j] -= can;
                ans += can;
                if (!left[j]) {
                    upd(r, -1);
                }
            }
            for (auto a : c[i]) {
                if (left[a]) {
                    upd(i, -1);
                    left[a] = 0;
                }
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}