
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <string>

using namespace std;

typedef long long ll;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<vector<int>> graph(n);
		vector<set<int>> gr(n);
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			a--, b--;
			graph[a].push_back(b);
			graph[b].push_back(a);
			gr[a].insert(b);
			gr[b].insert(a);
		}
		vector<vector<int>> dist(n, vector<int>(n, 1e9));
		dist[0][0] = 0;
		priority_queue<pair<int, pair<int, int>>> ss;
		ss.push({ 0, {0, 0} });
		while (!ss.empty()) {
			int i = ss.top().second.first, j = ss.top().second.second;
			// cout << '!' << i << ' ' << j << ' ' << dist[i][j] << '\n';
			if (ss.top().first != -dist[i][j]) {
				ss.pop();
				continue;
			}
			ss.pop();
			if (i == j) {
				for (auto to : graph[i]) {
					if (dist[i][to] > dist[i][j] + 1) {
						dist[i][to] = dist[i][j] + 1;

						ss.push({ -dist[i][to], {i, to} });
					}
				}
			}
			if (gr[i].find(j) != gr[i].end()) {
				if (dist[i][i] > dist[i][j] + 1) {
					dist[i][i] = dist[i][j] + 1;

					ss.push({ -dist[i][i], {i, i} });
				}
			}
			if (i != j) {
				for (auto to : graph[i]) {
					if (to != j && dist[to][j] > dist[i][j]) {
						dist[to][j] = dist[i][j];

						ss.push({ -dist[to][j], {to, j} });
					}
				}
			}
		}
		for (int e = 1; e < n; e++) {
			if (dist[e][e] == (int)1e9) {
				cout << -1 << ' ';
			}
			else {
				cout << dist[e][e] << ' ';
			}
		}
		cout << '\n';
	}
	return 0;
}