#include <bits/stdc++.h>

using namespace std;

const int R = 1 << 15;

long long t[R * 2], push[R * 2];

void build() {
    for (int i = R - 1; i > 0; --i) {
        push[i] = -1;
        t[i] = t[i * 2] + t[i * 2 + 1];
    }
}

void psh(int node, int nl, int nm, int nr) {
    if (push[node] != -1) {
        push[node * 2] = push[node * 2 + 1] = push[node];
        t[node * 2] = push[node] * (nm - nl);
        t[node * 2 + 1] = push[node] * (nr - nm);
    }
    push[node] = -1;
}

long long get_sum(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return t[node];
    }
    if (qr <= nl || nr <= ql || ql == qr) {
        return 0;
    }
    int nm = (nl + nr) / 2;
    psh(node, nl, nm, nr);
    long long ans = get_sum(ql, qr, node * 2, nl, nm) + get_sum(ql, qr, node * 2 + 1, nm, nr);
    t[node] = t[node * 2] + t[node * 2 + 1];
    return ans;
}

void assign(int ql, int qr, int val, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        push[node] = val;
        t[node] = val * 1LL * (nr - nl);
        return;
    }
    if (qr <= nl || nr <= ql) {
        return;
    }
    int nm = (nl + nr) / 2;
    psh(node, nl, nm, nr);
    assign(ql, qr, val, node * 2, nl, nm);
    assign(ql, qr, val, node * 2 + 1, nm, nr);
    t[node] = t[node * 2] + t[node * 2 + 1];
}

int get_pos(long long val, int node = 1, int nl = 0, int nr = R) {
    if (nl == nr - 1) {
        return nl;
    }
    int nm = (nl + nr) / 2;
    psh(node, nl, nm, nr);
    int ans = -1;
    if (t[node * 2] >= val) {
        ans = get_pos(val, node * 2, nl, nm);
    } else {
        ans = get_pos(val - t[node * 2], nm, nr);
    }
    t[node] = t[node * 2] + t[node * 2 + 1];
    return ans;
}

bool cmp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.second < b.first.second;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> l(m), r(m), c(m), t(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i] >> c[i] >> t[i];
        l[i]--;
    }
    for (int i = 0; i < n; ++i) {
        vector<pair<pair<int, int>, int>> v;
        for (int j = 0; j < n; ++j) {
            t[j + R] = a[j];
        }
        build();
        for (int j = 0; j < m; ++j) {
            if (t[j] == 0) {
                v.push_back({{l[j], r[j]}, c[j]});
            } else {
                v.push_back({{min(l[j], i), max(r[j], i + 1)}, c[j]});
            }
        }
        sort(v.begin(), v.end(), cmp);
        long long ans = 0;
        for (auto &k : v) {
            if (get_sum(k.first.first, k.first.second) <= k.second) {
                ans += get_sum(k.first.first, k.first.second);
                assign(k.first.first, k.first.second, 0);
            } else {
                int p = get_pos(get_sum(0, k.first.first) + k.second);
                long long v = get_sum(k.first.first, p);
                assign(k.first.first, p, 0);
                ans += k.second;
                assign(p, p + 1, get_sum(p, p + 1) - (k.second - v));
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
