#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <ctime>
#include <cmath>
#include <cassert>

using namespace std;

#define sz(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = int64_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using int128 = __int128_t;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;

struct Fenwick {
    int n;
    vector<int> tree;

    Fenwick(int _n) {
        n = _n;
        tree.assign(n + 1, 0);
    }

    void add(int v, int val) {
        for (int i = v; i <= n; i += i & -i) {
            tree[i] += val;
        }
    }

    int get(int v) {
        int s = 0;
        for (int i = v; i > 0; i -= i & -i) {
            s += tree[i];
        }
        return s;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve() {
    string x;
    ll y;
    cin >> x >> y;
    int n = sz(x);
    vector<pii> pos(n);
    for (int i = 0; i < n; ++i) {
        pos[i] = {x[i], i};
    }
    sort(all(pos), [](pii a, pii b) {
        return a.first > b.first || (a.first == b.first && a.second < b.second);
    });
    ll now = stoll(x);
    string ans = x;
    for (int i = 1; i <= n; ++i) {
        ll k = 0;
        string cur;
        Fenwick f(n);
        vector<int> used(n, 0);
        for (int j = 0; j < i; ++j) {
            used[pos[j].second] = 1;
            int p = pos[j].second + f.get(pos[j].second + 1, n);
            k += abs(p - j);
            cur += pos[j].first;
            if (p != j) f.add(pos[j].second + 1, 1);
        }
        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                cur += x[j];
            }
        }
        ll res = stoll(cur) - k * y;
        if (res >= now) {
            now = res;
            ans = cur;
        }
    }
    cout << ans << en;
//    int pos_ok = n - 22;
//    string xx = x, ans;
//    for (int i = 0; i < n; ++i) {
//        if (abs(pos[i].second - i) > 22) {
//            ans += pos[i].first;
//        }
//    }
}

int32_t main() {
    int T = 1;
#ifdef THEEVILBIRD
    freopen("a.txt", "r", stdin);
    T = 4;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    while (T--) {
        solve();
    }
    return 0;
}
