#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;

struct Dsu {
	vector<ll> p;
	vector<ll> k;
	void init(ll n) {
		p.assign(n, 0);
		k.assign(n, 1);
		for (ll i = 0; i < n; i++) p[i] = i;
	}
	ll get(ll v) {
		if (v == p[v]) return v;
		p[v] = get(p[v]);
		return p[v];
	}
	bool unite_(ll a, ll b) {
		a = get(a), b = get(b);
		if (a == b) return 0;
		p[b] = a;
		k[a] += k[b];
		return 1;
	}
};

struct O {
	ll d, a, b;
	bool operator<(const O& other) const {
		return d < other.d;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, q;
	cin >> n >> q;
	vector<pair<ll, ll>> c(n);
	for (ll i = 0; i < n; i++) {
		cin >> c[i].first;
		c[i].second = i;
	}
	sort(c.begin(), c.end());
	vector<vector<ll>> ans(10001, vector<ll>(n, 0));
	for (ll i = 0; i < n; i++) ans[0][i] = c[i].first;
	for (ll i = 1; i < ans.size(); i++) {
		set<ll> s;
		for (ll j = n - 1; j >= 0;j--) {
			ans[i][j] = ans[i - 1][j] + s.size() - (s.find(ans[i - 1][j]) != s.end());
			s.insert(ans[i-1][j]);
		}
	}
	for (ll qq = 0; qq < q; qq++) {
		ll t, k;
		cin >> t >> k;
		if (t == 1) {
			set<ll> s;
			for (ll i = 0; i < n; i++) {
				s.insert(ans[k][i]);
			}
			cout << s.size() << "\n";
		}
		else if (t == 2) {
			ll res = 0;
			for (ll i = 0; i < n; i++) {
				res += ans[k][i] - ans[0][i];
			}
			cout << res << "\n";
		}
		else {
			ll i;
			cin >> i;
			i--;
			for (ll j = 0; j < n; j++) {
				if (c[j].second == i) {
					cout << ans[k][j] << "\n";
					break;
				}
			}
		}
	}
	return 0;
}