#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;

struct R {
	ll l, r, c, t;
	R get(ll x) {
		if (t == 1) return { min(l, x), max(r, x), c, t };
		return { l, r, c, t };
	}
	bool operator<(const R& other) const {
		if (l != other.l) return l < other.l;
		return r < other.r;
	}
	void input() {
		cin >> l >> r >> c >> t;
		l--; r--;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<vector<ll>> g(n);
		for (ll i = 0; i < m; i++) {
			ll u, v;
			cin >> u >> v;
			u--; v--;
			g[v].push_back(u);
			g[u].push_back(v);
		}
		vector<ll> dp1(n, INF), dp2(n, INF);
		dp1[0] = 0;
		queue<ll> que1, que2;
		que1.push(0);
		vector<bool> used1(n, 0), used2(n, 0);
		ll type = 1;
		while (que1.size() > 0 || que2.size() > 0) {
			if (type == 1) {
				ll v = que1.front();
				que1.pop();
				if (!que1.size()) type = 2;
				used1[v] = 1;
				for (ll i : g[v]) {
					if (dp2[i] > dp1[v] + 1) {
						dp2[i] = dp1[v] + 1;
						if (!used2[i]) {
							que2.push(i);
							used2[i] = 1;
						}
					}
				}
			}
			else {
				ll v = que2.front();
				que2.pop();
				if (!que2.size()) type = 1;
				used2[v] = 1;
				for (ll i : g[v]) {
					if (dp1[i] > dp2[v] + 1) {
						dp1[i] = dp2[v] + 1;
						if (!used1[i]) {
							que1.push(i);
							used1[i] = 1;
						}
					}
				}
			}
		}
		for (ll i = 1; i < n; i++) {
			if (dp1[i] < INF)cout << dp1[i] << " ";
			else cout << "-1 ";
		}
		cout << "\n";
	}
	return 0;
}