#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>

using namespace std;
#define int long long

const int S = (1LL << 41);

struct Tree {
  struct Node {
    Node *l, *r;
    int sum, push;
    Node() {
      l = r = nullptr;
      sum = push = 0;
    }
  };

  Node *root;

  Tree() {
    root = new Node();
  }

  void create(Node *x) {
    if (x->l == nullptr) {
      x->l = new Node();
    }
    if (x->r == nullptr) {
      x->r = new Node();
    }
  }

  void propagate(Node *x, int lx, int rx) {
    if (lx + 1 == rx || x->push == 0) return;
    int p = x->push;
    create(x);
    int m = (lx + rx) / 2;
    x->l->push += p;
    x->r->push += p;
    x->l->sum += p * (m - lx);
    x->r->sum += p * (rx - m);
    x->push = 0;
  }

  void add(int l, int r, int val, Node *x, int lx, int rx) {
    if (lx >= r || rx <= l) return;
    propagate(x, lx, rx);
    if (lx >= l && rx <= r) {
      x->sum += (rx - lx) * val;
      x->push = val;
//      cout << lx << ' ' << rx << ' ' << x->sum << '\n';
      return;
    }
    int m = (lx + rx) / 2;
    create(x);
    add(l, r, val, x->l, lx, m);
    add(l, r, val, x->r, m, rx);
    x->sum = x->r->sum + x->l->sum;
  }

  void add(int l, int r, int val) {
//    cout << "add: " << l << ' ' << r << ' ' << val << '\n';
    add(l, r, val, root, 0, S);
  }

  int get(int k, Node *x, int lx, int rx) {
    if (lx >= k || x == nullptr) return 0;
//    cout << lx << ' ' << rx << ' ' << x->sum << ' ' << x->push << '\n';
    propagate(x, lx, rx);
    if (rx <= k) return x->sum;
    int m = (lx + rx) / 2;
    return get(k, x->l, lx, m) + get(k, x->r, m, rx);
  }
};

//struct SegTree {
//  vector<int> tree, push;
//  int s;
//
//  SegTree(int n) {
//    s = 1;
//    while (s < n) s *= 2;
//    tree.resize(2 * s + 1);
//    push.resize(2 * s + 1);
//  }
//
//  void add(int l, int r, int x, int lx, int rx) {
//    if (lx >= r || rx <= l) return;
//    if (lx >= l && rx <= r) {
//
//    }
//  }
//};

vector<int> get_array(vector<int> a, int k) {
  int n = (int) a.size();
  for (int i = 0; i < k; i++) {
    auto b = a;
    for (int i = 0; i < n; i++) {
      set<int> st;
      for (int j = 0; j < n; j++) {
        if (a[j] > a[i]) {
          st.insert(a[j]);
        }
      }
      b[i] = a[i] + (int) st.size();
    }
    a = b;
  }
  return a;
}

void solve() {
  int n, q;
  cin >> n >> q;
  vector<int> a(n);
  for (auto &x : a) cin >> x;

  for (int i = 0; i < q; i++) {
    int type, k;
    cin >> type >> k;
    auto ar = get_array(a, k);
    if (type == 3) {
      int pos;
      cin >> pos;
      --pos;
      cout << ar[pos] << ' ';
    } else if (type == 2) {
      int res = 0;
      for (int i = 0; i < n; i++) {
        res += ar[i] - a[i];
      }
      cout << res << ' ';
    } else {
      set<int> st;
      for (int i = 0; i < n; i++) {
        st.insert(ar[i]);
      }
      cout << (int) st.size() << ' ';
    }
  }

}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  solve();
  return 0;
}
