#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>

using namespace std;
#define int long long

const int inf = 1e18;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<vector<int>> g(n);
  for (int i = 0; i < m; i++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    g[u].push_back(v);
    g[v].push_back(u);
  }

  vector<vector<int>> dp(n, vector<int> (n, inf));
  dp[0][0] = 0;
  set<array<int, 3>> st;
  st.insert({0, 0, 0});

  auto update = [&] (int i, int j, int val) {
    if (val < dp[i][j]) {
      st.erase({dp[i][j], i, j});
      dp[i][j] = val;
      st.insert({dp[i][j], i, j});
    }
  };

  while (!st.empty()) {
    auto [cost, i, j] = *st.begin();
    st.erase(st.begin());
    for (auto &u : g[i]) {
      if (u == j) {
        update(i, i, cost + 1);
      } else if (i == j) {
        update(i, u, cost + 1);
      } else {
        update(u, j, cost);
      }
    }
  }

  for (int i = 1; i < n; i++) {
    cout << (dp[i][i] == inf ? -1 : dp[i][i]) << ' ';
  }
  cout << '\n';
}

signed main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}
