#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = (ll)(1e18);

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<vector<ll>> h(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b;
        cin >> a >> b;

        --a, --b;

        h[a].push_back(b);
        h[b].push_back(a);
    }

    vector<vector<ll>> g(n);

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < h[i].size() - 1; ++j) {
            for (ll k = j + 1; k < h[i].size(); ++k) {
                g[h[i][j]].push_back(h[i][k]);
                g[h[i][k]].push_back(h[i][j]);
            }
        }
    }

    vector<ll> dist(n, INF);
    set<pair<ll, ll>> st;

    for (ll i = 0; i < n; ++i) {
        st.insert({INF, i});
    }

    for (auto i : h[0]) {
        st.erase({dist[i], i});
        dist[i] = 1;

        st.insert({1, i});
    }

    while (st.size()) {
        pair<ll, ll> k = *st.begin();
        st.erase(k);

        ll v = k.second;
        ll dst = k.first;

        for (auto i : g[v]) {
            if (dist[i] > dist[v] + 2) {
                st.erase({dist[i], i});
                dist[i] = dist[v] + 2;
                st.insert({dist[i], i});
            }
        }
    }

    for (ll i = 1; i < n; ++i) {
        ll ans = INF;

        for (auto v : h[i]) {
            ans = min(ans, dist[v]);
        }

        if (ans == INF) ans = -2;

        cout << ans + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    fast_stream();

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}

/*
 5 6
1 2
3 2
1 3
3 5
5 4
3 4
 */