#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;

int t;
int n, m;
vector <int> g[500010];
int d[500010][2];

struct ve
{
	int u;
	bool up;

	ve() {}

	ve(int u, bool up) : u(u), up(up) {}
};

const int inf = 1e9;

inline void solve()
{
	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
	{
		g[i].clear();
		d[i][0] = d[i][1] = inf;
	}

	d[1][1] = 0;

	for (int i = 1; i <= m; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	deque <ve> s;	
	s.push_back(ve(1, 1));

	while (s.size())
	{
		auto u = s.front().u;
		auto p = s.front().up;
		s.pop_front();
		for (auto v : g[u])
		{
			int nd = d[u][p] + 1;
			if (d[v][!p] > nd)
			{
				d[v][!p] = nd;
				s.push_back(ve(v, !p));
			}
		}
	}

	for (int i = 2; i <= n; ++i)
	{
		cout << (d[i][1] == inf ? -1 : d[i][1]) << ' ';
	}
	cout << '\n';
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> t;
	while (t--) solve();

	return 0;
}