#include <bits/stdc++.h>

using namespace std;

struct Fenwick {
	int n;
	vector<long long> f;

	void add(int i, long long val) {
		for (++i; i <= n; i += i & -i) {
			f[i] += val;
		}
	}

	long long get(int i) {
		long long res = 0;
		for (; i > 0; i -= i & -i) {
			res += f[i];
		}
		return res;
	}

	long long get(int l, int r) {
		return get(r) - get(l);
	}

	Fenwick(int n) : n(n) {
		f = vector<long long>(n + 1, 0);
	}
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<long long> c(n);
	vector<pair<long long, int>> cc(n);
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		cc[i] = {c[i], i};
	}
	sort(c.begin(), c.end());
	sort(cc.begin(), cc.end());
	vector<int> ccpos(n);
	for (int i = 0; i < n; ++i) {
		ccpos[cc[i].second] = i;
	}
	vector<long long> d;
	vector<pair<long long, int>> dd;
	for (int i = 0; i < n - 1; ++i) {
		d.push_back(c[i + 1] - c[i]);
		dd.push_back({c[i + 1] - c[i], i});
	}
	sort(d.begin(), d.end());
	sort(dd.begin(), dd.end());
	vector<int> t(q), ind(q);
	vector<long long> k(q);
	for (int i = 0; i < q; ++i) {
		cin >> t[i] >> k[i];
		if (t[i] == 3) {
			cin >> ind[i];
			--ind[i];
			ind[i] = ccpos[ind[i]];
		}
	}
	vector<long long> pref(n);
	vector<long long> pref2(n);
	pref[0] = 0;
	for (int i = 0; i < n - 1; ++i) {
		pref[i + 1] = pref[i] + dd[i].first * (dd[i].second + 1);
		pref2[i + 1] = pref2[i] + dd[i].second + 1;
	}
	vector<vector<int>> here(n);
	vector<long long> ans(q);
	for (int i = 0; i < q; ++i) {
		if (t[i] == 1) {
			ans[i] = n - (int)(lower_bound(d.begin(), d.end(), k[i] + 1) - d.begin());
		}
		if (t[i] == 2) {
			__int128 cans = k[i] * __int128(n) * (n - 1) / 2;
			int prefpos = lower_bound(d.begin(), d.end(), k[i]) - d.begin();
			cans -= __int128(pref2[prefpos]) * k[i];
			cans += pref[prefpos];
			ans[i] = (long long)cans;
		}	
		if (t[i] == 3) {
			here[ind[i]].push_back(i);
		}
	}
	Fenwick fcnt(n);
	Fenwick fsum(n);
	for (int i = n - 1; i >= 0; --i) {
		if (i != n - 1) {
			int p = lower_bound(d.begin(), d.end(), c[i + 1] - c[i]) - d.begin();
			fcnt.add(p, 1);
			fsum.add(p, c[i + 1] - c[i]);
		}
		for (int id : here[i]) {
			ans[id] = c[ind[id]] + k[id] * (n - 1 - i); 
 			int p = lower_bound(d.begin(), d.end(), k[id]) - d.begin();
			ans[id] += fsum.get(p);
			ans[id] -= fcnt.get(p) * k[id];
		}	
	}
	for (int i = 0; i < q; ++i) {
		cout << ans[i] << "\n";
	}
	return 0;
}
