#include <bits/stdc++.h>

using namespace std;

const int N = 500500;
const int INF = 1e9;
const int NN = 3 * N;

int n, m;
vector<int> g[N];
vector<int> id[N];
int nn;
vector<pair<int, int>> g2[NN];
int tin[N], tout[N], fup[N], timer;
bool used[N];
int comp[N];
int d[NN];
int ans[N];

int get_id(int v, int u) {
	// v - box, u - robot
	return id[v][lower_bound(g[v].begin(), g[v].end(), u) - g[v].begin()];
}

void dfs(int v, int p = -1) {
	used[v] = true;
	tin[v] = timer++;
	fup[v] = tin[v];
	
	vector<pair<int, int>> subs;
	for (int u : g[v]) {
		if (!used[u]) {
			dfs(u, v);
			subs.push_back({tout[u], u});
			fup[v] = min(fup[v], fup[u]);
		} else {
			if (u != p) {
				fup[v] = min(fup[v], tin[u]);
			}
		}
	}

	sort(subs.begin(), subs.end());
	vector<pair<int, int>> srt;
	for (int u : g[v]) {
		srt.push_back({tin[u], u});
	}

	sort(srt.begin(), srt.end());
	int ptr = 0;
	for (auto e : srt) {
		int t = e.first;
		int u = e.second;
		if (tin[u] < tin[v]) {
			comp[u] = 0;
		} else {
			while (subs[ptr].first <= t) {
				++ptr;
			}
			int w = subs[ptr].second;
			if (fup[w] >= tin[v]) {
				comp[u] = ptr + 1;
			} else {
				comp[u] = 0;
			}
		}
	}

	vector<vector<int>> by_comp(subs.size() + 1);
	for (int u : g[v]) {
		by_comp[comp[u]].push_back(u);
	}
	for (auto &cmp : by_comp) {
		if (cmp.size() >= 2) {
			int f = nn++;
			g2[f].clear();
			for (int u : cmp) {
				int i = get_id(v, u);
				g2[i].push_back({0, f});
				g2[f].push_back({0, i});
			}
		}
	}

	tout[v] = timer;
} 

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v;
		--u;
		g[v].push_back(u);
		g[u].push_back(v);
	}

	nn = 0;	
	for (int i = 0; i < n; ++i) {
		sort(g[i].begin(), g[i].end());
		id[i] = vector<int>(g[i].size());
		for (int j = 0; j < g[i].size(); ++j) {
			id[i][j] = nn++;
		}
	}

	for (int i = 0; i < nn; ++i) {
		g2[i].clear();
	}

	for (int v = 0; v < n; ++v) {
		int f = nn++;
		g2[f].clear();
		for (int u : g[v]) {
			int i = get_id(u, v);
			g2[i].push_back({1, f});
			g2[f].push_back({1, i});	
		}
	}

	fill(used, used + n, false);
	timer = 0;	
	dfs(0);

	fill(d, d + nn, INF);
	for (int i = 0; i < nn; ++i) {
		sort(g2[i].begin(), g2[i].end());
	}

	deque<int> q;
	for (int v : g[0]) {
		d[get_id(v, 0)] = 0;
		q.push_back(get_id(v, 0));
	}

	while (!q.empty()) {
		int v = q.front();
		q.pop_front();
		for (auto e : g2[v]) {
			int u = e.second, w = e.first;
			if (d[v] + w < d[u]) {
				d[u] = d[v] + w;
				if (w == 0) {
					q.push_front(u);
				} else {
					q.push_back(u);
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		ans[i] = INF;
	}

	for (int v = 0; v < n; ++v) {
		for (int u : g[v]) {
			int i = get_id(u, v);
			ans[v] = min(ans[v], d[i]);
		}
	}

	for (int i = 1; i < n; ++i) {
		cout << (ans[i] == INF ? -1 : ans[i] + 2) << " ";
	}
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}