#include <iostream>
#include <string>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

vector<int> tree;

void add(int i, int l, int r, int q)
{
	++tree[i];
	if (l + 1 == r) return;
	int mid = (l + r) / 2;
	if (mid <= q) add(2 * i + 2, mid, r, q);
	else add(2 * i + 1, l, mid, q);
}

int get_sm(int i, int l, int r, int lq, int rq)
{
	if (rq <= l || r <= lq) return 0;
	if (lq <= l && r <= rq) return tree[i];
	int mid = (l + r) / 2;
	return get_sm(2 * i + 1, l, mid, lq, rq) + get_sm(2 * i + 2, mid, r, lq, rq);
}

void solve()
{
	string s; cin >> s;
	int n = s.size();
	tree.resize(4 * n, 0);
	ll y; cin >> y;
	vector<vector<int>> pos(10);
	for (int i = 0; i < n; ++i)
		pos[s[i] - '0'].push_back(i);
	for (int i = 0; i < 10; ++i) reverse(all(pos[i]));
	string ans = "";
	for (int i = 0; i < n; ++i)
	{
		if (n - i >= 19)
		{
			for (int j = 9; j >= 0; --j)
			{
				if (pos[j].size())
				{
					add(0, 0, n, pos[j].back());
					pos[j].pop_back();
					ans.push_back('0' + j);
					break;
				}
			}
		}
		else
		{
			ll prof = 1;
			for (int j = 1; j < n - i; ++j)
				prof *= 10LL;
			vector<pair<ll, int>> pr;
			for (int j = 0; j < 10; ++j)
			{
				if (pos[j].size())
				{
					int wr = pos[j].back();
					wr -= get_sm(0, 0, n, wr, n);
					ll k = wr - i;
					pr.push_back({ prof * (ll)j - k * y, j });
				}
			}
			ll bf = pr[0].first;
			int bj = pr[0].second;
			for (int j = 1; j < pr.size(); ++j)
			{
				if (bf < pr[j].first)
				{
					bf = pr[j].first;
					bj = pr[j].second;
				}
				else if (bf == pr[j].first)
				{
					bj = max(bj, pr[j].second);
				}
			}
			ans.push_back('0' + bj);
			add(0, 0, n, pos[bj].back());
			pos[bj].pop_back();
		}
	}
	cout << ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout << fixed << setprecision(20);
	int t = 1; //cin >> t;
	while (t--) solve();
}
