#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

using uint = uint32_t;
using int64 = int64_t;
using uint64 = uint64_t;

int INF32 = (int)1e9 + 2;

class DSU {
public:
	vector <int> pr, h;
	vector <int> cnt;
	vector <int> mn;
	int64 cntpair;

	int get(int v) {
		if (pr[v] == v) return v;
		return pr[v] = get(pr[v]);
	}

public:
	DSU(int n) {
		pr.resize(n); iota(all(pr), 0);
		h.assign(n, 0);
		cnt.assign(n, 1);
		mn.resize(n); iota(all(mn), 0);
		cntpair = n * (n - 1) / 2;
	}

	void unique(int u, int v) {
		u = get(u);
		v = get(v);

		if (u == v) return;

		if (h[u] < h[v]) swap(u, v);
		if (h[u] == h[v]) ++h[u];
		cntpair -= (int64)cnt[u] * cnt[v];
		mn[u] = min(mn[u], mn[v]);
		cnt[u] += cnt[v];
		pr[v] = u;
	}

	int getcnt(int v) {
		return cnt[get(v)];
	}

	int64 get() {
		return cntpair;
	}

	int getmn(int v) {
		return mn[get(v)];
	}
};

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, q; cin >> n >> q;
	vector <pair <int64, int>> v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i].first;
		v[i].second = i;
	}
	sort(all(v));

	vector <int> ls(n, 0);
	for (int i = 1; i < ls.size(); ++i) {
		ls[i] = ls[i - 1];
		if (v[i].first > v[i - 1].first) ++ls[i];
	}

	vector <pair <int64, pair <int, int>>> dv(n, { 0, {0, 0} });
	for (int i = 0; i < n - 1; ++i) {
		dv[i].first = v[i + 1].first - v[i].first;
		dv[i].second = { i + 1, i };
	}
	sort(all(dv));

	vector <int64> pr(n, 0);
	DSU dsu(n);
	vector <int64> cnt(n, dsu.get());
	for (int i = 1; i < pr.size(); ++i) {
		pr[i] = pr[i - 1] + (dv[i].first - dv[i - 1].first) * (cnt[i - 1]);
		cnt[i] = cnt[i - 1] - (int64)dsu.getmn(dv[i].second.second) - (int64)dsu.getcnt(dv[i].second.second);
		dsu.unique(dv[i].second.first, dv[i].second.second);
	}

	while (q--) {
		int t; cin >> t;
		if (t == 1) {
			int64 k; cin >> k;
			cout << n - (upper_bound(all(dv), pair <int64, pair <int, int>>({ k, {INF32, INF32} })) - dv.begin()) + 1 << '\n';
		}
		if (t == 2) {
			int64 k; cin >> k;
			int ind = upper_bound(all(dv), pair <int64, pair <int, int>>({ k, {0, 0} })) - dv.begin();
			cout << pr[ind - 1] + (k - dv[ind - 1].first) * (cnt[ind - 1]) << '\n';
		}
	}
}