#include <iostream>
#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")

#define int long long
#define int128 __int128

//#define int int128

struct DSU{
    vector<int> parent;

    void build(int n){
        parent.resize(n, 0);
        for(int i = 0; i < n; i++) parent[i] = i;
    }

    int get(int a){
        if(parent[a] == a) return a;
        return parent[a] = get(parent[a]);
    }

    void merge(int a, int b){
        a = get(a);
        b = get(b);
        if(a == b) return;
        parent[b] = a;
    }

    int size(){
        int ans = 0;
        set<int> st;
        for(int i = 0; i < parent.size(); i++){
            st.insert(get(i));
        }

        return st.size();
    }
};

struct T{
    int time;
    int a;
    int b;
};

bool operator<(T a, T b){
    return a.time < b.time;
}

int32_t main() {
    int n;
    cin >> n;
    int q;
    cin >> q;

    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }

    sort(a.begin(), a.end());

    auto t = unique(a.begin(), a.end());
    a.erase(t, a.end());

    n = a.size();

    vector<T> b;

    for(int i = 1; i < n; i++){
        b.push_back({a[i] - a[i-1], i-1, i});
    }

    sort(b.begin(), b.end());

    int l = 0;

    pair<int, int> que[q];

    for(int i = 0; i < q; i++){
        int a, b;
        cin >> a >> b;
        que[i] = {b, i};
    }

    sort(que, que + n);

    DSU d;

    int ans[q];

    d.build(a.size());

    for(int i = 0; i < q; i++){
        while(l < b.size() && que[i].first >= b[l].time){
            d.merge(b[l].a, b[l].b);
            l++;
        }
        ans[que[i].second] = d.size();
    }

    for(int i = 0; i < q; i++){
        cout << ans[i] << "\n";
    }

    return 0;
}
