#include <bits/stdc++.h>

using num = long long;

void print(std::vector<num> const& arr)
{
    for(auto elem : arr)
        std::cout << elem << ' ';
    std::cout << " = " << std::accumulate(arr.begin(), arr.end(), 0ll) << '\n';
}

void f(std::vector<num>& c)
{
    const auto set = std::set(c.begin(), c.end(), std::greater<>{});
    num val = 0;
    std::unordered_map<num, num> add;

    for(auto elem : set)
        add[elem] = val++;

    for(auto& elem : c)
        elem += add[elem];
}

int main()
{
    num n, q;
    std::cin >> n >> q;
    std::vector<num> c(n);
    for(auto& elem : c)
        std::cin >> elem;

    std::sort(c.begin(), c.end());
    std::vector<std::pair<num, num>> diffs(n-1);
    for(num i = 0; i < n-1; i++)
        diffs[i] = {c[i+1] - c[i], i+1};
    std::sort(diffs.begin(), diffs.end());

    const auto f1 = [&](num k)
    {
        num l = -1, r = diffs.size();
        while(r - l > 1)
        {
            const num mid = (r + l)/2;
            if(diffs[mid].first <= k)
                l = mid;
            else
                r = mid;
        }
        return diffs.size() - r;
    };

    std::vector<num> pref_sum(n-1);
    pref_sum[0] = diffs[0].first * diffs[0].second;
    for(num i = 1; i < n-1; i++)
        pref_sum[i] = pref_sum[i-1] + diffs[i].first * diffs[i].second;
    std::vector<num> post_sum(n-1);
    post_sum[n-2] = diffs[n-2].second;
    for(num i = n-3; i != -1; i--)
        post_sum[i] = post_sum[i+1] + diffs[i].second;

    const auto f2 = [&](num k)
    {
        const num greater = f1(k);
        if(diffs.size() == greater)
            return post_sum[0] * k;
        if(0 == greater)
            return pref_sum.back();
        return pref_sum[diffs.size() - greater - 1] + post_sum[diffs.size() - greater] * k;
    };

    for(num i = 0; i < 10; i++)
    {
        print(c);
        f(c);
    }

    while(q--)
    {
        num t;
        std::cin >> t;

        if(t == 1)
        {
            num k;
            std::cin >> k;
            std::cout << f1(k) + 1 << '\n';
        }

        if(t == 2)
        {
            num k;
            std::cin >> k;
            std::cout << f2(k) << '\n';
        }
    }
}
