#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MAXN = 1000 + 10;
const int INF = 1e12 + 7;

vector<int> graph[MAXN];
int dist[MAXN][MAXN];

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t-- > 0) {
        int n, m;
        cin >> n >> m;
        set<pair<int, int>> edges;
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            --v, --u;
            graph[v].push_back(u);
            graph[u].push_back(v);
            edges.insert({v, u});
            edges.insert({u, v});
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dist[i][j] = INF;
            }
        }
        for (int i = 0; i < n; ++i) {
            dist[0][i] = 0;
        }
        deque<pair<int, int>> x;
        for (int u: graph[0]) {
            dist[u][0] = 1;
            x.emplace_back(u, 0);
        }
        while (!x.empty()) {
            auto[b, r] = x.front();
            x.pop_front();
            if (edges.count({b, r})) {
                for (int new_b: graph[r]) {
                    if (dist[new_b][r] > dist[b][r] + 1) {
                        dist[new_b][r] = dist[b][r] + 1;
                        x.emplace_back(new_b, r);
                    }
                }
            }
            for (int new_r: graph[r]) {
                if (new_r != b) {
                    if (dist[b][new_r] > dist[b][r]) {
                        dist[b][new_r] = dist[b][r];
                        x.push_front({b, new_r});
                    }
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            int mn = INF;
            for (int j = 0; j < n; ++j) {
                mn = min(mn, dist[i][j]);
            }
            cout << mn << " ";
        }
        cout << "\n";
        for (int i = 0; i < n; ++i) {
            graph[i].clear();
        }
    }
    return 0;
}