#include <bits/stdc++.h>

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;

struct query {
    int ind;
    int type;
    ll k;
    int pos;

    query(int ind, int type, ll k, int pos = -1) : ind(ind), type(type), k(k), pos(pos) {};
};

bool operator<(const query& a, const query& b) {
    return a.k < b.k;
}

ll total_xp;
ll total_incr;
int cnt_different;

void advance(vector<ll>& c, vector<ll>& val, vector<ll>& incr, ll t) {
    for (size_t i = 0; i < c.size(); ++i) {
        c[i] += incr[i] * t;
        total_xp += incr[i] * t;
    }

    val = c;
    sort(all(val));
    val.resize(unique(all(val)) - val.begin());
    cnt_different = (int)val.size();

    for (size_t i = 0; i < c.size(); ++i) {
        int idx = lower_bound(all(val), c[i]) - val.begin();
        incr[i] = cnt_different - 1 - idx;
        total_incr += incr[i];
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }

    vector<query> quer;
    vector<ll> ans(q);
    for (int i = 0; i < q; ++i) {
        int type;
        ll k;
        cin >> type >> k;
        if (type == 3) {
            int pos;
            cin >> pos;
            quer.emplace_back(i, type, k, pos - 1);
        } else {
            quer.emplace_back(i, type, k);
        }
    }
    sort(all(quer));

    vector<ll> val = c;
    vector<ll> incr(c.size());
    cnt_different = n;
    total_xp = 0;
    total_incr = 0;
    advance(c, val, incr, 0);

    vector<ll> ev;
    for (size_t i = 1; i < val.size(); ++i) {
        ev.push_back(val[i] - val[i - 1]);
    }
    ll last_event = 0;
    sort(all(ev));
    ev.resize(unique(all(ev)) - ev.begin());
    size_t ev_idx = 0;
    for (int i = 0; i < q; ++i) {
        while (ev_idx < ev.size() && ev[ev_idx] <= quer[i].k) {
            advance(c, val, incr, ev[ev_idx] - last_event);
            last_event = ev[ev_idx];
            ++ev_idx;
        }

        if (quer[i].type == 1) {
            ans[quer[i].ind] = cnt_different;
        } else if (quer[i].type == 2) {
            ans[quer[i].ind] = total_xp + total_incr * (quer[i].k - last_event);
        } else {
            ans[quer[i].ind] = c[quer[i].pos] + incr[quer[i].pos] * (quer[i].k - last_event);
        }
    }

    for (const auto& x : ans) {
        cout << x << '\n';
    }

    return 0;
}