#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("rename-registers")

using namespace std;
constexpr int MAXN = 1000;
constexpr int MAXV = MAXN * MAXN;
constexpr int INF = (int)1e9;
vector<int> g[MAXN];
int dist[MAXV];
int n, m;
int cnt_vert;

int get_idx(int u, int v) {
    return u * n + v;
}

void bfs01() {
    fill(dist, dist + cnt_vert, INF);
    deque<pair<int, int>> q;
    q.emplace_back(0, 0);
    dist[get_idx(0, 0)] = 0;

    while (!q.empty()) {
        auto [u, v] = q.front();
        q.pop_front();

        if (u != v) {
            for (int to : g[u]) {
                if (to != v && dist[get_idx(to, v)] > dist[get_idx(u, v)]) {
                    dist[get_idx(to, v)] = dist[get_idx(u, v)];
                    q.emplace_front(to, v);
                }
                if (to == v && dist[get_idx(u, u)] > dist[get_idx(u, v)] + 1) {
                    dist[get_idx(u, u)] = dist[get_idx(u, v)] + 1;
                    q.emplace_back(u, u);
                }
            }
        } else {
            for (int to : g[u]) {
                if (dist[get_idx(u, to)] > dist[get_idx(u, v)] + 1) {
                    dist[get_idx(u, to)] = dist[get_idx(u, v)] + 1;
                    q.emplace_back(u, to);
                }
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    cnt_vert = n * n;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    bfs01();

    for (int v = 1; v < n; ++v) {
        if (dist[get_idx(v, v)] == INF) {
            cout << "-1 ";
        } else {
            cout << dist[get_idx(v, v)] << ' ';
        }
    }
    cout << '\n';
}

void clear_graph() {
    for (int v = 0; v < n; ++v) {
        g[v].clear();
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
        clear_graph();
    }

    return 0;
}

