#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <list>
#include <string>
#include <cstdlib>
#include <random>
#include <algorithm>
#include <list>

#define len(a) (int)a.size()

typedef long long ll;


const int INF = (int)1e9;

using namespace std;

int randint(int a, int b)
{
    static random_device rd;
    static mt19937 rnd(rd());
    return (int)(rnd() % (b - a + 1)) + a;
}

void run();
void gen();
void stupid();

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void solve_test()
{
    int n, m;
    cin >> n >> m;
    if (m != 1)
    {
        cout << "PIZDA\n";
        return;
    }
    vector<int> capacity(n + 1);
    for (int i = 1; i <= n; ++i)
    {
        cin >> capacity[i];
    }

    vector<ll> prefix_sums(n + 1);
    for (int i = 1; i <= n; ++i)
    {
        prefix_sums[i] = capacity[i] + prefix_sums[i - 1];
    }

    int left, right, cap, type;
    cin >> left >> right >> cap >> type;

    for (int i = 1; i <= n; ++i)
    {
        int nleft, nright;
        if (type == 1)
        {
            nleft = min(left, i);
            nright = max(right, i);
        }
        else
        {
            nleft = left;
            nright = right;
        }

        ll store = prefix_sums[nright] - prefix_sums[nleft - 1];
        cout << min(store, (ll)cap) << ' ';
    }
    cout << '\n';
}

void run()
{
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}