#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#endif

#include <iostream>
#include <vector>
#include <list>
#include <string>
#include <algorithm>
#include <queue>
#include <set>

#define len(a) (int)a.size()

typedef long long ll;


const int INF = (int)1e9;

using namespace std;

void run();

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif

    run();

}

void solve_test()
{
    int n, m;
    cin >> n >> m;
    vector<int> capacity(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> capacity[i];
    }

    vector<int> rob(m);
    vector< vector<int> > starts(n);
    vector< vector<int> > ends(n);
    vector<int> borders(m);
    vector< tuple<int, int, int> > one_borders;
    for (int i = 0; i < m; ++i)
    {
        int left, right, cap, type;
        cin >> left >> right >> cap >> type;
        --left, --right;
        rob[i] = cap;
        if (type == 0)
        {
            starts[left].push_back(i);
            ends[right].push_back(i);
        }
        else
        {
            one_borders.emplace_back(left, right, i);
        }
        borders[i] = right;
    }

    for (int i = 0; i < n; ++i)
    {
        for (auto [left, right, id] : one_borders)
        {
            starts[min(left, i)].push_back(id);
            ends[max(right, i)].push_back(id);
            borders[id] = max(right, i);
        }

        set< tuple<int, int, int> > opened;
        ll sum = 0;
        for (int j = 0; j < n; ++j)
        {
            for (int id : starts[j])
            {
                opened.insert({borders[id], id, rob[id]});
            }

            int left = capacity[j];
            while (left && !opened.empty())
            {
                auto [right, id, rob_left] = *opened.begin();
                opened.erase(opened.begin());
                int spend = min(left, rob_left);
                left -= spend;
                sum += spend;
                rob_left -= spend;
                if (rob_left)
                {
                    opened.insert({right, id, rob_left});
                }
            }

            for (int id : ends[j])
            {
                auto it = opened.lower_bound({j, id, -INF});
                if ((it != opened.end()) && (get<1>(*it) == id))
                {
                    opened.erase(it);
                }
            }
        }

        cout << sum << ' ';

        for (auto [left, right, id] : one_borders)
        {
            starts[min(left, i)].pop_back();
            ends[max(right, i)].pop_back();
            borders[id] = right;
        }
    }
    cout << '\n';
}

void run()
{
    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve_test();
    }
}