#pragma GCC optimize("Ofast")
#pragma GCC target("avx2,bmi2,avx512f,avx512dq")
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
int ptwo = 131072;
struct stree
{
	std::vector<int> data;
	stree()
	{
		data.resize(ptwo*2);
	}
	void inc(int at)
	{
		at += ptwo;
		while(at) data[at]++, at /= 2;
	}
	int rsum(int v, int L, int R, int ql, int qr)
	{
		if(ql <= L && R <= qr) return data[v];
		if(R <= ql || L >= qr) return 0;
		return rsum(2*v, L, (L+R)/2, ql, qr) +
			rsum(2*v+1, (L+R)/2, R, ql, qr);
	}
};
int64_t inversions(std::vector<int> ar) // permutation
{
	stree st {};
	//for(int x :  ar) printf("%d ", x); printf("\n");
	// count greater elements on prefix
	int n = ar.size();
	std::vector<int> ctrs(n);
	int64_t ans = 0;
	for(int i = 0; i < n; i++)
	{
		int e = ar[i];
		//for(int x : ctrs) printf("%d ", x); printf("\n");
		//for(int j = e; j < n; j++) ans += ctrs[j];
		ans += st.rsum(1, 0, ptwo, e, n);
		st.inc(e);
		//ctrs[e]++;
	}
	//printf("%lld\n", ans);
	return ans;
}
int64_t str_inv(std::string s, std::string t)
{
	std::vector<std::vector<int>> dmap(10);
	for(int i = 0; i < t.size(); i++)
		dmap[t[i]-'0'].push_back(i);
	for(int i = 0; i < 10; i++)
		std::reverse(dmap[i].begin(), dmap[i].end());
	int n = s.size();
	std::vector<int> perm(n);
	for(int i = 0; i < n; i++)
	{
		char c = s[i]-'0';
		int j = dmap[c].back();
		dmap[c].pop_back();
		perm[i] = j;
	}
	return inversions(perm);
}
int main()
{
	// maximize b[0], then maximize b[1], ...
	std::string A; std::cin >> A;
	int64_t y; scanf("%lld", &y);
	while(ptwo > A.size()) ptwo /= 2;
	// all digits that cost >=n*y must be maximized greedily
	// assume all digits but the last 18 are maximized
	//std::vector<int> ctrs(10);
	//for(char c : A) ctrs[c-'0']++;
	std::string A0 = A;
	std::string B = A;
	std::sort(B.rbegin(), B.rend());
	std::string pref = B.substr(0, B.size()<=18 ? 0 : int(B.size())-18);
	//printf("pref=%s\n", pref.data());
	std::string suf = B.substr(pref.size());
	//printf("suf=%s\n", suf.data());
	std::sort(suf.begin(), suf.end());
	std::string best = "";
	int64_t bestval = -1;
	do
	{
		A = pref + suf;
		int64_t cost = str_inv(A0, A);
		int64_t res = std::stoll(A) - cost * y;
		if(res > bestval || (res == bestval && A > best))
		{
			bestval = res;
			best = A;
		}
		//printf("%lld %s: %lld\n", res, A.data(), cost);
	} while(std::next_permutation(suf.begin(), suf.end()));
	printf("%s\n", best.data());
}
