//#define _GLIBCXX_DEBUG
#include <climits>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <vector>
struct query
{
	int64_t round;
	int64_t count;
	int i;
	int qi;
	char type;
};

std::pair<std::vector<int64_t>, std::vector<int64_t>> get_ans(std::vector<int64_t> c0)
{
	int n = c0.size();
	std::vector<int> curc; for(int x : c0) curc.push_back(x);
	int maxq = 10;
	std::vector<int64_t> n_uniq(maxq+1), n_gain(maxq+1);
	int64_t gain = 0;
	int64_t u0 = 0;
	//std::vector<int> n_uniq(maxq+1);
	//for(int x : curc) printf("%d ", x); printf("\n");
	//{
	//	std::set<int64_t> st; for(int64_t x : c0) st.insert(x);
	//	u0 = st.size();
	//	n_uniq[0] = u0;
	//}
	for(int t = 0; t <= maxq; t++)
	{
		n_gain[t] = gain;
		std::set<int64_t> st; for(int64_t x : c0) st.insert(x);
		std::vector<int> newc(n);
		std::vector<int> ctrs(10001);
		for(int i = 0; i < n; i++)
			ctrs[curc[i]]++;
		int rt = 0;
		for(int i = 0; i < 10000; i++) { if(ctrs[i]) printf("%d:%d ", i, ctrs[i]); }
		printf("\n");
		for(int i = 10001; i --> 0;)
		{
			if(ctrs[i] == 0) continue;
			else ctrs[i] = rt++;			
		}
		for(int i = 0; i < n; i++)
		{
			newc[i] = curc[i] + ctrs[curc[i]];
			gain += ctrs[curc[i]];
		}
		n_uniq[t] = rt;
		//printf("%d: ", t+1); for(int x : newc) printf("%d ", x); printf("\n");
		curc = newc;
	}
	return {n_uniq, n_gain};
}
struct gap
{
	int64_t k;
	int c;
	int i;
	int64_t lval;
	bool operator <(const gap& rhs) const { return std::tie(i,k,c,lval) < std::tie(rhs.i,rhs.k,rhs.c,rhs.lval); }
};
int main()
{
	int n, q; std::cin >> n >> q;
	// gap between every two distinct levels decreases by 1 every round
	// when two become equal, they are merged
	std::vector<int64_t> c0(n);
	for(int64_t& x : c0) std::cin >> x;
	std::vector<query> queries;
	std::map<int64_t, int> ctr;
	std::set<int64_t> st;
	for(int64_t x : c0) st.insert(x), ctr[x]++;
	std::vector<gap> gaps;
	int ci = 0;
	for(auto it = st.begin(); it != st.end(); ++it)
	{
		auto it2 = it; ++it2;
		if(it2 == st.end()) break;
		gaps.push_back({*it2 - *it, ctr[*it], ci, *it});
		ci++;
	}
	std::sort(gaps.begin(), gaps.end());
	for(int gi = 0; gi < gaps.size(); gi++)
	{
		auto[g, c, i, lv] = gaps[gi];
		queries.push_back({ g, c, i, gi, 4 });
	}
	//int64_t maxq = 0;
	std::vector<int64_t> qanswers(q, -1);
	for(int qi = 0; qi < q; qi++)
	{
		int t; int64_t k; int i = -1;
		scanf("%d%lld", &t, &k);
		if(t == 3) scanf("%d", &i), i--;
		//if(t == 2) k--;
		// simulation
		// create std::map<level, gained> (in an array because c is small)
		// add to each
		queries.push_back({ k, -1, i, qi, t });
		//maxq = std::max<int64_t>(maxq, k);
	}
	int64_t u0 = 0;
	{
		std::set<int64_t> st; for(int64_t x : c0) st.insert(x);
		u0 = st.size();
	}
	//auto[n_uniq, n_gain] = get_ans(c0);
	std::stable_sort(queries.begin(), queries.end(), [](auto a, auto b) { return a.round < b.round; } );
	int64_t ndist = u0;
	int64_t cdelta = 0;
	int64_t psum = 0;
	for(auto[k,c,i,lv] : gaps)
	{
		//printf("k=%d c=%d i=%d\n", k, c, i);
		psum += c;
		cdelta += psum;
	}
	int64_t pdelta = 0;
	int64_t pk = 0;
	std::vector<int64_t> cpsum(gaps.size());
	for(int i = 0; i < gaps.size(); i++)
		cpsum[i] = (i == 0 ? 0 : cpsum[i-1]) + gaps[i].c;
	std::vector<int64_t> txp(n), gain(n);
	txp = c0;
	std::map<int64_t,int64_t> imap;
	for(int i = 0; i < n; i++)
		imap[c0[i]] = 0;
	int ii = 0;
	for(auto&[k, v] : imap)
	{
		v = imap.size() - ii - 1, ii++;
		//printf("%d: %d\n", k, v);
	}
	for(int i = 0; i < n; i++)
		gain[i] = imap[c0[i]];
	// each element currently gains [number of greater elements] per turn
	for(auto[K, C, I, QI, T] : queries)
	{
		if(T == 1)
			qanswers[QI] = ndist;
		if(T == 2)
		{
			//printf("cdelta=%lld pdelta=%lld K=%lld pk=%lld\n", cdelta, pdelta, K, pk);
			qanswers[QI] = pdelta + cdelta * (K - pk);
		}
		if(T == 3)
		{
			// recompute total xp and gain rate of every element when a gap is removed
			// 16 pts lost for being O(n^2) instead of O(n log n)?
			//printf("K=%lld pk=%lld i=%d txp=%lld gain=%lld\n", K, pk, I, txp[I], gain[I]);
			int64_t ans = txp[I] + (K - pk) * gain[I];
			qanswers[QI] = ans;
		}
		if(T == 4)
		{
			//printf("gap K=%d C=%d I=%d removed\n", K, C, I);
			ndist--;
			pdelta += (K - pk) * cdelta;
			//for(int i = 0; i <= I; i++)
			//	cdelta -= gaps[i].c;
			cdelta -= cpsum[I];
			//cdelta -= C;
			// all <= elements now gain 1 less
			int64_t lv = gaps[QI].lval;
			for(int i = 0; i < n; i++)
			{
				//printf("K=%lld pk=%lld i=%d gain=%lld\n", K, pk, i, gain[i]);
				txp[i] += (K - pk) * gain[i];
				if(c0[i] <= lv)
					gain[i]--;
			}
			pk = K;
		}
	}
	for(int64_t x : qanswers) printf("%lld\n", x);
}
// simulate
// gap removed -> merge groups in dsu?
// query arrives
// 1 -> count distinct elements based on number of closed gaps
// 2 -> compute from current ptotal, delta
// 3 -> find number of greater elements?
//      was not changed
