#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

int n, q;
vector<ll> c;
vector<ll> d;

class Tree {
public:
	int sz;
	vector<vector<ll>> nodes;
	vector<vector<ll>> pref;

	Tree(vector<ll> d) {
		sz = 1;
		while ( sz < d.size() ) { sz <<= 1; }

		nodes = vector<vector<ll>>(2 * sz, vector<ll>(0)); for ( int i = sz; i < 2 * sz; ++i ) nodes[i] = {0};
		pref = vector<vector<ll>>(2 * sz, vector<ll>(0)); for ( int i = sz; i < 2 * sz; ++i ) pref[i] = {0, 0};

		for ( int i = 0; i < d.size(); ++i ) nodes[sz + i][0] = d[i];
		for ( int i = 0; i < d.size(); ++i ) pref[sz + i][1] = d[i];

		for ( int i = sz - 1; i > 0; --i ) do_merge(i);
	}

	void do_merge(int node) {
		merge(nodes[2 * node].begin(), nodes[2 * node].end(), nodes[2 * node + 1].begin(), nodes[2*node + 1].end(), back_inserter(nodes[node]));
		
		pref[node] = vector<ll>(nodes[node].size() + 1, 0);
		for ( int i = 0; i < nodes[node].size(); ++i ) pref[node][i + 1] = pref[node][i] + nodes[node][i];
	}

	ll calc_node(int node, ll k) {
		int ind = lower_bound(nodes[node].begin(), nodes[node].end(), k + 1) - nodes[node].begin();

		ll res = pref[node][ind] + k * (nodes[node].size() - ind);

		return res;
	}

	ll query(int node, int lft, int rgt, int l, int r, ll k) {
		if ( (rgt <= l) || (r <= lft) ) return 0;
		if ( (l <= lft) && (rgt <= r) ) return calc_node(node, k);

		int mid = (lft + rgt) / 2;

		ll left_res = query(node * 2, lft, mid, l, r, k);
		ll right_res = query(node * 2 + 1, mid, rgt, l, r, k);

		return left_res + right_res;
	}

	ll call_query(int l, int r, ll k) { return query(1, 0, sz, l, r, k); }
};

int main() {
	cin >> n >> q;

	c = vector<ll>(n);
	for ( int i = 0; i < n; ++i ) cin >> c[i];

	vector<pair<ll, int>> sorted(n);
	for ( int i = 0; i < n; ++i ) sorted[i] = {c[i], i};
	
	sort(sorted.begin(), sorted.end());
	reverse(sorted.begin(), sorted.end());	

	vector<int> translate(n);
	for ( int i = 0; i < n; ++i ) translate[sorted[i].second] = i;

	d = vector<ll>(n - 1);
	for ( int i = 0; i < n - 1; ++i ) d[i] = sorted[i].first - sorted[i + 1].first ;

	vector<ll> ds(n - 1);
	for ( int i = 0; i < n - 1; ++i ) ds[i] = d[i];
	sort(ds.begin(), ds.end());
	
	vector<pair<ll, int>> dt(n - 1);
	for ( int i = 0; i < n - 1; ++i ) dt[i] = {d[i], n - i - 1};
	sort(dt.begin(), dt.end());

	vector<ll> pref(n, 0);
	for ( int i = 0; i < n - 1; ++i ) pref[i + 1] = pref[i] + (dt[i].first * dt[i].second);

	vector<ll> suff(n, 0);
	for ( int i = n - 2; i >= 0; --i ) suff[i] = suff[i + 1] + dt[i].second;

	Tree tree(d);

	for ( int i = 0; i < q; ++i ) {
		int t;
		cin >> t;

		ll k; int pos;

		if ( t == 1 ) {
			cin >> k;

			ll ind = lower_bound(ds.begin(), ds.end(), k + 1) - ds.begin();

			cout << n - ind << endl;
		} else if ( t == 2 ) {
			cin >> k;

			ll ind = lower_bound(ds.begin(), ds.end(), k + 1) - ds.begin();

			ll ans = pref[ind] + (k * suff[ind]);

			cout << ans << endl;
		} else if ( t == 3 ) {
			cin >> k >> pos;
			ll initial = c[pos - 1];

			pos = translate[pos - 1];

			if ( n == 1 ) {
				cout << 0 << endl;
			} else {
				cout << initial + tree.call_query(0, pos, k) << endl;
			}
		}
	}
	return 0;
}