#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;

vi s;
vi pos[10];
ll y, n;

struct fenwick {
    int n;
    vi tree;

    fenwick(int _n): n{_n}, tree(_n) {}

    void inc(int i) {
        while (i < n) {
            tree[i]++;
            i |= i + 1;
        }
    }

    void dec(int i) {
        while (i < n) {
            tree[i]--;
            i |= i + 1;
        }
    }

    int rsum(int r) {
        int res = 0;
        while (r >= 0) {
            res += tree[r];
            r = (r & (r + 1)) - 1;
        }
        return res;
    }
};

int main() {
    string input;
    cin >> input >> y;
    n = (ll)input.size();
    s = vi(n);
    for (int i = 0; i < n; i++) {
        s[i] = int(input[i] - '0');
        pos[s[i]].push_back(i);
    }
    sort(s.begin(), s.end());
    ll answer = 0;
    string num = input;
    do {
        int idx[10] = {0};
        ll curr = 0, tax = 0;
        fenwick shift(n);
        for (int i = 0; i < n; i++) {
            curr = (curr * 10) + s[i];
            int j = idx[s[i]]++;
            ll d = shift.rsum(i) + pos[s[i]][j] - i;
            if (d > 0) {
                tax += d;
                shift.inc(i);
                shift.dec(pos[s[i]][idx[s[i]] - 1] + 1);
            }
        }
        ll with_tax = curr -  y * tax;
        //printf("curr = %lld, tax = %lld, with_tax = %lld\n", curr, tax, with_tax);
        if (with_tax >= answer) {
            answer = with_tax;
            for (int i = 0; i < n; i++)
                num[i] = char(s[i] + '0');
        }
    } while (next_permutation(s.begin(), s.end()));
    cout << num;
}