#include <bits/stdc++.h>

using namespace std;
using vi = vector<int>;

const int INF = 1e9;

int n;
vector<vi> fa;
vector<bool> isCutVertex;
vi p;
vi tin, up;
vi comps;
int lastComp = 1;
vi _cut;

void findCutVertex(int v, int p) {
    up[v] = tin[v] = p == -1 ? 0 : tin[p] + 1;
    int cc = 0, mup = up[v];
    for (int u : fa[v]) {
        if (u == p)
            continue;
        if (tin[u] == -1) {
            cc++;
            findCutVertex(u, v);
            if (up[u] >= tin[v] && p != -1) {
                isCutVertex[v] = true;
                while (!_cut.empty()) {
                    comps[_cut.back()] = lastComp;
                    _cut.pop_back();
                }
                lastComp++;
            }
        }
        mup = min(mup, up[u]);
        if (p == -1) {
            while (!_cut.empty()) {
                comps[_cut.back()] = lastComp;
                _cut.pop_back();
            }
            if (comps[v] == 0)
                comps[v] = lastComp;
            lastComp++;
        }
    }
    _cut.push_back(v);
    up[v] = mup;
    if (cc > 1 && p == -1)
        isCutVertex[v] = true;
}

void compute() {
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : fa[v])
            for (int k : fa[u]) {
                int nd = p[v] + 2;
                if (nd < p[k]) {
                    if (comps[v] == comps[k] || !isCutVertex[u]) {
                        p[k] = nd;
                        q.push(k);
                    }
                }
            }
    }
}

void solve() {
    int m;
    cin >> n >> m;
    fa = vector<vi>(n);
    while(m--) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        fa[u].push_back(v);
        fa[v].push_back(u);
    }
    tin.assign(n, -1);
    up.assign(n, INF);
    isCutVertex.assign(n, false);
    comps.assign(n, 0);
    findCutVertex(0, -1);
    p.assign(n, INF);
    p[0] = 0;
    compute();
    for (int v = 1; v < n; v++)
        cout << (p[v] == INF ? -1 : p[v]) << ' ';
    cout << '\n';
    cout << flush;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
}