#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

#define int int32_t
#define uint uint32_t

#define ll int64_t
#define ull uint64_t

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define en '\n'
#define mt

void io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> cap(n);
    for (auto &elem : cap) cin >> elem;
    vector<tuple<int, int, int, int>> rb(m); // lrct
    for (auto &[l, r, c, t] : rb) {
        cin >> l >> r >> c >> t;
        --l;
    }
    for (int x = 0; x < n; ++x) {
        vector<tuple<int, int, int>> rb2;
        for (auto [l, r, c, t] : rb) {
            if (t == 1) {
                l = min(l, x);
                r = max(r, x + 1);
            }
            rb2.push_back({l, r, c});
        }
        sort(all(rb2));
        vector<int> flow(n, 0);
        multiset<pair<int, int>> cur;
        int curM = 0;
        for (int i = 0; i < n; ++i) {
            while (!cur.empty() && cur.begin()->first == i) {
                cur.erase(cur.begin());
            }
            while (curM < m && get<0>(rb2[curM]) == i) {
                cur.insert({get<1>(rb2[curM]), get<2>(rb2[curM])});
                ++curM;
            }
            while (!cur.empty() && flow[i] != cap[i]) {
                auto [r, cnt] = *cur.begin();
                cur.erase(cur.begin());
                int val = min(cap[i] - flow[i], cnt);
                flow[i] += val;
                cnt -= val;
                if (cnt != 0) cur.insert({r, cnt});
            }
        }
        cout << accumulate(all(flow), 0ll) << ' ';
    }
}

int32_t main() {
    io();
#ifdef mt
    int ttt;
    cin >> ttt;
    while (ttt-- > 0) solve();
#else
    solve();
#endif
    return 0;
}