#include <numeric>
#include <cassert>
#include <queue>
#include <sstream>
#include <functional>
#include <random>
#include <ctime>
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
mt19937 rnd(time(0) + 239);

 #define int long long
constexpr int inf = 1e9 + 7;
using ll = long long;

void Solve(istream &in, ostream &out) {
    int t;
    in >> t;
    while (t--) {
        int n, m;
        in >> n >> m;
        vector<int> A(n);
        for (int &a_i : A) {
            in >> a_i;
        }
        vector<int> L(m), R(m), C(m), T(m);
        for (int i = 0; i < m; ++i) {
            in >> L[i] >> R[i] >> C[i] >> T[i];
            --L[i];
            --R[i];
        }
        for (int x = 0; x < n; ++x) {
            vector<vector<pair<int, int>>> E(n);
            for (int i = 0; i < m; ++i) {
                int l = L[i], r = R[i];
                if (T[i]) {
                    l = min(l, x);
                    r = max(r, x);
                }
                E[l].emplace_back(r, C[i]);
            }
            //
            int res = 0;
            multiset<pair<int, int>> bots;
            for (int i = 0; i < n; ++i) {
                for (auto bot : E[i]) {
                    bots.insert(bot);
                }

                int a = A[i];
                while (a > 0 && !bots.empty()) {
                    auto bot = *bots.begin();
                    bots.erase(bots.begin());
                    int delta = min(a, bot.second);
                    a -= delta;
                    res += delta;
                    bot.second -= delta;
                    if (bot.second > 0) {
                        bots.insert(bot);
                    }
                }

                while (!bots.empty() && bots.begin()->first == i) {
                    bots.erase(bots.begin());
                }
            }
            out << res << ' ';
        }
        out << '\n';
    }
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    Solve(cin, cout);
//    ostringstream test;
//    GenFull(test);
//    istringstream in(test.str());
//    ostringstream out;
//    Solve(in, cout);
    cerr << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    return 0;
}
