/*
 * Join us on Telegram:
 * - My blog on competitive programming & software development: @ivanqs_blog
 * - A competitive programming community: @dshindov_chat
 * - Other blogs at @pr_channels_list
 */

#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;

	vector<int> c(n);
	for(int i = 0; i < n; i++) {
		cin >> c[i];
	}

	auto c_sorted = c;
	sort(c_sorted.begin(), c_sorted.end());
	vector<pair<int, int>> jumps;
	for(int i = 1; i < n; i++) {
		jumps.emplace_back(c_sorted[i] - c_sorted[i - 1], i);
	}
	sort(jumps.begin(), jumps.end());

	vector<int> diffs(n);
	for(int i = n - 1; i >= 0; i--) {
		diffs[i] = n - 1 - i;
	}
	int diffs_sum = 0;
	for(int x: diffs) {
		diffs_sum += x;
	}

	vector<pair<int, int>> diff_sums_at_time;
	diff_sums_at_time.emplace_back(0, diffs_sum);

	for(auto [jump, i]: jumps) {
		// for(int j = 0; j < i; j++) {
		// 	diffs[j]--;
		// }
		diffs_sum -= i;

		if(diff_sums_at_time.back().first == jump) {
			diff_sums_at_time.pop_back();
		}
		diff_sums_at_time.emplace_back(jump, diffs_sum);
	}

	vector<int> prefix(diff_sums_at_time.size());
	for(int i = 1; i < prefix.size(); i++) {
		prefix[i] = prefix[i - 1] + (diff_sums_at_time[i].first - diff_sums_at_time[i - 1].first) * diff_sums_at_time[i - 1].second;
	}
 
	for(int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if(t == 1) {
			int k;
			cin >> k;
			cout << jumps.end() - lower_bound(jumps.begin(), jumps.end(), make_pair(k + 1, 0LL)) + 1 << "\n";
		} else if(t == 2) {
			int k;
			cin >> k;

			auto it = lower_bound(diff_sums_at_time.begin(), diff_sums_at_time.end(), make_pair(k + 1, 0LL));
			--it;
			int epoch = it - diff_sums_at_time.begin();
			int ans = diff_sums_at_time[epoch].second * (k - diff_sums_at_time[epoch].first);
			ans += prefix[epoch];

			cout << ans << "\n";
		} else if(t == 3) {
			int k, i;
			cin >> k >> i;
			cout << -1 << "\n";
		}
	}

	return 0;
}
