/*
 * Join us on Telegram:
 * - My blog on competitive programming & software development: @ivanqs_blog
 * - A competitive programming community: @dshindov_chat
 * - Other blogs at @pr_channels_list
 */

#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;

	vector<int> c(n);
	for(int i = 0; i < n; i++) {
		cin >> c[i];
	}

	vector<int> c_ind(n);
	iota(c_ind.begin(), c_ind.end(), 0);
	sort(c_ind.begin(), c_ind.end(), [&](int i, int j) {
		return c[i] < c[j];
	});
	vector<int> rev_c_ind(n);
	for(int i = 0; i < n; i++) {
		rev_c_ind[c_ind[i]] = i;
	}

	auto c_sorted = c;
	sort(c_sorted.begin(), c_sorted.end());
 
 	vector<tuple<int, int, int, int>> queries;
	for(int i = 0; i < q; i++) {
		int t;
		cin >> t;
		if(t == 1) {
			int k;
			cin >> k;
			queries.emplace_back(k, 1, -1, i);
		} else if(t == 2) {
			int k;
			cin >> k;
			queries.emplace_back(k, 2, -1, i);
		} else if(t == 3) {
			int k, j;
			cin >> k >> j;
			j--;
			queries.emplace_back(k, 3, rev_c_ind[j], i);
		}
	}
	for(int i = 1; i < n; i++) {
		queries.emplace_back(c_sorted[i] - c_sorted[i - 1], 0, i, -1);
	}
	sort(queries.begin(), queries.end());

	vector<int> diffs(n);
	for(int i = n - 1; i >= 0; i--) {
		diffs[i] = n - 1 - i;
	}
	int diffs_sum = 0;
	for(int x: diffs) {
		diffs_sum += x;
	}

	vector<int> prefix_diffs(n);
	int prefix_diffs_sum = 0;

	int cnt_blocks = n;

	vector<int> ans(q, -1);
	int prev_k = 0;
	for(auto [k, t, i, qi]: queries) {
		prefix_diffs_sum += diffs_sum * (k - prev_k);
		for(int j = 0; j < n; j++) {
			prefix_diffs[j] += diffs[j] * (k - prev_k);
		}
		prev_k = k;

		if(t == 0) {
			for(int j = 0; j < i; j++) {
				diffs[j]--;
			}
			diffs_sum -= i;
			cnt_blocks--;
		} else if(t == 1) {
			ans[qi] = cnt_blocks;
		} else if(t == 2) {
			ans[qi] = prefix_diffs_sum;
		} else if(t == 3) {
			ans[qi] = prefix_diffs[i] + c_sorted[i];
		}
	}

	for(int i = 0; i < q; i++) {
		cout << ans[i] << "\n";
	}

	return 0;
}
