/*
 * Join us on Telegram:
 * - My blog on competitive programming & software development: @ivanqs_blog
 * - A competitive programming community: @dshindov_chat
 * - Other blogs at @pr_channels_list
 */

#include <bits/stdc++.h>

using namespace std;

#define int long long

struct robot_t {
	int l, r, c, t;
};

void solve() {
	int n, m;
	cin >> n >> m;

	vector<int> a(n);
	for(int& x: a) {
		cin >> x;
	}

	vector<robot_t> robots(m);
	for(auto& robot: robots) {
		cin >> robot.l >> robot.r >> robot.c >> robot.t;
		robot.l--;
	}

	for(int x = 0; x < n; x++) {
		auto new_robots = robots;
		for(auto& robot: new_robots) {
			if(robot.t == 1) {
				robot.l = min(robot.l, x);
				robot.r = max(robot.r, x + 1);
			}
		}
		sort(new_robots.begin(), new_robots.end(), [](auto& r1, auto& r2) {
			return r1.r < r2.r;
		});

		vector<int> left = a;
		set<int> non_zero_poss;
		for(int i = 0; i < n; i++) {
			if(left[i] > 0) {
				non_zero_poss.insert(i);
			}
		}

		int ans = 0;
		for(auto& robot: new_robots) {
			auto it = non_zero_poss.lower_bound(robot.l);
			while(it != non_zero_poss.end() && *it < robot.r && robot.c > 0) {
				int i = *it;
				int d = min(left[i], robot.c);
				left[i] -= d;
				robot.c -= d;
				ans += d;
				if(left[i] == 0) {
					it = non_zero_poss.erase(it);
				}
			}
		}
		cout << ans << " ";
	}
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;

	while(t --> 0) {
		solve();
	}

	return 0;
}