/*
 * Join us on Telegram:
 * - My blog on competitive programming & software development: @ivanqs_blog
 * - A competitive programming community: @dshindov_chat
 * - Other blogs at @pr_channels_list
 */

#include <bits/stdc++.h>

using namespace std;

#define int long long

struct robot_t {
	int l, r, c, t;
};

void solve() {
	int n, m;
	cin >> n >> m;

	vector<int> a(n);
	for(int& x: a) {
		cin >> x;
	}

	vector<robot_t> robots(m);
	for(auto& robot: robots) {
		cin >> robot.l >> robot.r >> robot.c >> robot.t;
		robot.l--;
	}

	vector<int> defii;
	defii.push_back(0);
	defii.push_back(n);
	for(auto& robot: robots) {
		defii.push_back(robot.l);
		defii.push_back(robot.r);
	}
	sort(defii.begin(), defii.end());
	defii.erase(unique(defii.begin(), defii.end()), defii.end());

	for(int i1 = 1; i1 < defii.size(); i1++) {
		int lx = defii[i1 - 1];
		int rx = defii[i1];

		auto new_robots = robots;
		for(auto& robot: new_robots) {
			if(robot.t == 1) {
				robot.l = min(robot.l, rx);
				robot.r = max(robot.r, lx);
			}
		}

		vector<int> left(defii.size() - 1);
		for(int i = 1; i < defii.size(); i++) {
			for(int j = defii[i - 1]; j < defii[i]; j++) {
				left[i - 1] += a[j];
			}
		}

		int ans = 0;

		sort(new_robots.begin(), new_robots.end(), [](auto& r1, auto& r2) {
			return r1.r < r2.r;
		});
		for(auto& robot: new_robots) {
			int l = lower_bound(defii.begin(), defii.end(), robot.l) - defii.begin();
			int r = lower_bound(defii.begin(), defii.end(), robot.r) - defii.begin();
			while(l < r && l < lx && robot.c > 0) {
				int d = min(left[l], robot.c);
				left[l] -= d;
				robot.c -= d;
				ans += d;
				l++;
			}
			robot.l = defii[l];
		}

		sort(new_robots.begin(), new_robots.end(), [](auto& r1, auto& r2) {
			return r1.l > r2.l;
		});
		for(auto& robot: new_robots) {
			int l = lower_bound(defii.begin(), defii.end(), robot.l) - defii.begin();
			int r = lower_bound(defii.begin(), defii.end(), robot.r) - defii.begin();
			while(r > l && r > rx && robot.c > 0) {
				int d = min(left[r - 1], robot.c);
				left[r - 1] -= d;
				robot.c -= d;
				ans += d;
				r--;
			}
			robot.r = defii[r];
		}

		// for(int x: left) {
		// 	cerr << x << " ";
		// }
		// cerr << "duh." << endl;

		int cover_left = 0;
		int cover_right = 0;
		int cover_all = 0;
		for(auto& robot: new_robots) {
			if(robot.t == 1 && robot.r < rx) {
				cover_left += robot.c;
			}
			if(robot.t == 1 && robot.l > lx) {
				cover_right += robot.c;
			}
			if(robot.l <= lx && rx <= robot.r) {
				cover_all += robot.c;
			}
		}

		int total_left = 0;
		int total_right = left[i1 - 1] - a[lx];

		for(int x = lx; x < rx; x++) {
			int cur = ans;

			int arr[3] = {total_left, a[x], total_right};
			int d;

#define C(from, to) do { \
			d = min(from, arr[to]); \
			arr[to] -= d; \
			from -= d; \
			cur += d; \
		} while(0);

			C(cover_left, 0)
			C(cover_left, 1)
			C(cover_right, 1)
			C(cover_right, 2)
			C(cover_all, 0)
			C(cover_all, 1)
			C(cover_all, 2)

			total_left += a[x];
			total_right -= a[x];
			cout << cur << " ";
		}
	}

	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;

	while(t --> 0) {
		solve();
	}

	return 0;
}