#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define len(a) int((a).size())
#define all(a) begin(a), end(a)

template<typename Fun>
struct y_combinator {
    const Fun fun;

    y_combinator(const Fun&& fun) : fun(forward<const Fun>(fun)) {}

    template<typename... Args>
    decltype(auto) operator()(Args&&... args) const {
        return fun(ref(*this), forward<Args>(args)...);
    }
};

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    for (auto &x : c) cin >> x;

    struct query {
        int type;
        ll k;
        int i, id;
    };
    vector<query> qq(q);
    for (int i = 0; i < q; i++) qq[i].id = i;
    for (auto &[type, k, i, id] : qq) {
        cin >> type >> k;
        if (type == 3) cin >> i, i--;
    }
    sort(all(qq), [&](const query &a, const query &b) {
        return a.k < b.k;
    });

    vector<int> par(n), sz(n, 1);
    iota(all(par), 0);
    map<ll, int> last;
    for (int i = 0; i < n; i++) {
        if (last.count(c[i])) {
            par[i] = last[c[i]];
            sz[par[i]]++;
        } else {
            last[c[i]] = i;
        }
    }

    auto root = y_combinator([&](auto root, int v) -> int {
        return par[v] == v ? v : par[v] = root(par[v]);
    });

    auto a = c;
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    vector<int> inds;
    for (auto x : a) inds.push_back(last[x]);

    ll cur_time = 0;
    int qpos = 0;
    vector<ll> ans(q);
    ll already = 0;

    while (true) {
        int id = -1;
        for (int i = 0; i < len(a) - 1; i++) {
            ll cur = a[i + 1] - a[i];
            if (id == -1 || cur < a[id + 1] - a[id]) {
                id = i;
            }
        }

        ll cnt = id == -1 ? 0 : a[id + 1] - a[id];
        cur_time += cnt;
        while (qpos < len(qq) && (qq[qpos].k < cur_time || id == -1)) {
            auto [type, k, i, id] = qq[qpos];
            if (type == 1) {
                ans[id] = len(a);
            } else if (type == 2) {
                ans[id] += already;
                ans[id] += 1ll * len(a) * (len(a) - 1) / 2 * (k - (cur_time - cnt));
            } else {
                int where = root(i);
                int pos = find(all(inds), where) - inds.begin();
                ans[id] = a[pos] + (len(a) - 1 - pos) * (k - (cur_time - cnt));
            }
            qpos++;
        }

        if (id == -1) break;
        for (int i = 0; i < len(a) - 1; i++) {
            ll delta = (len(a) - i - 1) * cnt;
            already += delta * sz[inds[i]];
            a[i] += delta;
        }
        par[inds[id]] = inds[id + 1];
        sz[par[inds[id]]] += sz[inds[id]];
        inds.erase(inds.begin() + id);
        a.erase(a.begin() + id);

        // cout << "cur_time = " << cur_time << endl;
        // cout << "a: "; for (auto x : a) cout << x << ' '; cout << endl;
        // cout << "inds: "; for (auto x : inds) cout << x << ' '; cout << endl;
        // cout << "root: "; for (int i = 0; i < n; i++) cout << root(i) << ' '; cout << endl;
        // cout << endl;
    }

    assert(qpos == q);
    for (int i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }
}
