#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>

using namespace std;

int n;

struct state {
    long k;
    set<long> s;
    vector<long> c;
    long ps = 0;

    void do_transform_from(state &a, long step) {
        c.resize(n);
        long j = 1;
        ps = a.ps;
        map<long, long> tr;
        for (auto i : a.s) {
            s.insert(i + (a.s.size() - j) * step);
            tr[i] = i + (a.s.size() - j) * step;
            j++;
        }
        for (int i = 0;i < n;i++) {
            ps += (tr[a.c[i]] - a.c[i]);
            c[i] = tr[a.c[i]];
        }
    }

};

struct comp {

    bool operator()(state a, state b) const {
        return a.k > b.k;
    }

};

int main() {
    int q;
    cin >> n >> q;
    set<state, comp> states;
    state start;
    vector<long> c(n);
    for (int i = 0;i < n;i++) cin >> c[i];
    start.c = c;
    start.k = 0;
    start.ps = 0;
    for (auto i : c) start.s.insert(i);
    vector<long> raw;
    for (auto i : start.s) {
        raw.push_back(i);
    }
    set<long> dif;
    for (int i = 1;i < raw.size();i++) {
        dif.insert(raw[i] - raw[i - 1]);
    }
    states.insert(start);
    state pre = start;
    for (auto i : dif) {
        state new_st = state();
        new_st.k = i;
        new_st.do_transform_from(pre, i - pre.k);
        pre = new_st;
        states.insert(new_st);
    }
    for (int i = 0;i < q;i++) {
        int t;
        cin >> t;
        long k;
        cin >> k;
        state zgl;
        zgl.k = k;
        state minst = *states.lower_bound(zgl);
        // cout << minst.k << endl;
        state final_state;
        final_state.do_transform_from(minst, k - minst.k);
        if (t == 1) {
            cout << final_state.s.size() << endl;
        }
        else if (t == 2) {
            cout << final_state.ps << endl;
        }
        else {
            int ind;
            cin >> ind;
            ind--;
            cout << final_state.c[ind] << endl;
        }
    }
}







