#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <assert.h>
#include <random>
#include <bitset>
#include <tuple>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pii;

#define all(v) v.begin(), v.end()
#define mp make_pair
#define endl '\n'
#define pb push_back

const int N = 5005;

vector<int> e1[N];
vector<int> e[N];

int d[N];

int col[N][N];

int C;

int B;

void dfs(int i)
{
	col[B][i] = C;
	for (int j : e1[i])
	{
		if (j != B && col[j] == 0)
		{
			dfs(j);
		}
	}
}

bitset<N> mat1[N];
bitset<N> mat[N];

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
	{
		int n, m;
		cin >> n >> m;
		for (int i = 0; i < n; i++)
		{
			e1[i].clear();
			e[i].clear();
		}
		for (int i = 0; i < m; i++)
		{
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			e1[a].push_back(b);
			mat1[a][b] = 1;
			e1[b].push_back(a);
			mat1[b][a] = 1;
		}
		for (int i = 0; i < n; i++)
		{
			B = i;
			C = 1;
			for (int j = 0; j < n; j++)
			{
				if (j != B && col[j] == 0)
				{
					dfs(j);
					C++;
				}
			}
		}
		for (int i = 0; i < n; i++)
		{
			for (int j : e[i])
			{
				for (int u : e[j])
				{
					if (i != u && col[i] == col[u])
					{
						e[i].push_back(u);
					}
				}
			}
		}
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				if (mat1[i][j] && i != j)
				{
					e[i].push_back(j);
				}
			}
		}
		fill(d, d + n, -1);
		set<pii> s;
		s.insert({ 0,0 });
		while (!s.empty())
		{
			auto [dis, i] = *s.begin();
			s.erase(s.begin());
			if (d[i] != -1)
			{
				continue;
			}
			d[i] = dis;
			for (int j : e[i])
			{
				if (d[j] == -1)
				{
					s.insert({ dis + 1,j });
				}
			}
		}
		for (int i = 1; i < n; i++)
		{
			if (d[i] == -1)
			{
				cout << "-1 ";
				continue;
			}
			cout << d[i] * 2 << " ";
		}
		cout << endl;
	}
}