#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define int ll
using namespace __gnu_pbds;
using namespace std;
using ll = long long;
#define all(o) (o).begin(), (o).end()
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

struct Event {
    ll time;
    int id, type, arg;
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<ll> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int l, int r) { return a[l] < a[r]; });
    sort(all(a));

    vector<Event> requests;
    for (int i = 0; i < n - 1; ++i) {
        requests.push_back({a[i + 1] - a[i], -1, 0, -1});
    }

    vector<int> rp(n);
    for (int i = 0; i < n; ++i) {
        rp[p[i]] = i;
    }

    for (int i = 0; i < q; ++i) {
        int type;
        ll time;
        cin >> type >> time;
        if (type <= 2) {
            requests.push_back({time, i, type, -1});
        } else {
            int j;
            cin >> j;
            j--;
            requests.push_back({time, i, type, rp[j]});
        }
    }

    sort(all(requests), [](Event l, Event r) {
        return make_pair(l.time, l.type) < make_pair(r.time, r.type);
    });

    ll timer = 0;
    vector<ll> ans(q, -1);

    vector<pair<ll, int>> groups;
    for (int i = 0; i < n; ++i) groups.emplace_back(a[i], 1);

    ll total_added = 0;
    for (auto[time, id, type, arg]: requests) {
        ll diff = time - timer;

        for (int i = 0; i < groups.size(); ++i) {
            groups[i].first += ll(groups.size() - i - 1) * diff;
            total_added += ll(groups.size() - i - 1) * diff * groups[i].second;
        }
        if (type == 0) {
            vector<pair<ll, int>> new_groups;
            ll last = -1;
            for (auto &group: groups) {
                if (group.first == last) {
                    new_groups.back().second += group.second;
                } else {
                    new_groups.push_back(group);
                    last = group.first;
                }
            }
            groups = new_groups;
        } else if (type == 1) {
            ans[id] = int(groups.size());
        } else if (type == 2) {
            ans[id] = total_added;
        } else if (type == 3) {
            for (auto &group: groups) {
                arg -= group.second;
                if (arg < 0) {
                    ans[id] = group.first;
                    break;
                }
            }
        }
        timer = time;
    }

    cout << ans << "\n";
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q = 1;
    cin >> q;
    while (q--) {
        solve();
        cout << "###############\n";
    }
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
    int q = 1;
    // cin >> q;
    while (q--) solve();
#endif
    return 0;
}