#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using ll = long long;
#define all(o) (o).begin(), (o).end()
#if LOCAL
#define dbg(o) ({cout << #o << " = " << (o) << "\n"; (o);})
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &o, const vector<T> &v) {
    for (const auto &e: v) o << e << " ";
    return o;
}

vector<vector<int>> graph;
vector<array<bool, 2>> visited;
vector<array<int, 2>> dist;
#define at(p) operator[]((p).first)[(p).second]

void solve() {
    int n, m;
    cin >> n >> m;
    graph.assign(n, {});
    visited.assign(n, {});
    dist.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        visited[i].fill(false);
        dist[i].fill(INT32_MAX);
    }

    queue<pair<int, int>> q;
    q.push({0, 0});
    dist[0][0] = 0;
    visited[0][0] = true;
    while (!q.empty()) {
        auto[v, layer] = q.front();
        q.pop();
        for (int u : graph[v]) {
            if (visited[u][!layer]) continue;
            dist[u][!layer] = dist[v][layer] + 1;
            visited[u][!layer] = true;
            q.push({u, !layer});
        }
    }

    for (int i = 1; i < n; ++i) {
        if (dist[i][0] == INT32_MAX) {
            cout << -1 << " ";
        } else {
            cout << dist[i][0] << " ";
        }
    }
    cout << "\n";
}

signed main() {
#if LOCAL
    freopen("../input.txt", "r", stdin);
    int q = 1;
    cin >> q;
    while (q--) {
        solve();
        cout << "###############\n";
    }
#else
    ios_base::sync_with_stdio(false), cin.tie(0);
    int q = 1;
    cin >> q;
    while (q--) solve();
#endif
    return 0;
}