#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
typedef long double ld;
#define int ll
typedef pair<int, int> pii;
#define vec vector
#define all(a) a.begin(), a.end()
#define _ << ' ' <<
#ifndef HOME
#define cerr if(0) cerr
#endif
#ifdef int
const int INF = 2e16;
#else
const int INF = 2e9;
#endif
class SegTree {
    int n;
    vec<int> t;
    vec<int> p;
    void build(int v, int l, int r) {
        if (l == r - 1) {
            t[v] = n - 1 - l;
            return;
        }
        int m = (r + l) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = t[2 * v +1] + t[2 * v + 2];
    }
    void push(int v, int l, int r) {
        t[v] += p[v] * (r - l);
        if (l != r- 1) {
            p[2 * v + 1] += p[v];
            p[2 * v + 2] += p[v];
        }
        p[v] = 0;
    }
    void upd(int v, int l, int r, int L, int R, int x) {
        if (L <= l && r <= R) {
            p[v] += x;
            push(v, l, r);
            return;
        }
        push(v, l, r);
        if (R <= l || r <= L) {
            return;
        }
        int m = (r + l) / 2;
        upd(2 * v + 1, l, m ,L, R, x);
        upd(2 * v + 2, m, r ,L, R, x);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }
    int get(int v, int l, int r, int L, int R) {
        push(v, l, r);
        if (L <= l && r <= R) {
            return t[v];
        }
        if (R <= l || r <= L) {
            return 0;
        }
        int m = ( r + l) / 2;
        int a = get(2 * v + 1, l, m, L, R);
        int b = get(2 * v + 2, m, r, L, R);
        return a + b;
    }

public:
    SegTree(int n) :n(n) {
        t.resize(4 * n);
        p.resize(4 * n);
        build(0, 0, n);
    }
    int get(int l, int r) {
        return get(0,0, n, l, r);
    }
    void upd(int l, int r) {
        upd(0, 0, n, l, r, -1);
    }
    void print() {
        for (int i = 0; i < n; ++i) {
            cerr << get(i, i + 1) << ' ';
        }
        cerr << '\n';
    }
};
void solve() {
    int n, q;
    cin >> n >> q;
    SegTree sg(n);
    sg.print();
    vec<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(all(a));
    map<int, vec<int>> mp;
    for (int i = 1; i < n; ++i) {
        int d = a[i] - a[i - 1];
        mp[d].push_back(i);
    }
    vec<int> ks;
    vec<int> cnt;
    vec<int> presum;
    vec<int> laysum;
    int tmp = 0;
    int prvk = 0, prvcnt = n;
    for (auto [k, v]: mp) {
        cerr << "\n---\n";
        cerr << k << '\n';
        for (auto i: v) {
            sg.upd(0, i);
            cerr << i << ": ";
            sg.print();
        }
        ks.push_back(k);
        cnt.push_back(sg.get(0, 1) + 1);
        if (!laysum.empty()) {
            tmp += laysum.back() * (k - prvk);
        }
        int x =sg.get(0, n);
        laysum.push_back(x);
        presum.push_back(tmp);
//        tmp += x * (k - prvk );
        prvk = k;

    }
    for (int r = 0; r < q; ++r) {
        int t;
        cin >> t;
        int k;
        cin >> k;
        if (t == 1) {


            int i = upper_bound(all(ks), k) - ks.begin() - 1;
            int ans = n;
            if (i >= 0) {
                ans = cnt[i];
            }
            cout << ans << '\n';
        }
        if (t == 2) {
            int i = upper_bound(all(ks), k) - ks.begin() - 1;
            int ans = k * n * (n - 1) / 2;
            if (i >= 0) {
                ans = presum[i] + (k - ks[i]) * laysum[i];
            }
            cout << ans << '\n';

        }
    }
}

signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    for (int i = 0; i < tt; ++i) {
        ld s = clock();
        solve();
        cout << '\n';
        ld e = clock();
        cerr << "Worktime:" _ (e - s) / CLOCKS_PER_SEC << '\n';
    }
}