//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<int>> g;

vector<int> tin, up;
vector<int> used;
int cur_time;

vector<pair<int, int>> st;
vector<vector<pair<int, int>>> comps;

void dfs(int v, int p=-1) {
    used[v] = 1;
    up[v] = tin[v] = cur_time++;
    for (int u : g[v]) {
        if (tin[u] == -1) {
            int time_was = st.size();
            st.push_back({u, v});
            dfs(u, v);
            up[v] = min(up[v], up[u]);
            if (p == -1 || up[u] >= tin[v]) {
                comps.push_back({});
                while (st.size() > time_was) {
                    comps.back().push_back(st.back());
                    st.pop_back();
                }
            } 
        } else if (u != p) {
            if (used[u] == 1)
                st.push_back({u, v});
            up[v] = min(up[v], tin[u]);
        }
    }
    used[v] = 2;
}

void solve() {
    comps.clear();
    int n, m;
    cin >> n >> m;
    g.clear();
    g.resize(n);
    used.assign(n, 0);
    tin.assign(n, -1);
    up.assign(n, -1);
    cur_time = 0;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0, -1);
    for (auto &el : comps) {
        for (auto &el2 : el) {
            if (el2.second < el2.first) {
                swap(el2.first, el2.second);
            }
        }
        sort(el.begin(), el.end());
        el.erase(unique(el.begin(), el.end()), el.end());
    }
#ifdef LOCAL
    cout << "Printing comps:" << endl;
    for (auto el : comps) {
        for (auto [a, b] : el) {
            cout << a << " " << b << endl;
        }
        cout << endl;
    }
    cout << '#' << endl;/**/
#endif

    vector<int> ans(n, -1);
    ans[0] = 0;
    g.clear();
    g.resize(n);
    while (!comps.empty()) {
        auto comp = comps.back();
        comps.pop_back();
        vector<int> vers;
        for (auto [a, b] : comp) {
            g[a].push_back(b);
            g[b].push_back(a);
            vers.push_back(a);
            vers.push_back(b);
        }
        sort(vers.begin(), vers.end());
        vers.erase(unique(vers.begin(), vers.end()), vers.end());
        vector<unordered_map<int, int>> dist(2); 
        deque<pair<int, int>> q;
        for (int v : vers) {
            if (ans[v] != -1) {
                dist[0][v] = ans[v];
                q.push_back({0, v});
            }
        }
        while (!q.empty()) {
            int type = q.front().first;
            int v = q.front().second;
            q.pop_front();
            for (int u : g[v]) {
                if (!dist[type ^ 1].count(u)) {
                    dist[type ^ 1][u] = dist[type][v] + 1;
                    q.push_back({type ^ 1, u});
                }
            }
        }
        for (auto el : dist[0]) {
            ans[el.first] = el.second;
        }
        for (auto [a, b] : comp) {
            g[a].clear();
            g[b].clear();
        }
    }
#ifdef LOCAL
    cout << "answer: " << endl;
#endif
    for (int i = 1; i < n; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
