//#undef LOCAL
#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

const int MAXN = 2e5 + 228;

int pa[MAXN];
int ra[MAXN];
int re[MAXN];

int get(int a) {
    if (pa[a] != a)
        return pa[a] = get(pa[a]);
    return a;
}

void merge(int a, int b) {
    a = get(a);
    b = get(b);
    int rr = re[a];
    if (ra[b] > ra[a])
        swap(a, b);
    ra[a] += ra[b];
    pa[b] = a;
    re[a] = rr;
}

void init(int n) {
    iota(pa, pa + n, 0);
    iota(re, re + n, 0);
    fill(ra, ra + n, 1);
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    } 
    vector<array<int, 4>> arr(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 4; j++) {
            cin >> arr[i][j];
        }
        arr[i][0]--;
    }
    sort(arr.begin(), arr.end(), [&](auto a, auto b) {
            return a[1] < b[1];
            });
    vector<array<int, 4>> arr1, arr2;
    for (auto el : arr) {
        if (el[3]) {
            arr2.push_back(el);
        } else {
            arr1.push_back(el);
        }
    }
    for (int x = 0; x < n; x++) {
        init(n + 1);
        vector<int> a2 = a;
        auto get2 = [&](int x) {
            while (1) {
                x = re[get(x)];
                if (x == n) {
                    return x;
                }
                if (a[x] != 0) {
                    return x;
                }
                merge(x + 1, x); 
            }
        };
        int ans = 0;
        int i1 = 0, i2 = 0;
        while (i1 < (int) arr1.size() || i2 < (int) arr2.size()) {
            array<int, 4> el;
            if (i1 == (int) arr1.size()) {
                el = arr2[i2++];
            } else if (i2 == (int) arr2.size()) {
                el = arr1[i1++];
            } else if (arr1[i1][1] <= max(arr2[i2][1], x + 1)) {
                el = arr1[i1++];
            } else {
                el = arr2[i2++];
            }

            int l = el[0];
            int r = el[1];
            int rem = el[2];
            if (el[3]) {
                l = min(l, x);
                r = max(r, x + 1);
            }
            int cur = get2(l);
            while (rem && cur < r) {
                int k = min(rem, a[cur]);
                rem -= k;
                ans += k;
                a[cur] -= k;
                cur = get2(cur);
            }
        }
        a = a2;
        cout << ans << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
