#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

#define int ll

const ll SZ = 5e5 + 100, INF = 1e9 * 1e9 + 100, MX = 1'000'000'000'000 + 1000;
ll n, m;
vector<vector<ll>> gr;

ll dist[SZ][2];
bool soch[SZ], used[SZ];
ll tin[SZ], mx[SZ];


void dfs(int v, int par = -1) {
	int cnt = 0;
	used[v] = 1;

	for (auto to : gr[v]) {
		if (!used[to]) {
			tin[to] = tin[v] + 1;
			mx[to] = tin[to];
			dfs(to, v);
			if (v == 2) {
				cout << "";
			}
			mx[v] = min(mx[v], mx[to]);
			if (mx[to] > tin[v]) soch[v] = 1;
			cnt++;
		}
		else if (to != par) {
			mx[v] = min(mx[v], tin[to]);
		}
	}

	if (par == -1) {
		if (cnt > 1) soch[v] = 1;
	}
}

void sol() {
	ll n, m;
	cin >> n >> m;

	gr.clear();
	gr.resize(n);

	for (int i = 0; i < n; i++) {
		used[i] = 0;
		soch[i] = 0;
	}
	for (int i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}

	tin[0] = 0;
	dfs(0);

	for (int i = 0; i < n; i++) {
		dist[i][0] = INF;
		dist[i][1] = INF;
	}

	dist[0][0] = 0;
	queue<pair<ll, ll>> q;
	q.push({ 0, 0 });

	while (!q.empty()) {
		pair<ll, ll> v = q.front();
		q.pop();

		for (auto to : gr[v.first]) {
			if (v.second == 0 && soch[to]) continue;
			if (dist[to][!v.second] >= INF) {
				dist[to][!v.second] = dist[v.first][v.second] + 1;
				q.push({ to, !v.second });
			}
		}
	}

	for (int i = 1; i < n; i++) {
		if (dist[i][0] >= INF) {
			cout << "-1 ";
		}
		else {
			cout << dist[i][0] << " ";
		}
	}
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		sol();
	}

	return 0;
}

/*
1
12 15
1 2
1 12

2 3
4 1
2 4
4 3
5 3
5 1
5 6
3 7
7 8
4 9
9 10
10 11
11 9
*/