#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <deque>
#define int long long
using namespace std;

const int inf = 1e13;

vector <vector <int>> g;

void solve() {
	int n, m; cin >> n >> m;
	g.assign(n, {});
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--, v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	vector <int> dp(n * n, -1); dp[0] = 0;
	deque <int> q; q.push_front(0);
	while (!q.empty()) {
		int s = q.front(); q.pop_front();
		int u = s / n;
		int cor = s % n;
		if (cor == u) {
			for (auto v : g[u]) {
				int vv = u * n + v;
				if (dp[vv] == -1) {
					dp[vv] = dp[s] + 1;
					q.push_back(vv);
				}
			}
		}
		else {
			for (auto v : g[u]) {
				if (v == cor) {
					int vv = u * n + u;
					if (dp[vv] == -1) {
						dp[vv] = dp[s] + 1;
						q.push_back(vv);
					}
				}
				else {
					int vv = v * n + cor;
					if (dp[vv] == -1) {
						dp[vv] = dp[s];
						q.push_front(vv);
					}
				}
			}
		}
	}

	for (int i = 1; i < n; i++) {
		int t = dp[i * n + i];
		cout << t << ' ';
	}
	cout << '\n';
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
	}

	return 0;
}
