#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define print(x) {for(auto &__val: x) cout << __val << ' '; cout << '\n';}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rngl(chrono::steady_clock::now().time_since_epoch().count());
int random(int l, int r) { return uniform_int_distribution<int>(l, r)(rng);}
ll randoml(ll l, ll r) { return uniform_int_distribution<ll>(l, r)(rngl);}

vector<vector<pii>> graf;
vector<int> tin, fup;
vector<bool> most;
vector<int> cmp;
int timer = 0;

void dfs(int v, int last) {
    tin[v] = fup[v] = timer++;
    for(auto &[i, r]: graf[v]) {
        if(i == last) continue;
        if(tin[i] != -1) fup[v] = min(fup[v], tin[i]);
        else {
            dfs(i, v);
            fup[v] = min(fup[v], fup[i]);
        }
        if(fup[i] > tin[v]) {
            most[r] = true;
        }
    }
}

vector<bool> was;

void sfd(int v, int last, int clr) {
    was[v] = true;
    for(auto &[i, r]: graf[v]){
        if(i == last) continue;
        if(was[i]) {
            if(tin[i] < tin[v] && cmp[r] == -1) cmp[r] = clr;
        } else {
            if(fup[v] < fup[i]) {
                int nclr = timer++;
                cmp[r] = nclr;
                sfd(i, v, nclr);
            } else {
                cmp[r] = clr;
                sfd(i, v, clr);
            }
        }
    }
}

vector<int> can;

void build(int v) {
    can[v] = true;
    for(auto &[i, r]: graf[v]) {
        if(can[i]) continue;
        if(!most[r]) build(i);
    }
}

void solve() {
    graf.clear();
    tin.clear();
    fup.clear();
    most.clear();
    can.clear();
    cmp.clear();
    was.clear();
    timer = 0;
    int n, m;
    cin >> n >> m;
    can.resize(n);
    graf.resize(n);
    tin.resize(n, -1);
    fup.resize(n);
    was.resize(n);
    most.resize(m);
    cmp.resize(m, -1);
    for(int i=0;i<m;i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        graf[x].pb({y, i});
        graf[y].pb({x, i});
    }
    dfs(0, -1);
    timer = 0;
    sfd(0, -1, 0);
    build(0);
    for(int i=0;i<n;i++) {
        if(!can[i]) graf[i].clear();
        else {
            vector<pii> x = graf[i];
            graf[i].clear();
            for(auto &v: x) {
                if(can[v.ff]) graf[i].pb(v);
            }
        }
    }
    vector<vector<int>> farg(n);
    for(int v=0;v<n;v++) {
        for(auto &[i, r1]: graf[v]) {
            for(auto &[u, r2]: graf[i]) {
                if(v != u) {
                    if(cmp[r1] == cmp[r2]) farg[v].pb(u);
                }
            }
        }
    }
    vector<int> d(n, -1);
    queue<int> q;
    d[0] = 0;
    q.push(0);
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        for(auto &i: farg[v]) {
            if(d[i] == -1) {
                d[i] = d[v] + 2;
                q.push(i);
            }
        }
    }
    for(int i=1;i<n;i++) cout << d[i] << ' ';
    cout << '\n';
}
/*
4
4 4
1 2
2 3
3 4
4 1

5 5
1 2
2 3
3 4
4 5
5 1

5 6
1 2
3 2
1 3
3 5
5 4
3 4

9 12
1 2
2 3
3 1
4 5
5 6
6 4
7 8
8 9
9 7
3 6
6 9
9 3
*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
}