#include <iostream>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <utility>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <deque>
#include <bitset>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

struct Event {
    long long k;
    int ind, type;
    Event() {}
    Event(long long k_, int ind_, int type_): k(k_), ind(ind_), type(type_) {}
    bool operator<(Event other) {
        return k < other.k;
    }
};

vector<long long> stsum, stcnt;

void build_cnt(int v, int l, int r) {
    if (r - l == 1) {
        stcnt[v] = 1;
        return;
    }
    int mid = (l + r) / 2;
    build_cnt(v * 2 + 1, l, mid);
    build_cnt(v * 2 + 2, mid, r);
    stcnt[v] = stcnt[v * 2 + 1] + stcnt[v * 2 + 2];
}

void update_cnt(int v, int l, int r, int ind) {
    if (r - l == 1) {
        stcnt[v] = 0;
        return;
    }
    --stcnt[v];
    int mid = (l + r) / 2;
    if (ind < mid) {
        update_cnt(v * 2 + 1, l, mid, ind);
    } else {
        update_cnt(v * 2 + 2, mid, r, ind);
    }
}

void update_sum(int v, int l, int r, int ind, long long x) {
    if (r - l == 1) {
        stsum[v] = x;
        return;
    }
    int mid = (l + r) / 2;
    if (ind < mid) {
        update_sum(v * 2 + 1, l, mid, ind, x);
    } else {
        update_sum(v * 2 + 2, mid, r, ind, x);
    }
    stsum[v] = stsum[v * 2 + 1] + stsum[v * 2 + 2];
}

long long get_cnt(int v, int l, int r, int L, int R) {
    if (R <= l || r <= L) {
        return 0;
    }
    if (L <= l && r <= R) {
        return stcnt[v];
    }
    int mid = (l + r) / 2;
    return get_cnt(v * 2 + 1, l, mid, L, R) + get_cnt(v * 2 + 2, mid, r, L, R);
}

long long get_sum(int v, int l, int r, int L, int R) {
    if (R <= l || r <= L) {
        return 0;
    }
    if (L <= l && r <= R) {
        return stsum[v];
    }
    int mid = (l + r) / 2;
    return get_sum(v * 2 + 1, l, mid, L, R) + get_sum(v * 2 + 2, mid, r, L, R);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<long long> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    vector<long long> sortedc = c;
    sort(sortedc.begin(), sortedc.end());
    vector<pair<long long, int>> r(n);
    for (int i = 0; i + 1 < n; ++i) {
        r[i] = make_pair(sortedc[i + 1] - sortedc[i], i);
    }
    r[n - 1] = make_pair(0, n - 1);
    sort(r.begin(), r.end());
    vector<Event> query(q);
    for (int i = 0; i < q; ++i) {
        long long k;
        int type;
        cin >> type >> k;
        if (type == 3) {
            cin >> type;
            --type;
        } else {
            type = -type;
        }
        query[i] = Event(k, i, type);
    }
    sort(query.begin(), query.end());
    vector<long long> ans(q);
    int ind = 0;
    long long arif = (long long)n * (n + 1) / 2;
    long long mod = 0;
    stsum.resize(4 * n, 0);
    stcnt.resize(4 * n, 0);
    build_cnt(0, 0, n);
    for (int i = 0; i < q; ++i) {
        while (ind < n && r[ind].first <= query[i].k) {
            arif -= r[ind].second + 1;
            mod += r[ind].first * (r[ind].second + 1);
            update_cnt(0, 0, n, r[ind].second);
            update_sum(0, 0, n, r[ind].second, r[ind].first);
            ++ind;
        }
        if (query[i].type == -1) {
            ans[query[i].ind] = n - ind + 1;
        } else if (query[i].type == -2) {
            ans[query[i].ind] = arif * query[i].k + mod;
        } else {
            int cind = lower_bound(sortedc.begin(), sortedc.end(), c[query[i].type]) - sortedc.begin();
            ans[query[i].ind] = get_sum(0, 0, n, cind, n)
                    + get_cnt(0, 0, n, cind, n) * query[i].k + c[query[i].type];
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }

}

signed main() {
    fastio();

    int t = 1;
    while (t--) {
        solve();
    }

    return 0;
}
