#include <iostream>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

const ll inf = 1e18;

void solve() {
	int n, m; cin >> n >> m;
	vector<vector<int>> g(n);
	for (int i = 0; i < m; i++) {
		int v, u; cin >> v >> u;
		v--; u--;

		g[v].push_back(u);
		g[u].push_back(v);
	}

	queue<pair<int, bool>> q[3];
	map<pair<int, bool>, int> dist;
	map<pair<int, bool>, bool> used;
	q[0].push({ 0, true });
	dist[{0, true}] = 0;
	used[{0, true}] = true;

	while (q[0].size() + q[1].size() + q[2].size() != 0) {
		pair<int, int> v;
		if (q[0].size() > 0) {
			v = q[0].front();
			q[0].pop();
		} else if (q[1].size() > 0) {
			v = q[1].front();
			q[1].pop();
		} else {
			v = q[2].front();
			q[2].pop();
		}

		if (v.second) {
			for (auto to : g[v.first]) {
				pair<int, bool> cur = { v.first, false };
				if (!used[cur]) {
					q[1].push(cur);
					dist[cur] = dist[v] + 1;
					used[cur] = true;
				}

				cur = { to, true };
				if (!used[cur]) {
					q[2].push(cur);
					dist[cur] = dist[v] + 2;
					used[cur] = true;
				}
			}
		}
		else {
			for (auto to : g[v.first]) {
				pair<int, int> cur = { to, false };
				if (!used[cur]) {
					q[0].push(cur);
					dist[cur] = dist[v];
					used[cur] = true;
				}
			}
		}
	}

	for (int i = 1; i < n; i++) {
		if (!used[{i, true}])
			cout << -1 << ' ';
		else
			cout << dist[{i, true}] << ' ';
	}

	cout << '\n';
}

int main() {
	int t; cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}