#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <queue>
#include <set>

using namespace std;

vector<vector<int>> gr;
vector<int> tin, fout, used, bad, comp;
// vector<set<int>> gr_comp;

int timer;

void dfs_time(int v) {
	used[v] = 1;
	tin[v] = fout[v] = timer++;
	int cnt = 0;
	for (int u : gr[v]) {
		if (used[u]) {
			fout[v] = min(fout[v], tin[u]);
		}
		else {
			cnt++;
			dfs_time(u);
			fout[v] = min(fout[v], fout[u]);
			if (v && fout[u] >= tin[v]) {
				bad[v] = true;
			}
		}
	}
	if (cnt > 1 && v == 0) {
		bad[v] = true;
	}
}

void dfs_comp(int v, int c) {
	if (comp[v] != -1) {
		return;
	}
	comp[v] = c;
	for (int u : gr[v]) {
		if (bad[u]) {
			// gr_comp[c].insert(u);
			continue;
		}
		dfs_comp(u, c);
	}
}

vector<array<int, 2>> ans;

void dfs_ans(int c, int u) {
	// cout << "u = " << u << "\n";
	queue<pair<int, int>> q;
	q.push({ u, 1 });
	while (!q.empty()) {
		int v = q.front().first;
		int t = q.front().second;
		// cout << "ans[" << v << "][" << t << "] = " << ans[v][t] << "\n";
		q.pop();
		for (int w : gr[v]) {
			if (ans[w][!t] != -1) {
				continue;
			}
			if (comp[w] == c || bad[w]) {
				// cout << "(" << v << ", " << t << ") -> (" << w << ", " << !t << "), c = " << c << "\n";
				ans[w][!t] = ans[v][t] + 1;
				q.push({ w, !t });
			}
			if (bad[w] && t == 0) {
				set<int> next_c;
				for (int nc : gr[w]) {
					if (comp[nc] != c) {
						next_c.insert(comp[nc]);
					}
				}
				for (int nc : next_c) {
					dfs_ans(nc, w);
				}
			}
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	gr.assign(n, {});
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}
	timer = 0;
	used.assign(n, 0), tin.resize(n), fout.resize(n), bad.assign(n, 0);
	dfs_time(0);
	int cnt = 0;
	comp.assign(n, -1);
	for (int i = 0; i < n; i++) {
		// cout << "bad[" << i << "] = " << bad[i] << "\n";
		if (!bad[i] && comp[i] == -1) {
			// gr_comp.push_back(set<int>());
			dfs_comp(i, cnt++);
		}
		// cout << "comp[" << i << "] = " << comp[i] << "\n";
	}
	ans.assign(n, { -1, -1 });
	ans[0][1] = 0;
	dfs_ans(0, 0);
	for (int i = 1; i < n; i++) {
		cout << ans[i][1] << " ";
	}
	cout << "\n";
}

int main() {
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
}
