#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

//#define int ll

vector<int> from(ll x) {
	vector<int> res;
	while (x > 0) {
		res.emplace_back(x % 10);
		x /= 10;
	}
	reverse(all(res));
	return res;
}

ll to(vector<int>& x) {
	ll res = 0;
	for (auto& i : x)
		res = res * 10 + i;
	return res;
}

vector<int> rev(int i, int j, vector<int>& it) {
	vector<int> itt;
	itt.reserve(it.size());
	for (int k = 0; k < it.size(); ++k) {
		if (k == i) {
			itt.emplace_back(it[j]);
			continue;
		}
		if (k > i) {
			if (k - 1 >= j) itt.emplace_back(it[k]);
			else itt.emplace_back(it[k - 1]);
		}
		else
			itt.emplace_back(it[k]);
	}
	return itt;
}

ll cost(int i, int j, vector<int> x, ll y) {
	ll res = -y * (j - i) - to(x);
	auto itt = rev(i, j, x);
	res += to(itt);
	return res;
}

const int len = 17;

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	vector<int> x;
	ll y;
	string s;
	cin >> s >> y;
	for (auto& i : s)
		x.emplace_back(i - '0');
	int n = x.size();
	if (n < len) {
		bool f = 1;
		vector<int> a = x;
		while (f) {
			f = 0;
			ll mx = 0, im = 0, jm = 0;
			for (int i = 0; i < n; ++i) {
				for (int j = i + 1; j < n; ++j) {
					ll cst = cost(i, j, a, y);
					if (cst >= mx) {
						f = 1;
						mx = cst;
						im = i, jm = j;
					}
				}
			}
			a = rev(im, jm, a);
		}
		for (auto& i : a)
			cout << i;
	}
	else {
		sort(x.begin(), x.end() - len, greater<int>());
		bool f = 1;
		vector<int> a;
		for (int i = n - 1; i >= n - len; --i)
			a.emplace_back(x[i]);
		reverse(all(a));
		while (f) {
			f = 0;
			ll mx = 0, im = 0, jm = 0;
			for (int i = 0; i < len; ++i) {
				for (int j = i + 1; j < len; ++j) {
					ll cst = cost(i, j, a, y);
					if (cst >= mx) {
						f = 1;
						mx = cst;
						im = i, jm = j;
					}
				}
			}
			a = rev(im, jm, a);
		}
		for (int i = 0; i < n - len; ++i)
			cout << x[i];
		for (auto& i : a)
			cout << i;
	}
	return 0;
}