#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <numeric>
#include <queue>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

//#define int ll

struct dsu {
	int n;
	vector<int> p, rang;
	dsu(int _n, vector<int>& rangs) {
		n = _n;
		p.resize(n);
		rang = rangs;
		iota(all(p), 0);
	}
	int lead(int v) {
		if (p[v] == v) return v;
		return p[v] = lead(p[v]);
	}
	int unite(int a, int b) {
		a = lead(a);
		b = lead(b);
		if (a == b) return 0;
		p[a] = b;
		return 1;
	}
};

ll getvl(map<int, int>& cnt) {
	ll cc = cnt.size() - 1;
	ll res = 0;
	for (auto& i : cnt) {
		res += cc * i.second;
		--cc;
	}
	return res;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	int n, q;
	cin >> n >> q;
	vector<ll> c(n);
	map<ll, int> cnt;
	for (ll& i : c) {
		cin >> i;
		cnt[i]++;
	}
	sort(all(c));
	c.resize(unique(all(c)) - c.begin());
	vector<ll> r;
	for (int i = 1; i < c.size(); ++i)
		r.emplace_back(c[i] - c[i - 1]);

	sort(all(r));
	ll t, k;
	vector<int> ccnt(cnt.size());
	int in = 0;
	map<int, int> cccnt;
	for (auto& it : cnt) {
		cccnt[in] = it.second;
		ccnt[in++] = it.second;
	}

	vector<pair<ll, int>> ss;
	for (int i = 0; i < r.size(); ++i) {
		ss.emplace_back(r[i], i);
	}
	sort(all(ss));
	vector<vector<pair<ll, ll>>> xx(r.size() + 1, vector<pair<ll, ll>>(n));

	vector<dsu> th(r.size() + 1);
	vector<pair<ll, ll>> aa(r.size() + 1);
	ll sum = 0, val = getvl(cccnt);
	aa[0] = { sum, val };
	ll prt = 0;
	dsu ds(r.size() + 1, ccnt);
	for (int i = 0; i < ss.size(); ++i) {
		sum += aa[i].second * (ss[i].first - prt);
		cccnt[ds.lead(ss[i].second + 1)] += cccnt[ds.lead(ss[i].second)];
		cccnt[ds.lead(ss[i].second)] = 0;
		cccnt.erase(ds.lead(ss[i].second));
		ds.unite(ss[i].second, ss[i].second + 1);
		aa[i + 1] = { sum, getvl(cccnt) };
		prt = ss[i].first;
	}

	for (int i = 0; i < q; ++i) {
		cin >> t >> k;
		if (t == 1) {
			auto it = upper_bound(all(r), k);
			cout << r.size() - (it - r.begin()) + 1 << '\n';
		}
		if (t == 2) {
			auto it = upper_bound(all(r), k);
			int in = (it - r.begin());
			if (in == 0)
				cout << aa[in].first + aa[in].second * k << '\n';
			else
				cout << aa[in].first + aa[in].second * (k - r[in - 1]) << '\n';
		}
		if (t == 3) {

		}
	}
	return 0;
}