#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <numeric>
#include <queue>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

//#define int ll

vector<vector<int>> g;
vector<set<pair<int, int>>> gg;
vector<int> u;
int timer = 0;

void dfs(int v) {
	u[v] = timer;
	for (auto& i : g[v]) {
		if (u[i] == timer) continue;
		dfs(i);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	g.assign(n, {});
	int a, b;
	for (int i = 0; i < m; ++i) {
		cin >> a >> b;
		--a, --b;
		g[a].emplace_back(b);
		g[b].emplace_back(a);
	}
	gg.assign(n, {});
	u.assign(n, 0);
	for (int v = 0; v < n; ++v) {
		for (auto& i : g[v]) {
			++timer;
			u[i] = timer;
			dfs(v);
			for (auto& it : g[i])
				if (u[it] == timer)
					gg[v].emplace(it, 2);
		}
	}
	vector<int> d(n, 1e9);
	d[0] = 0;
	priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> q;
	q.emplace(d[0], 0);
	while (!q.empty()) {
		auto it = q.top();
		q.pop();
		if (d[it.second] < it.first) continue;
		int v = it.second;
		for (auto& i : gg[v]) {
			if (d[i.first] > d[v] + i.second) {
				d[i.first] = d[v] + i.second;
				q.emplace(d[i.first], i.first);
			}
		}
	}
	for (int i = 1; i < n; ++i)
		cout << (d[i] == 1e9 ? -1 : d[i]) << " ";
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(false);
#endif
	int t;
	cin >> t;
	while (t-- > 0) {
		solve();
		cout << '\n';
	}
	return 0;
}