#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e15;
const int MAXN =  3e5 + 100;

int dsu[MAXN];
int szs[MAXN];
int lst[MAXN];

void build(int n) {
    iota(dsu, dsu + n, 0);
    iota(lst, lst + n, 0);
    fill(szs, szs + n, 1);
}

int getroot(int v) {
    if (v == dsu[v])
        return v;
    return dsu[v] = getroot(dsu[v]);
}

void unite(int v, int u) {
    v = getroot(v);
    u = getroot(u);
    if (v == u)
        return;
    if (szs[v] < szs[u])
        swap(v, u);
    szs[v] += szs[u];
    lst[v] = max(lst[v], lst[u]);
    dsu[u] = v;
}

void gettt2(vector<pair<int, pair<int, int>>> &tt2, vector<int> &arr) {
    int n = arr.size();
    vector<int> uni = arr;
    uni.resize(unique(uni.begin(), uni.end()) - uni.begin());
    vector<int> prefuni(uni.size());
    int p = -1;
    int ll = -1;
    for (int i = 0; i < n; ++i) {
        if (ll != arr[i])
            p++, ll = arr[i];
        prefuni[p]++;
    }
    int sm = 0;
    for (int i = 0; i < uni.size(); ++i) {
        sm += ((int)uni.size() - 1 - i) * prefuni[i];
    }
    for (int i = 1; i < uni.size(); ++i) {
        prefuni[i] = prefuni[i] + prefuni[i - 1];
    }
    vector<pair<int, int>> dif(n - 1);
    for (int i = 1; i < n; ++i) {
        dif[i - 1].first = arr[i] - arr[i - 1];
        dif[i - 1].second = arr[i - 1];
    }
    sort(dif.rbegin(), dif.rend());
    while (!dif.empty() && dif.back().first == 0)
        dif.pop_back();
    reverse(dif.begin(), dif.end());

    tt2.reserve(dif.size() + 10);
    tt2.push_back({0, {0, sm}});
    build(uni.size());
    for (int i = 0; i < dif.size(); ++i) {
        int time = dif[i].first;
        int totsm = tt2.back().second.first + (time - tt2.back().first) * (tt2.back().second.second);
        int val1 = dif[i].second;
        int ind1 = lower_bound(uni.begin(), uni.end(), val1) - uni.begin();
        ind1 = lst[getroot(ind1)];
        int ind2 = ind1 + 1;
        int ks = prefuni[ind1];
        int nsm = tt2.back().second.second - ks;
        tt2.push_back({time, {totsm, nsm}});
        unite(ind2, ind1);
    }
}

int get2(vector<pair<int, pair<int, int>>> &tt2, int k) {
    int ind = upper_bound(tt2.begin(), tt2.end(), make_pair(k, make_pair(INF, INF))) - tt2.begin() - 1;
    int res = tt2[ind].second.first;
    int dt = k - tt2[ind].first;
    res += dt * tt2[ind].second.second;
    return res;
}
vector<int> crr;

struct Query {
    int t, k, i;
    int ind;

    bool operator<(const Query &o) const {
        if ((t == 3) != (o.t == 3)) {
            return t == 3;
        }
        return crr[i] > crr[o.i];
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    scanf("%lld %lld", &n, &q);
    crr.resize(n);
    for (int &el: crr) {
        scanf("%lld", &el);
    }

    vector<int> arr = crr;
    sort(arr.begin(), arr.end());
    vector<pair<int, int>> dif(n - 1);
    for (int i = 1; i < n; ++i) {
        dif[i - 1].first = arr[i] - arr[i - 1];
        dif[i - 1].second = arr[i - 1];
    }
    sort(dif.begin(), dif.end());


    vector<Query> qrr(q);
    for (int i = 0; i < q; ++i) {
        int t, k, ii;
        scanf("%lld %lld", &t, &k);
        if (t == 3)
            scanf("%lld", &ii), ii--;
        else
            ii = 0;
        qrr[i] = {t, k, ii, i};
    }
    sort(qrr.begin(), qrr.end());

    vector<pair<int, pair<int, int>>> lsttt2;
    vector<pair<int, pair<int, int>>> curtt2;
    vector<int> curar;
    int p = n;
    vector<int> ans(q);
    for (auto &qq : qrr) {
        while (p == n || arr[p] > crr[qq.i] || (qq.t != 3 && p > 0)) {
            swap(lsttt2, curtt2);
            p--;
            curtt2.clear();
            curar.insert(curar.begin(), arr[p]);
            gettt2(curtt2, curar);
        }
        if (qq.t == 3) {
            int val = crr[qq.i];
            int ind = upper_bound(arr.begin(), arr.end(), val) - arr.begin() - 1;
            int a = get2(curtt2, qq.k);
            if (ind + 1 < n)
                a -= get2(lsttt2, qq.k);
            a += val;
            ans[qq.ind] = a;
        } else if (qq.t == 2) {
            int res = get2(curtt2, qq.k);
            ans[qq.ind] = res;
        } else {
            int ind = upper_bound(dif.begin(), dif.end(), make_pair(qq.k, INF)) - dif.begin();
            int res = (int)dif.size() - ind + 1;
            ans[qq.ind] = res;
        }
    }
    for (int &el : ans)
        printf("%lld\n", el);
}