#include <bits/stdc++.h>
#define ll long long
#define lll __int_128
#define all(v) v.begin(), v.end()
#define pii pair<int, int>
using namespace std;
mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
struct treap{
    ll b, c, sum;
    int sz, ind, prior;
    treap *lson, *rson, *anc;
    treap(int i) {
        ind = i, sz = 1;
        sum = b = c = 0;
        lson = 0, rson = 0, anc = 0;
        prior = rng();
    }
};
void push(treap *t) {
    int sz = 0;
    if (t->lson)
        sz = t->lson->sz;
    t->sum += t->b + t->c * sz;
    if (t->lson)
        t->lson->b += t->b, t->lson->c += t->c;
    if (t->rson)
        t->rson->b += t->b + t->c*(sz + 1), t->rson->c += t->c;
    t->c = 0, t->b = 0;
}
void recalc(treap *t) {
    t->sz = 0;
    if (t->lson)
        t->sz += t->lson->sz, t->lson->anc = t;
    if (t->rson)
        t->sz += t->rson->sz, t->rson->anc = t;
}
treap *merge(treap *l, treap *r) {
    if (!l)
        return r;
    if (!r)
        return l;
    if (l->prior > r->prior) {
        push(l);
        l->rson = merge(l->rson, r);
        recalc(l);
        return l;
    }
    push(r);
    r->lson = merge(l, r->lson);
    recalc(r);
    return r;
}
pair<treap*, treap*> split(treap *t, int need) {
    if (!t)
        return {t, t};
    int sz = 0;
    if (t->lson)
        sz = t->lson->sz;
    push(t);
    if (sz + 1 > need) {
        auto a = split(t->lson, need);
        t->lson = a.second;
        recalc(t);
        return {a.first, t};
    }
    auto a = split(t->rson, need - sz - 1);
    t->rson = a.first;
    recalc(t);
    return {t, a.second};
}
int get_index(treap *t) {
    int res = 1;
    if (t->lson)
        res += t->sz;
    if (t->anc) {
        if (t->anc->lson == t)
            res -= t->sz + 1;
        return res + get_index(t->anc);
    }
    return res;
}
const int N = 3e5 + 113;
vector<ll> queries[N];
pii mrg[N];
int snm[N], sz[N];
int getroot(int v) {
    if (snm[v] == v)
        return v;
    return snm[v] = getroot(snm[v]);
}
void merge(int a, int b) {
    a = getroot(a), b = getroot(b);
    snm[a] = b;
    sz[b] += sz[a];
}
ll ans[N];
signed main() {
    int n, q;
    cin >> n >> q;
    vector<pair<ll, int>> val(n);
    for (int i = 0; i < n; i++)
        cin >> val[i].first, val[i].second = i, snm[i] = i, sz[i] = 1;
    set<pair<ll, pii>> events;
    sort(all(val));
    for (int i = 1; i < n; i++) {
        mrg[i] = {val[i - 1].second, val[i].second};
        events.insert({val[i].first - val[i - 1].first, {0, i}});
    }
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        ll k;
        cin >> k;
        if (t == 1) {

            queries[i] = {1, k};
        }
        if (t == 2) {
            queries[i] = {2, k};
        }
        if (t == 3) {
            int j;
            cin >> j;
            queries[i] = {3, k, j};
        }
        events.insert({k, {1, i}});
    }
    ll curr_time = 0;
    vector<pair<ll, int>> order = val;
    ll sum = 0;
    for (auto i : events) {
        ll k = i.first;
        int type = i.second.first;
        for (int j = 0; j < order.size(); j++)
            order[j].first += (k - curr_time) * (order.size() - j - 1), sum += (k - curr_time) * (order.size() - j - 1) * sz[order[j].second];
        if (!type) {
            int a = mrg[i.second.second].first, b = mrg[i.second.second].second;
            a = getroot(a), b = getroot(b);
            int ind = -1;
            for (int j = 0; j < order.size(); j++) {
                if (order[j].second == a) {
                    ind = j;
                    break;
                }
            }
            merge(a, b);
            order.erase(order.begin() + ind);
        }
        else {
            int t = queries[i.second.second][0];
            if (t == 1) {
                ans[i.second.second] = order.size();
                //cout << t << " " << order.size() << endl;
            }
            if (t == 2) {
                ans[i.second.second] = sum;
                //cout << t << " " << sum << endl;
            }
            if (t == 3) {
                int ind = queries[i.second.second][2] - 1;
                ind = getroot(ind);
                for (int j = 0; j < order.size(); j++) {
                    if (order[j].second == ind) {
                       ans[i.second.second] = order[j].first;
                       break;
                    }
                }
            }
        }
        curr_time = k;
       /* cout << curr_time << " ! " << sum << endl;
        for (auto j : order)
            cout << j.first << " " << j.second << "  ";
        cout << endl;*/
    }
    for (int i = 0; i < q; i++)
        cout << ans[i] << endl;
}