#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define pii pair<int, int>

struct node {
    int len, sum = 0, x = 0;
    node *lf = nullptr, *rf = nullptr;
    node(int len): len(len) {}
};
void push(node* v) {
    int x = v->x;
    v->lf->x += x;
    v->rf->x += x;
    v->lf->sum += x * v->lf->len;
    v->rf->sum += x * v->rf->len;
    v->x = 0;
}
void add(node* v, int l, int r, int ql, int qr, int x) {
    if (l > qr || r < ql) return;
    if (l >= ql && r <= qr) {
        v->x += x;
        v->sum += v->len * x;
        return;
    }
    int c = (l + r) / 2;
    if (!v->lf) {
        v->lf = new node(v->len / 2);
        v->rf = new node(v->len / 2);
    }
    push(v);
    add(v->lf, l, c, ql, qr, x); add(v->rf, c + 1, r, ql, qr, x);
    v->sum = v->lf->sum + v->rf->sum;
}
int get(node* v, int l, int r, int ql, int qr) {
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return v->sum;
    int c = (l + r) / 2;
    if (!v->lf) {
        v->lf = new node(v->len / 2);
        v->rf = new node(v->len / 2);
    }
    push(v);
    return get(v->lf, l, c, ql, qr) + get(v->rf, c + 1, r, ql, qr);
}


node *root2 = nullptr, *root3 = nullptr;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n, q; cin >> n >> q;
    vi a(n);
    vi gr(n); iota(gr.begin(), gr.end(), 0);
    for (int i = 0; i < n; ++i) cin >> a[i];
    sort(gr.begin(), gr.end(), [&](int i, int j) {
        return a[i] < a[j];
    });

    vi ids(n);
    for (int i = 0; i < n; ++i) {
        ids[gr[i]] = i;
    }

    sort(a.begin(), a.end());

    vi diff(n);
    for (int i = 0; i < n - 1; ++i) {
        diff[i] = a[i + 1] - a[i];
    }

    vi ans(q);
    vector<vector<pair<int, int>>> que3(n);

    int start = 1;
    while (start < 1e12) start *= 2;
    root2 = new node(start), root3 = new node(start);

    // 1
    vi sim;
    for (int i = 0; i < n - 1; ++i) {
        sim.push_back(a[i + 1] - a[i]);
    }
    sort(sim.begin(), sim.end());

    // 2
    for (int i = 0; i < n; ++i) {
        add(root2, 0, start - 1, 1, diff[i], i + 1);
    }

    for (int i = 0; i < q; ++i) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            ans[i] = n - (upper_bound(sim.begin(), sim.end(), k) - sim.begin());
        } else if (t == 2) {
            int k; cin >> k;
            ans[i] = get(root2, 0, start - 1, 0, k);
        } else {
            int k, x; cin >> k >> x;
            x = ids[--x];
            que3[x].push_back({k, i});
        }
    }

    for (int i = n - 1; i >= 0; --i) {
        add(root3, 0, start - 1, 1, diff[i], 1);
        for (auto que : que3[i]) {
            ans[que.second] = a[i] + get(root3, 0, start - 1, 0, que.first);
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << ans[i] << '\n';
    }
}
