//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,popcnt")

#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double D;

struct Fenwick {
    vector<int> ts;
    int n;
    Fenwick(int n) : ts(n, 0), n(n) {
    }
    int get(int i) {
        int res = 0;
        for (;i >= 0; i = (i & (i + 1)) - 1) {
            res += ts[i];
        }
        return res;
    }
    void add(int i, int x) {
        for (; i < n; i = (i|(i + 1))) {
            ts[i] += x;
        }
    }
};
template<class T>
T bin_pow(T x, int n) {
    assert(n >= 0);
    if (n == 0) return 1;
    if (n == 1) return x;
    if (n & 1)
        return x * bin_pow(x, n - 1);
    else {
        auto t = bin_pow(x, n / 2);
        return t * t;
    }
}

int main() {
    string num; cin >> num;
    ll cost; cin >> cost;
    int n = num.size();
    vector<int> arr(n);
    range(i, n) {
        arr[i] = num[i] - '0';
    }
    vector<vector<int>> where(10, vector<int>());
    vector<int> ans(n);
    rrange(i, n) {
        where[arr[i]].push_back(n - i - 1);
        ans[n - i - 1] = arr[i];
    }
//    vector<int> tt;
//
//    rrange(i, n) {
//        int best_j = 0;
//        __int128_t best_margin = -1;
//        range(j, i + 1) {
//            __int128_t margin = 0;
//            for (int t = j + 1; t <= i; ++t) {
//                margin += (bin_pow<__int128_t>(10, t - 1) - bin_pow<__int128_t>(10, t)) * ans[t];
//            }
//            margin += (bin_pow<__int128_t>(10, i) - bin_pow<__int128_t>(10, j))* ans[j];
//            margin -= (i - j) * cost;
//            if (margin > best_margin || (margin == best_margin && ans[j] > ans[best_j])) {
//                best_j = j;
//                best_margin = margin;
//            }
//        }
//        for (int t = best_j; t < i; ++t) {
//            swap(ans[t], ans[t + 1]);
//        }
//    }
//
    Fenwick f(n);
    rrange(i, n) {
        int best_a = 0;
        D best_margin = -1;
        rrange(a, 10) {
            if (where[a].empty()) continue;
            int j = where[a].back();
            j -= f.get(j);
            D margin = a * (bin_pow<D>(10, i) - bin_pow<D>(10, j)) - cost * (i - j);
            for (auto t = i; t > j; --t) {
                margin -= ans[t] * (bin_pow<D>(10, t) - bin_pow<D>(10, t - 1));
            }
            if (margin > best_margin) {
                best_margin = margin;
                best_a = a;
            }
        }
        int j = where[best_a].back();
        j -= f.get(j);
        f.add(where[best_a].back(), 1);
        where[best_a].pop_back();
        for (auto t = j; t < i; ++t) {
            ans[t] = ans[t + 1];
        }
        ans[i] = best_a;
    }

    rrange(i, n) {
        cout << ans[i];
    }
    cout << '\n';
    return 0;
}
