#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define input(a) do {for (auto& e : a) cin >> e;} while(0);
#define print(a) do {cerr << #a << ": "; for (auto& e : a) cerr << e << " "; cerr << "\n";} while(0);

const int MAXN = 300000;

namespace t2ans {
	int t[MAXN * 2 - 1];
	int arr[MAXN * 2 - 1];
	void build(int i = 0, int l = 0, int r = MAXN) {
		if (r - l == 1)
			t[i] = arr[l];
		else {
			int m = (r + l) / 2;
			build(2 * i + 1, l, m);
			build(2 * i + 2, m, r);
			t[i] = t[2 * i + 1] + t[2 * i + 2];
		}
	}
	// +=
	void upd(int I, int X, int i = 0, int l = 0, int r = MAXN) {
		if (r <= I || I < l)
			return;
		if (r - l == 1) {
			t[i] += X;
			return;
		}
		int m = (r + l) / 2;
		upd(I, X, 2 * i + 1, l, m);
		upd(I, X, 2 * i + 2, m, r);
		t[i] = t[2 * i + 1] + t[2 * i + 2];
	}
	int get(int L, int R, int i = 0, int l = 0, int r = MAXN) {
		if (max(l, L) >= min(r, R))
			return 0;
		if (L <= l && r <= R)
			return t[i];
		int m = (l + r) / 2;
		return get(L, R, 2 * i + 1, l, m) + get(L, R, 2 * i + 2, m, r);
	}
}

int dsu[MAXN];
int cnt[MAXN];
ll value[MAXN];

int get(int x) {
	if (dsu[x] == x)
		return x;
	return dsu[x] = get(dsu[x]);
}
void unite(int a, int b) {
	a = get(a);
	b = get(b);
	if (a > b)
		swap(a, b);
	dsu[a] = b;
}


struct myOp {
	int a = 0, b = 0;
	ll round = 0;
};
struct query {
	int t;
	ll k;
	int i;
	int id;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	int n, q;
	cin >> n >> q;
	vector<ll> arr(n);
	input(arr);
	vector<ll> cp = arr;
	sort(cp.begin(), cp.end());
	map<ll, int> ids;
	int freeId = 0;
	for (auto& e : cp) {
		if (ids.find(e) != ids.end()) {
			cnt[ids[e]]++;
		}
		else {
			ids[e] = freeId;
			dsu[freeId] = freeId;
			cnt[freeId] = 1;
			value[freeId] = e;
			freeId++;
		}
	}

	vector<myOp> important;
	for (int i = 1; i < n; i++) {
		if (cp[i - 1] != cp[i]) {
			int i1 = ids[cp[i - 1]];
			int i2 = ids[cp[i]];
			ll roundid = cp[i] - cp[i - 1];
			important.push_back({i1, i2, roundid});
		}
	}
	sort(important.begin(), important.end(), [](myOp& a, myOp& b) {
		return a.round < b.round;
	});


	vector<ll> anses(q, -1);
	vector<query> tasks(q);
	for (int i = 0; i < q; i++) {
		auto& now = tasks[i];
		now.id = i;
		cin >> now.t >> now.k;
		if (now.t == 3)
			cin >> now.i;
	}
	sort(tasks.begin(), tasks.end(), [](query& a, query& b) {
		return a.k < b.k;
	});

	// init2
	for (int i = 0; i < MAXN; i++)
		t2ans::arr[i] = cnt[i];
	t2ans::build();

	int impId = 0;
	int lastK = 0;
	int cntUniq = freeId;
	ll ans2 = 0;
	ll addPerK2 = 0;

	int _addNow = 0;
	for (int i = MAXN - 1; i >= 0; i--) {
		if (cnt[i] != 0) {
			addPerK2 += (ll)_addNow * cnt[i];
			_addNow++;
		}
	}


	for (int i = 0; i < q; i++) {
		while (impId < important.size() && important[impId].round <= tasks[i].k) {
			cntUniq--;
			int iNow = min(get(important[impId].a), get(important[impId].b));
			ans2 += ll(important[impId].round - lastK) * addPerK2;
			addPerK2 -= t2ans::get(0, iNow + 1);
			int _toSwap = t2ans::get(iNow, iNow + 1);
			t2ans::upd(iNow, -_toSwap);
			t2ans::upd(iNow + 1, _toSwap);

			unite(important[impId].a, important[impId].b);
			lastK  = important[impId].round;

			impId++;
		}

		ans2 += ll(tasks[i].k - lastK) * addPerK2;
		if (tasks[i].t == 1) {
			anses[tasks[i].id] = cntUniq;
		}
		if (tasks[i].t == 2) {
			anses[tasks[i].id] = ans2;
		}
		lastK = tasks[i].k;
	}
	for (auto& e : anses)
		cout << e << "\n";
}