#include <bits/stdc++.h>

#define int long long

using namespace std;

struct Data
{
    int v, vs;
    int vp, vps;
    int p, ps;

    Data(int v=0, int vs=0, int vp=0, int vps=0, int p=0, int ps=0): v(v), vs(vs), vp(vp), vps(vps), p(p), ps(ps) {}

    friend bool operator<(Data A, Data B) {
        return A.v < B.v;
    }

    friend ostream& operator<<(ostream& out, Data D) {
        out << D.v << " " << D.vs << "  " << D.vp << " " << D.vps << "  " << D.p << " " << D.ps;
        return out;
    }
};

int n;
vector <vector <Data>> fenwick;
//vector <vector <pair <pair <int, int>, pair <int, int>>> fenwick2;

tuple <int, int, int> query(int idx, int x)
{
    int res = 0;
    int sufsum = 0;
    int sum = 0;
    for (int i = idx; i > 0; i -= (i & (-i))) {
        int j = (upper_bound(fenwick[i].begin(), fenwick[i].end(), Data(x, 0, 0, 0, 0, 0)) - fenwick[i].begin());
        int cnt = (int)fenwick[i].size() - j;
        res += cnt;

        if (j == fenwick[i].size())
            continue;

        //cout << i << " " << j << endl;
        //cout << fenwick[i][j] << endl;

        sufsum += fenwick[i][j].vps - fenwick[i][j].ps * x;

        sum += fenwick[i][j].vs - cnt * x;
    }
    return {res, sufsum, sum};
}

signed main()
{
    #ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif // LOCAL

    cin >> n;
    int Q; cin >> Q;
    vector <pair <int, int>> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first;
        arr[i].second = i;
    }
    sort(arr.begin(), arr.end());

    vector <int> indx(n);
    for (int i = 0; i < n; ++i) {
        indx[arr[i].second] = i;
    }

    int sum = 0;
    for (auto i: arr)
        sum += i.first;

    vector <int> deltas(n - 1);
    for (int i = 1; i < n; ++i)
        deltas[i - 1] = arr[i].first - arr[i - 1].first;

    fenwick.resize(n);
    //fenwick2.resize(n);
    for (int i = 1; i < n; ++i) {
        for (int j = i; j < fenwick.size(); j += (j & (-j)))
            //fenwick[j].push_back(deltas[i - 1]);
            fenwick[j].push_back({deltas[i - 1], deltas[i - 1], deltas[i - 1] * i, deltas[i - 1] * i, i, i});
    }
    for (auto& i: fenwick)
        sort(i.begin(), i.end());

    for (int i = 1; i < n; ++i) {
        for (int j = fenwick[i].size() - 2; j >= 0; --j) {
            fenwick[i][j].vs += fenwick[i][j + 1].vs;
            fenwick[i][j].vps += fenwick[i][j + 1].vps;
            fenwick[i][j].ps += fenwick[i][j + 1].ps;
        }
    }

    while (Q--) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            cout << (get<0>(query(n - 1, k))) + 1 << "\n";
        }
        else if (t == 2) {
            int k; cin >> k;
            //cout << "here " << get<1>(query(n - 1, k)) << "\n";
            cout << arr.back().first * n - (get<1>(query(n - 1, k))) - sum << "\n";
        }
        else {
            int k, idx; cin >> k >> idx;
            idx = indx[idx - 1];
/*
            cout << "idx " << idx << "\n";
            cout << "there " << get<2>(query(n - 1, k)) << "\n";
            cout << get<2>(query(3, k)) << "\n";*/
            cout << arr.back().first - ((get<2>(query(n - 1, k))) - (get<2>(query(idx, k)))) << "\n";
        }
    }
}
