#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cassert>
#include <cstdlib>

using namespace std;
#define int long long
#pragma GCC optimize("03")

struct masel;

const int inf = 1e14;
int calct(const vector<int>& mas) {
    int mnres = inf;
    for (int i = 1; i < mas.size(); i++) {
        if (mas[i] == mas[i - 1]) continue;
        mnres = min(mnres, mas[i - 1] - mas[i]);
    }
    return mnres;
}

const bool cmp(const int& a, const int& b) {
    return a > b;
}

int calcls(const vector<int>& mas, int v) {
    int l = 0;
    int r = mas.size() - 1;
    if (v == l) return 0;
    if (v == r) return r;
    while (l <= r) {
        int m = (l + r) / 2;
        if (mas[m] == v) {
            return m;
        } else if (mas[m] > v) {
            l = m + 1;
        } else {
            r = m - 1;
        }
    }
    assert(false);
}

int readi() {
    int x = 0;
    char c;
    while ((c = getchar()) >= '0' && c <= '9') {
        x = x * 10 + (c - '0');
    }
    return x;
}

void outpi(int x) {
    int l = 0;
    char buf[20];
    if (x == 0) {
        putchar('0');
        return;
    }
    while (x) {
        buf[l++] = x % 10 + '0';
        x /= 10;
    }
    for (int i = l - 1; i >= 0; i--) putchar(buf[i]);
}

signed main() {
    int n = readi(), q = readi();
    if (n > 5001) assert(false);
    int sm0 = 0;
    vector<int> inp(n);
    map<int, int> srtindbyv;
    map<int, vector<int>> blocks;
    for (int i = 0; i < n; i++) {
        inp[i] = readi();
        sm0 += inp[i];
    }
    vector<int> mas0 = inp;
    sort(mas0.begin(), mas0.end(), cmp);
    for (int i = 0; i < mas0.size(); i++) {
        srtindbyv[mas0[i]] = i;
    }
    blocks[0] = mas0;
    int prvt = 0;
    int nxtt = calct(mas0);
    set<int> times;
    times.insert(0);
    while (nxtt < inf) {
        int crt = nxtt;
        times.insert(crt);
        vector<int> prmas = blocks[prvt];
        vector<int> crmas = blocks[prvt];
        int add = 0;
        for (int i = 1; i < n; i++) {
            if (prmas[i] != prmas[i - 1]) add++;
            crmas[i] += add * (crt - prvt);
        }
        prvt = crt;
        blocks[crt] = crmas;
        nxtt = crt + calct(crmas);
    }
    map<int, int> precalc1;
    map<int, int> precalcbasesm;
    map<int, int> precalcsmad;
    map<int, vector<int>> precalcqu;
    while (q--) {
        int typ = readi();
        int k = readi();
        if (typ == 1) {
            // calcdif
            int bast = *times.lower_bound(k);
            if (k != bast) {
                bast = *(--times.lower_bound(k));
            }
            if (precalc1.find(bast) != precalc1.end()) {
                outpi(precalc1[bast]);
                putchar('\n');
                continue;
            }
            int ans = 1;
            for (int i = 1; i < blocks[bast].size(); i++) {
                if ( blocks[bast][i] !=  blocks[bast][i - 1]) {
                    ans++;
                }
            }
            precalc1[bast] = ans;
            outpi(ans);
            putchar('\n');
        } else if (typ == 2) {
            // sm
            int bast = *times.lower_bound(k);
            if (k != bast) {
                bast = *(--times.lower_bound(k));
            }
            int dift = k - bast;
            if (precalcbasesm.find(bast) != precalcbasesm.end()) {
                outpi(precalcbasesm[bast] + dift * precalcsmad[bast] - sm0);
                putchar('\n');
                continue;
            }
            int ad = 0;
            int add = 0;
            int sm = 0;
            for (int i = 0; i < blocks[bast].size(); i++) {
                sm += blocks[bast][i];
                if (i) {
                    if (blocks[bast][i] != blocks[bast][i - 1]) {
                        add++;
                    }
                }
                ad += add;
            }
            precalcbasesm[bast] = sm;
            precalcsmad[bast] = ad;
            outpi(precalcbasesm[bast] + dift * precalcsmad[bast] - sm0);
            putchar('\n');
        } else {
            // how much
            int ind = readi();
            ind--;
            int begv = inp[ind];
            int acti = srtindbyv[begv];


            int bast = *times.lower_bound(k);
            if (k != bast) {
                bast = *(--times.lower_bound(k));
            }
            int dift = k - bast;
            if (precalcqu.find(bast) != precalcqu.end()) {
                int i = calcls(precalcqu[bast], blocks[bast][acti]);
                outpi(blocks[bast][acti] + dift * i);
                putchar('\n');
                continue;
            }
            set<int> qu(blocks[bast].begin(), blocks[bast].end());
            precalcqu[bast] = vector<int>(qu.begin(), qu.end());
            reverse(precalcqu[bast].begin(), precalcqu[bast].end());
            if (precalcqu.find(bast) != precalcqu.end()) {
                int i = calcls(precalcqu[bast], blocks[bast][acti]);
                outpi(blocks[bast][acti] + dift * i);
                putchar('\n');
                continue;
            }
            assert(false);
        }
    }
    return 0;
}
