#include <iostream>
#include <algorithm>
#include <set>

struct Robot {
    int32_t left, right, cnt, type;
};

int64_t solve(int32_t n, int32_t m, Robot* robots, int32_t* arr) {
    std::sort(robots, robots + m, [](Robot r1, Robot r2) {
        return r1.right < r2.right;
    });
    std::vector<int32_t>* open = new std::vector<int32_t>[n];
    std::vector<int32_t>* close = new std::vector<int32_t>[n];
    for(int32_t i = 0; i < m;i++) {
        open[robots[i].left].push_back(i);
        close[robots[i].right].push_back(i);
    }
    int64_t ans = 0;
    std::set<int32_t> active;
    for(int32_t i = 0; i < n; i++) {
        for(int32_t r : open[i])
            active.insert(r);
        for(auto it = active.begin(); it != active.end();) {
            Robot &r = robots[*active.begin()];
            int32_t take = std::min(arr[i], r.cnt);
            r.cnt -= take;
            arr[i] -= take;
            ans += take;
            if(r.cnt == 0)
                it = active.erase(it);
            else
                it++;
            if(arr[i] == 0)
                break;
        }
        for(int32_t r : close[i])
            active.erase(r);
    }
    return ans;
}

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0 ;t < num_tests; t++) {
        int32_t n, m;
        std::cin >> n >> m;

        int32_t* arr = new int32_t[n];
        for(int32_t i = 0; i < n; i++)
            std::cin >> arr[i];

        Robot* robots = new Robot[m];
        for(int32_t i = 0; i < m; i++) {
            std::cin >> robots[i].left >> robots[i].right >> robots[i].cnt >> robots[i].type;
            robots[i].left--;
            robots[i].right--;
        }

        Robot* robot2 = new Robot[m];
        int32_t* arr2 = new int32_t[n];
        for(int32_t i = 0; i < n; i++) {
            for(int32_t j = 0; j < m; j++) {
                robot2[j] = robots[j];
                robot2[j].left = (robots[j].type == 0 ? robots[j].left : std::min(i, robots[j].left));
                robot2[j].right = (robots[j].type == 0 ? robots[j].right : std::max(i, robots[j].right));
            }
            for(int32_t j = 0; j < n; j++)
                arr2[j] = arr[j];
            std::cout << solve(n, m, robot2, arr2) << " ";
        }
        std::cout << "\n";
    }
    return 0;
}
