#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

struct ST {
    vector<int> st;
    vector<int> cnt;
    vector<int> add1, add2, add3;

    ST(vector<int> &a) {
        int n = a.size();
        cnt.resize(4 * n);
        add1.resize(4 * n);
        add2.resize(4 * n);
        add3.resize(4 * n);
        st.resize(4 * n);
        build(0, 0, n, a);
    }

    void build(int i, int l, int r, vector<int> &a) {
        if (l + 1 == r) {
            cnt[i] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(i * 2 + 1, l, m, a);
        build(i * 2 + 2, m, r, a);
    }

    void push(int i, int l, int r) {
        add3[i] += add2[i] * add1[i];
        cnt[i] -= add2[i];
        st[i] += cnt[i] * add1[i];
        st[i] += add3[i];
        if (l + 1 < r) {
            add1[i * 2 + 1] += add1[i];
            add1[i * 2 + 2] += add1[i];
            add2[i * 2 + 1] += add2[i];
            add2[i * 2 + 2] += add2[i];
            add3[i * 2 + 1] += add3[i];
            add3[i * 2 + 2] += add3[i];
        }
        add3[i] = 0;
        add2[i] = 0;
        add1[i] = 0;
    }

    void upd1(int i, int l, int r, int x) {
        int m = (l + r) / 2;
        if (l + 1 < r) {
            push(i * 2 + 1, l, m);
            push(i * 2 + 2, m, r);
        }
        push(i, l, r);
        add1[i] += x;
        push(i, l, r);
    }

    void upd2(int i, int l, int r, int ql, int qr, int x) {
        int m = (l + r) / 2;
        if (l + 1 < r) {
            push(i * 2 + 1, l, m);
            push(i * 2 + 2, m, r);
        }
        push(i, l, r);
        if (l == ql && r == qr) {
            if (l + 1 < r) {
                push(i * 2 + 1, l, m);
                push(i * 2 + 2, m, r);
            }
            add2[i] += x;
            push(i, l, r);
            return;
        }
        if (qr <= m) {
            upd2(i * 2 + 1, l, m, ql, qr, x);
        } else if (ql >= m) {
            upd2(i * 2 + 2, m, r, ql, qr, x);
        } else {
            upd2(i * 2 + 1, l, m, ql, m, x);
            upd2(i * 2 + 2, m, r, m, qr, x);
        }
    }

    int get_val(int i, int l, int r, int pos) {
        push(i, l, r);
        if (l + 1 == r) {
            return st[i];
        }
        int m = (l + r) / 2;
        if (pos < m) {
            return get_val(i * 2 + 1, l, m, pos);
        }
        return get_val(i * 2 + 2, m, r, pos);
    }
};

struct query {
    int k;
    int ind;
    int x;

    bool operator<(const query &other) const {
        return k < other.k;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(all(a));
    vector<int> ansans(q, -1);
    vector<query> qs1, qs2, qs3;
    for (int i = 0; i < q; i++) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            qs1.push_back({k, i, 0});
        } else if (t == 2) {
            qs2.push_back({k, i, 0});
        } else {
            int x;
            cin >> x;
            qs3.push_back({k, i, x});
        }
    }
    {
        vector<int> kek;
        for (int i = 0; i < n - 1; i++) {
            kek.push_back(a[i + 1].first - a[i].first);
        }
        sort(all(kek));
        for (auto el: qs1) {
            ansans[el.ind] = n - (upper_bound(all(kek), el.k) - kek.begin());
        }
    }
    {
        sort(all(qs2));
        int cnt = n * (n - 1) / 2;
        int prev = 0;
        int ans = 0;
        int ind = 0;
        vector<pair<int, int>> kek;
        for (int i = 0; i < n - 1; i++) {
            kek.push_back({a[i + 1].first - a[i].first, i});
        }
        sort(all(kek));
        for (auto el: qs2) {
            while (ind < n - 1 && kek[ind].first <= el.k) {
                ans += cnt * (kek[ind].first - prev);
                cnt -= kek[ind].second + 1;
                prev = kek[ind].first;
                ind++;
            }
            ans += cnt * (el.k - prev);
            prev = el.k;
            ansans[el.ind] = ans;
        }
    }
    {
        sort(all(qs3));
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            p[a[i].second] = i;
        }
        vector<int> cnt;
        vector<int> ans;
        for (int i = 0; i < n; i++) {
            ans.push_back(a[i].first);
            cnt.push_back(n - i - 1);
        }
        ST st(cnt);
        int prev = 0;
        int ind = 0;
        vector<pair<int, int>> kek;
        for (int i = 0; i < n - 1; i++) {
            kek.push_back({a[i + 1].first - a[i].first, i});
        }
        sort(all(kek));
        for (auto el: qs3) {
            while (ind < n - 1 && kek[ind].first <= el.k) {
                st.upd1(0, 0, n, kek[ind].first - prev);
                prev = kek[ind].first;
                st.upd2(0, 0, n, 0, kek[ind].second + 1, 1);
                ind++;
            }
            el.x = p[el.x - 1];
            st.upd1(0, 0, n, el.k - prev);
            prev = el.k;
            ansans[el.ind] = st.get_val(0, 0, n, el.x);
        }
    }
    for (int el: ansans) {
        cout << el << '\n';
    }
}

/*
6 6
5 4 4 2 2 2
1 0
1 1
1 2
2 1
2 2
3 1 5

5 4
0 3 5 4 2
1 0
1 1
2 1
3 1 1
 */