#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>

using namespace std;
using ll = long long;

string solve12(string s, ll y)
{
	int tpos = 0;
	int n = s.size();
	vector<ll> pows(19);
	for (int i = 0; i < 18; ++i)
		pows[i + 1] = pows[i] * 10;

	string res(n, '1');
	for (int i = 0; i < n; ++i)
	{
		if (s[i] == '2')
		{
			if (n - tpos > 18)
				res[tpos++] = '2';
			else
			{
				ll bestPos = i, bestRes = 0;
				for (int j = i - 1; j >= tpos; --j)
				{
					ll num = stoll(s.substr(j, i - j));
					ll prev = num * 10 + s[i] - '0';
					ll nxt = num + (s[i] - '0') * pows[i - j];
					ll cur = (nxt - prev) * pows[n - i - 1] - y * (i - j);
					if (cur >= bestRes)
						bestPos = j, bestRes = cur;
				}
				res[bestPos] = '2';
				tpos = bestPos + 1;
			}
		}
	}
	return res;
}

string solve(string s, ll y)
{
	int n = s.size();
	vector<ll> pows(n + 1, 1);
	for (int i = 0; i < n; ++i)
		pows[i + 1] = pows[i] * 10;

	for (int digit = 9; digit >= 0; --digit)
	{
		for (int i = 0; i < n; ++i)
		{
			if (s[i] != digit + '0')
				continue;
			ll bestPos = i, bestRes = 0;
			for (int j = i - 1; j >= 0; --j)
			{
				ll num = stoll(s.substr(j, i - j));
				ll prev = num * 10 + s[i] - '0';
				ll nxt = num + (s[i] - '0') * pows[i - j];
				ll cur = (nxt - prev) * pows[n - i - 1] - y * (i - j);
				if (cur >= 0)
					bestPos = j, bestRes = cur;
			}

			for (int j = i; j > bestPos; --j)
				swap(s[j], s[j - 1]);
		}
	}
	return s;
}

string solveSmall(string s, ll y)
{
	int n = s.size();
	vector<ll> pows(n + 1, 1);
	for (int i = 0; i < n; ++i)
		pows[i + 1] = pows[i] * 10;

	for (int d = 9; d >= 0; --d)
	{
		for (int i = n - 1; i >= 0; --i)
		{
			if (s[i] != d + '0')
				continue;
			for (int t = 0; t < 20; ++t)
			{
				ll bestRes = 0, bestPos = i;
				for (int j = i - 1; j >= 0; --j)
				{
					ll val = stoll(s.substr(j, i - j));
					ll prev = val * 10 + s[i] - '0';
					ll cur = val + (s[i] - '0') * pows[i - j];
					ll curRes = (cur - prev) * pows[n - i - 1] - (i - (ll)j) * y;
					if (curRes >= bestRes)
						bestRes = curRes, bestPos = j;
				}
				for (int j = i; j > bestPos; --j)
					swap(s[j], s[j - 1]);
			}
		}
	}
	
	return s;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	string s;
	cin >> s;

	ll y = 0;
	cin >> y;

	cout << solve12(s, y) << "\n";
	//sort(s.begin(), s.end(), std::greater<char>());
	//cout << s << "\n";
	//cout << solveSmall(s, y) << "\n";

	/*int n = s.size();
	sort(s.begin(), s.begin() + max(0, n - 20), std::greater<char>());
	cout << s.substr(0, max(0, n - 20)) + solveSmall(s.substr(max(0, n - 20), min(n, 20)), y);*/

	return 0;
}