#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <numeric>
#include <string>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;

struct query
{
	int type, player, ind;
	ll time;

	query(int type, ll time, int ind, int player = 0) : type(type), player(player), ind(ind), time(time) {}
	bool operator<(const query& q) const
	{
		return time < q.time;
	}
};

const int MAXN = 300'000;

int p[MAXN];
int rnk[MAXN];

int getComp(int u)
{
	if (p[u] == u)
		return u;
	return p[u] = getComp(p[u]);
}

int merge(int u, int v)
{
	u = getComp(u), v = getComp(v);
	if (u == v)
		return u;
	if (rnk[u] < rnk[v])
		swap(u, v);
	p[v] = u;
	if (rnk[v] == rnk[u])
		++rnk[u];
	return u;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int  n = 0, q = 0;
	cin >> n >> q;

	vector<ll> c(n);
	for (int i = 0; i < n; ++i)
		cin >> c[i];

	vector<query> queries;
	int type = 0, player = 0;
	ll t = 0;
	for (int i = 0; i < q; ++i)
	{
		cin >> type;
		if (type == 1 || type == 2)
			cin >> t;
		else
			cin >> t >> player;
		queries.push_back(query(type, t, i, player));
	}

	sort(all(queries));
	vector<ll> ans(q, 1);

	iota(p, p + n, 0);

	map<ll, int> comp;
	vector<int> groupNum;
	for (int i = 0; i < n; ++i)
	{
		if (comp.count(c[i]))
			groupNum[merge(i, comp[c[i]])] = comp[c[i]];
		else
			comp[c[i]] = i;
	}

	set<pair<ll, int>> cs;
	for (int i = 0; i < n; ++i)
		if (p[i] == i)
			cs.emplace(c[i], i);

	set<pair<ll, int>> dist;
	for (auto it = cs.begin(); next(it) != cs.end(); ++it)
	{
		dist.emplace(next(it)->first - it->first, it->second);
	}

	ll curTime = 0;
	int qPos = 0;
	//map<int, int> components;
	while (!dist.empty())
	{
		int nextTime = dist.begin()->first;
		while (qPos < q && queries[qPos].time < nextTime)
		{
			auto quer = queries[qPos];
			if (quer.type == 1)
			{
				ans[quer.ind] = dist.size() + 1;
			}
			else if (quer.type == 2)
			{

			}
			else
			{

			}
			++qPos;
		}

		auto [dif, gr] = *dist.begin();
		auto it = cs.find({ c[gr], gr });
		int u = next(it)->second;
		dist.erase(dist.begin());
		int top = merge(gr, u);
	}

	for (auto x : ans)
		cout << x << "\n";

	return 0;
}