#include <bits/stdc++.h>
// #define int long long
#pragma GCC optimize("unroll-loops")

using namespace std;

class Node {
public:
    Node* ld;
    Node* lu;
    Node* rd;
    Node* ru;
    int left;
    int right;
    int down;
    int up;
    int vel;
    int debt;

    Node(int left, int right, int down, int up):
    left(left),
    right(right),
    down(down),
    up(up),
    vel(0LL),
    debt(0LL)
    {}

    void assign() {
        int lr = (this->left + this->right) / 2;
        int du = (this->down + this->up) / 2;
        if (!ld) {
            this->ld = new Node(this->left, lr, this->down, du);
        }
        if (!lu) {
            this->lu = new Node(this->left, lr, du, this->up);
        }
        if (!rd) {
            this->rd = new Node(lr, this->right, this->down, du);
        }
        if (!ru) {
            this->ru = new Node(lr, this->right, du, this->up);
        }
    }

    void push() {
        this->assign();
        int db = this->debt;
        this->vel += (this->right - this->left) * (this->up - this->down) * db;
        this->debt = 0;
        this->ld->debt += db;
        this->lu->debt += db;
        this->rd->debt += db;
        this->ru->debt += db;
    }

    void pull() {
        this->vel = this->ld->vel + this->lu->vel + this->rd->vel + this->ru->vel;
    }

    bool noChild() {
        return !this->ld;
    }
};

int gett(Node *v, int left, int right, int down, int up) {
    if (!v) {
        return 0;
    }
    if (v->noChild()) {
        int sq = max(0, (min(right, v->right) - max(left, v->left)) * (min(up, v->up) - max(down, v->down)));
        int fsq = (v->right - v->left) * (v->up - v->down);
        if (v->vel == 0 && v->debt == 0 || fsq == 0) {
            return 0;
        }
        return sq * v->debt + v->vel / fsq * sq;
    }
    v->push();
    if (v->left >= right || v->right <= left || v->down >= up || v->up <= down) {
        return 0;
    } else if (v->left >= left && v->down >= down && v->right <= right && v->up <= up) {
        return v->vel;
    }
    return gett(v->ld, left, right, down, up) + gett(v->lu, left, right, down, up) + gett(v->rd, left, right, down, up) + gett(v->ru, left, right, down, up);
}

void sett(Node* v, int left, int right, int down, int up, int db) {
    if (!v) {
        return;
    }
    if (v->left >= right || v->right <= left || v->down >= up || v->up <= down) {
        return;
    } else if (v->left >= left && v->down >= down && v->right <= right && v->up <= up) {
        v->debt += db;
        v->push();
        return;
    }
    v->push();
    sett(v->ld, left, right, down, up, db);
    sett(v->lu, left, right, down, up, db);
    sett(v->rd, left, right, down, up, db);
    sett(v->ru, left, right, down, up, db);
    v->pull();
}

// const int MAXN = 524288LL;        // 3 * 10 ^ 5
// const int MAXK = 1099511627776LL; // 10 ^ 12
const int MAXN = 8192;            // 5000
const int MAXK = 16777216;        // 10 ^ 7

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    Node* root = new Node(0LL, MAXN, 0LL, MAXK);
    vector<int> rev(n);
    vector<int> x(n);
    vector<pair<int, int>> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
        s[i] = {x[i], i};
    }
    sort(s.begin(), s.end());
    int la = n;
    int cnt = 0;
    int k0 = 1;
    vector<int> k;
    for (int i = n - 1; i >= 0; --i) {
        rev[s[i].second] = i;
        x[i] = s[i].first;
    }
    for (int i = n - 1; i >= 0; --i) {
        if (i == 0 || x[i - 1] != x[i]) {
            sett(root, i, la, 0, MAXK, cnt);
            cnt++;
            la = i;
            if (i != 0) {
                k0++;
                sett(root, 0, i, x[i] - x[i - 1], MAXK, -1);
                k.push_back(x[i] - x[i - 1]);
            }
        }
    }
    sort(k.begin(), k.end());
    for (; q; --q) {
        int type, day;
        cin >> type >> day;
        if (type == 1) {
            auto p = upper_bound(k.begin(), k.end(), day);
            cout << k0 - (p - k.begin()) << "\n";
        } else if (type == 2) {
            cout << gett(root, 0, n, 0, day) << "\n";
        } else {
            int dude;
            cin >> dude;
            dude = rev[dude - 1];
            cout << x[dude] + gett(root, dude, dude + 1, 0, day) << "\n";
        }
    }
}