#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

template<class T> using pq_min = priority_queue<T, vector<T>, greater<T>>;
template<class T> using pq_max = priority_queue<T, vector<T>, less<T>>;

struct Robot {
    int l, r, c, t;
};

const int N = 2e5+7;

int a[N];
ll ans[N];

void solve(int xl, int xr, vector<Robot> old_rob, ll sl, ll sr, ll flow) {
    vector<Robot> rob;

    const int n = xr - xl + 1;

    for (const auto& [l, r, c, t] : old_rob) {
        if ((l > xr || r < xl) && t == 0) continue;
        if (c == 0) continue;
        
             if (l >= xr && t == 1) sr += c;
        else if (r <= xl && t == 1) sl += c;
        else {
            rob.push_back(Robot {max(xl, l), min(xr, r), c, t});
        }
    }

/*
    cout << "Solve x in [" << xl << ", " << xr << "], sl=" << sl << ", sr=" << sr << ", flow=" << flow << endl;
    for (const auto& [l, r, c, t] : rob) {
        cout << "[" << l << ", " << r << "], cap=" << c << ", type=" << t << endl;
    }
*/

    if (xl == xr) {
        ll sum = sl + sr;
        for (const auto& [l, r, c, t] : rob) sum += c;
        ans[xl] = flow + min<ll>(sum, a[xl]);
    } else {
        int xm = (xl + xr) / 2;

        vector<vi> ref(xr - xl + 1);
        vector<Robot> rb_r = rob, rb_l = rob;
        ll fr = flow, fl = flow;
        pq_min<pi> qr;
        pq_max<pi> ql;

        for (auto& [l, r, c, t] : rb_r) if (t == 1) r = max(r, xm);
        for (auto& [l, r, c, t] : rb_l) if (t == 1) l = min(l, xm+1);
        for (int i = 0; i < rob.size(); ++i) {
            if (rob[i].l <= xm) ref[rob[i].l - xl].push_back(i);
            if (rob[i].r >  xm) ref[rob[i].r - xl].push_back(i);
        }


        ll sl_save = sl;

        for (int i = xl; i <= xm; ++i) {
            for (int j : ref[i-xl]) qr.emplace(rb_r[j].r, j);

            int x = a[i];
            while (x != 0 && !qr.empty()) {
                auto [ir, j] = qr.top(); qr.pop();
                if (ir < i) continue;
                
                const int push = min(rb_r[j].c, x);
                x -= push;
                rb_r[j].c -= push;
                fr += push;
                if (rb_r[j].c != 0) qr.emplace(ir, j);
            }

            const int push = min<ll>(x, sl);

            x -= push;
            sl -= push;
            fr += push;
        }

        solve(xm+1, xr, rb_r, sl, sr, fr);
        sl = sl_save;

        for (int i = xr; i > xm; --i) {
            for (int j : ref[i-xl]) ql.emplace(rb_l[j].l, j);

            int x = a[i];
            while (x != 0 && !ql.empty()) {
                auto [il, j] = ql.top(); ql.pop();
                if (il > i) continue;

                const int push = min(rb_l[j].c, x);
                x -= push;
                rb_l[j].c -= push;
                fl += push;

                if (rb_l[j].c != 0) ql.emplace(rb_l[j].l, j);
            }

            const int push = min<ll>(x, sr);

            x -= push;
            sr -= push;
            fl += push;
        }

        solve(xl, xm, rb_l, sl, sr, fl);
    }
}

void solve() {
    int n, m; cin >> n >> m;
    
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector<Robot> robots(m);
    for (auto& [l, r, c, t] : robots) cin >> l >> r >> c >> t, --l, --r;

    solve(0, n-1, robots, 0, 0, 0);

    for (int i = 0; i < n; ++i) cout  << ans[i] << ' ';
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}