#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt")

#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;

struct Robot {
    int l, r, c, t;
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    vector<Robot> robots(m);
    for (auto& [l, r, c, t] : robots) cin >> l >> r >> c >> t, --l;


    vector<ll> ps(n+1);
    for (int i = 0; i < n; ++i) {
        ps[i+1] = ps[i] + a[i];
    }

    vector<int> gr(n+1); gr[n] = 1;
    for (auto& [l, r, c, t] : robots) gr[l] = gr[r] = 1;
    vector<int> bounds;
    for (int i = 0; i <= n; ++i) if (gr[i]) bounds.push_back(i);
    for (int i = 0; i < n; ++i) gr[i+1] += gr[i];

    vector<ll> res(n);

    for (int x = 0; x < n; ++x) {
        auto rob = robots; 
        auto bnd = bounds;

        int fx = 0, fx1 = 0;
        
        auto itx = lower_bound(bnd.begin(), bnd.end(), x);
        if (*itx != x) bnd.insert(itx, x), fx = 1;


        auto itx1 = lower_bound(bnd.begin(), bnd.end(), x+1);
        if (*itx1 != x+1) bnd.insert(itx1, x+1), fx1 = 1;
        
        for (auto& [l, r, c, t] : rob) {
            if (t != 0) {
                l = min(l, x);
                r = max(r, x+1);
            }

            const int vl = l, vr = r;

            l = gr[vl] + (fx && x < vl) + (fx1 && x+1 < vl) - 1;
            r = gr[vr] + (fx && x < vr) + (fx1 && x+1 < vr) - 2;
        }

        vector<ll> a0;

        for (int i = 0; i + 1 < bnd.size(); ++i) {
            a0.push_back(ps[bnd[i+1]] - ps[bnd[i]]);
        }

        const int k = a0.size();

        vector<vi> def(n);
        for (int i = 0; i < m; ++i) {
            def[rob[i].r].push_back(i);
        }
        
        ll cur = 0;
        priority_queue<pi> q;
        for (int i = k; i--; ) {
            for (int j : def[i]) {
                q.emplace(rob[j].l, rob[j].c);
            }

            ll x = a0[i];
            while (!q.empty() && x != 0) {
                auto [l, c] = q.top(); q.pop();
                if (l > i) continue;
                
                int df = min<ll>(c, x);
                c -= df;
                x -= df;
                cur += df;

                if (c != 0) q.emplace(l, c);
            }
        }

        res[x] = cur;
    }

    for (ll t : res) cout << t << ' ';
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) solve();
}