#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 1e5 + 5;

ll binpow(ll a, ll b) {
    if (b == 0) return 1ll;
    ll res = binpow(a, b / 2);
    if (b % 2) return res * res * a;
    return res * res;
}

string generate(int n) {
    string s;
    for (int i = 0; i < n; ++i) {
        s += to_string(rand() % 10);
    }
    return s;
}

string solve_very_slow(string s, ll y) {
    int n = s.size();
    int arr[10];
    ll best = 0; string best_str = s;
    for (int i = 0; i < n; ++i) {
        arr[i] = i;
    }
    do {
        string m = s;
        for (int i = 0; i < n; ++i) m[i] = s[arr[i]];
        ll res = stoll(m) - stoll(s);
        string s1 = s;
        for (int i = 0; i < n; ++i) {
            if (m[i] != s1[i]) {
                for (int j = i + 1; j < n; ++j) {
                    if (s1[j] == m[i]) {
                        for (int k = j - 1; k >= i; --k) {swap(s1[k], s1[k + 1]); res -= y;}
                        break;
                    }
                }
            }
        }
        if (res > best || (res == best && m > best_str)) {
            best = res;
            best_str = m;
        }
    } while (next_permutation(arr, arr + n));

    return best_str;
}

string solve_slow(string s, ll y) {
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        for (int _ = 0; _ < n; ++_) {
            bool used[10];
            fill(used, used + 10,false);
            used[s[i] - '0'] = 1;
            int best_pos = i; ll best_res = 0;
            int num = s[i] - '0';
            for (int j = i + 1; j < n; ++j) {
                if (used[s[j] - '0']) continue;
                used[s[j] - '0'] = 1;
                ll res = (s[j] - '0') * binpow(10ll, n - i - 1);
                for (int k = i; k < j; ++k) {
                    res -= 9ll * binpow(10ll, n - k - 2) * (s[k] - '0');
                }
                res -= (s[j] - '0') * binpow(10ll, n - j - 1);
                res -= y * (j - i);
//            cout << s << endl;
//            cout << i << " " << j << " " << res << endl;
                if (res > best_res || (res == best_res && (s[j] - '0') > num)) {
                    best_pos = j;
                    best_res = res;
                    num = s[j] - '0';
                }
            }

            for (int j = best_pos - 1; j >= i; --j) swap(s[j], s[j + 1]);
        }
    }

    return s;
}

void test() {
    for (int i = 0; i < 100000; ++i) {
        int n = rand() % 5 + 1;
        string s = generate(n);
        ll y = rand() % 10000;
        if (solve_very_slow(s, y) != solve_slow(s, y)) {
            cout << s << " " << y << endl;
        }
    }
}

vector<int> pos[10];
bool used[N];

int main() {
    string s; cin >> s;
    int n = s.size();
    ll y; cin >> y;

    for (int i = 0; i < n; ++i) {
        pos[s[i] - '0'].push_back(i);
    }
    for (int i = 0; i < 10; ++i) {
        reverse(pos[i].begin(), pos[i].end());
    }
    int p = 9;
    string ans = "";
    for (int i = 0; i < n - 10; ++i) {
        while (pos[p].empty()) --p;
        int k = pos[p].back();
        pos[p].pop_back();
        ans += s[k];
        used[k] = 1;
    }

    string a = "";
    for (int i = 0; i < n; ++i) {
        if (!used[i]) a += s[i];
    }

    ans += solve_very_slow(a, y);

    cout << ans << endl;
    return 0;
}
