#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 2e5 + 5;

int arr[N];
int can[N];
int type[N];

int used[N];
int filled[N];
pii bounds_default[N];
pii bounds[N];
vector<pair<pair<int, int>, int>> q; // pos, type, robot; type == 0 <=> open
set<pair<int, int>> robots; // right bound, robot index

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    bool all_zero = true;
    for (int i = 0; i < m; ++i) {
        ll l, r, c, t; cin >> l >> r >> c >> t;
        --l; --r;
        all_zero = all_zero && (t == 0);
        bounds_default[i] = {l, r};
        can[i] = c;
        type[i] = t;
    }

    if (!all_zero) {
        for (int x = 0; x < n; ++x) {
            ll ans = 0;
            fill(used, used + m, 0);
            fill(filled, filled + n, 0);
            q.clear();
            robots.clear();
            for (int r = 0; r < m; ++r) {
                if (type[r] == 1) {
                    bounds[r] = {min(x, bounds_default[r].first), max(x, bounds_default[r].second)};
                }
                else bounds[r] = bounds_default[r];
                q.push_back({{bounds[r].first, 0}, r});
                q.push_back({{bounds[r].second + 1, 1}, r});
            }
            sort(q.begin(), q.end());
            int pointer = 0;
            for (int i = 0; i < n; ++i) {
                while (pointer < q.size() && q[pointer].first.first == i) {
                    auto robot = q[pointer];
                    int ind = robot.second;
                    if (robot.first.second == 0) robots.insert({bounds[ind].second, ind});
                    else {
                        if (robots.count({bounds[ind].second, ind})) robots.erase({bounds[ind].second, ind});
                    }
                    ++pointer;
                }
                while (filled[i] != arr[i] && !robots.empty()) {
                    int ind = robots.begin()->second;
                    if (used[ind] == can[ind]) {
                        robots.erase(robots.begin());
                    }
                    else {
                        int to_fill = min(can[ind] - used[ind], arr[i] - filled[i]);
                        used[ind] += to_fill;
                        filled[i] += to_fill;
                        ans += to_fill;
                    }
                }
            }
            cout << ans << " ";
        }

        cout << endl;
    }
    else {
        ll ans = 0;
        fill(used, used + m, 0);
        fill(filled, filled + n, 0);
        q.clear();
        robots.clear();
        for (int r = 0; r < m; ++r) {
            bounds[r] = bounds_default[r];
            q.push_back({{bounds[r].first, 0}, r});
            q.push_back({{bounds[r].second + 1, 1}, r});
        }
        sort(q.begin(), q.end());
        int pointer = 0;
        for (int i = 0; i < n; ++i) {
            while (pointer < q.size() && q[pointer].first.first == i) {
                auto robot = q[pointer];
                int ind = robot.second;
                if (robot.first.second == 0) robots.insert({bounds[ind].second, ind});
                else {
                    if (robots.count({bounds[ind].second, ind})) robots.erase({bounds[ind].second, ind});
                }
                ++pointer;
            }
            while (filled[i] != arr[i] && !robots.empty()) {
                int ind = robots.begin()->second;
                if (used[ind] == can[ind]) {
                    robots.erase(robots.begin());
                }
                else {
                    int to_fill = min(can[ind] - used[ind], arr[i] - filled[i]);
                    used[ind] += to_fill;
                    filled[i] += to_fill;
                    ans += to_fill;
                }
            }
        }
        for (int i = 0; i < n; ++i) cout << ans << " ";
        cout << endl;
    }
}

int main() {

    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

    return 0;
}
