#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <queue>

using namespace std;

using ll = long long;
using ld = long double;

vector<vector<pair<int, int>>> gr;
vector<pair<int, int>> e;
vector<int> cole, up, h;
vector<bool> bl, used;
//vector<unordered_set<int>> check;

int n, m, color = -1;

inline void clearall() {
	bl = vector<bool>(n, 0);
	gr = vector<vector<pair<int, int>>>(n);
	e = vector<pair<int, int>>(m);
	cole = vector<int>(m, 0);
	up = vector<int>(n, 0);
	h = vector<int>(n, 0);
	used = vector<bool>(n, 0);
	color = -1;
	//check = vector<unordered_set<int>>(n);
}

void dfs1(int v, int p) {
	used[v] = 1;
	for (pair<int, int>& to : gr[v]) {
		int u = to.first;
		if (u == p) {
			continue;
		}
		if (used[u]) {
			up[v] = min(up[v], h[u]);
		}
		else {
			up[u] = h[u] = h[v] + 1;
			dfs1(u, v);
			up[v] = min(up[v], up[u]);
		}
	}
}

void dfs2(int v, int p, int col) {
	used[v] = 1;
	for (auto& to : gr[v]) {
		int u = to.first;
		if (u == p) {
			continue;
		}
		int num = to.second;
		if (used[u]) {
			if (h[u] < h[v]) { // 
				cole[num] = col;
			}
		}
		else {
			if (up[u] < h[v]) {
				cole[num] = col;
				dfs2(u, v, col);
			}
			else {
				++color;
				cole[num] = color;
				dfs2(u, v, color);
			}
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		clearall();
		for (int i = 0; i < m; ++i) {
			int v, u;
			cin >> v >> u;
			--v; --u;
			gr[v].push_back({ u, i });
			gr[u].push_back({ v, i });
			e[i] = { v, u };
		}
		dfs1(0, 0);
		used = vector<bool>(n, 0);
		dfs2(0, 0, 0);

		/*for (int i = 0; i < n; ++i) {
			for (auto& to : gr[i]) {
				check[i].insert(cole[to.second]);
			}
		}*/

		queue<int> q;
		q.push(0);
		const int INF = 1e9;
		vector<int> ans(n, INF);
		ans[0] = 0;

		vector<char> gg(color + 5, 0);

		while (!q.empty()) {
			int v = q.front();
			q.pop();
			if (bl[v]) {
				continue;
			}
			bl[v] = 1;
			for (auto& to1 : gr[v]) {
				gg[to1.second] = 1;
			}
			for (auto& to1 : gr[v]) {
				int u = to1.first;
				for (auto to2 : gr[u]) {
					int v1 = to2.first;
					if (ans[v1] != INF) {
						continue;
					}
					for (auto to3 : gr[v1]) {
						if (to3.first != u && gg[cole[to3.second]]) {
							ans[v1] = ans[v] + 2;
							q.push(v1);
							break;
						}
					}
				}
			}
			for (auto& to1 : gr[v]) {
				gg[to1.second] = 0;
			}
		}
		for (int i = 1; i < n; ++i) {
			if (ans[i] == INF) {
				cout << -1 << ' ';
			}
			else {
				cout << ans[i] << ' ';
			}
		}
		cout << '\n';
	}
	return 0;
}