#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using lll = __int128;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

const int length = 20;

struct SumTree {
    int n;
    vector<int> s;

    SumTree(int n) : n(n), s(2 * n) {}

    void set(int i, int x) {
        s[i += n] = x;
        for (i /= 2; i > 0; i /= 2) s[i] = s[i * 2] + s[2 * i + 1];
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l & 1) res += s[l++];
            if (r & 1) res += s[--r];
        }
        return res;
    }
};

lll check(string t, string s, ll y) {
    lll cost = 0;
    vector<int> p(t.size());
    lll res = 0;
    lll ten = 1;
    for (int i = 0; i < length && i < t.size(); ++i) {
        res += (t[t.size() - 1 - i] - '0') * ten;
        ten *= 10;
    }
    for (char c = '0'; c <= '9'; ++c) {
        vector<int> si, ti;
        for (int i = 0; i < s.size(); ++i) if (s[i] == c) si.push_back(i);
        for (int i = 0; i < s.size(); ++i) if (t[i] == c) ti.push_back(i);
        for (int i = 0; i < si.size(); ++i) p[ti[i]] = si[i];
    }
    SumTree st(p.size());
    for (int i = 0; i < p.size(); ++i) {
        cost += st.get(p[i], p.size());
        st.set(p[i], 1);
    }
    return res - cost * y;
}

mt19937 rng(0);

void solve() {
    string s;
    cin >> s;
    ll y;
    cin >> y;
    vector<int> ind(s.size());
    iota(ind.begin(), ind.end(), 0);
    sort(ind.rbegin(), ind.rend(), [&](int i, int j) { return pair{s[i], -i} < pair{s[j], -j}; });
    auto create = [&](string s, int i) -> string {
        sort(ind.end() - i, ind.end());
        string t = s;
        for (int i = 0; i < s.size(); ++i) t[i] = s[ind[i]];
        return t;
    };
    lll ans = -((lll) 1 << 120);
    string best;
    auto go = [&](string s, string t, ll y, lll curCost) {
        for (int i = 100; i >= 0; --i) {
            int i1 = s.size() - 1 - rng() % length;
            i1 %= s.size();
            int i2 = s.size() - 1 - rng() % length;
            i2 %= s.size();
            swap(t[i1], t[i2]);
            lll newCost = check(t, s, y);
            if (newCost > ans) {
                ans = newCost;
                best = t;
            }
            if (newCost > curCost) {
                curCost = newCost;
            } else {
                swap(t[i1], t[i2]);
            }
        }
    };
    for (int i = 0; i <= min((int) s.size(), length); ++i) {
        {
            string t = create(s, i);
            lll c = check(t, s, y);
            if (c > ans) {
                ans = c;
                best = t;
            }
            go(s, t, y, c);
        }
    }
    cout << best << '\n';
}