#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

mt19937 rng(0);

struct qu3 {
    ll k;
    int i, idx;

    qu3(ll k, int i, int idx) : k(k), i(i), idx(idx) {}
};

struct SumTree {
    int n;
    vector<ll> data;

    SumTree(int n) : n(n), data(2 * n) {}

    void set(int i, ll x) {
        data[i += n] = x;
        for (i /= 2; i > 0; i /= 2) data[i] = data[2 * i] + data[2 * i + 1];
    }

    ll get(int l, int r) {
        ll res = 0;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l & 1) res += data[l++];
            if (r & 1) res += data[--r];
        }
        return res;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> c(n);
    for (auto &x: c) cin >> x;
    vector<int> ind(n);
    iota(ind.begin(), ind.end(), 0);
    sort(ind.begin(), ind.end(), [&](int i, int j) { return c[i] < c[j]; });
    vector<int> inv(n);
    for (int i = 0; i < n; ++i) inv[ind[i]] = i;
    ll sum0 = accumulate(c.begin(), c.end(), 0LL);
    sort(c.begin(), c.end());
    vector<ll> diffsSorted;
    for (int i = 1; i < c.size(); ++i) diffsSorted.push_back(c[i] - c[i - 1]);
    vector<ll> d = diffsSorted;
    set<pair<ll, int>> ds;
    for (int i = 0; i < d.size(); ++i) ds.emplace(d[i], i);
    map<ll, pair<ll, ll>> lvl;
    ll curSum = 0;
    for (int i = 0; i < d.size(); ++i) curSum += d[i] * (i + 1);
    ll scnd = d.size() * (d.size() + 1) / 2;
    while (!ds.empty()) {
        auto[di, i] = *ds.begin();
        if (lvl.find(di) == lvl.end()) lvl[di] = {curSum, scnd};
        ds.erase(ds.begin());
        curSum -= di * (i + 1);
        scnd -= (i + 1);
    }
    sort(diffsSorted.begin(), diffsSorted.end());
    vector<ll> ans(q);
    vector<qu3> offline;
    for (int j = 0; j < q; ++j) {
        ll t, k;
        cin >> t >> k;
        if (t == 1) {
            ans[j] = c.size() - (upper_bound(diffsSorted.begin(), diffsSorted.end(), k) - diffsSorted.begin());
        }
        if (t == 2) {
            auto it = lvl.upper_bound(k);
            if (it == lvl.end()) {
                ans[j] = c.back() * n - sum0;
            } else {
                auto[sum, cnt] = (it->second);
                ans[j] = c.back() * n - sum0 - (sum - k * cnt);
            }
        }
        if (t == 3) {
            int i;
            cin >> i;
            i = inv[i - 1];
            offline.emplace_back(k, i, j);
        }
    }
    auto solveOffline = [&]() {
        sort(offline.begin(), offline.end(), [&](auto u, auto v) { return u.k > v.k; });
        vector<pair<ll, int>> ds(d.size());
        for (int i = 0; i < d.size(); ++i) ds[i] = {d[i], i};
        sort(ds.rbegin(), ds.rend());
        int p = 0;
        SumTree st(d.size()), exists(d.size());
        for (auto[k, i, idx]: offline) {
            while (p < ds.size() && ds[p].first >= k) {
                st.set(ds[p].second, ds[p].first);
                exists.set(ds[p].second, 1);
                ++p;
            }
            ans[idx] = c.back() - (st.get(i, st.n) - k * exists.get(i, st.n));
        }
    };
    solveOffline();
    for (ll &x: ans) cout << x << '\n';
}
