#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    do {
        solve();
    } while (--t);
    return 0;
}

struct bot {
    int l, r, c, t;

    bot(int l, int r, int c, int t) : l(l), r(r), c(c), t(t) {}

    bot() = default;

    bool operator<(bot other) const {
        return pair{r, l} < pair{other.r, other.l};
    }
};

vector<bot> modify(vector<bot> v, int x) {
    vector<bot> res;
    for (auto b: v) {
        if (b.t == 1) {
            b.l = min(b.l, x);
            b.r = max(b.r, x + 1);
        }
        res.push_back(b);
    }
    return res;
}

ll solve(vector<bot> bots, vector<int> a) {
    vector<vector<bot>> grouped(a.size());
    for (auto bot: bots) {
        grouped[bot.l].push_back(bot);
    }
    multiset<bot> cur;
    ll ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        cur.insert(grouped[i].begin(), grouped[i].end());
        while (!cur.empty()) {
            auto bot = *cur.begin();
            cur.erase(cur.begin());
            if (bot.r <= i) continue;
            int surplus = min(bot.c, a[i]);
            ans += surplus;
            bot.c -= surplus;
            a[i] -= surplus;
            if (bot.c) cur.emplace(bot);
            if (a[i] == 0) break;
        }
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &x: a) cin >> x;
    vector<bot> bots(m);
    for (auto &[l, r, c, t]: bots) cin >> l >> r >> c >> t;
    for (auto &[l, r, c, t]: bots) --l;
    for (int x = 0; x < n; ++x) {
        cout << solve(modify(bots, x), a) << '\n';
    }
}