#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ll fast_pow(ll a, ll p) {
    if (p == 0) return 1;
    ll tmp = fast_pow(a, p / 2);
    tmp *= tmp;
    if (p % 2) tmp *= a;
    return tmp;
}

bool compare(string &a, string &b) {
    for (int i = 0; i < a.size(); i++) {
        if (a[i] < b[i]) return true;
        if (a[i] > b[i]) return false;
    }
    return false;
}

ll get_num(string &a) {
    ll res = 0;
    for (int i = 0; i < a.size(); i++) {
        res += fast_pow(10, a.size() - i - 1) * (a[i] - '0');
    }
    return res;
}

ll get_dist(string a, string b) {
    ll total = 0;
    for (int i = 0; i < a.size(); i++) {
        if (a[i] == b[i]) continue;
        for (int j = i + 1; j < a.size(); j++) {
            if (b[j] == a[i]) {
                for (int p = j; p > i; p--) {
                    b[p] = b[p - 1];
                }
                b[i] = a[j];
                total += j - i;
                break;
            }
        }
    }
    return total;
}

void stupid_solve(string &a, ll y) {
    vector<int> order;
    for (int i = 0; i < a.size(); i++) order.push_back(i);

    ll best_ans = get_num(a);
    string best_ln = a;
    while (true) {
        string ln;
        for (int i: order) {
            ln += a[i];
        }
        ll d = get_dist(a, ln);
        ll num = get_num(ln) - d * y;
        if (num > best_ans or (num == best_ans and compare(best_ln, ln))) {
            best_ans = num;
            best_ln = ln;
        }

        bool fl = next_permutation(order.begin(), order.end());
        if (!fl) break;
    }
    cout << best_ln << '\n';
}

void solve() {
    string a, b;
    ll y;
    cin >> a >> y;
    stupid_solve(a, y);
//    int n = a.size();
//    ll best_ans = get_num(a);
//    string best_ln = a;
//    for (int mask = 0; mask < (1 << n); mask++) {
//        vector<char> nums, other_nums;
//        for (int i = 0; i < n; i++) {
//            if (mask & (1 << i)) nums.push_back(a[i]);
//            else other_nums.push_back(a[i]);
//        }
//        sort(nums.rbegin(), nums.rend());
//    }
//    cout << a << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(20);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}