#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define pi pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vll vector<ll>

struct block {
    ll start, length, val;
    block(ll s, ll l, ll v) {
        start = s;
        length = l;
        val = v;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pll> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first;
        arr[i].second = i;
    }

    vi person_to_block(n);

    sort(arr.begin(), arr.end());
    vector<block> blocks;
    for (int i = 0; i < n; i++) {
        if (i == 0 or arr[i].first != arr[i - 1].first) {
            blocks.emplace_back(i, 1, arr[i].first);
        } else {
            blocks.back().length++;
        }
        person_to_block[arr[i].second] = blocks.size() - 1;
    }

    ll cnt = blocks.size();
    vector<pll> events;
    for (int i = 1; i < cnt; i++) {
        events.emplace_back(blocks[i].val - blocks[i - 1].val, i - 1);
    }
    sort(events.begin(), events.end());

    vll ans(n + 1);
    ans[0] = 0;

    vector<block> init = blocks;

    vector<vector<block>> after_change(n);

    if (cnt > 1) {

        for (int i = 1; i <= n; i++) {
            ll delta;
            if (i == 1) delta = events[i - 1].first;
            else delta = events[i - 1].first - events[i - 2].first;
            ans[i] = ans[i - 1];

            ll val = 0;
            for (int j = int(blocks.size()) - 1; j >= 0; j--) {
                blocks[j].val += delta * val;
                ans[i] += blocks[j].length * delta * val;
                val++;
            }

            vector<block> tmp_blocks = {blocks[0]};
            for (int j = 1; j < blocks.size(); j++) {
                if (blocks[j].val == blocks[j - 1].val) {
                    tmp_blocks.back().length += blocks[j].length;
                    continue;
                } else {
                    tmp_blocks.push_back(blocks[j]);
                }
            }
            blocks = tmp_blocks;
            after_change[i - 1] = blocks;
        }
    }

    while (q--) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 1) {
            if (cnt == 1) {
                cout << 1 << '\n';
                continue;
            }
            int left = 0, right = cnt - 1, medium;
            while (right - left > 1) {
                medium = (left + right) / 2;
                if (events[medium].first <= k) left = medium;
                else right = medium;
            }
            if (events[left].first > k) left--;
            cout << cnt - (left + 1) << '\n';
        } else if (t == 2) {
            if (cnt == 1) {
                cout << '0' << '\n';
                continue;
            }
            int left = 0, right = cnt, medium;
            while (right - left > 1) {
                medium = (left + right) / 2;
                if (events[medium].first <= k) left = medium;
                else right = medium;
            }
            if (events[left].first > k) left--;
            if (left == -1) {
                ll x = 0;
                ll res = 0;
                for (int i = cnt - 1; i >= 0; i--) {
                    res += k * init[i].length * x;
                    x++;
                }
                cout << res << '\n';
            }
            else {
                ll res = ans[left + 1];
                ll leftover = k - events[left].first;
                ll x = 0;
                for (int pos = after_change[left].size() - 1; pos >= 0; pos--) {
                    res += leftover * after_change[left][pos].length * x;
                    x++;
                }
                cout << res << '\n';
            }
        } else {
            int i;
            cin >> i;
            ll res = init[person_to_block[i - 1]].val;
            if (cnt == 1) {
                cout << res << '\n';
                continue;
            }
            int left = 0, right = cnt, medium;
            // TODO k is bigger than left
            while (right - left > 1) {
                medium = (left + right) / 2;
                if (events[medium].first <= k) left = medium;
                else right = medium;
            }
            if (events[left].first > k) left--;

            ll bl = person_to_block[i - 1];

            if (left == -1) {
                cout << res + (cnt - 1 - bl) * k << '\n';
                continue;
            }

            ll leftover = k - events[left].first;
            ll x = cnt - bl - 1;
            for (int j = 0; j <= left; j++) {
                ll delta;
                if (j == 0) delta = events[j].first;
                else delta = events[j].first - events[j - 1].first;
                res += x * delta;
                if (events[j].second >= bl) x--;
            }
            res += leftover * x;
            cout << res << '\n';
        }
    }
}

int main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    cout.precision(20);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}