#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define pi pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vll vector<ll>

struct block {
    ll start, length, val;
    block(ll s, ll l, ll v) {
        start = s;
        length = l;
        val = v;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pll> arr(n);
    ll begin = 0;
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first;
        begin += arr[i].first;
        arr[i].second = i;
    }

    vi person_to_block(n);

    sort(arr.begin(), arr.end());
    vector<block> blocks;
    for (int i = 0; i < n; i++) {
        if (i == 0 or arr[i].first != arr[i - 1].first) {
            blocks.emplace_back(i, 1, arr[i].first);
        } else {
            blocks.back().length++;
        }
        person_to_block[arr[i].second] = blocks.size() - 1;
    }

    ll cnt = blocks.size();
    vector<pll> events;
    for (int i = 1; i < cnt; i++) {
        events.emplace_back(blocks[i].val - blocks[i - 1].val, i - 1);
    }
    sort(events.begin(), events.end());

    vector<vector<block>> after_change(n);
    auto init = blocks;

    if (cnt > 1 and n <= 5000) {
        for (int i = 1; i <= n; i++) {
            ll delta;
            if (i == 1) delta = events[i - 1].first;
            else delta = events[i - 1].first - events[i - 2].first;
            ll val = 0;
            for (int j = int(blocks.size()) - 1; j >= 0; j--) {
                blocks[j].val += delta * val;
                if (j and blocks[j].val - delta * val > blocks[j - 1].val) val++;
            }

            vector<block> tmp_blocks = {blocks[0]};
            for (int j = 1; j < blocks.size(); j++) {
                tmp_blocks.push_back(blocks[j]);
            }
            blocks = tmp_blocks;
            after_change[i - 1] = blocks;
        }
    }

    while (q--) {
        int t;
        ll k;
        cin >> t >> k;
        if (t == 1) {
            if (cnt == 1) cout << 1 << '\n';
            else {
                int left = 0, right = cnt - 1, medium;
                while (right - left > 1) {
                    medium = (left + right) / 2;
                    if (events[medium].first <= k) left = medium;
                    else right = medium;
                }
                if (events[left].first > k) left--;
                cout << cnt - (left + 1) << '\n';
            }
        } else if (t == 2) {
            if (cnt == 1) {
                cout << 0 << '\n';
            } else {
                int left = 0, right = cnt - 1, medium;
                while (right - left > 1) {
                    medium = (left + right) / 2;
                    if (events[medium].first <= k) left = medium;
                    else right = medium;
                }
                if (events[left].first > k) left--;
                vector<block> tmp;
                ll leftover;
                if (left == -1) {
                    tmp = init;
                    leftover = k;
                } else {
                    tmp = after_change[left];
                    leftover = k - events[left].first;
                }
                ll total = 0;
                ll x = 0;
                for (int i = tmp.size() - 1; i >= 0; i--) {
                    total += tmp[i].val * tmp[i].length + tmp[i].length * x * leftover;
                    if (i and tmp[i].val > tmp[i - 1].val) x++;
                }
                cout << total - begin << '\n';
            }
        } else {
            int pos;
            cin >> pos;
            pos--;
            int block_id = person_to_block[pos];

            if (cnt == 1) {
                cout << init[block_id].val << '\n';
                continue;
            }

            int left = 0, right = cnt - 1, medium;
            while (right - left > 1) {
                medium = (left + right) / 2;
                if (events[medium].first <= k) left = medium;
                else right = medium;
            }
            if (events[left].first > k) left--;

            vector<block> tmp;
            ll leftover;
            if (left == -1) {
                tmp = init;
                leftover = k;
            } else {
                tmp = after_change[left];
                leftover = k - events[left].first;
            }

            ll res = tmp[block_id].val;
            ll x = 0;
            for (int i = tmp.size() - 1; i >= block_id; i--) {
                if (i and tmp[i].val > tmp[i - 1].val) x++;
            }
            res += x * leftover;
            cout << res << '\n';
        }
    }
}

int main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    cout.precision(20);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}