#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cassert>
#include <cstring>
#include <map>
#include <queue>

using namespace std;

//#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) ((int)(x.size()))
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;

//const long long INFll = 1e18 + 3;
const int INF = 1e8 + 3;
const int N = 2e5 + 228;

int a[N];
int a2[N];

struct robot {
	int l, r, c, t;
	robot() {}
	robot(int l, int r, int c, int t) : l(l), r(r), c(c), t(t) {}
};

vi events[N];
set<pi> stopen;

int n, m;
int solve1(vector<robot>& b) {
	stopen.clear();
	for (int i = 0; i < n; ++i) {
		a2[i] = a[i];
	}
	for (int i = 0; i < m; ++i) {
		events[b[i].l].push_back(i + 1);
		events[b[i].r].push_back(-(i + 1));
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int id : events[i]) {
			if (id > 0) {
				stopen.insert(make_pair(b[id - 1].r, id - 1));
			}
			else {
				stopen.erase(make_pair(b[-(id + 1)].r, -(id + 1)));
			}
		}
		events[i].clear();
		while (a2[i] > 0 && !stopen.empty()) {
			int id = stopen.begin()->second;
			int c = b[id].c;
			if (a2[i] >= c) {
				ans += c;
				a2[i] -= c;
				stopen.erase(stopen.begin());
			}
			else {
				ans += a2[i];
				b[id].c -= a2[i];
				a2[i] = 0;
			}
		}
	}
	events[n].clear();
	return ans;
}
robot b[N];

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < m; ++i) {
		int l, r, c, t;
		cin >> l >> r >> c >> t;
		//assert(t == 0);
		--l;
		b[i] = robot(l, r, c, t);
	}

	vector<robot> b2(m);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (b[j].t == 1) {
				b2[j] = robot(min(b[j].l, i), max(b[j].r, i + 1), b[j].c, b[j].t);
			}
			else {
				b2[j] = b[j];
			}
		}
		cout << solve1(b2) << " ";
	}
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
1
5 6
1 2
3 2
1 3
3 5
5 4
3 4
*/