#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll inf = 1e18 + 228;
const ll cst = 3e5 + 5;

void ex() {
	cout.flush();
	exit(0);
}

struct Event {
	ll x;
	ll typ; // 0 - merge; 1,2,3 - queries;
	ll ind; // if merge => ind and ind+ 1 merged. else means query ind
	ll q3i;
	Event(ll nx = 0, ll nt = 0, ll ni = 0, ll nq3 = -1) {
		x = nx;
		typ = nt;
		ind = ni;
		q3i = nq3;
	}
	bool operator<(Event b) {
		return pair<ll, ll>{ x, typ } < pair<ll, ll>{b.x, b.typ};
	}
};

ll n, q;

vector<pair<ll, ll>> vc;

ll mp[cst];

ll answ[cst];

vector<Event> ev;

ll sbl;
ll cb;

ll pr[cst];
ll lb[cst];
ll rb[cst];

ll find(ll v) {
	if (pr[v] == v) return v;
	return pr[v] = find(pr[v]);
}

void unite(ll a, ll b) {
	a = find(a);
	b = find(b);
	sbl -= lb[b];
	lb[b] = lb[a];
	pr[a] = b;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> q;
	for (ll i = 0; i < n; i++) {
		pr[i] = i;
		lb[i] = rb[i] = i;
		ll x;
		cin >> x;
		vc.push_back({ x, i + 1 });
	}
	sort(all(vc));
	for (ll i = 0; i < n; i++) {
		mp[vc[i].second] = i;
	}
	for (ll i = 0; i < n - 1; i++) {
		ev.push_back({ vc[i + 1].first - vc[i].first, 0, i });
	}
	for (ll i = 0; i < q; i++) {
		ll tp;
		ll x;
		ll q3 = -1;
		cin >> tp >> x;
		if (tp == 3) {
			cin >> q3;
			q3 = mp[q3];
		}
		ev.push_back({ x, tp, i, q3 });
	}
	sort(all(ev));
	cb = n;
	ll cs = 0;
	sbl = n * (n - 1) / 2;
	ll last = 0;
	for (ll i = 0; i < ev.size(); i++) {
		cs += sbl * (ev[i].x - last);
		if (ev[i].typ == 0) {
			cb--;
			unite(ev[i].ind, ev[i].ind + 1);
		}
		if (ev[i].typ == 1) {
			answ[ev[i].ind] = cb;
		}
		if (ev[i].typ == 2) {
			answ[ev[i].ind] = cs;
		}
		last = ev[i].x;
	}
	for (ll i = 0; i < q; i++) cout << answ[i] << endl;
	ex();
}
