#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll inf = 1e18 + 228;
const ll cst = 5e5 + 5;

void ex() {
	cout.flush();
	exit(0);
}

vector<ll> g[cst];

ll n, m;

ll d[2][cst];
ll cutp[cst];

vector<bool> used;

ll ban;

ll vs = 0;

void dfs(ll v) {
	used[v] = 1;
	vs++;
	for (ll u : g[v]) {
		if (used[u] || u == ban) continue;
		dfs(u);
	}
}

void solve() {
	cin >> n >> m;
	for (ll i = 1; i <= n; i++) {
		g[i].clear();
		d[0][i] = d[1][i] = inf;
		cutp[i] = 0;
	}
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (ll cp = 1; cp <= n; cp++) {
		used.assign(n + 1, 0);
		vs = 0;
		ban = cp;
		if (cp != 1) dfs(1);
		else dfs(2);
		if (vs != n - 1) cutp[cp] = 1;
	}
	d[0][1] = 0;
	queue<pair<ll, ll>> q;
	q.push({ 0, 1 });
	while (!q.empty()) {
		auto x = q.front();
		ll v = x.second;
		ll tp = x.first;
		q.pop();
		if (tp && cutp[v]) continue;
		for (ll u : g[v]) {
			if (d[!tp][u] > d[tp][v] + 1) {
				d[!tp][u] = d[tp][v] + 1;
				q.push({ !tp, u });
			}
		}
	}
	for (ll i = 2; i <= n; i++) {
		if (d[0][i] == inf) cout << -1 << " ";
		else cout << d[0][i] << " ";
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	ex();
}
