#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,avx,mmx,abm,popcnt,tune=native")

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;

const ll inf = 1e18 + 228;
const ll cst = 5e5 + 5;

void operator delete(void*);

void ex() {
	cout.flush();
	exit(0);
}

vector<ll> g[cst];

ll n, m;

ll d[2][cst];

ll ds[5005][5005];

void solve() {
	cin >> n >> m;
	for (ll i = 1; i <= n; i++) {
		g[i].clear();
		d[0][i] = d[1][i] = inf;
	}
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	if (n > 5000) {
		d[0][1] = 0;
		queue<pair<ll, ll>> q;
		q.push({ 0, 1 });
		while (!q.empty()) {
			auto x = q.front();
			ll v = x.second;
			ll tp = x.first;
			q.pop();
			for (ll u : g[v]) {
				if (d[!tp][u] > d[tp][v] + 1) {
					d[!tp][u] = d[tp][v] + 1;
					q.push({ !tp, u });
				}
			}
		}
		for (ll i = 2; i <= n; i++) {
			if (d[0][i] == inf) cout << -1 << " ";
			else cout << d[0][i] << " ";
		}
		return;
	}
	for (ll i = 0; i <= n; i++) {
		for (ll j = 0; j <= n; j++) ds[i][j] = inf;
	}
	ds[0][1] = 0;
	set<pair<ll, pair<ll, ll>>> st;
	st.insert({ 0, {0, 1} });
	while (!st.empty()) {
		auto x = *st.begin();
		st.erase(x);
		ll v = x.second.second;
		ll bn = x.second.first;
		for (ll u : g[v]) {
			if (bn == 0) {
				if (ds[u][v] > ds[0][v] + 1) {
					st.erase({ ds[u][v], {u, v} });
					ds[u][v] = ds[0][v] + 1;
					st.insert({ ds[u][v], {u, v} });
				}
			}
			else if (bn == u) {
				if (ds[0][v] > ds[u][v] + 1) {
					st.erase({ ds[0][v], {0, v} });
					ds[0][v] = ds[u][v] + 1;
					st.insert({ ds[0][v], {0, v} });
				}
			}
			else {
				if (ds[bn][u] > ds[bn][v]) {
					st.erase({ ds[bn][u], {bn, u} });
					ds[bn][u] = ds[bn][v];
					st.insert({ ds[bn][u], {bn, u} });
				}
			}
		}
	
	}
	for (ll i = 2; i <= n; i++) {
		if (ds[0][i] == inf) cout << -1 << " ";
		else cout << ds[0][i] << " ";
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
	ex();
}
