#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <map>
#include <tuple>
#include <numeric>
#include <queue>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;

template <typename T>
istream& operator>> (istream& in, v<T>& a) {
	for (T& x : a) {
		in >> x;
	}
	return in;
}

ll n, m;
v<v<ll>> graph;

void solve() {
	cin >> n >> m;
	graph = v<v<ll>>(n);
	for (ll i = 0; i < m; ++i) {
		ll ui, vi;
		cin >> ui >> vi;
		--ui;
		--vi;
		graph[ui].push_back(vi);
		graph[vi].push_back(ui);
	}
	v<v<ll>> midist(n);
	for (ll i = 0; i < n; ++i) {
		midist[i] = v<ll>(2, -1);
	}
	queue<tuple<ll, ll, ll>> q;
	q.push({ 0, 1, 0 });
	while (!q.empty()) {
		auto [vert, comp, dist] = q.front();
		q.pop();
		if (midist[vert][comp] == -1) {
			midist[vert][comp] = dist;
			for (ll overt : graph[vert]) {
				if (comp == 1) {
					q.push({ overt, 0, dist + 1 });
				}
				else if (comp == 0) {
					q.push({ overt, 1, dist + 1 });
				}
			}
		}
	}
	for (ll i = 1; i < n; ++i) {
		cout << midist[i][1] << ' ';
	}
	cout << '\n';
}

int main() {
	ll t;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
}