#include <iostream>
#include <vector>
#include <cassert>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <queue>

using namespace std;

//#define int int64_t
#define bint __int128_t
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
#pragma GCC optimize("O3")
mt19937 rnd(235215);

struct node {
    int sz, y;
    int64_t val;
    int cnt;
    vector<int> inds;
    node *l, *r, *pr, *next;
    int64_t st, del;
    node() {
        cnt = 0;
        st = 0;
        del = 0;
        y = rnd();
        sz = 1;
        l = r = pr = next = nullptr;
    }
};

int sz(node *v) {
    return (!v ? 0 : v->sz);
}
int cnt(node *v) {
    return (!v ? 0 : v->cnt);
}

void upd(node *v) {
    if (!v) return;
    v->sz = sz(v->l) + sz(v->r) + 1;
    v->cnt = cnt(v->l) + cnt(v->r) + v->inds.size();
}

void push(node *v) {
    if (!v) return;
    upd(v);
    v->val += v->st + sz(v->l) * v->del;
    if (v->l) {
        v->l->st += v->st;
        v->l->del += v->del;
    }
    if (v->r) {
        v->r->st += v->st + (v->del * (sz(v->l) + 1));
        v->r->del += v->del;
    }
    v->st = 0;
    v->del = 0;
}

pair<node*, node*> split(node *t, int k) {
    if (!t) return {nullptr, nullptr};
    push(t);
    if (sz(t->l) >= k) {
        if (t->l) t->l->pr = nullptr;
        auto [l, r] = split(t->l, k);
        t->l = r;
        if (r) r->pr = t;
        upd(t);
        return {l, t};
    } else {
        if (t->r) t->r->pr = nullptr;
        auto [l, r] = split(t->r, k - sz(t->l) - 1);
        t->r = l;
        if (l) l->pr = t;
        upd(t);
        return {t, r};
    }
}

pair<node*, node*> split2(node *t, int x) {
    if (!t) return {nullptr, nullptr};
    push(t);
    if (t->val >= x) {
        if (t->l) t->l->pr = nullptr;
        auto [l, r] = split2(t->l, x);
        t->l = r;
        if (r) r->pr = t;
        upd(t);
        return {l, t};
    } else {
        if (t->r) t->r->pr = nullptr;
        auto [l, r] = split2(t->r, x);
        t->r = l;
        if (l) l->pr = t;
        upd(t);
        return {t, r};
    }
}

node* merge(node *L, node *R) {
    push(L); push(R);
    if (!L) return R;
    if (!R) return L;
    if (L->y < R->y) {
        L->r = merge(L->r, R);
        L->r->pr = L;
        upd(L);
        return L;
    } else {
        R->l = merge(L, R->l);
        R->l->pr = R;
        upd(R);
        return R;
    }
}

node *next(node *v) {
    return (v->next == nullptr ? v : v->next = next(v->next));
}

node* add_seg(node *v, int st, int del) {
    v->st += st;
    v->del += del;
    push(v);
    return v;
}

node *mx;
int64_t cur_add = 0;
void dfs(node *v, node *st, int64_t k=0) {
    cur_add -= (sz(st) - (sz(v->l)+k) - 1) * (int64_t)v->inds.size();
    if (mx->inds.size() < v->inds.size()) {
        swap(mx->inds, v->inds);
    }
    if (v->l) dfs(v->l, st, k);
    if (v->r) dfs(v->r, st, k + 1 + sz(v->l));
}

vector<node*> ind;
void dfs2(node *v, node *st) {
    if (v != mx) {
        for (int i : v->inds) {
            st->inds.push_back(i);
            ind[i] = st;
        }
    }
    if (v != st) {
        v->next = st;
    }
    if (v->l) dfs2(v->l, st);
    if (v->r) dfs2(v->r, st);
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> mas(n);
    for (auto &i : mas) {
        cin >> i;
    }
    vector<vector<int64_t>> que;
    for (int i = 0; i < q; ++i) {
        int64_t tp, k, g = 0;
        cin >> tp >> k;
        if (tp == 3) {
            cin >> g;
            g--;
        }
        que.push_back({k, tp, g, i});
    }
    int64_t SS = 0;
    sort(all(que));
    vector<int64_t> ans(q);
    map<int64_t, vector<int>> cnt;
    for (int i = 0; i < n; ++i) {
        cnt[mas[i]].push_back(i);
    }
    priority_queue<pair<int64_t, pair<node*, node*>>, vector<pair<int64_t, pair<node*, node*>>>, greater<>> pr;
    ind.resize(n);
    node *root = nullptr;
    node *last = nullptr;
    for (auto i : cnt) {
        node *nw = new node();
        nw->val = i.fi;
        nw->inds = i.se;
        nw->cnt = i.se.size();
        for (int j : i.se) {
            ind[j] = nw;
        }
        if (last != nullptr) {
            pr.push({nw->val - last->val, {last, nw}});
        }
        last = nw;
        root = merge(root, nw);
    }

    int sz = cnt.size();
    int64_t cur_t = 0;
    int cn = 0;
    for (auto i : cnt) {
        cur_add += i.se.size() * (cnt.size() - 1 - cn);
        cn++;
    }
    for (int Q = 0; Q < q; ++Q) {
        auto ev = que[Q];
        int64_t k = ev[0], tp = ev[1], g = ev[2];
        //cout << "cur_add = " << cur_add << endl;

        while (!pr.empty() && pr.top().fi <= (k)) {
            auto pp = pr.top();

            SS += cur_add * (pp.fi-cur_t);
            //cout << "tim = " << pp.fi << ' ' << cur_t << ' ' << SS << endl;
            root = add_seg(root, (sz-1) * (pp.fi-cur_t), -(pp.fi-cur_t));

            vector<node*> sus;
            for (node* i = next(pp.se.fi); i != nullptr; i = i->pr) {
                sus.push_back(i);
            }
            reverse(all(sus));
            for (auto i : sus) {
                push(i);
            }
            int64_t val = next(pp.se.fi)->val;
            auto [l1, r1] = split2(root, val);
            auto [l2, r2] = split2(r1, val+1);

            int delt = l2->sz - 1;
            if (l1 != nullptr) {
                cur_add -= l1->cnt * delt;
            }
            mx = l2;
            dfs(l2, l2);

            if (mx != l2) {
                swap(l2->inds, mx->inds);
            }
            dfs2(l2, l2);
            l2->l = l2->r = nullptr;
            l2->cnt = l2->inds.size();
            upd(l2);

            root = merge(l1, merge(l2, r2));
            cur_t = pp.fi;
            sz--;
            pr.pop();
        }

        SS += cur_add * (k-cur_t);
        root = add_seg(root, (sz-1LL) * (k - cur_t), -(k - cur_t));
        cur_t = k;
        if (tp == 1) {
            ans[ev[3]] = sz;
        } else if (tp == 2) {
            ans[ev[3]] = SS;
        } else {
            vector<node*> sus;
            for (node* i = next(ind[g]); i != nullptr; i = i->pr) {
                sus.push_back(i);
            }
            reverse(all(sus));
            for (auto i : sus) {
                push(i);
            }
            ans[ev[3]] = next(ind[g])->val;
        }
    }
    for (int64_t i : ans) {
        cout << i << '\n';
    }
}
/*
6 3
5 4 4 2 2 1
2 1
2 2
2 3
 */